var SYMBOL_DICTIONARY = {
	"$ajax" : [ "property", "$ajax", false, false, "_global_" ],
	"$callback" : [ "method", "$callback", false, false, "_global_" ],
	"$class" : [ "method", "$class", false, false, "_global_" ],
	"$create" : [ "method", "$create", false, false, "_global_" ],
	"$DomUtils" : [ "property", "$DomUtils", false, false, "_global_" ],
	"$extend" : [ "method", "$extend", false, false, "_global_" ],
	"$fly" : [ "method", "$fly", false, false, "_global_" ],
	"$getSuperClass" : [ "method", "$getSuperClass", false, false, "_global_" ],
	"$getSuperClasses" : [ "method", "$getSuperClasses", false, false,
			"_global_" ],
	"$group" : [ "method", "$group", false, false, "_global_" ],
	"$invokeSuper" : [ "method", "$invokeSuper", false, false, "_global_" ],
	"$map" : [ "method", "$map", false, false, "_global_" ],
	"$namespace" : [ "method", "$namespace", false, false, "_global_" ],
	"$resource" : [ "method", "$resource", false, false, "_global_" ],
	"$scopify" : [ "method", "$scopify", false, false, "_global_" ],
	"$setInterval" : [ "method", "$setInterval", false, false, "_global_" ],
	"$setTimeout" : [ "method", "$setTimeout", false, false, "_global_" ],
	"$setting" : [ "property", "$setting", false, false, "_global_" ],
	"$singleton" : [ "method", "$singleton", false, false, "_global_" ],
	"$tag" : [ "method", "$tag", false, false, "_global_" ],
	"$url" : [ "method", "$url", false, false, "_global_" ],
	"_global_" : [ "object", "_global_", false, false, "" ],
	"Array" : [ "class", "Array", false, false, "" ],
	"Array#each" : [ "method", "each", false, false, "Array" ],
	"Array#indexOf" : [ "method", "indexOf", false, false, "Array" ],
	"Array#insert" : [ "method", "insert", false, false, "Array" ],
	"Array#peek" : [ "method", "peek", false, false, "Array" ],
	"Array#push" : [ "method", "push", false, false, "Array" ],
	"Array#remove" : [ "method", "remove", false, false, "Array" ],
	"Array#removeAt" : [ "method", "removeAt", false, false, "Array" ],
	"Date" : [ "class", "Date", false, false, "" ],
	"Date#formatDate" : [ "method", "formatDate", false, false, "Date" ],
	"Date.parseDate" : [ "method", "parseDate", false, false, "Date" ],
	"dorado" : [ "namespace", "dorado", false, false, "" ],
	"dorado.AbortException" : [ "class", "AbortException", false, false,
			"dorado" ],
	"dorado.AbstractException" : [ "class", "AbstractException", true, false,
			"dorado" ],
	"dorado.AttributeSupport" : [ "class", "AttributeSupport", true, false,
			"dorado" ],
	"dorado.AttributeSupport#attribute:tags" : [ "attribute", "attribute:tags",
			false, false, "dorado.AttributeSupport" ],
	"dorado.AttributeSupport#ATTRIBUTES" : [ "property", "ATTRIBUTES", false,
			false, "dorado.AttributeSupport" ],
	"dorado.AttributeSupport#doSet" : [ "method", "doSet", false, false,
			"dorado.AttributeSupport" ],
	"dorado.AttributeSupport#event:onAttributeChange" : [ "event",
			"event:onAttributeChange", false, false, "dorado.AttributeSupport" ],
	"dorado.AttributeSupport#get" : [ "method", "get", false, false,
			"dorado.AttributeSupport" ],
	"dorado.AttributeSupport#getAttributeWatcher" : [ "method",
			"getAttributeWatcher", false, false, "dorado.AttributeSupport" ],
	"dorado.AttributeSupport#hasTag" : [ "method", "hasTag", false, false,
			"dorado.AttributeSupport" ],
	"dorado.AttributeSupport#set" : [ "method", "set", false, false,
			"dorado.AttributeSupport" ],
	"dorado.AttributeWatcher" : [ "class", "AttributeWatcher", false, false,
			"dorado" ],
	"dorado.AttributeWatcher#getWritingTimes" : [ "method", "getWritingTimes",
			false, false, "dorado.AttributeWatcher" ],
	"dorado.Browser" : [ "object", "Browser", false, false, "dorado" ],
	"dorado.Browser.chrome" : [ "property", "chrome", false, false,
			"dorado.Browser" ],
	"dorado.Browser.mozilla" : [ "property", "mozilla", false, false,
			"dorado.Browser" ],
	"dorado.Browser.msie" : [ "property", "msie", false, false,
			"dorado.Browser" ],
	"dorado.Browser.opera" : [ "property", "opera", false, false,
			"dorado.Browser" ],
	"dorado.Browser.safari" : [ "property", "safari", false, false,
			"dorado.Browser" ],
	"dorado.Browser.version" : [ "property", "version", false, false,
			"dorado.Browser" ],
	"dorado.Callback" : [ "object", "Callback", false, false, "dorado" ],
	"dorado.Callback#callback" : [ "method", "callback", false, false,
			"dorado.Callback" ],
	"dorado.Callback#failure" : [ "method", "failure", false, false,
			"dorado.Callback" ],
	"dorado.Callback#success" : [ "method", "success", false, false,
			"dorado.Callback" ],
	"dorado.Callback.invokeCallback" : [ "method", "invokeCallback", false,
			false, "dorado.Callback" ],
	"dorado.Core" : [ "object", "Core", false, false, "dorado" ],
	"dorado.Core.clone" : [ "method", "clone", false, false, "dorado.Core" ],
	"dorado.Core.getTimestamp" : [ "method", "getTimestamp", false, false,
			"dorado.Core" ],
	"dorado.Core.newId" : [ "method", "newId", false, false, "dorado.Core" ],
	"dorado.Core.scopify" : [ "method", "scopify", false, false, "dorado.Core" ],
	"dorado.Core.setInterval" : [ "method", "setInterval", false, false,
			"dorado.Core" ],
	"dorado.Core.setTimeout" : [ "method", "setTimeout", false, false,
			"dorado.Core" ],
	"dorado.Core.VERSION" : [ "property", "VERSION", false, false,
			"dorado.Core" ],
	"dorado.Draggable" : [ "class", "Draggable", false, false, "dorado" ],
	"dorado.Draggable#attribute:draggable" : [ "attribute",
			"attribute:draggable", false, false, "dorado.Draggable" ],
	"dorado.Draggable#attribute:dragTags" : [ "attribute",
			"attribute:dragTags", false, false, "dorado.Draggable" ],
	"dorado.Draggable#createDraggingInfo" : [ "method", "createDraggingInfo",
			false, false, "dorado.Draggable" ],
	"dorado.Draggable#event:onDragMove" : [ "event", "event:onDragMove", false,
			false, "dorado.Draggable" ],
	"dorado.Draggable#event:onDragStart" : [ "event", "event:onDragStart",
			false, false, "dorado.Draggable" ],
	"dorado.Draggable#event:onDragStop" : [ "event", "event:onDragStop", false,
			false, "dorado.Draggable" ],
	"dorado.Draggable#event:onGetDraggingIndicator" : [ "event",
			"event:onGetDraggingIndicator", false, false, "dorado.Draggable" ],
	"dorado.Draggable#getDraggableOptions" : [ "method", "getDraggableOptions",
			false, false, "dorado.Draggable" ],
	"dorado.Draggable#initDraggingIndicator" : [ "method",
			"initDraggingIndicator", false, false, "dorado.Draggable" ],
	"dorado.Draggable#initDraggingInfo" : [ "method", "initDraggingInfo",
			false, false, "dorado.Draggable" ],
	"dorado.DraggingIndicator" : [ "class", "DraggingIndicator", false, false,
			"dorado" ],
	"dorado.DraggingIndicator#attribute:accept" : [ "attribute",
			"attribute:accept", false, false, "dorado.DraggingIndicator" ],
	"dorado.DraggingIndicator#attribute:content" : [ "attribute",
			"attribute:content", false, false, "dorado.DraggingIndicator" ],
	"dorado.DraggingIndicator#attribute:contentOffsetLeft" : [ "attribute",
			"attribute:contentOffsetLeft", false, false,
			"dorado.DraggingIndicator" ],
	"dorado.DraggingIndicator#attribute:contentOffsetTop" : [ "attribute",
			"attribute:contentOffsetTop", false, false,
			"dorado.DraggingIndicator" ],
	"dorado.DraggingIndicator#attribute:icon" : [ "attribute",
			"attribute:icon", false, false, "dorado.DraggingIndicator" ],
	"dorado.DraggingIndicator#attribute:iconClass" : [ "attribute",
			"attribute:iconClass", false, false, "dorado.DraggingIndicator" ],
	"dorado.DraggingInfo" : [ "class", "DraggingInfo", false, false, "dorado" ],
	"dorado.DraggingInfo#attribute:accept" : [ "attribute", "attribute:accept",
			false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:element" : [ "attribute",
			"attribute:element", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:indicator" : [ "attribute",
			"attribute:indicator", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:insertMode" : [ "attribute",
			"attribute:insertMode", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:object" : [ "attribute", "attribute:object",
			false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:options" : [ "attribute",
			"attribute:options", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:refObject" : [ "attribute",
			"attribute:refObject", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:sourceControl" : [ "attribute",
			"attribute:sourceControl", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:tags" : [ "attribute", "attribute:tags",
			false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:targetControl" : [ "attribute",
			"attribute:targetControl", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#attribute:targetObject" : [ "attribute",
			"attribute:targetObject", false, false, "dorado.DraggingInfo" ],
	"dorado.DraggingInfo#isDropAcceptable" : [ "method", "isDropAcceptable",
			false, false, "dorado.DraggingInfo" ],
	"dorado.Droppable" : [ "class", "Droppable", false, false, "dorado" ],
	"dorado.Droppable#attribute:droppable" : [ "attribute",
			"attribute:droppable", false, false, "dorado.Droppable" ],
	"dorado.Droppable#attribute:droppableTags" : [ "attribute",
			"attribute:droppableTags", false, false, "dorado.Droppable" ],
	"dorado.Droppable#event:onDraggingSourceDrop" : [ "event",
			"event:onDraggingSourceDrop", false, false, "dorado.Droppable" ],
	"dorado.Droppable#event:onDraggingSourceMove" : [ "event",
			"event:onDraggingSourceMove", false, false, "dorado.Droppable" ],
	"dorado.Droppable#event:onDraggingSourceOut" : [ "event",
			"event:onDraggingSourceOut", false, false, "dorado.Droppable" ],
	"dorado.Droppable#event:onDraggingSourceOver" : [ "event",
			"event:onDraggingSourceOver", false, false, "dorado.Droppable" ],
	"dorado.Droppable#getDroppableOptions" : [ "method", "getDroppableOptions",
			false, false, "dorado.Droppable" ],
	"dorado.EventSupport" : [ "class", "EventSupport", true, false, "dorado" ],
	"dorado.EventSupport#addListener" : [ "method", "addListener", false,
			false, "dorado.EventSupport" ],
	"dorado.EventSupport#attribute:listener" : [ "attribute",
			"attribute:listener", false, false, "dorado.EventSupport" ],
	"dorado.EventSupport#clearListeners" : [ "method", "clearListeners", false,
			false, "dorado.EventSupport" ],
	"dorado.EventSupport#disableListeners" : [ "method", "disableListeners",
			false, false, "dorado.EventSupport" ],
	"dorado.EventSupport#enableListeners" : [ "method", "enableListeners",
			false, false, "dorado.EventSupport" ],
	"dorado.EventSupport#EVENTS" : [ "property", "EVENTS", false, false,
			"dorado.EventSupport" ],
	"dorado.EventSupport#fireEvent" : [ "method", "fireEvent", false, false,
			"dorado.EventSupport" ],
	"dorado.EventSupport#getListenerCount" : [ "method", "getListenerCount",
			false, false, "dorado.EventSupport" ],
	"dorado.EventSupport#removeListener" : [ "method", "removeListener", false,
			false, "dorado.EventSupport" ],
	"dorado.Exception" : [ "class", "Exception", false, false, "dorado" ],
	"dorado.Exception#formatStack" : [ "method", "formatStack", false, false,
			"dorado.Exception" ],
	"dorado.Exception#remoteStack" : [ "property", "remoteStack", false, false,
			"dorado.Exception" ],
	"dorado.Exception#stack" : [ "property", "stack", false, false,
			"dorado.Exception" ],
	"dorado.Exception#systemStack" : [ "property", "systemStack", false, false,
			"dorado.Exception" ],
	"dorado.Exception.processException" : [ "method", "processException",
			false, false, "dorado.Exception" ],
	"dorado.Exception.removeException" : [ "method", "removeException", false,
			false, "dorado.Exception" ],
	"dorado.getFunctionName" : [ "method", "getFunctionName", false, false,
			"dorado" ],
	"dorado.JSON" : [ "object", "JSON", false, false, "dorado" ],
	"dorado.JSON.evaluate" : [ "method", "evaluate", false, false,
			"dorado.JSON" ],
	"dorado.JSON.parse" : [ "method", "parse", false, false, "dorado.JSON" ],
	"dorado.JSON.stringify" : [ "method", "stringify", false, false,
			"dorado.JSON" ],
	"dorado.ModalManager" : [ "object", "ModalManager", false, false, "dorado" ],
	"dorado.ModalManager.hide" : [ "method", "hide", false, false,
			"dorado.ModalManager" ],
	"dorado.ModalManager.show" : [ "method", "show", false, false,
			"dorado.ModalManager" ],
	"dorado.Object" : [ "object", "Object", false, false, "dorado" ],
	"dorado.Object.apply" : [ "method", "apply", false, false, "dorado.Object" ],
	"dorado.Object.clone" : [ "method", "clone", false, false, "dorado.Object" ],
	"dorado.Object.createClass" : [ "method", "createClass", false, false,
			"dorado.Object" ],
	"dorado.Object.createNamespace" : [ "method", "createNamespace", false,
			false, "dorado.Object" ],
	"dorado.Object.eachProperty" : [ "method", "eachProperty", false, false,
			"dorado.Object" ],
	"dorado.Object.extend" : [ "method", "extend", false, false,
			"dorado.Object" ],
	"dorado.Object.isInstanceOf" : [ "method", "isInstanceOf", false, false,
			"dorado.Object" ],
	"dorado.Object.override" : [ "method", "override", false, false,
			"dorado.Object" ],
	"dorado.ObjectGroup" : [ "class", "ObjectGroup", false, false, "dorado" ],
	"dorado.RemoteException" : [ "class", "RemoteException", false, false,
			"dorado" ],
	"dorado.RemoteException#exceptionType" : [ "property", "exceptionType",
			false, false, "dorado.RemoteException" ],
	"dorado.RenderableElement" : [ "class", "RenderableElement", true, false,
			"dorado" ],
	"dorado.RenderableElement#attribute:className" : [ "attribute",
			"attribute:className", false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#attribute:exClassName" : [ "attribute",
			"attribute:exClassName", false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#attribute:height" : [ "attribute",
			"attribute:height", false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#attribute:rendered" : [ "attribute",
			"attribute:rendered", false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#attribute:style" : [ "attribute",
			"attribute:style", false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#attribute:width" : [ "attribute",
			"attribute:width", false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#createDom" : [ "method", "createDom", false,
			false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#getDom" : [ "method", "getDom", false, false,
			"dorado.RenderableElement" ],
	"dorado.RenderableElement#getRealHeight" : [ "method", "getRealHeight",
			false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#getRealWidth" : [ "method", "getRealWidth",
			false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#refresh" : [ "method", "refresh", false, false,
			"dorado.RenderableElement" ],
	"dorado.RenderableElement#refreshDom" : [ "method", "refreshDom", false,
			false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#render" : [ "method", "render", false, false,
			"dorado.RenderableElement" ],
	"dorado.RenderableElement#replace" : [ "method", "replace", false, false,
			"dorado.RenderableElement" ],
	"dorado.RenderableElement#resetDimension" : [ "method", "resetDimension",
			false, false, "dorado.RenderableElement" ],
	"dorado.RenderableElement#unrender" : [ "method", "unrender", false, false,
			"dorado.RenderableElement" ],
	"dorado.Renderer" : [ "class", "Renderer", true, false, "dorado" ],
	"dorado.Renderer#render" : [ "method", "render", false, false,
			"dorado.Renderer" ],
	"dorado.Renderer.NONE_RENDERER" : [ "object", "NONE_RENDERER", false,
			false, "dorado.Renderer" ],
	"dorado.ResourceException" : [ "class", "ResourceException", false, false,
			"dorado" ],
	"dorado.RunnableException" : [ "class", "RunnableException", false, false,
			"dorado" ],
	"dorado.RunnableException#script" : [ "property", "script", false, false,
			"dorado.RunnableException" ],
	"dorado.Setting" : [ "object", "Setting", false, false, "dorado" ],
	"dorado.TagManager" : [ "object", "TagManager", false, false, "dorado" ],
	"dorado.TagManager.find" : [ "method", "find", false, false,
			"dorado.TagManager" ],
	"dorado.TagManager.register" : [ "method", "register", false, false,
			"dorado.TagManager" ],
	"dorado.TagManager.unregister" : [ "method", "unregister", false, false,
			"dorado.TagManager" ],
	"dorado.Toolkits" : [ "object", "Toolkits", false, false, "dorado" ],
	"dorado.Toolkits.createInstance" : [ "method", "createInstance", false,
			false, "dorado.Toolkits" ],
	"dorado.Toolkits.getPrototype" : [ "method", "getPrototype", false, false,
			"dorado.Toolkits" ],
	"dorado.Toolkits.registerPrototype" : [ "method", "registerPrototype",
			false, false, "dorado.Toolkits" ],
	"dorado.Toolkits.translateURL" : [ "method", "translateURL", false, false,
			"dorado.Toolkits" ],
	"dorado.Toolkits.URL_VARS" : [ "property", "URL_VARS", false, false,
			"dorado.Toolkits" ],
	"dorado.util" : [ "namespace", "util", false, false, "dorado" ],
	"dorado.util.AjaxEngine" : [ "class", "AjaxEngine", false, false,
			"dorado.util" ],
	"dorado.util.AjaxEngine#attribute:autoBatchEnabled" : [ "attribute",
			"attribute:autoBatchEnabled", false, false,
			"dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#attribute:defaultOptions" : [ "attribute",
			"attribute:defaultOptions", false, false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#attribute:maxBatchSize" : [ "attribute",
			"attribute:maxBatchSize", false, false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#attribute:minConnectInterval" : [ "attribute",
			"attribute:minConnectInterval", false, false,
			"dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#event:beforeConnect" : [ "event",
			"event:beforeConnect", false, false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#event:beforeRequest" : [ "event",
			"event:beforeRequest", false, false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#event:onConnect" : [ "event", "event:onConnect",
			false, false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#event:onRequest" : [ "event", "event:onRequest",
			false, false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#request" : [ "method", "request", false, false,
			"dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#requestAsync" : [ "method", "requestAsync", false,
			false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxEngine#requestSync" : [ "method", "requestSync", false,
			false, "dorado.util.AjaxEngine" ],
	"dorado.util.AjaxException" : [ "class", "AjaxException", false, false,
			"dorado.util" ],
	"dorado.util.AjaxException#description" : [ "property", "description",
			false, false, "dorado.util.AjaxException" ],
	"dorado.util.AjaxException#message" : [ "property", "message", false,
			false, "dorado.util.AjaxException" ],
	"dorado.util.AjaxException#method" : [ "property", "method", false, false,
			"dorado.util.AjaxException" ],
	"dorado.util.AjaxException#status" : [ "property", "status", false, false,
			"dorado.util.AjaxException" ],
	"dorado.util.AjaxException#statusText" : [ "property", "statusText", false,
			false, "dorado.util.AjaxException" ],
	"dorado.util.AjaxException#url" : [ "property", "url", false, false,
			"dorado.util.AjaxException" ],
	"dorado.util.AjaxResult" : [ "class", "AjaxResult", false, false,
			"dorado.util" ],
	"dorado.util.AjaxResult#allResponseHeaders" : [ "property",
			"allResponseHeaders", false, false, "dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#exception" : [ "property", "exception", false,
			false, "dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#getJsonData" : [ "method", "getJsonData", false,
			false, "dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#getResponseHeaders" : [ "method",
			"getResponseHeaders", false, false, "dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#getXmlDocument" : [ "method", "getXmlDocument",
			false, false, "dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#method" : [ "property", "method", false, false,
			"dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#options" : [ "property", "options", false, false,
			"dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#status" : [ "property", "status", false, false,
			"dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#statusText" : [ "property", "statusText", false,
			false, "dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#success" : [ "property", "success", false, false,
			"dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#text" : [ "property", "text", false, false,
			"dorado.util.AjaxResult" ],
	"dorado.util.AjaxResult#url" : [ "property", "url", false, false,
			"dorado.util.AjaxResult" ],
	"dorado.util.ArrayIterator" : [ "class", "ArrayIterator", false, false,
			"dorado.util" ],
	"dorado.util.ArrayIterator#setNextIndex" : [ "method", "setNextIndex",
			false, false, "dorado.util.ArrayIterator" ],
	"dorado.util.Common" : [ "object", "Common", false, false, "dorado.util" ],
	"dorado.util.Common.formatFloat" : [ "method", "formatFloat", false, false,
			"dorado.util.Common" ],
	"dorado.util.Common.getClassType" : [ "method", "getClassType", false,
			false, "dorado.util.Common" ],
	"dorado.util.Common.getSingletonInstance" : [ "method",
			"getSingletonInstance", false, false, "dorado.util.Common" ],
	"dorado.util.Common.parseFloat" : [ "method", "parseFloat", false, false,
			"dorado.util.Common" ],
	"dorado.util.Dom" : [ "object", "Dom", false, false, "dorado.util" ],
	"dorado.util.Dom.bringToFront" : [ "method", "bringToFront", false, false,
			"dorado.util.Dom" ],
	"dorado.util.Dom.disableUserSelection" : [ "method",
			"disableUserSelection", false, false, "dorado.util.Dom" ],
	"dorado.util.Dom.enableUserSelection" : [ "method", "enableUserSelection",
			false, false, "dorado.util.Dom" ],
	"dorado.util.Dom.findParent" : [ "method", "findParent", false, false,
			"dorado.util.Dom" ],
	"dorado.util.Dom.getCellPosition" : [ "method", "getCellPosition", false,
			false, "dorado.util.Dom" ],
	"dorado.util.Dom.getInvisibleContainer" : [ "method",
			"getInvisibleContainer", false, false, "dorado.util.Dom" ],
	"dorado.util.Dom.getOwnerWindow" : [ "method", "getOwnerWindow", false,
			false, "dorado.util.Dom" ],
	"dorado.util.Dom.isOwnerOf" : [ "method", "isOwnerOf", false, false,
			"dorado.util.Dom" ],
	"dorado.util.Dom.locateIn" : [ "method", "locateIn", false, false,
			"dorado.util.Dom" ],
	"dorado.util.Dom.xCreateElement" : [ "method", "xCreateElement", false,
			false, "dorado.util.Dom" ],
	"dorado.util.Iterator" : [ "class", "Iterator", true, false, "dorado.util" ],
	"dorado.util.Iterator#createBookmark" : [ "method", "createBookmark",
			false, false, "dorado.util.Iterator" ],
	"dorado.util.Iterator#current" : [ "method", "current", false, false,
			"dorado.util.Iterator" ],
	"dorado.util.Iterator#first" : [ "method", "first", false, false,
			"dorado.util.Iterator" ],
	"dorado.util.Iterator#hasNext" : [ "method", "hasNext", false, false,
			"dorado.util.Iterator" ],
	"dorado.util.Iterator#hasPrevious" : [ "method", "hasPrevious", false,
			false, "dorado.util.Iterator" ],
	"dorado.util.Iterator#last" : [ "method", "last", false, false,
			"dorado.util.Iterator" ],
	"dorado.util.Iterator#next" : [ "method", "next", false, false,
			"dorado.util.Iterator" ],
	"dorado.util.Iterator#previous" : [ "method", "previous", false, false,
			"dorado.util.Iterator" ],
	"dorado.util.Iterator#restoreBookmark" : [ "method", "restoreBookmark",
			false, false, "dorado.util.Iterator" ],
	"dorado.util.KeyedArray" : [ "class", "KeyedArray", false, false,
			"dorado.util" ],
	"dorado.util.KeyedArray#append" : [ "method", "append", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#clear" : [ "method", "clear", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#clone" : [ "method", "clone", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#deepClone" : [ "method", "deepClone", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#each" : [ "method", "each", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#get" : [ "method", "get", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#indexOf" : [ "method", "indexOf", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#insert" : [ "method", "insert", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#items" : [ "property", "items", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#iterator" : [ "method", "iterator", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#remove" : [ "method", "remove", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#removeAt" : [ "method", "removeAt", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#replace" : [ "method", "replace", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#size" : [ "property", "size", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedArray#toArray" : [ "method", "toArray", false, false,
			"dorado.util.KeyedArray" ],
	"dorado.util.KeyedList" : [ "class", "KeyedList", false, false,
			"dorado.util" ],
	"dorado.util.KeyedList#append" : [ "method", "append", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#clear" : [ "method", "clear", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#clone" : [ "method", "clone", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#deepClone" : [ "method", "deepClone", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#each" : [ "method", "each", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#first" : [ "property", "first", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#get" : [ "method", "get", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#getFirst" : [ "method", "getFirst", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#getLast" : [ "method", "getLast", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#insert" : [ "method", "insert", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#iterator" : [ "method", "iterator", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#last" : [ "property", "last", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#remove" : [ "method", "remove", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#removeKey" : [ "method", "removeKey", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#size" : [ "property", "size", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedList#toArray" : [ "method", "toArray", false, false,
			"dorado.util.KeyedList" ],
	"dorado.util.KeyedListIterator" : [ "class", "KeyedListIterator", false,
			false, "dorado.util" ],
	"dorado.util.Map" : [ "class", "Map", false, false, "dorado.util" ],
	"dorado.util.Map#clear" : [ "method", "clear", false, false,
			"dorado.util.Map" ],
	"dorado.util.Map#eachKey" : [ "method", "eachKey", false, false,
			"dorado.util.Map" ],
	"dorado.util.Map#get" : [ "method", "get", false, false, "dorado.util.Map" ],
	"dorado.util.Map#keys" : [ "method", "keys", false, false,
			"dorado.util.Map" ],
	"dorado.util.Map#put" : [ "method", "put", false, false, "dorado.util.Map" ],
	"dorado.util.Map#remove" : [ "method", "remove", false, false,
			"dorado.util.Map" ],
	"dorado.util.Map#set" : [ "method", "set", false, false, "dorado.util.Map" ],
	"dorado.util.Map#toJSON" : [ "method", "toJSON", false, false,
			"dorado.util.Map" ],
	"dorado.util.ObjectPool" : [ "class", "ObjectPool", false, false,
			"dorado.util" ],
	"dorado.util.ObjectPool#borrowObject" : [ "method", "borrowObject", false,
			false, "dorado.util.ObjectPool" ],
	"dorado.util.ObjectPool#destroy" : [ "method", "destroy", false, false,
			"dorado.util.ObjectPool" ],
	"dorado.util.ObjectPool#getNumActive" : [ "method", "getNumActive", false,
			false, "dorado.util.ObjectPool" ],
	"dorado.util.ObjectPool#getNumIdle" : [ "method", "getNumIdle", false,
			false, "dorado.util.ObjectPool" ],
	"dorado.util.ObjectPool#returnObject" : [ "method", "returnObject", false,
			false, "dorado.util.ObjectPool" ],
	"dorado.util.Resource" : [ "object", "Resource", false, false,
			"dorado.util" ],
	"dorado.util.Resource.append" : [ "method", "append", false, false,
			"dorado.util.Resource" ],
	"dorado.util.Resource.get" : [ "method", "get", false, false,
			"dorado.util.Resource" ],
	"dorado.util.TaskGroupPanel" : [ "class", "TaskGroupPanel", false, false,
			"dorado.util" ],
	"dorado.util.TaskIndicator" : [ "object", "TaskIndicator", false, false,
			"dorado.util" ],
	"dorado.util.TaskIndicator.hideTaskIndicator" : [ "method",
			"hideTaskIndicator", false, false, "dorado.util.TaskIndicator" ],
	"dorado.util.TaskIndicator.registerTaskGroup" : [ "method",
			"registerTaskGroup", false, false, "dorado.util.TaskIndicator" ],
	"dorado.util.TaskIndicator.showTaskIndicator" : [ "method",
			"showTaskIndicator", false, false, "dorado.util.TaskIndicator" ],
	"dorado.util.TaskList#addTask" : [ "method", "addTask", false, false,
			"dorado.util.TaskList" ],
	"dorado.util.TaskList#hide" : [ "method", "hide", false, false,
			"dorado.util.TaskList" ],
	"dorado.util.TaskList#refreshInterval" : [ "method", "refreshInterval",
			false, false, "dorado.util.TaskList" ],
	"dorado.util.TaskList#removeTask" : [ "method", "removeTask", false, false,
			"dorado.util.TaskList" ],
	"dorado.util.TaskList#show" : [ "method", "show", false, false,
			"dorado.util.TaskList" ],
	"jQuery" : [ "object", "jQuery", false, false, "" ],
	"jQuery#addClassOnClick" : [ "method", "addClassOnClick", false, false,
			"jQuery" ],
	"jQuery#addClassOnFocus" : [ "method", "addClassOnFocus", false, false,
			"jQuery" ],
	"jQuery#addClassOnHover" : [ "method", "addClassOnHover", false, false,
			"jQuery" ],
	"jQuery#bottom" : [ "method", "bottom", false, false, "jQuery" ],
	"jQuery#bringToFront" : [ "method", "bringToFront", false, false, "jQuery" ],
	"jQuery#draggable" : [ "method", "draggable", false, false, "jQuery" ],
	"jQuery#droppable" : [ "method", "droppable", false, false, "jQuery" ],
	"jQuery#fullWindow" : [ "method", "fullWindow", false, false, "jQuery" ],
	"jQuery#left" : [ "method", "left", false, false, "jQuery" ],
	"jQuery#outerHeight" : [ "method", "outerHeight", false, false, "jQuery" ],
	"jQuery#outerWidth" : [ "method", "outerWidth", false, false, "jQuery" ],
	"jQuery#position" : [ "method", "position", false, false, "jQuery" ],
	"jQuery#repeatOnClick" : [ "method", "repeatOnClick", false, false,
			"jQuery" ],
	"jQuery#right" : [ "method", "right", false, false, "jQuery" ],
	"jQuery#safeSlideIn" : [ "method", "safeSlideIn", false, false, "jQuery" ],
	"jQuery#safeSlideOut" : [ "method", "safeSlideOut", false, false, "jQuery" ],
	"jQuery#shadow" : [ "method", "shadow", false, false, "jQuery" ],
	"jQuery#slideIn" : [ "method", "slideIn", false, false, "jQuery" ],
	"jQuery#slideOut" : [ "method", "slideOut", false, false, "jQuery" ],
	"jQuery#top" : [ "method", "top", false, false, "jQuery" ],
	"jQuery#unfullWindow" : [ "method", "unfullWindow", false, false, "jQuery" ],
	"jQuery#unshadow" : [ "method", "unshadow", false, false, "jQuery" ],
	"jQuery#xCreate" : [ "method", "xCreate", false, false, "jQuery" ]
}