SYMBOLS["_global_"] = {
	"name" : "_global_",
	"type" : "object",
	"desc" : null,
	"alias" : "_global_",
	"classDesc" : null,
	"properties" : [
			{
				"name" : "$setting",
				"type" : "dorado.Setting",
				"desc" : "dorado.Setting的快捷方式。",
				"alias" : "$setting",
				"author" : "Benny Bao (mailto:benny.bao@bstek.com)",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "var debugEnabled = $setting[\"core.debugEnabled\"]; // 相当于dorado.Setting[\"core.debugEnabled\"]"
				} ],
				"see" : [ "dorado.Setting" ],
				"visibility" : "public",
				"memberOf" : "_global_",
				"package" : "core"
			},
			{
				"name" : "$ajax",
				"type" : "property",
				"desc" : "默认的dorado.util.AjaxEngine实例。\r<p>\r很多情况下，我们建议您直接利用$ajax来完成Ajax操作，这样就不必频繁的创建dorado.util.AjaxEngine的对象实例了。\r</p>",
				"alias" : "$ajax",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "// 发起一个Ajax异步请求，使用Function作为回调对象。\r$ajax.request( {\r\turl : \"/delete-employee.do\",\r\tmethod : \"POST\",\r\tjsonData : [ \"0001\", \"0002\", \"0005\" ] // 定义要提交给服务器的信息\r}, function(result) {\r\talert(result.responseText);\r});"
				} ],
				"see" : [ "dorado.util.AjaxEngine" ],
				"visibility" : "public",
				"memberOf" : "_global_",
				"package" : "core"
			}, {
				"name" : "$DomUtils",
				"type" : "property",
				"desc" : "dorado.util.Dom的快捷方式。",
				"alias" : "$DomUtils",
				"see" : [ "dorado.util.Dom" ],
				"visibility" : "public",
				"memberOf" : "_global_",
				"package" : "core"
			} ],
	"attributes" : [],
	"methods" : [
			{
				"name" : "$fly",
				"type" : "method",
				"desc" : "根据传入的DOM元素返回一个jQuery的对象。\r<p>\r注意：与jQuery()或$()不同，$fly()为了提高效率并不总是返回新的jQuery对象的实例。\r因此，保留$fly()返回的实例变量不能保证我们能够一直操作同样的DOM元素。\r</p>",
				"alias" : "$fly",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "var elem1 = $fly(\"div1\");\relem1.text(\"Text A\"); // 将div1的内容设置为\"Text A\"。\r\rvar elem2 = $fly(\"div2\"); // 此处返回的elem2很可能和elem1是同一个jQuery实例。\relem2.text(\"Text B\"); // 将div2的内容设置为\"Text B\"。\r\relem1.text(\"Text C\"); // 很可能改写的不是div1的内容，而是div2的内容。"
				} ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "要包装的DOM元素或DOM元素的数组。",
					"type" : "HTMLElement|HTMLElement[]",
					"name" : "elems"
				} ],
				"returns" : {
					"desc" : "jQuery对象的实例。",
					"type" : "jQuery"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$create",
				"type" : "method",
				"desc" : "document.createElement()方法的快捷方式。",
				"alias" : "$create",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "var div = $create(\"DIV\"); // 相当于document.createElement(\"DIV\")"
				} ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "要创建的DOM元素的标签名。",
					"type" : "String",
					"name" : "tagName"
				} ],
				"returns" : {
					"desc" : "新创建的DOM元素。",
					"type" : "HTMLElement"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$scopify",
				"type" : "method",
				"desc" : "dorado.Core.scopify()方法的快捷方式。",
				"alias" : "$scopify",
				"example" : [
						{
							"title" : "example",
							"type" : "",
							"name" : "",
							"isOptional" : false,
							"defaultValue" : "",
							"desc" : "var s = \"hello!\";\r$scopify(s, \"alert(this)\")(); // should say \"hello!\""
						},
						{
							"title" : "example",
							"type" : "",
							"name" : "",
							"isOptional" : false,
							"defaultValue" : "",
							"desc" : "var s = \"hello!\";\r$scopify(s, function(){\r\t alert(this);\r})(); // should say \"hello!\""
						} ],
				"see" : [ "dorado.Core.scopify" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "调用时this对象。",
					"type" : "Object",
					"name" : "scope"
				}, {
					"desc" : "要处理的函数或文本形式表示的代码片段。",
					"type" : "Function|String",
					"name" : "fn"
				} ],
				"returns" : {
					"desc" : "代理函数。",
					"type" : "Function"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$setTimeout",
				"type" : "method",
				"desc" : "dorado.Core.setTimeout()方法的快捷方式。",
				"alias" : "$setTimeout",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "// should say \"hello!\" after one second.\rvar s = \"hello!\";\r$setTimeout(s, function() {\r\t alert(this);\r}, 1000);"
				} ],
				"see" : [ "dorado.Core.setTimeout" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "调用时this对象。",
					"type" : "Object",
					"name" : "scope"
				}, {
					"desc" : "要处理的函数或文本形式表示的代码片段。",
					"type" : "Function|String",
					"name" : "fn"
				}, {
					"desc" : "延时的时长（毫秒数）。",
					"type" : "int",
					"name" : "timeMillis"
				} ],
				"returns" : {
					"desc" : "延时任务的id。",
					"type" : "int"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$setInterval",
				"type" : "method",
				"desc" : "dorado.Core.setInterval()方法的快捷方式。",
				"alias" : "$setInterval",
				"see" : [ "dorado.Core.setInterval" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "调用时this对象。",
					"type" : "Object",
					"name" : "scope"
				}, {
					"desc" : "要处理的函数或文本形式表示的代码片段。",
					"type" : "Function|String",
					"name" : "fn"
				}, {
					"desc" : "定时任务的间隔（毫秒数）。",
					"type" : "int",
					"name" : "timeMillis"
				} ],
				"returns" : {
					"desc" : "定时任务的id。",
					"type" : "int"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$namespace",
				"type" : "method",
				"desc" : "dorado.Object.createNamespace()方法的快捷方式。\r详细用法请参考dorado.Object.createNamespace()的说明。",
				"alias" : "$namespace",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "// 创建新的名为\"dorado.sample\"的命名空间。\r$namespace(\"dorado.sample\");\r\r// 使用新创建的命名空间。\rdorado.sample.MyClass = function() {\r};"
				} ],
				"see" : [ "dorado.Object.createNamespace" ],
				"visibility" : "public",
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$class",
				"type" : "method",
				"desc" : "dorado.Object.createClass()方法的快捷方式。\r详细用法请参考dorado.Object.createClass()的说明。",
				"alias" : "$class",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "var MyClass = $class(\"MyClass\"， {\r\t\t// 构造方法\r\t\tconstructor: function(message) {\r\t\t\tthis.message = message;\r\t\t},\r\t\tgetMessage: function() {\r\t\t\treturn this.message;\r\t\t}\r\t});\rvar foo = new Foo(\"Hello world!\");\ralert(foo.getMessage());\t// should say \"Hello world!\";"
				} ],
				"see" : [ "dorado.Object.createClass" ],
				"visibility" : "public",
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$extend",
				"type" : "method",
				"desc" : "dorado.Object.extend()方法的快捷方式。\r详细用法请参考dorado.Object.extend()的说明。",
				"alias" : "$extend",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "// 从SuperClass派生并得到MyClass。\rvar MyClass = $extend(\"MyClass\", SuperClass, {\r\t// constructor是一个特殊的方法用于声明子类的构造方法。\r\tconstructor : function() {\r\t\t// 调用父类的构造方法。\r\t\tSubClass.superClass.constructor.call(this, arguments);\r\t\tthis.children = [];\r\t},\r\r\t// 这是一个子类自有的方法。\r\tgetChildren : function() {\r\t\treturn this.children;\r\t}\r});"
				} ],
				"see" : [ "dorado.Object.extend" ],
				"visibility" : "public",
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$getSuperClass",
				"type" : "method",
				"desc" : "返回当前对象的超类。对于多重继承而言，此方法返回第一个超类。\r<p>\r注意：此方法的调用必须放在类方法内部才有效。\r</p>",
				"alias" : "$getSuperClass",
				"visibility" : "public",
				"returns" : {
					"desc" : "超类。",
					"type" : "Function"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$getSuperClasses",
				"type" : "method",
				"desc" : "返回当前对象的超类的数组。\r<p>\r注意：此方法的调用必须放在类方法内部才有效。\r</p>",
				"alias" : "$getSuperClasses",
				"visibility" : "public",
				"returns" : {
					"desc" : "超类的数组。",
					"type" : "Prototype[]"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$invokeSuper",
				"type" : "method",
				"desc" : "调用当前方法在超类中的实现逻辑。\r<p>\r注意此方法的调用必须放在类方法内部才有效。<br>\r另外，此方法必须通过call语法进行调用，见示例。\r</p>",
				"alias" : "$invokeSuper",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "$invokeSuper.call(this, arguments); // 较简单的调用方式\r$invokeSuper.call(this, [ \"Sample Arg\", true ]); // 自定义传给超类方法的参数数组"
				} ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "调用超类方法时的宿主对象。一般应直接传入this。",
					"type" : "Object",
					"name" : "scope"
				}, {
					"desc" : "调用超类方法时的参数数组。很多情况下我们可以直接传入arguments。",
					"type" : "Object[]",
					"name" : "args",
					"isOptional" : true
				} ],
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$callback",
				"type" : "method",
				"desc" : "的快捷方式。",
				"alias" : "$callback",
				"see" : [ "dorado.Callback#invokeCallback" ],
				"visibility" : "public",
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$group",
				"type" : "method",
				"desc" : "创建一个对象组。new dorado.ObjectGroup()操作的快捷方式。",
				"alias" : "$group",
				"see" : [ "dorado.ObjectGroup" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "要进行的组合的对象的数组。",
					"type" : "Object..",
					"name" : "objects"
				} ],
				"returns" : {
					"desc" : "新创建的对象组。",
					"type" : "dorado.ObjectGroup"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$tag",
				"type" : "method",
				"desc" : "返回所有具有某一指定标签的对象的对象组。dorado.TagManager.find()方法的快捷方式。",
				"alias" : "$tag",
				"example" : [ {
					"title" : "example",
					"type" : "",
					"name" : "",
					"isOptional" : false,
					"defaultValue" : "",
					"desc" : "// 寻找所有具有limited标签的对象，并统一设置他们的readOnly属性。\r$tag(\"limited\").set(\"readOnly\", true);"
				} ],
				"see" : [ "dorado.TagManager.find" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "标签值。",
					"type" : "String",
					"name" : "tags"
				} ],
				"returns" : {
					"desc" : "对象组。",
					"type" : "dorado.ObjectGroup"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$url",
				"type" : "method",
				"desc" : "dorado.Toolkits.translateURL()方法的快捷方式。\r详细用法请参考dorado.Toolkits.translateURL()的说明。",
				"alias" : "$url",
				"see" : [ "dorado.Toolkits.translateURL" ],
				"visibility" : "public",
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$singleton",
				"type" : "method",
				"desc" : "dorado.util.Common.getSingletonInstance()方法的快捷方式。",
				"alias" : "$singleton",
				"see" : [ "dorado.util.Common.getSingletonInstance" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "单例对象的类型名或创建工厂。",
					"type" : "String|Object",
					"name" : "factory"
				} ],
				"returns" : {
					"desc" : "单例对象的实例。",
					"type" : "Object"
				},
				"package" : "core",
				"memberOf" : "_global_"
			},
			{
				"name" : "$resource",
				"type" : "method",
				"desc" : "dorado.util.Resource.get()的快捷方式。根据给定的资源路径和一组参数返回资源字符串。",
				"alias" : "$resource",
				"example" : [
						{
							"title" : "example",
							"type" : "",
							"name" : "",
							"isOptional" : false,
							"defaultValue" : "",
							"desc" : "// 提取名默认命名空间中的property1代表的字符串\rvar text = $resource(\"property1\");"
						},
						{
							"title" : "example",
							"type" : "",
							"name" : "",
							"isOptional" : false,
							"defaultValue" : "",
							"desc" : "// 提取名为命名空间xxx.yyy.zzz中的property1代表的字符串\rvar text = $resource(\"xxx.yyy.zzz.property1\");"
						},
						{
							"title" : "example",
							"type" : "",
							"name" : "",
							"isOptional" : false,
							"defaultValue" : "",
							"desc" : "// 假设xxx.yyy.zzz.property1所代表的资源字符串是\"My name is {0}, I'm {1} years old.\"，\r// 此方法将返回\"My name is John, I'm 5 years old.\"\rvar text = $resource(\"xxx.yyy.zzz.property1\", \"John\", 5);"
						} ],
				"see" : [ "dorado.util.Resource#get" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "由命名空间+资源项名称组成的资源路径。",
					"type" : "String",
					"name" : "path"
				}, {
					"desc" : "一到多个参数。",
					"type" : "Object",
					"name" : "args...",
					"isOptional" : true
				} ],
				"returns" : {
					"desc" : "资源字符串。",
					"type" : "String"
				},
				"package" : "core",
				"memberOf" : "_global_"
			}, {
				"name" : "$map",
				"type" : "method",
				"desc" : "用于将一个JSON对象包装成dorado的仿Map对象。",
				"alias" : "$map",
				"see" : [ "dorado.util.Map" ],
				"visibility" : "public",
				"params" : [ {
					"desc" : "此参数应是一个JSON对象，其中定义的所有属性会自动的被添加到Map中。",
					"type" : "Object",
					"name" : "用于初始化Map键值对的参数。"
				} ],
				"returns" : {
					"desc" : "仿Map对象。",
					"type" : "dorado.util.Map"
				},
				"package" : "core",
				"memberOf" : "_global_"
			} ],
	"constructors" : [],
	"events" : []
}