SYMBOLS["Array"]={"name":"Array","type":"class","desc":null,"alias":"Array","classDesc":"为系统的数组提供的prototype扩展。\r<p>\r<b>注意：此处的文档只描述了扩展的部分，并未列出数组对象所支持的所有属性方法。</b>\r</p>","package":"core","properties":[],"attributes":[],"methods":[{"name":"push","type":"method","desc":"向数组的末尾追加一个元素。\r<p>\r<b>大部分浏览器中JavaScript引擎已经支持此方法，dorado扩展的目的仅针对那些原本不支持此方法的浏览器。</b>\r</p>","alias":"Array#push","visibility":"public","params":[{"desc":"要追加的元素。","type":"Object","name":"element"}],"package":"core","memberOf":"Array"},{"name":"indexOf","type":"method","desc":"返回某元素在数组中第一次出现的下标位置。\r<p>\r<b>大部分浏览器中JavaScript引擎已经支持此方法，dorado扩展的目的仅针对那些原本不支持此方法的浏览器。</b>\r</p>","alias":"Array#indexOf","visibility":"public","params":[{"desc":"要寻找的元素。","type":"Object","name":"element"}],"returns":{"desc":"元素的下标位置。","type":"int"},"package":"core","memberOf":"Array"},{"name":"remove","type":"method","desc":"从数组删除某元素。\r<p>\r如果要删除的元素并不存在于数组中，那么此方法什么都不会做，并且返回值为-1。<br/>\r 如果要删除的元素在于数组中出现多次，那么此方法只删除元素第一次出现的位置，并返回该位置的下标。\r</p>","alias":"Array#remove","visibility":"public","params":[{"desc":"要删除的元素。","type":"Object","name":"element"}],"returns":{"desc":"被删除元素原先的下标位置。","type":"int"},"package":"core","memberOf":"Array"},{"name":"removeAt","type":"method","desc":"从数组删除某下标位置处的元素。\r<p>\r此方法删除某下标位置后，后面的元素会自动递补，最终数组的长度会缩小1个单位。\r</p>","alias":"Array#removeAt","visibility":"public","params":[{"desc":"要删除的下标位置。","type":"int","name":"i"}],"package":"core","memberOf":"Array"},{"name":"insert","type":"method","desc":"向数组中的指定位置插入一个元素。\r<p>\r插入元素后，原插入位置开始的元素会自动后退，最终数组的长度会增加1个单位。\r</p>","alias":"Array#insert","visibility":"public","params":[{"desc":"要插入的元素。","type":"Object","name":"element"},{"desc":"要插入的下标位置。","type":"Object","name":"i","isOptional":true,"defaultValue":"0"}],"package":"core","memberOf":"Array"},{"name":"peek","type":"method","desc":"返回数组中的最后一个元素。","alias":"Array#peek","visibility":"public","returns":{"desc":"最后一个元素。","type":"Object"},"package":"core","memberOf":"Array"},{"name":"each","type":"method","desc":"遍历数组。","alias":"Array#each","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var s = '';\r['A', 'B', 'C'].each(function(item) {\r\ts += item;\r});\r// s == \"ABC\""}],"visibility":"public","params":[{"desc":"针对数组中每一个元素的回调函数。此函数支持下列两个参数:\r<ul>\r<li>item - {Object} 当前遍历到的数据元素。</li>\r<li>[i] - {int} 当前遍历到的数据下标。</li>\r</ul>\r另外，此函数的返回值可用于通知系统是否要终止整个遍历操作。\r返回true或不返回任何数值表示继续执行遍历操作，返回false表示终止整个遍历操作。<br/>\r此回调函数中的this指向正在被遍历的数组。","type":"Function","name":"fn"}],"package":"core","memberOf":"Array"}],"constructors":[],"events":[]}