SYMBOLS["Date"]={"name":"Date","type":"class","desc":null,"alias":"Date","classDesc":"为系统日期对象提供格式化输入输出支持的prototype扩展。\r<p>\r<b>注意：此处的文档只描述了扩展的部分，并未列出日期对象所支持的所有属性方法。</b>\r</p>\r<p>\r格式化输入输出日期值时，都需要使用格式化字符串。此处的格式化字符串支持下列具有特殊含义的字符：\r<ul>\r<li>d - 补足到两位的以数字表示的日期，即年月日中的日。</li>\r<li>D - 以文字缩写表示的星期几。</li>\r<li>j - 以数字表示日期，即年月日中的日。</li>\r<li>l - 以文字表示的星期几。</li>\r<li>S - 当前时间对象中天的英文序数后缀，返回值为 'st', 'nd', 'rd' 或 'th'。</li>\r<li>w - 以数字表示的星期几。</li>\r<li>z - 日期是当年中的第几天。</li>\r<li>W - 日期在当年中的第几周。</li>\r<li>F - 以文字表示的月份。</li>\r<li>m - 补足到两位的以数字表示的月份。</li>\r<li>M - 以文字缩写表示的月份。</li>\r<li>n - 以数字表示的月份。</li>\r<li>t - 日期是当月中的第几天。</li>\r<li>L - 以1和0表示是否闰年。</li>\r<li>Y - 年份。</li>\r<li>y - 年份的缩写。</li>\r<li>a - 以am、pm表示的上午、下午。</li>\r<li>A - 以AM、PM表示的上午、下午。</li>\r<li>g - 以数字表示的12进制小时。</li>\r<li>G - 以数字表示的24进制小时。</li>\r<li>h - 补足到两位的以数字表示的12进制小时。</li>\r<li>H - 补足到两位的以数字表示的24进制小时。</li>\r<li>i - 补足到两位的以数字表示的分钟。</li>\r<li>s - 补足到两位的以数字表示的秒数。</li>\r<li>O - 时区偏移字符串，格式如：'+0800'。</li>\r<li>T - 时区名，如 'CST', 'PDT', 'EDT' 等。</li>\r<li>Z - 以秒钟表示的与格林威治时间的时差。</li>\r</ul>\r</p>","package":"core","properties":[],"attributes":[],"methods":[{"name":"formatDate","type":"method","desc":"格式化输出日期值。","alias":"Date#formatDate","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var date = new Date();\rdate.formatDate(\"Y-m-d\");    // 返回类似\"2000-09-25\"的字符串\rdate.formatDate(\"H:i:s\");    // 返回类似\"23:10:30\"的字符串\rdate.formatDate(\"Y年m月d日 H点i分s秒\");    // 返回类似\"2000年09月25日 23点10分30秒\"的字符串"}],"visibility":"public","params":[{"desc":"格式化字符串。","type":"String","name":"format"}],"returns":{"desc":"格式化后的日期字符串。","type":"String"},"package":"core","memberOf":"Date"},{"name":"parseDate","type":"method","desc":"根据给定的格式尝试将一段日期字符串解析为日期值。","alias":"Date.parseDate","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var date1 = Date.parseDate(\"2000-09-25\", \"Y-m-d\");\rvar date2 = Date.parseDate(\"20000925\", \"Ymd\");\rvar date3 = Date.parseDate(\"2000-09-25 23:10:30\", \"Y-m-d H:i:s\");"}],"visibility":"public","params":[{"desc":"要解析的日期字符串。","type":"String","name":"input"},{"desc":"格式化字符串。","type":"String","name":"format"}],"returns":{"desc":"日期值。","type":"Date"},"package":"core","isStatic":true,"memberOf":"Date"}],"constructors":[],"events":[]}