SYMBOLS["_global_"]={"name":"_global_","type":"object","desc":null,"alias":"_global_","classDesc":null,"properties":[{"name":"$packagesConfig","type":"Object","desc":"用于为$import方法定义参数和待装载的包的对象。\r该对象中包含下列子属性：\r<ul>\r<li>contextPath - {String} 应用的根路径。</li>\r<li>defaultContentType - {String} 资源默认的content-type头信息，即用于表示资源类型的字符串。\r目前支持的资源类型包括：\"text/javascript\"、\"text/css\"。此属性的默认值为\"text/javascript\"。</li>\r<li>defaultCharset - {String} 资源默认的字符集。默认值为空，即不对资源的字符集做任何处理。</li>\r<li>patterns - {Object} 用于定义一些可命名的资源路径的格式(Pattern)，以便于为一组相似的资源提供统一的配置。当我们要启用资源文件的合并装载功能时，Pattern也将被系统用于判断究竟哪些资源是可以被合并在一起下载的。\r每一个Pattern都是一个子对象，该对象又可包含下列子属性：\r<ul>\r<li>name - {String} 某个Pattern的名称。注意：此名称在定义时并不是作为Pattern对象的name属性存在的，它事实上是patterns的一个属性，见示例。<br/>\r另外，如果定义了一个名为\"default\"的Pattern，那么该Pattern将被作为默认的Pattern应用到那些未明确引用Pattern的Package上。</li>\r<li>url - {String} 资源路径的格式，其中可以${fileName}代替实际的文件名或子路径。</li>\r<li>contentType - {String} 所有引用此资源路径的包文件的默认content-type头信息。\r此属性的默认值是text/javascript，因此对于JavaScript文件而言不需要特别指定此属性，而对于CSS文件而言则必须指定为text/css。</li>\r<li>charset - {String} 所有引用此资源路径的包文件的默认字符集。</li>\r<li>mergeRequests - {boolean} 是否要将引用此资源路径的、相邻的各个包合并成为一个Http请求，此功能可用于优化网络通讯，但需服务器提供相应的支持。</li>\r</ul>\r</li>\r<li>packages - {Object} 用于定义所有资源包(Package)。\r每一个资源包可以包含一个或多个资源文件，但必须同类型的文件。例如我们不能把JavaScript文件和CSS文件定义在一个资源包中。\r每一个的资源包的配置都是一个子对象，该对象又可包含下列子属性：\r<ul>\r<li>name - {String} 某个Package的名称。注意：此名称在定义时并不是作为Package对象的name属性存在的，它事实上是packages的一个属性，见示例。</li>\r<li>fileName - {String|String[]} 此Package的实际文件名或路径。默认值与Package的名称相同。\r如果此Package引用了某个Pattern，那么该属性的值最终将被替换到Pattern的url属性中，并以替换后的字符串作为最终的资源路径。</li>\r<li>pattern - {String 此Package引用的Pattern。如果不指定此参数则将引用默认的Pattern。</li>\r<li>contentType - {String} Package文件的content-type头信息。</li>\r<li>charset - {String} Package文件的字符集 。</li>\r<li>depends - {String|String[]} 依赖的Package的名称，即该Package依赖于哪些其他的Package。如用String来定义，多个Package的名称之间用\",\"分隔。\r如果一个Package A依赖于Package B，那么当我们指定装载Package A时，$import()会首先自动装载Package B。</li>\r</ul>\r</li>\r</ul>\r<p>\r$import方法并不要求所有的资源包都必须在packages中定义，当我们尝试引入一个未定义的Package时，$import会认为其fileName就是Package的名称，并且引用默认的Pattern。\r</p>","alias":"$packagesConfig","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"$packagesConfig.defaultCharset = \"UTF-8\";"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"$packagesConfig.patterns = {\r\t \"js\": { url: \"/lib/javascript/${fileName}.js\" },\r\t \"css\": { url: \"/lib/css/${fileName}.css\", contentType: \"text/css\" }\r};\r\r$packagesConfig.packages = {\r\t \"skin\": { pattern: \"css\" },\r\t \"jquery\": { pattern: \"js\", fileName: \"jquery-1.2.6\" },\r\t \"jquery.ui\": { pattern: \"js\", depends: \"jquery,skin\" },\r};\r\r// 将一同装载skin.css、jquery-1.2.6.js、jquery.ui.js这三个文件\r$import(\"jquery.ui\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 本段示例的效果同上一段完全一致\r$packagesConfig.patterns = {\r\t \"default\": { url: \"/lib/javascript/${fileName}\" },\r\t \"css\": { url: \"/lib/css/${fileName}\", contentType: \"text/css\" }\r};\r\r$packagesConfig.packages = {\r\t \"skin.css\": { pattern: \"css\" },\r\t \"jquery.js\": { fileName: \"jquery-1.2.6.js\" },\r\t \"jquery.ui.js\": { depends: [\"jquery.js\", \"skin.css\"] },\r};\r\r// 将一同装载skin.css、jquery-1.2.6.js、jquery.ui.js这三个文件\r$import(\"jquery.ui.js\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用未定义的package\r$packagesConfig.patterns = {\r\t \"default\" : {\r\t\t url : \"/lib/javascript/${fileName}\"\r\t }\r};\r\r// 将装载/lib/javascript/core.js、/lib/javascript/utils.js这两个文件。\r$import(\"core.js,utils.js\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用根路径的配置，配合路径中\">\"符简化路径的定义方式。\r$packagesConfig.contextPath = \"/dorado\";\r$packagesConfig.patterns = {\r\t \"default\" : {\r\t\turl : \">/lib/javascript/${fileName}\"\r\t }\r}\r// 将装载/lib/javascript/core.js、/lib/javascript/utils.js这两个文件。\r$import(\"core.js,utils.js\");"}],"see":["$import"],"visibility":"public","memberOf":"_global_","package":"boot"},{"name":"$setting","type":"dorado.Setting","desc":"dorado.Setting的快捷方式。","alias":"$setting","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var debugEnabled = $setting[\"common.debugEnabled\"]; // 相当于dorado.Setting[\"common.debugEnabled\"]"}],"see":["dorado.Setting"],"visibility":"public","memberOf":"_global_","package":"core"},{"name":"$ajax","type":"property","desc":"默认的dorado.util.AjaxEngine实例。\r<p>\r很多情况下，我们建议您直接利用$ajax来完成Ajax操作，这样就不必频繁的创建dorado.util.AjaxEngine的对象实例了。\r</p>","alias":"$ajax","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 发起一个Ajax异步请求，使用Function作为回调对象。\r$ajax.request( {\r\turl : \"/delete-employee.do\",\r\tmethod : \"POST\",\r\tjsonData : [ \"0001\", \"0002\", \"0005\" ] // 定义要提交给服务器的信息\r}, function(result) {\r\talert(result.responseText);\r});"}],"see":["dorado.util.AjaxEngine"],"visibility":"public","memberOf":"_global_","package":"core"},{"name":"$DomUtils","type":"property","desc":"dorado.util.Dom的快捷方式。","alias":"$DomUtils","see":["dorado.util.Dom"],"visibility":"public","memberOf":"_global_","package":"core"},{"name":"finalTop","type":"property","desc":"+ $fly(element.offsetParent).scrollLeft()","alias":"finalTop","visibility":"public","memberOf":"_global_","package":"core"},{"name":"modalKey","type":"property","desc":"dorado.Browser.isTouch && (dorado.Browser.iOS || dorado.Browser.android)","alias":"modalKey","visibility":"public","memberOf":"_global_","package":"widget-support"}],"attributes":[],"methods":[{"name":"$import","type":"method","desc":"根据包名导入(装载)一个或一组来自服务端的资源，此处的资源一般指JavaScript库文件或CSS文件。\r<p>\r$import可以支持同步和异步两种方式来装载服务端的资源。\r$import使用同步还是异步方式来装载资源取决于是否在调用时为方法提供了回调方法。当提供了回调方法时$import将按照异步方式执行，否则将以同步方式执行。\r但是，在这两种装载方式中，您并不能完全随意的进行自主选择。<br/>\r当我们在页面装载完毕之前调用$import时，即在window.onload事件触发之前调用$import时，您可以根据需要选择同步和异步方式来装载资源。\r一般而言，对于在页面初始过程中就要用到javascript库或css文件，我们建议您使用同步方式。<br/>\r当我们在页面装载完毕之后调用$import时，即在window.onload事件触发之后或直接在window.onload事件中调用$import时，您只能使用异步方式来装载资源。\r尽管在技术上，确实有方法可以在此时利用同步方式来装载资源，但是受制于浏览器自身的缺陷，此时以同步方式装载的资源无法正常的支持开发阶段的JavaScript调试。\r为了避免由此导致的调试陷阱令项目陷入困境，我们不得不放弃了对此种模式的支持。\r</p>\r<p>\r注意：当您在网页中引入boot.js时，应该确保其对应的script标记位于所有其他直接引入javascript库的script标记之前。<br/>\r例如，必须确保boot.js先于jquery.js被引入到网页中，否则可能导致$import方法无法正确的判断页面是否装载完毕的状态。<br/>\r当然，一般而言，如果您已经使用了boot.js，我们建议你将其他所有需要引入的javascript库都设置为通过$import而不是script标记来装载。\r</p>\r<p>\r$import方法并不总是为每一个资源发起一个Http请求，利用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$packagesConfig')\">$packagesConfig</A>中的设置，我们可以将一组资源包装成一个Http请求以优化对网络的使用。\r不过这一功能需要服务器端提供相应的支持才能正常运作。\r</p>\r<p>\r$import方法可以管理各个资源的装载状态，您不必担心因为调用$import的方式不合理而导致资源被重复装载。\r</p>","alias":"$import","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"<script lang=\"javascript\">\r// 同步模式装载一个名为\"dorado.core\"的package\r$import(\"dorado.core\");\r// 由于浏览器内部实现机制的原因，在这里我们暂时仍不能使用\"dorado.core\"中的内容，尽管我们使用的同步装载模式。\r</script>\r<script lang=\"javascript\">\r// 此处可使用\"dorado.core\"中的内容\r</script>"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 我们不推荐以下面的方式调用$import方法：\r$import(\"dorado.core\");\r$import(\"dorado.data\");\r\r// 应该采用如下的同步方式：\r$import(\"dorado.core,dorado.data\");\r// 或如下的异步方式：\r$import(\"dorado.core,dorado.data\", function() {\r\t ... ... ...\r});\r\r// 这样做的目的有两个：\r// 1. 便于$import对Http请求进行优化\r// 2. 如果我们使用异步方式来装载一组资源，这应该是唯一可行的使用方法。"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 异步模式装载名为\"dorado.core\"和\"dorado.data\"的两个package\r$import(\"dorado.core,dorado.data\", function() {\r\t // 此处即可使用\"dorado.core\"或\"dorado.data中的内容\r\t });\r// 此处不可以使用\"dorado.core\"或\"dorado.data中的内容"}],"see":["$packagesConfig"],"visibility":"public","params":[{"desc":"要导入(装载)的包名。通过以\",\"分隔的字符串方式也可以定义多个包名。","type":"String","name":"pkgs"},{"desc":"回调函数或执行选项。\r<p>\r此参数具有两种定义方式:\r<ul>\r<li>如果定义此参数为回调函数，那么该函数将在装载过程完成之后被激活。</li>\r<li>如果定义此参数为执行选项，那么该选项对象中可包含一系列子属性。</li>\r</ul>\r如果$import方法在options参数中找到了回调函数，或者options参数本身就是回调函数，那么$import方法将按照异步的方式来装载资源，\r否则，$import方法将按照同步的方式来装载资源。\r<p>","type":"Function|Object","name":"options","isOptional":true},{"desc":"回调函数。","type":"Function","name":"options.callback","isOptional":true},{"desc":"回调函数的调用宿主。即回调函数在执行时，其中this的指向。","type":"Object","name":"options.scope","isOptional":true}],"package":"boot","memberOf":"_global_"},{"name":"$load","type":"method","desc":"直接根据url装载一个或一组JavaScript库文件或CSS文件。\r<p>\r$load可以支持同步和异步两种方式来装载服务端的资源。但是，在这两种装载方式中，您并不能完全随意的进行自主选择。<br/>\r当我们在页面装载完毕之前调用$load时，即在window.onload事件触发之前调用$load时，您可以根据需要选择同步和异步方式来装载资源。\r一般而言，对于在页面初始过程中就要用到javascript库或css文件，我们建议您使用同步方式。<br/>\r当我们在页面装载完毕之后调用$load时，即在window.onload事件触发之后或直接在window.onload事件中调用$load时，您只能使用异步方式来装载资源。\r尽管在技术上，确实有方法可以在此时利用同步方式来装载资源，但是受制于浏览器自身的缺陷，此时已同步方式装载的资源无法正常的支持开发阶段的JavaScript调试。\r为了避免由此导致的调试陷阱令项目陷入困境，我们不得不放弃了对此种模式的支持。\r</p>","alias":"$load","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 装载两个javascript文件和一个css文件\r$load(\"scripts/jquery.js,scripts/json2.js,styles/skin.css\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 装载两个javascript文件和一个css文件\r$load([\"scripts/jquery.js\", \"scripts/json2.js\", \"styles/skin.css\"]);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 通过options参数指定资源类型\r$load([\"load-css.do?res=common\", \"load-css.do?res=skin\"], \"css\");"}],"visibility":"public","params":[{"desc":"要装载的资源的url或url的数组。通过以\",\"分隔的字符串方式也可以定义多个资源。\r<p>通常情况下，系统可以自动的根据某资源url的后缀是否js或css来判断该资源是JavaScript库还是CSS文件。\r但在部分场景中此方法可能不能正确的判断资源的具体类型，此时我们可以通过options参数来指定资源类型。</p>","type":"String|String[]","name":"urls"},{"desc":"资源类型或回调函数或执行选项。\r<p>\r此参数具有三种定义方式:\r<ul>\r<li>如果定义此参数为字符串，那么此参数将被识别为资源的类型。</li>\r<li>如果定义此参数为回调函数，那么该函数将在装载过程完成之后被激活。</li>\r<li>如果定义此参数为执行选项，那么该选项对象中可包含一系列子属性。</li>\r</ul>\r如果$import方法在options参数中找到了回调函数，或者options参数本身就是回调函数，那么$import方法将按照异步的方式来装载资源，\r否则，$import方法将按照同步的方式来装载资源。\r<p>","type":"String|Function|Object","name":"options","isOptional":true},{"desc":"资源类型。取值包括：js、css。","type":"String","name":"options.type","isOptional":true,"defaultValue":"\"js\""},{"desc":"资源的content-type头信息。如果定义了此参数，那么options.type参数的值将会失效。","type":"String","name":"options.contentType","isOptional":true,"defaultValue":"\"text/javascript\""},{"desc":"资源的字符集。","type":"String","name":"options.charset","isOptional":true},{"desc":"回调函数。","type":"Function","name":"options.callback","isOptional":true},{"desc":"回调函数的调用宿主。即回调函数在执行时，其中this的指向。","type":"Object","name":"options.scope","isOptional":true}],"package":"boot","memberOf":"_global_"},{"name":"$fly","type":"method","desc":"根据传入的DOM元素返回一个jQuery的对象。\r             <p>\r             注意：与jQuery()或$()不同，$fly()为了提高效率并不总是返回新的jQuery对象的实例。\r             因此，保留$fly()返回的实例变量不能保证我们能够一直操作同样的DOM元素。\r             </p>","alias":"$fly","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var elem1 = $fly(\"div1\"); elem1.text(\"Text A\"); //\r         将div1的内容设置为\"Text A\"。\r\rvar elem2 = $fly(\"div2\"); // 此处返回的elem2很可能和elem1是同一个jQuery实例。\relem2.text(\"Text B\"); // 将div2的内容设置为\"Text B\"。\r\relem1.text(\"Text C\"); // 很可能改写的不是div1的内容，而是div2的内容。"}],"visibility":"public","params":[{"desc":"要包装的DOM元素或DOM元素的数组。","type":"HTMLElement|HTMLElement[]","name":"elems"}],"returns":{"desc":"jQuery对象的实例。","type":"jQuery"},"package":"core","memberOf":"_global_"},{"name":"$create","type":"method","desc":"document.createElement()方法的快捷方式。","alias":"$create","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var div = $create(\"DIV\"); // 相当于document.createElement(\"DIV\")"}],"visibility":"public","params":[{"desc":"要创建的DOM元素的标签名。","type":"String","name":"tagName"}],"returns":{"desc":"新创建的DOM元素。","type":"HTMLElement"},"package":"core","memberOf":"_global_"},{"name":"$scopify","type":"method","desc":"dorado.Core.scopify()方法的快捷方式。","alias":"$scopify","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var s = \"hello!\";\r$scopify(s, \"alert(this)\")(); // should say \"hello!\""},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var s = \"hello!\";\r$scopify(s, function(){\r\t alert(this);\r})(); // should say \"hello!\""}],"see":["dorado.Core.scopify"],"visibility":"public","params":[{"desc":"调用时this对象。","type":"Object","name":"scope"},{"desc":"要处理的函数或文本形式表示的代码片段。","type":"Function|String","name":"fn"}],"returns":{"desc":"代理函数。","type":"Function"},"package":"core","memberOf":"_global_"},{"name":"$setTimeout","type":"method","desc":"dorado.Core.setTimeout()方法的快捷方式。","alias":"$setTimeout","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// should say \"hello!\" after one second.\rvar s = \"hello!\";\r$setTimeout(s, function() {\r\t alert(this);\r}, 1000);"}],"see":["dorado.Core.setTimeout"],"visibility":"public","params":[{"desc":"调用时this对象。","type":"Object","name":"scope"},{"desc":"要处理的函数或文本形式表示的代码片段。","type":"Function|String","name":"fn"},{"desc":"延时的时长（毫秒数）。","type":"int","name":"timeMillis"}],"returns":{"desc":"延时任务的id。","type":"int"},"package":"core","memberOf":"_global_"},{"name":"$setInterval","type":"method","desc":"dorado.Core.setInterval()方法的快捷方式。","alias":"$setInterval","see":["dorado.Core.setInterval"],"visibility":"public","params":[{"desc":"调用时this对象。","type":"Object","name":"scope"},{"desc":"要处理的函数或文本形式表示的代码片段。","type":"Function|String","name":"fn"},{"desc":"定时任务的间隔（毫秒数）。","type":"int","name":"timeMillis"}],"returns":{"desc":"定时任务的id。","type":"int"},"package":"core","memberOf":"_global_"},{"name":"$namespace","type":"method","desc":"dorado.Object.createNamespace()方法的快捷方式。\r详细用法请参考dorado.Object.createNamespace()的说明。","alias":"$namespace","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 创建新的名为\"dorado.sample\"的命名空间。\r$namespace(\"dorado.sample\");\r\r// 使用新创建的命名空间。\rdorado.sample.MyClass = function() {\r};"}],"see":["dorado.Object.createNamespace"],"visibility":"public","package":"core","memberOf":"_global_"},{"name":"$class","type":"method","desc":"dorado.Object.createClass()方法的快捷方式。\r详细用法请参考dorado.Object.createClass()的说明。","alias":"$class","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var MyClass = $class(\"MyClass\"， {\r\t\t// 构造方法\r\t\tconstructor: function(message) {\r\t\t\tthis.message = message;\r\t\t},\r\t\tgetMessage: function() {\r\t\t\treturn this.message;\r\t\t}\r\t});\rvar foo = new Foo(\"Hello world!\");\ralert(foo.getMessage());    // should say \"Hello world!\";"}],"see":["dorado.Object.createClass"],"visibility":"public","package":"core","memberOf":"_global_"},{"name":"$extend","type":"method","desc":"dorado.Object.extend()方法的快捷方式。\r详细用法请参考dorado.Object.extend()的说明。","alias":"$extend","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 从SuperClass派生并得到MyClass。\rvar MyClass = $extend(\"MyClass\", SuperClass, {\r\t// constructor是一个特殊的方法用于声明子类的构造方法。\r\tconstructor : function() {\r\t\t// 调用父类的构造方法。\r\t\tSubClass.superClass.constructor.call(this, arguments);\r\t\tthis.children = [];\r\t},\r\r\t// 这是一个子类自有的方法。\r\tgetChildren : function() {\r\t\treturn this.children;\r\t}\r});"}],"see":["dorado.Object.extend"],"visibility":"public","package":"core","memberOf":"_global_"},{"name":"$getSuperClass","type":"method","desc":"返回当前对象的超类。对于多重继承而言，此方法返回第一个超类。\r<p>\r注意：此方法的调用必须放在类方法内部才有效。\r</p>","alias":"$getSuperClass","visibility":"public","returns":{"desc":"超类。","type":"Function"},"package":"core","memberOf":"_global_"},{"name":"$getSuperClasses","type":"method","desc":"返回当前对象的超类的数组。\r<p>\r注意：此方法的调用必须放在类方法内部才有效。\r</p>","alias":"$getSuperClasses","visibility":"public","returns":{"desc":"超类的数组。","type":"Prototype[]"},"package":"core","memberOf":"_global_"},{"name":"$invokeSuper","type":"method","desc":"调用当前方法在超类中的实现逻辑。\r<p>\r注意此方法的调用必须放在类方法内部才有效。<br/>\r另外，此方法必须通过call语法进行调用，见示例。\r</p>","alias":"$invokeSuper","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"$invokeSuper.call(this, arguments); // 较简单的调用方式\r$invokeSuper.call(this, [ \"Sample Arg\", true ]); // 自定义传给超类方法的参数数组"}],"visibility":"public","params":[{"desc":"调用超类方法时的宿主对象。一般应直接传入this。","type":"Object","name":"scope"},{"desc":"调用超类方法时的参数数组。很多情况下我们可以直接传入arguments。","type":"Object[]","name":"args","isOptional":true}],"package":"core","memberOf":"_global_"},{"name":"$callback","type":"method","desc":"的快捷方式。","alias":"$callback","see":["dorado.Callback#invokeCallback"],"visibility":"public","package":"core","memberOf":"_global_"},{"name":"$resource","type":"method","desc":"dorado.util.Resource.get()的快捷方式。根据给定的资源路径和一组参数返回资源字符串。","alias":"$resource","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 提取名默认命名空间中的property1代表的字符串\rvar text = $resource(\"property1\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 提取名为命名空间xxx.yyy.zzz中的property1代表的字符串\rvar text = $resource(\"xxx.yyy.zzz.property1\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 假设xxx.yyy.zzz.property1所代表的资源字符串是\"My name is {0}, I'm {1} years old.\"，\r// 此方法将返回\"My name is John, I'm 5 years old.\"\rvar text = $resource(\"xxx.yyy.zzz.property1\", \"John\", 5);"}],"see":["dorado.util.Resource#get"],"visibility":"public","params":[{"desc":"由命名空间+资源项名称组成的资源路径。","type":"String","name":"path"},{"desc":"一到多个参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"资源字符串。","type":"String"},"package":"core","memberOf":"_global_"},{"name":"$url","type":"method","desc":"dorado.Toolkits.translateURL()方法的快捷方式。\r详细用法请参考dorado.Toolkits.translateURL()的说明。","alias":"$url","see":["dorado.Toolkits.translateURL"],"visibility":"public","package":"core","memberOf":"_global_"},{"name":"$singleton","type":"method","desc":"dorado.util.Common.getSingletonInstance()方法的快捷方式。","alias":"$singleton","see":["dorado.util.Common.getSingletonInstance"],"visibility":"public","params":[{"desc":"单例对象的类型名或创建工厂。","type":"String|Object","name":"factory"}],"returns":{"desc":"单例对象的实例。","type":"Object"},"package":"core","memberOf":"_global_"},{"name":"$map","type":"method","desc":"用于将一个JSON对象包装成dorado的仿Map对象。","alias":"$map","see":["dorado.util.Map"],"visibility":"public","params":[{"desc":"此参数应是一个JSON对象，其中定义的所有属性会自动的被添加到Map中。","type":"Object","name":"用于初始化Map键值对的参数。"}],"returns":{"desc":"仿Map对象。","type":"dorado.util.Map"},"package":"core","memberOf":"_global_"},{"name":"$group","type":"method","desc":"创建一个对象组。new dorado.ObjectGroup()操作的快捷方式。","alias":"$group","see":["dorado.ObjectGroup"],"visibility":"public","params":[{"desc":"要进行的组合的对象的数组。","type":"Object..","name":"objects"}],"returns":{"desc":"新创建的对象组。","type":"dorado.ObjectGroup"},"package":"core","memberOf":"_global_"},{"name":"$tag","type":"method","desc":"返回所有具有某一指定标签的对象的对象组。dorado.TagManager.find()方法的快捷方式。","alias":"$tag","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 寻找所有具有limited标签的对象，并统一设置他们的readOnly属性。\r$tag(\"limited\").set(\"readOnly\", true);"}],"see":["dorado.TagManager.find"],"visibility":"public","params":[{"desc":"标签值。","type":"String","name":"tags"}],"returns":{"desc":"对象组。","type":"dorado.ObjectGroup"},"package":"core","memberOf":"_global_"},{"name":"$id","type":"method","desc":"返回某给定的id，返回当前页面的所有视图(View)中于此id匹配的控件所组成的对象组。","alias":"$id","visibility":"public","params":[{"desc":"要查找的id。","type":"String","name":"id"}],"returns":{"desc":"对象组。","type":"dorado.ObjectGroup"},"package":"widget-support","memberOf":"_global_"},{"name":"$waitFor","type":"method","desc":"的快捷方式。","alias":"$waitFor","see":["dorado.widget.View.waitFor"],"visibility":"public","package":"widget-support","memberOf":"_global_"}],"constructors":[],"events":[]}