SYMBOLS["dorado.AttributeSupport"]={"name":"AttributeSupport","type":"class","desc":null,"alias":"dorado.AttributeSupport","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 读写类属性。\roop.set(\"visible\", true); // 设置一个属性\roop.get(\"visible\"); // 读取一个属性"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 声明类属性。\rvar SampleClass = $class({\r\tATTRIBUTES: {\r\t\tvisible: {}, // 声明一个简单的属性\r\t\tlabel: { // 声明一个带有getter方法的属性\r\t\t\tgetter: function(attr) {\r\t\t\t\t... ...\r\t\t\t}\r\t\t},\r\t\tstatus: { // 声明一个带有setter方法的只读属性\r\t\t\treadOnly: true,\r\t\t\tsetter: function(value, attr) {\r\t\t\t\t... ...\r\t\t\t}\r\t\t}\r\t}\r});"}],"isAbstract":true,"classDesc":"支持get/set属性的对象的通用接口。\r       <p>\r       对于实现了此接口的子对象，用户可在其prototype的ATTRIBUTES中定义若干个属性。\r       然后，用后可利用此接口提供的get、set方法来读取和设置属性值。\r       </p>\r       <p>\r       此种对象通过一个名为ATTRIBUTES的特殊属性来声明的给类支持的属性。\r       声明时，每一个被声明的属性应作为ATTRIBUTES对象的一个子属性，该属性的值为一个用于描述属性的JSON对象。该JSON对象中支持下列子属性：\r       <ul>\r       <li>getter - {Function} 该属性对应的getter方法。\r       该方法具有一个传入参数，为属性名。方法的返回值为外界读取到的属性值。</li>\r       <li>setter - {Function} 该属性对应的setter方法。\r       该方法具有两个传入参数，依次为要设置的属性值和属性名。</li>\r       <li>readOnly - {boolean} 该属性是否只读。</li>\r       <li>writeOnly - {boolean} 该属性是否只写。</li>\r       <li>writeOnce - {boolean} 该属性是否只允许被写入一次。</li>\r       <li>defaultValue - {Object|Function} 该属性的默认值。\r       如果默认值是一个Function，那么系统将调用该Function，以其返回值作为属性的默认值。</li>\r       见:<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#getAttributeWatcher')\">dorado.AttributeSupport#getAttributeWatcher</A>,\r       <A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeWatcher')\">dorado.AttributeWatcher</A></li>\r       </ul>\r       </p>","package":"core","inherits":["dorado.DataType","dorado.DraggingInfo","dorado.PropertyDef","dorado.RenderableElement","dorado.validator.Validator","dorado.widget.grid.ColumnModel","dorado.widget.layout.Layout"],"memberOf":"dorado","properties":[{"name":"ATTRIBUTES","type":"Object","desc":"用于声明该对象中所支持的所有Attribute。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.AttributeSupport#ATTRIBUTES","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的caption属性的声明。\rvar attributeDef = oop.ATTRIBUTES.caption。\r// 判断该属性是否只读\rif (attributeDef.readOnly) { ... ... }"}],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"objects","type":"dorado.AttributeSupport[]","desc":"对象数组。","alias":"dorado.AttributeSupport#objects","visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"attributes":[{"name":"tags","type":"String|String[]","desc":"对象的标签。\r<p>\r开发人员可以为一个对象定义一到多个String型的标签，以便于后面快速的查找到一个或一批具有指定标签的对象。\r</p>","alias":"dorado.AttributeSupport#attribute:tags","see":["dorado.TagManager"],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"methods":[{"name":"getAttributeWatcher","type":"method","desc":"返回与该对象关联的属性观察者。","alias":"dorado.AttributeSupport#getAttributeWatcher","visibility":"public","returns":{"desc":"属性观察者。","type":"dorado.AttributeWatcher"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"get","type":"method","desc":"读取指定的属性值。\r<p>\r此方法还支持迭代式的属性读取，即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.AttributeSupport的实例还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r如果碰到的中间对象dorado.AttributeSupport的实例，系统会自动读取它的Attribute；\r如果碰到的中间对象是普通的JSON对象，系统会直接读取它的属性。\r</p>","alias":"dorado.AttributeSupport#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"label\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"address.postCode\"); // 迭代式的属性读取\r// 如果address的属性值是一个dorado.AttributeSupport的实例，那么此行命令的效果相当于oop.get(\"address\").get(\"postCode\")。\r// 如果address的属性值是一个JSON对象，那么此行命令的效果相当于oop.get(\"address\").postCode"}],"visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"读取到的属性值。","type":"Object"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.AttributeSupport#set","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set(\"label\", \"Sample Text\"); oop.set(\"visible\", true);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set( { label : \"Sample Text\", visible : true });"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用属性迭代的特性为子对象中的属性赋值。\roop.set(\"address.postCode\", \"7232-00124\");\r... ...\roop.set({\r\t\"name\" : \"Toad\",\r\t\"address.postCode\" : \"7232-00124\"\r});\r// 上面的两行命令相当于\roop.get(\"address\").set(\"postCode\", \"7232-00124\")"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用上文中提及的第一种方法为label属性赋值，同时为onClick事件绑定一个监听器。\roop.set({\r label : \"Sample Text\",\r onClick : function(self, arg) {\r \t... ...\r }\r});"}],"visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r           <ul>\r           <li>当attr为String时，系统会将attr的作为要设置属性名处理。属性值为value参数代表的值。</li>\r           <li>当attr为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r           注意：当通过此方式为对象设置一系列属性时，系统只会跳过那些设置出错的属性，并不会给出错误信息，也不会中断正在执行的设置操作。</li>\r           </ul>\r           <p>\r           如同<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>方法，set方法也支持对属性进行迭代式的设置。\r           即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘，直到挖掘到倒数第二个子对象时停止并记录下一个子属性名，然后对该子对象的属性进行复制操作，请参考后面的例程。\r           </p>\r           <p>\r           set方法不但可以用于为对象的属性赋值，同时也可以用于为对象中的事件添加事件监听器。\r           <ul>\r           <li>直接以事件名称作为属性，以事件监听器作为属性值，进行赋值操作。</li>\r           <li>为对象listener属性赋值，具体方法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#attribute:listener')\">dorado.EventSupport#attribute:listener</A>。</li>\r           </ul>\r           虽然上述两种方法都可以实现添加事件监听器的功能，并且第一种方法看起来更加方便易用。但第二种方法却较第一种更为灵活。\r           例如：当我们需要一次性的为同一个事件绑定多个监听器，第一种方法是不能胜任的；\r           或者我们当我们批量的设置一组属性值和事件监听器时，第二种方法总是确保事件监听器首先被绑定然后才处理该操作中剩余的属性值的赋值（在绝大多数的场景的这样的顺序是更加合理的），\r           而此时如果使用第一种方法，监听器和属性值的处理顺序是难以预知的。\r           </p>","type":"String|Object","name":"attr"},{"desc":"此参数具有多重含义：要设置的属性值。当attr为Object时，此参数将被忽略。\r           <ul>\r           <li>当attr为String时，此参数代表要设置的属性值。</li>\r           <li>当attr为Object时，此参数可代表一组执行选项，见option参数的说明。</li>\r           </ul>","type":"Object","name":"value","isOptional":true},{"desc":"执行选项。此参数仅在attr参数为Object时有效。","type":"Object","name":"options","isOptional":true},{"desc":"是否忽略未知的属性。","type":"boolean","name":"options.skipUnknownAttribute","isOptional":true,"defaultValue":"false"},{"desc":"是否在发生错误后继续尝试后续的属性设置操作。","type":"boolean","name":"options.tryNextOnError","isOptional":true,"defaultValue":"false"},{"desc":"是否组织本次赋值操作覆盖对象中原有的属性值。\r           即对于那些已拥有值(曾经通过set方法写入过值)的属性跳过本次的赋值操作，而只对那些未定义过的属性进行赋值。","type":"boolean","name":"options.preventOverwriting","isOptional":true,"defaultValue":"false"}],"returns":{"desc":"返回对象自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"doSet","type":"method","desc":"用于实现为单个属性赋值的内部方法。","alias":"dorado.AttributeSupport#doSet","visibility":"protected","params":[{"desc":"要设置的属性名。","type":"String","name":"attr"},{"desc":"属性值。","type":"Object","name":"value"},{"desc":"是否忽略未知的属性。","type":"boolean","name":"skipUnknownAttribute","isOptional":true},{"desc":null,"name":"lockWritingTimes"}],"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"hasTag","type":"method","desc":"判断对象中是否定义了某个标签值。","alias":"dorado.AttributeSupport#hasTag","visibility":"public","params":[{"desc":"要判断的标签值。","type":"String","name":"tag"}],"returns":{"desc":"是否具有该标签值。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}],"constructors":[],"events":[{"name":"onAttributeChange","type":"event","desc":"当对象中的某属性值被改变时触发的事件。","alias":"dorado.AttributeSupport#event:onAttributeChange","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"发生改变的属性名。","type":"String","name":"arg.attribute"},{"desc":"新的属性值。","type":"Object","name":"arg.value"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}]}