SYMBOLS["dorado.Callback"]={"name":"Callback","type":"object","desc":null,"alias":"dorado.Callback","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 以Function形式定义回调参数时\rdataPipe.getAsync(function(obj) {\r\t alert(\"获得的数据为：\" + obj);\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 以JavaScript对象形式定义回调参数，并使用success和failure子方法时\rdataPipe.getAsync({\r\t success : function(obj) {\r\t\t alert(\"获得的数据为：\" + obj);\r\t },\r\r\t failure : function(e) {\r\t\t alert(\"发生异常：\" + e);\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 以JavaScript对象形式定义回调参数，并使用callback子方法时\rdataPipe.getAsync({\r\t callback : function(success, obj) {\r\t\t if (success) {\r\t\t\t alert(\"执行成功！获得的数据为：\" + obj);\r\t\t }\r\t\t else {\r\t\t\t alert(\"执行失败！发生异常：\" + obj);\r\t\t }\r\t }\r});"}],"classDesc":"异步方法的回调参数对象。\r<p>\r<font color=\"red\"><b> 注意：这是一个虚拟的对象，在实际的运行状态中并不存在这样一个类型，因此您不能尝试实例化此类型。 </b></font>\r</p>\r<p>\r在dorado的客户端中，所有的异步执行方法都包含有一个相同类型的callback参数，该参数既可以是一个Function也可以是一个JavaScript对象。\r<ul>\r<li>当callback参数是一个Function时，那么该方法的声明应是如下形式：\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\rfunction (obj) {\r\t ... ...\r}\r</code>\r</pre>\r\r其中obj参数即为异步操作获得结果。 </li>\r<li>当callback参数是一个对象时，该对象的结构应是一个与此处dorado.Callback匹配的JavaScript对象。 </li>\r</ul>\r</p>","package":"core","memberOf":"dorado","properties":[],"attributes":[],"methods":[{"name":"callback","type":"method","desc":"当提取数据操作执行成功时触发的回调函数.","alias":"dorado.Callback#callback","visibility":"public","params":[{"desc":"异步操作被是否成功的执行了。","type":"boolean","name":"success","isOptional":true},{"desc":"异步操作获得返回结果或抛出的异常对象。","type":"Object","name":"obj","isOptional":true}],"package":"core","memberOf":"dorado.Callback"},{"name":"success","type":"method","desc":"当提取数据操作执行成功时触发的回调函数。","alias":"dorado.Callback#success","visibility":"public","params":[{"desc":"异步操作获得返回结果。","type":"Object","name":"obj","isOptional":true}],"package":"core","memberOf":"dorado.Callback"},{"name":"failure","type":"method","desc":"当提取数据操作执行失败时触发的回调函。","alias":"dorado.Callback#failure","visibility":"public","params":[{"desc":"异步操作执行过程中抛出的异常对象。","type":"Object","name":"e","isOptional":true}],"package":"core","memberOf":"dorado.Callback"},{"name":"invokeCallback","type":"method","desc":"对回调方法或对象进行调用。","alias":"dorado.Callback.invokeCallback","see":["$callback"],"visibility":"public","params":[{"desc":"要调用的回调方法或对象。","type":"Object|Function","name":"callback"},{"desc":"回调方法或对象监听的过程是否执行成功。","type":"Object","name":"success","isOptional":true,"defaultValue":"false"},{"desc":"调用回调方法时传入方法的参数。","type":"Object","name":"arg","isOptional":true},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"延时执行此事件方法的毫秒数。如果不指定此参数表示不对事件进行延时处理。","type":"int","name":"options.delay","isOptional":true}],"package":"core","isStatic":true,"memberOf":"dorado.Callback"}],"constructors":[],"events":[]}