SYMBOLS["dorado.Core"]={"name":"Core","type":"object","desc":null,"alias":"dorado.Core","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"dorado核心类，其中包含了若干最常用的工具方法。","package":"core","memberOf":"dorado","properties":[{"name":"VERSION","type":"String","desc":"返回dorado的版本号。","alias":"dorado.Core.VERSION","visibility":"public","isStatic":true,"memberOf":"dorado.Core","package":"core"}],"attributes":[],"methods":[{"name":"newId","type":"method","desc":"生成一个新的id。","alias":"dorado.Core.newId","visibility":"public","returns":{"desc":"新生成的id。","type":"String"},"package":"core","isStatic":true,"memberOf":"dorado.Core"},{"name":"getTimestamp","type":"method","desc":"生成新的时间戳。<br/>\r此处的时间戳事实上只是一个自动递增的整数，并不代表当前的时间。","alias":"dorado.Core.getTimestamp","visibility":"public","returns":{"desc":"新时间戳。","type":"int"},"package":"core","isStatic":true,"memberOf":"dorado.Core"},{"name":"scopify","type":"method","desc":"为一个函数指定其调用时的scope，即指定该函数在调用时this对象的指向。","alias":"dorado.Core.scopify","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var s = \"hello!\";\rdorado.Core.scopify(s, \"alert(this)\")(); // should say \"hello!\";"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var s = \"hello!\";\rdorado.Core.scopify(s, function(){\r\t alert(this);\r})(); // should say \"hello\""}],"see":["$scopify"],"visibility":"public","params":[{"desc":"调用时this对象。","type":"Object","name":"scope"},{"desc":"要处理的函数或文本形式表示的代码片段。","type":"Function|String","name":"fn"}],"returns":{"desc":"代理函数。","type":"Function"},"package":"core","isStatic":true,"memberOf":"dorado.Core"},{"name":"setTimeout","type":"method","desc":"设定一个延时任务，同时指定该延时任务在调用时的scope。 该方法的功能类似于window.setTimeout。","alias":"dorado.Core.setTimeout","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// should say \"hello!\" after one second.\rvar s = \"hello!\";\rdorado.Core.setTimeout(s, function() {\r\t alert(this);\r}, 1000);"}],"see":["dorado.Core.scopify","$setInterval"],"visibility":"public","params":[{"desc":"调用时this对象。","type":"Object","name":"scope"},{"desc":"要处理的函数或文本形式表示的代码片段。","type":"Function|String","name":"fn"},{"desc":"延时的时长（毫秒数）。","type":"int","name":"timeMillis"}],"returns":{"desc":"延时任务的id。","type":"int"},"package":"core","isStatic":true,"memberOf":"dorado.Core"},{"name":"setInterval","type":"method","desc":"设定一个定时任务，同时指定该定时任务在调用时的scope。 该方法的功能类似于window.setInterval。","alias":"dorado.Core.setInterval","see":["dorado.Core.scopify","$setInterval"],"visibility":"public","params":[{"desc":"调用时this对象。","type":"Object","name":"scope"},{"desc":"要处理的函数或文本形式表示的代码片段。","type":"Function|String","name":"fn"},{"desc":"定时任务的间隔（毫秒数）。","type":"int","name":"timeMillis"}],"returns":{"desc":"定时任务的id。","type":"int"},"package":"core","isStatic":true,"memberOf":"dorado.Core"},{"name":"clone","type":"method","desc":"克隆一个对象。\r<p>\r如果被克隆的对象本身支持clone()方法，那么此处将直接使用该对象自身的clone()来完成克隆。\r否则会使用默认的规则，按照类似属性反射的方式对对象进行浅克隆。\r</p>","alias":"dorado.Core.clone","visibility":"public","params":[{"desc":"将被克隆的对象。","type":"Object","name":"obj"},{"desc":"是否执行深度克隆。","type":"boolean","name":"deep","isOptional":true}],"returns":{"desc":"对象的克隆。","type":"Object"},"package":"core","isStatic":true,"memberOf":"dorado.Core"}],"constructors":[],"events":[]}