SYMBOLS["dorado.DataPath"]={"name":"DataPath","type":"class","desc":"构造器。\r<p>\r通常我们不建议您通过\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\rnew dorado.DataPath(\"xxx\");\r</code>\r</pre>\r的方式来创建数据路径的处理器， 而应该用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.create')\">dorado.DataPath.create</A>来代替。 这是因为用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.create')\">dorado.DataPath.create</A>支持缓存功能，利用此方法来获得数据路径的处理器的效率往往更高。\r</p>","alias":"dorado.DataPath","author":"Benny Bao (mailto:benny.bao@bstek.com)","see":["dorado.DataPath.create"],"classDesc":"数据路径的处理器。\r<p>\r数据路径表达式是用于描述如何提取、挖掘数据的表达式。其作用比较类似于XML中所使用的XPath。\r</p>\r<p>\r以具有以下结构的EntityList+Entity数据为例，其中包含Department和Employee两种实体类型，其中Department支持递归嵌套:\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\r[\r{\r\tid: \"D1\",\r\tname: \"XX部1\",\r\tdepartments: [\r\t\t{\r\t\t\tid: \"D11\",\r\t\t\tname: \"XX部2\",\r\t\t\temployees: [\r\t\t\t\t{\r\t\t\t\t\tid: \"0001\",\r\t\t\t\t\tname: \"John\",\r\t\t\t\t\tsex: \"male\",\r\t\t\t\t\tsalary: 5000\r\t\t\t\t},\r\t\t\t\t...\r\t\t\t]\r\t\t},\r\t\t...\r\t]\r},\r...\r]\r</code>\r</pre>\r</p>\r<p>\r基本结构说明：属性名1(参数1,参数2,..)[逻辑表达式1,逻辑表达式2,..].属性名2(参数1,参数,..2)[逻辑表达式1,逻辑表达式2,..].属性名n..<br/>\r符号说明:\r<ul>\r<li>. - 用于分隔不同层级间对象的属性。例如:<code>employee.id</code>表示employee子对象的id属性。</li>\r<li>* - 用于表示某一层级中所有的对象，一般仅用于表示顶层集合中的对象，且可以省略。例如:<code>*.id</code>表示所有顶层对象的id属性。</li>\r<li>() - 用于定义一组表达式执行参数，多个参数之间以\",\"分割。目前支持的参数包括：\r<ul>\r<li>repeat - 重复的执行当前的表达式片段直到无法找到更多的子对象为止。可简写为\"R\"。</li>\r<li>leaf - 重复的执行当前的表达式片段找出所有的叶子对象。可简写为\"L\"。</li>\r<li>数字 - 表示仅返回找到的前n个对象。</li>\r</ul>\r例如:<code>.employees(repeat)</code>或<code>.employees(R)</code>表示所有employees属性中的对象的集合，这些对象会被提取出来被平行的放置到一个返回的数组中。\r</li>\r<li>@ - 用于逻辑表达式中，表示当前正被过滤的数据对象。</li>\r<li>[] - 用于定义一组逻辑表达式以对数据进行过滤，其中如果要定义多个逻辑表达式可以以\",\"进行区隔。\r例如:<code>employees[@.get(\"sex\")==\"male\"]</code>表示筛选出性别为男性的员工。</li>\r<li>#current等 - 一种特殊的逻辑表达式，用于声明对Entity对象的过滤方式。具有如下几种取值:\r<ul>\r<li>#current - 表示集合中的当前Entity对象。</li>\r<li>#dirty - 表示集合中所有在客户端被改变过的（包含被删除的）Entity对象。</li>\r<li>#none - 表示集合中所有在客户端未被改变过的Entity对象。</li>\r<li>#all - 表示集合中所有状态的（包含被删除的）Entity对象。</li>\r<li>#new - 表示集合中所有在客户端新增的Entity对象。</li>\r<li>#modified - 表示集合中所有在客户端被修改过的Entity对象。</li>\r<li>#deleted - 表示集合中所有在客户端被标记为已删除的Entity对象。</li>\r<li>#move - 表示集合中所有在客户端被标记为已被移动的Entity对象。</li>\r</ul>\r例如:<code>employees[#current]</code>表示返回employees集合中的当前Employee对象。\r</li>\r<li># - #current的简式。例如<code>#employees</code>与<code>employees[#current]</code>具有完全相同的语义。</li>\r<li>! - 表示后面是一段自定义的数据路径片段。例如<code>!CURRENT_NODE.children</code>中的CURRENT_NODE就是一个自定义片段。\r见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.registerInterceptor')\">dorado.DataPath.registerInterceptor</A>的说明。</li>\r</ul>\r</p>\r<p>\r更多的表达式示例：\r<ul>\r<li>null - 相当于直接返回被查询的数据。表示顶层集合中所有的（不包含被删除的）Department。</li>\r<li>* - 同上。</li>\r<li># - 表示顶层集合中的当前Department。 </li>\r<li>[#current] - 同上。</li>\r<li>[#dirty] - 表示顶层集合中所有在客户端被改变过的（包含被删除的）Department。 </li>\r<li>#.employees - 表示顶层集合中当前Department中所有的Employee。</li>\r<li>#.#employees - 表示顶层集合中当前Department中的当前Employee。 </li>\r<li>#.#departments.#employees -\r表示顶层集合中当前Department中的当前Department中的当前Employee。 </li>\r<li>*.departments - 表示所有第二层的Department。 </li>\r<li>.departments - 同上。 </li>\r<li>departments(repeat) -\r表示所有Department的集合。注意：示例数据的顶层是一个集合，而在正常情况下是不能利用表达式来获取集合属性的。除非当一个具有repeat或leaf特性的表达式片段被应用于顶层集合时。引擎允许这样的特例，在此种情况下引擎会暂时忽略表达式片段中的属性名。</li>\r<li>.departments(R) - 表示除顶层Department外所有其它Department的集合。 </li>\r<li>.#departments(R) - 表示除顶层Department外所有其它各层中当前Department的集合。</li>\r<li>#departments(R) - 表示各层当前Department的集合。 </li>\r<li>#departments(leaf) -\r表示最末端的当前Department。即通过不断的尝试获取当前Department中的当前Department，直到最末端那个Department。\r</li>\r<li>#departments(L) - 同上。</li>\r<li>#departments(L).#employees -\r表示最末端的当前Department中的当前Employee。此表达式返回的结果是所有匹配Employee组成的数组。 </li>\r<li>.employees(R) - 表示所有employees属性中的对象的集合，即所有的Employee对象。</li>\r<li>.#employees(R) -\r表示所有Department中的当前Employee，将以数组的形式返回这些Employee实体的集合。 </li>\r<li>.employees(R)[@.get(\"sex\")==\"male\"] -\r表示所有Department中的男性Employee，将以数组的形式返回这些Employee实体的集合。 </li>\r<li>.employees(R)[#dirty,@.get(\"sex\")==\"male\"] -\r表示所有Department中的状态为已修改的男性Employee，将以数组的形式返回这些Employee实体的集合。 </li>\r<li>.employees(R)[@.get(\"salary\")>3500 && @.get(\"sex\")==\"male\"] - 同上。\r</li>\r<li>.employees(R)[@.get(\"salary\")>3500,@.get(\"sex\")==\"male\"] -\r表示所有Department中的薪水高于3500的男性Employee，将以数组的形式返回这些Employee实体的集合。 </li>\r<li>.employees(R).id - 表示返回所有Employee对象的id属性值的集合，即所有的Employee对象的id。</li>\r</ul>\r</p>","package":"data","memberOf":"dorado","properties":[],"attributes":[],"methods":[{"name":"compile","type":"method","desc":"编译数据路径表达式。","alias":"dorado.DataPath#compile","visibility":"public","exceptions":["SyntaxError"],"package":"data","memberOf":"dorado.DataPath"},{"name":"evaluate","type":"method","desc":"针对传入的数据应用(执行)路径表达式，并返回表达式的执行结果。","alias":"dorado.DataPath#evaluate","visibility":"public","params":[{"desc":"将被应用(执行)的数据。","type":"Object","name":"data"},{"desc":"执行选项。\r<p>\r此参数具有两种设定方式。当直接传入逻辑值true/false时，dorado会将此逻辑值直接认为是针对上述firstResultOnly子属性的值；\r当传入的是一个对象时，dorado将尝试识别该对象中的其中子属性。\r</p>","type":"boolean|Object","name":"options","isOptional":true},{"desc":"是否只返回找到的第一个结果。","type":"boolean","name":"options.firstResultOnly","isOptional":true},{"desc":"是否接受聚合型的结果对象。。\r默认情况下，当DataPath的执行器得到一个聚合型的结果(即dorado.EntityList或Array类型的结)时，\r会将其拆散，并将其中的结果压入DataPath的返回结果数组中。\r如果指定了此属性为true，执行器将直接把得到的dorado.EntityList或Array压入DataPath的返回结果数组中。","type":"boolean","name":"options.acceptAggregation","isOptional":true},{"desc":"数据装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always\t-\t如果有需要总是装载尚未装载的延时数据。</li>\r<li>auto\t-\t如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r<li>never\t-\t不会激活数据装载过程，直接返回数据的当前值。</li>\r</ul>","type":"String","name":"options.loadMode","isOptional":true,"defaultValue":"\"always\""}],"returns":{"desc":"表达式的执行结果。","type":"dorado.Entity|dorado.EntityList|any"},"package":"data","memberOf":"dorado.DataPath"},{"name":"getDataType","type":"method","desc":"返回某数据路径所对应的子数据类型。","alias":"dorado.DataPath#getDataType","visibility":"public","params":[{"desc":"根数据类型。","type":"dorado.DataType","name":"dataType"},{"desc":"执行选项。\r<p>\r此参数具有两种设定方式。当直接传入逻辑值true/false时，dorado会将此逻辑值直接认为是针对上述acceptAggregationDataType子属性的值；\r当传入的是一个对象时，dorado将尝试识别该对象中的其中的子属性。\r</p>","type":"boolean|Object","name":"options","isOptional":true},{"desc":"是否允许返回聚合类型。默认为不返回聚合类型。\r如果设置为不允许返回聚合类型，那么当通过数据路径的计算最终得到一个聚合类型时，系统会尝试返回该聚合类型中聚合元素的数据类型。","type":"boolean","name":"options.acceptAggregationDataType","isOptional":true},{"desc":"数据类型装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always\t-\t如果有需要总是装载尚未装载的延时数据。</li>\r<li>auto\t-\t如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r<li>never\t-\t不会激活数据装载过程，直接返回数据的当前值。</li>\r</ul>","type":"String","name":"options.loadMode","isOptional":true,"defaultValue":"\"always\""}],"returns":{"desc":"子数据类型。","type":"dorado.DataType"},"package":"data","memberOf":"dorado.DataPath"},{"name":"create","type":"method","desc":"创建一个数据路径的处理器。","alias":"dorado.DataPath.create","visibility":"public","params":[{"desc":"数据路径表达式。","type":"String","name":"path"}],"returns":{"desc":"数据路径的处理器。","type":"dorado.DataPath"},"package":"data","isStatic":true,"memberOf":"dorado.DataPath"},{"name":"evaluate","type":"method","desc":"对给定数据应用(执行)路径表达式，并返回表达式的执行结果。","alias":"dorado.DataPath.evaluate","see":["dorado.DataPath#evaluate"],"visibility":"public","params":[{"desc":"将被应用(执行)的数据。","type":"Object","name":"data"},{"desc":"数据路径。","type":"String","name":"path"},{"desc":"执行选项。","type":"boolean|Object","name":"options","isOptional":true}],"returns":{"desc":"表达式的执行结果。","type":"dorado.Entity|dorado.EntityList|any"},"package":"data","isStatic":true,"memberOf":"dorado.DataPath"},{"name":"registerInterceptor","type":"method","desc":"向系统中注册一个数据路径片段的拦截处理器，用以自定义某种片段的执行规则。\r<p>\r自定义的片段在使用时须在前面加一个\"!\"作为标识。\r例如我们注册了一个名为CURRENT_NODE的自定义片段，在实际编写数据路径时须这样使用<code>!CURRENT_NODE.children</code>。\r</p>","alias":"dorado.DataPath.registerInterceptor","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 此例注册了一个自定义片段CURRENT_DIR，用于表示树状列表控件treeDir中当前选中的节点对应的数据。\r// 假设treeDir是一个棵用于显示文件目录的树。这样，!CURRENT_DIR.childFiles就可以表示当前选中的目录中的所有子文件的集合。\rdorado.DataPath.registerInterceptor(\"CURRENT_DIR\", function() {\r\tvar data = null, node = treeDir.get(\"currentNode\");\r\tif (node) data = node.get(\"data\");\r\treturn data;\r}, function() {\r\treturn dataTypeFile;\r});"}],"visibility":"public","params":[{"desc":"要拦截的片段。","type":"String","name":"section"},{"desc":"数据运算的拦截方法。\r此方法支持如下两个参数：\r<ul>\r<li>data\t-\t{Object} 数据路径在运算时当前正在处理的数据。\r例如对于#employees.!DESCRIPTION，由于在!DESCRIPTION之前的#employees的含义是当前Employee对象。\r因此，当DESCRIPTION的拦截器被触发时，data参数的值就是当前Employee对象。</li>\r<li>section\t-\t{String} 当前正在处理的自定义数据路径片段。\r仍以#employees.!DESCRIPTION为例，section参数的值应该是DESCRIPTION。</li>\r</ul>\r此方法中的this关键字指向当前的dorado.DataPath实例。\r此方法的返回值就是该自定义数据路径片段的执行结果。","type":"Function","name":"dataIntercetor"},{"desc":"数据类型运算的拦截方法。\r见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath#getDataType')\">dorado.DataPath#getDataType</A>的说明。\r此方法支持如下两个参数：\r<ul>\r<li>dataType\t-\t{Object} 数据路径在运算时当前正在处理的数据类型。</li>\r<li>section\t-\t{String} 当前正在处理的自定义数据路径片段。</li>\r</ul>\r此方法中的this关键字指向当前的dorado.DataPath实例。\r此方法的返回值就是该自定义数据路径片段的执行结果。","type":"Function","name":"dataTypeIntercetor","isOptional":true}],"package":"data","isStatic":true,"memberOf":"dorado.DataPath"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.DataPath","params":[{"desc":"数据路径表达式。","type":"String","name":"path"}]}],"events":[]}