SYMBOLS["dorado.DataProvider"]={"name":"DataProvider","type":"class","desc":null,"alias":"dorado.DataProvider","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"数据提供者。\r<p>\r此对象一般只用于配合dorado服务端的开发模式中。在纯使用dorado客户端功能的开发模式下一般应使用@{link dorado.AjaxDataProvider}。\r</p>\r<p>\r通常我们不建议您通过<pre>new dorado.DataProvider(\"xxx\");</pre>的方式来创建数据提供者，而应该用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataProvider.create')\">dorado.DataProvider.create</A>来代替。\r这是因为用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataProvider.create')\">dorado.DataProvider.create</A>支持缓存功能，利用此方法来获得数据提供者的效率往往更高。\r</p>","package":"data","inherits":["dorado.AjaxDataProvider"],"memberOf":"dorado","properties":[{"name":"dataTypeRepository","type":"dorado.DataTypeRepository","desc":"解析返回数据时可能需要用到的数据类型管理器。","alias":"dorado.DataProvider#dataTypeRepository","visibility":"public","memberOf":"dorado.DataProvider","package":"data"},{"name":"dataType","type":"dorado.LazyLoadDataType|dorado.DataType","desc":"返回数据的数据类型。","alias":"dorado.DataProvider#dataType","visibility":"public","memberOf":"dorado.DataProvider","package":"data"},{"name":"message","type":"String","desc":"当此DataProvider正在执行时希望系统显示给用户的提示信息。\r<p>\r此属性目前仅在以异步模式执行时有效。\r</p>","alias":"dorado.DataProvider#message","visibility":"public","memberOf":"dorado.DataProvider","package":"data"},{"name":"supportsEntity","type":"boolean","desc":"是否支持Dorado的数据实体。\r<p>\r如果选择是，那么当有数据从服务端返回时，系统自动判断该数据在服务端的形态。\r如果该数据在服务端是Entity/EntityList的形式，那么系统也会在客户端将他们转换成Entity/EntityList的形式。<br/>\r如果选择否，那么不管这些数据在服务端是怎样的，到了客户端将变成JSON形式。\r</p>","alias":"dorado.DataProvider#supportsEntity","visibility":"public","defaultValue":"true","memberOf":"dorado.DataProvider","package":"data"},{"name":"id","type":"String","desc":null,"alias":"dorado.DataProvider#id","visibility":"public","memberOf":"dorado.DataProvider","package":"data"},{"name":"name","type":"String","desc":null,"alias":"dorado.DataProvider#name","visibility":"public","memberOf":"dorado.DataProvider","package":"data"}],"attributes":[],"methods":[{"name":"getAjaxOptions","type":"method","desc":"进行数据装载操作时传入<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.AjaxEngine')\">dorado.util.AjaxEngine</A>的执行选项。","alias":"dorado.DataProvider#getAjaxOptions","see":["dorado.util.AjaxEngine#request","dorado.util.AjaxEngine#requestSync"],"visibility":"protected","params":[{"desc":null,"name":"arg"}],"returns":{"desc":"执行选项。","type":"Object"},"package":"data","memberOf":"dorado.DataProvider"},{"name":"getResult","type":"method","desc":"用于以同步方式提取数据的方法。","alias":"dorado.DataProvider#getResult","visibility":"public","params":[{"desc":"提取数据时的选项。","type":"Object","name":"arg","isOptional":true},{"desc":"提取数据时使用的参数。","type":"Object","name":"arg.parameter","isOptional":true},{"desc":"提取分页数据时请求的页号。","type":"int","name":"arg.pageNo","isOptional":true},{"desc":"提取分页数据时每页的记录数。","type":"int","name":"arg.pageSize","isOptional":true}],"returns":{"desc":"提取到的数据。","type":"dorado.Entity|dorado.EntityList"},"exceptions":["Error"],"package":"data","memberOf":"dorado.DataProvider"},{"name":"getResultAsync","type":"method","desc":"用于以异步方式提取数据的方法。","alias":"dorado.DataProvider#getResultAsync","visibility":"public","params":[{"desc":"提取数据时的选项。","type":"Object","name":"arg"},{"desc":"提取数据时使用的参数。","type":"Object","name":"arg.parameter","isOptional":true},{"desc":"提取分页数据时请求的页号。","type":"int","name":"arg.pageNo","isOptional":true},{"desc":"提取分页数据时每页的记录数。","type":"int","name":"arg.pageSize","isOptional":true},{"desc":"回调对象，传入回调对象的参数即为提取到的数据。","type":"Function|dorado.Callback","name":"callback"}],"package":"data","memberOf":"dorado.DataProvider"},{"name":"create","type":"method","desc":"创建一个数据提供者。","alias":"dorado.DataProvider.create","visibility":"public","params":[{"desc":"数据提供者的服务id。","type":"String","name":"id"}],"returns":{"desc":"新创建的数据提供者。","type":"dorado.DataProvider"},"package":"data","isStatic":true,"memberOf":"dorado.DataProvider"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.DataProvider","params":[{"desc":"数据提供者的服务id。通常此id也会被直接认为是数据提供者的name。","type":"String","name":"id"}]}],"events":[]}