SYMBOLS["dorado.DataTypeRepository"]={"name":"DataTypeRepository","type":"class","desc":null,"alias":"dorado.DataTypeRepository","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"数据类型的管理器。\r<p>\r子数据类型的管理器总是会继承父管理器中所有的数据类型。当外界尝试从子管理器获取某个数据类型时，\r如果该类型不存在与子管理器中，那么子管理器将会继续尝试到父管理器查找。\r</p>","package":"data","memberOf":"dorado","properties":[{"name":"parent","type":"dorado.DataTypeRepository","desc":"父数据类型的管理器。","alias":"dorado.DataTypeRepository#parent","visibility":"public","memberOf":"dorado.DataTypeRepository","package":"data"},{"name":"children","type":"dorado.DataTypeRepository[]","desc":"子数据类型的管理器的数组。","alias":"dorado.DataTypeRepository#children","visibility":"public","memberOf":"dorado.DataTypeRepository","package":"data"},{"name":"loadOptions","type":"Object","desc":"进行数据类型装载操作时传入<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.AjaxEngine')\">dorado.util.AjaxEngine</A>的执行选项。\r<p>\r如果要修改此属性的内容，您应该为loadOptions属性赋一个新的对象，\r而不是直接修改原loadOptions对象中的子属性，因为这样很可能导致其他的其它DataTypeRepository实例的loadOptions被意外改变。\r</p>","alias":"dorado.DataTypeRepository#loadOptions","see":["dorado.util.AjaxEngine#request","dorado.util.AjaxEngine#requestSync"],"visibility":"public","memberOf":"dorado.DataTypeRepository","package":"data"},{"name":"ROOT","type":"property","desc":"客户端的根数据类型管理器。","alias":"dorado.DataTypeRepository.ROOT","visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.DataTypeRepository","package":"data"}],"attributes":[],"methods":[{"name":"register","type":"method","desc":"向管理器中注册一个数据类型。 注意此方法的多态参数。","alias":"dorado.DataTypeRepository#register","visibility":"public","params":[{"desc":"此参数是一个多态参数。\r<ul>\r<li>当参数类型为String时代表要注册的数据类型的名称，此时还必须通过dataType参数来指定要注册的具体数据类型。</li>\r<li>当参数类型为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataType')\">dorado.DataType</A>时代表要注册的数据类型，此时系统将忽略dataType参数。</li>\r</ul>","type":"String|dorado.DataType","name":"name"},{"desc":"要注册的数据类型。","type":"dorado.DataType","name":"dataType","isOptional":true}],"package":"data","memberOf":"dorado.DataTypeRepository"},{"name":"unregister","type":"method","desc":"从管理器中注销一个数据类型。","alias":"dorado.DataTypeRepository#unregister","visibility":"public","params":[{"desc":"此参数是一个多态参数。\r<ul>\r<li>当参数类型为String时代表要注销的数据类型的名称。</li>\r<li>当参数类型为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataType')\">dorado.DataType</A>时代表要注销的数据类型。</li>\r</ul>","type":"Object","name":"name"}],"package":"data","memberOf":"dorado.DataTypeRepository"},{"name":"get","type":"method","desc":"根据名称从管理器中获取相应的数据类型。<br/>\r如果该数据类型的详细信息尚不存于客户端，那么管理将自动从服务端装载该数据类型的详细信息。","alias":"dorado.DataTypeRepository#get","visibility":"public","params":[{"desc":"数据类型的名称。","type":"String","name":"name"},{"desc":"装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always\t-\t如果有需要总是装载尚未装载的DataType。</li>\r<li>auto\t-\t如果有需要则自动启动异步的DataType装载过程，但对于本次方法调用将返回undefined。</li>\r<li>never\t-\t不会激活DataType的装载过程。</li>\r</ul>","type":"String","name":"loadMode","isOptional":true,"defaultValue":"\"always\""}],"returns":{"desc":"数据类型。","type":"dorado.DataType"},"package":"data","memberOf":"dorado.DataTypeRepository"},{"name":"getAsync","type":"method","desc":"以异步方式、根据名称从管理器中获取相应的数据类型。<br/>\r如果该数据类型的详细类型尚不存于客户端，那么管理将自动从服务端装载该数据类型的详细信息。","alias":"dorado.DataTypeRepository#getAsync","visibility":"public","params":[{"desc":"数据类型的名称。","type":"String","name":"name"},{"desc":"回调对象，传入回调对象的参数即为获得的DataType。","type":"Function|dorado.Callback","name":"callback"},{"desc":"装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always\t-\t如果有需要总是装载尚未装载的DataType。</li>\r<li>auto\t-\t对于异步操作而言此选项没有实际意义，系统内部的处理方法将与always完全一致。</li>\r<li>never\t-\t不会激活DataType的装载过程。</li>\r</ul>","type":"String","name":"loadMode","isOptional":true,"defaultValue":"\"always\""}],"package":"data","memberOf":"dorado.DataTypeRepository"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.DataTypeRepository","params":[{"desc":"父数据类型的管理器。","type":"dorado.DataTypeRepository","name":"parent"}]}],"events":[{"name":"onDataTypeRegister","type":"event","desc":"每当有新的数据类型被注册到该管理器或其父管理器中是触发的事件。","alias":"dorado.DataTypeRepository#event:onDataTypeRegister","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"新注册的数据类型。","type":"dorado.DataType","name":"arg.dataType"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.DataTypeRepository"}]}