SYMBOLS["dorado.DataUtil"]={"name":"DataUtil","type":"object","desc":null,"alias":"dorado.DataUtil","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"与数据处理相关的工具函数。","package":"data","memberOf":"dorado","properties":[],"attributes":[],"methods":[{"name":"convertIfNecessary","type":"method","desc":"如果定义了明确的数据类型，则将传入的数据转换成该数据类型。\r<p>\r此处的数据类型既可以直接通过dataType参数来指定，也可以在data参数对应的JSON对象的$dataType属性中指定。\r</p>","alias":"dorado.DataUtil.convertIfNecessary","see":["dorado.DataType"],"visibility":"public","params":[{"desc":"要转换的数据。","type":"Object","name":"data"},{"desc":"数据类型的管理器。","type":"dorado.DataRepository","name":"dataTypeRepository","isOptional":true},{"desc":"要将数据转换为什么类型。","type":"dorado.DataType|dorado.LazyLoadDataType|String","name":"dataType","isOptional":true}],"returns":{"desc":"转换后的数据。","type":"Object"},"package":"data","isStatic":true,"memberOf":"dorado.DataUtil"},{"name":"convert","type":"method","desc":"将给定的JSON数据装转换成dorado中的数据封装形式。","alias":"dorado.DataUtil.convert","see":["dorado.DataType"],"visibility":"public","params":[{"desc":"要转换的数据。","type":"Object","name":"data"},{"desc":"数据类型的管理器。","type":"dorado.DataRepository","name":"dataTypeRepository","isOptional":true},{"desc":"要将数据转换为什么类型。","type":"dorado.DataType","name":"dataType","isOptional":true}],"returns":{"desc":"转换后的数据。","type":"Object"},"package":"data","isStatic":true,"memberOf":"dorado.DataUtil"},{"name":"isOwnerOf","type":"method","desc":"判断一个owner参数代表的数据是否data参数代表的数据的宿主。即data是否是owner中的子数据。","alias":"dorado.DataUtil.isOwnerOf","visibility":"public","params":[{"desc":"要判断的数据。","type":"dorado.Entity|dorado.EntityList","name":"data"},{"desc":"宿主数据。","type":"dorado.Entity|dorado.EntityList","name":"owner"}],"returns":{"desc":"是否宿主。","type":"boolean"},"package":"data","isStatic":true,"memberOf":"dorado.DataUtil"},{"name":"sort","type":"method","desc":"排序。","alias":"dorado.DataUtil.sort","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 根据salary属性的值进行逆向排序\rdorado.DataUtil.sort(dataArray, { property: \"salary\", desc: true });"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 根据comparator自定义排序的规则\rdorado.DataUtil.sort(dataArray, null, function(item1, item2, sortParams) {\r\t... ...\r});"}],"visibility":"public","params":[{"desc":"要排序的数组。","type":"Object[]","name":"array"},{"desc":"排序参数或排序参数的数组。","type":"Object|Object[]","name":"sortParams"},{"desc":"要排序的属性名。","type":"String","name":"sortParams.property"},{"desc":"是否逆向排序。","type":"boolean","name":"sortParams.desc"},{"desc":"比较器。\r比较器是一个具有三个输入参数的Function，三个参数依次为：\r<ul>\r<li>item1\t-\t{Object} 要比较的对象1。</li>\r<li>item2\t-\t{Object} 要比较的对象2。</li>\r<li>sortParams\t-\t{Object|Object[]} 排序参数或排序参数的数组。</li> \r</ul>\r比较器的返回值表示对象1和对象2的比较结果：\r<ul>\r<li>返回大于0的数字表示对象1>对象2。</li>\r<li>返回小于0的数字表示对象1<对象2。</li>\r<li>返回等于0的数字表示对象1和对象2的比较结果相等。</li>\r</ul>","type":"Function","name":"comparator","isOptional":true}],"package":"data","isStatic":true,"memberOf":"dorado.DataUtil"}],"constructors":[],"events":[]}