SYMBOLS["dorado.Entity"]={"name":"Entity","type":"class","desc":null,"alias":"dorado.Entity","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 创建一个空的实体对象，由于未指定实体数据类型，我们可以随意的访问实体对象中的任意属性。 var entity = new\r         dorado.Entity(); entity.set(\"property1, \"value1\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 将一个JSON对象封装为实体对象，同时利用$dataType指定实体数据类型。 var employee = {\r         $dataType : \"Employee\", id : \"0001\", name : \"John\", sex : true };\r         var entity = new dorado.Entity(employee,\r         view.dataTypeRepository); entity.get(\"name\"); //\r         只能访问Employee类型中存在属性。"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var employee = { id : \"0001\", name : \"John\", sex : true };\r\rvar Employee = new EntityDataType(\"Employee\");\rEmployee.addPropertyDef(new PropertyDef(\"id\"));\rEmployee.addPropertyDef(new PropertyDef(\"name\"));\rEmployee.addPropertyDef(new PropertyDef(\"sex\"));\r // 将一个JSON对象封装为实体对象，同时利用dataType参数指定实体数据类型。 var entity = new\rdorado.Entity(employee, null, Employee); entity.get(\"name\"); //\r只能访问Employee类型中存在属性。\r // 创建一个空的、类型为Employee的实体对象。 var entity = new dorado.Entity(null, null,\rEmployee); entity.set(\"name\", \"Mike\"); // 只能访问Employee类型中存在属性。"}],"classDesc":"实体对象。\r       <p>\r       在创建一个实体对象时，我们既可以为其指定实体数据类型，也可以不指定。<br/>\r       如果指定了实体数据类型，那么访问该实体对象的属性，这些属性必须存在于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityDataType')\">dorado.EntityDataType</A>的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.PropertyDef')\">dorado.PropertyDef</A>中。<br/>\r       如果为指定实体数据类型，就可以随意的访问实体对象中的任意属性。\r       </p>\r       <p>\r       为实体对象指定实体数据类型的方法有两种:<br/>\r       一是利用构造方法中的dataType参数直接指定，此时dorado.Entity的三个构造参数中只有dataType是必须指定的。<br/>\r       二是利用被封装的JSON对象中的$dataType属性，此时dorado.Entity的三个构造参数中的data和dataTypeRepository是必须指定的。\r       例如以下的JSON对象说明其对应的数据类型应为\"Employee\"。\r\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\r{\r\t$dataType : &quot;Employee&quot;,\r\tid : &quot;0001&quot;,\r\tname : &quot;John&quot;,\r\tsex : true\r}\r</code>\r</pre>\r\r</p>\r       <p>\r       注意：一旦我们将某个JSON数据对象封装为实体对象，那么这个JSON数据对象将将会被实际对象完全接管。\r       实体对象会根据自己的需要修改其中的属性、甚至增加属性。因此该JSON数据对象的有效性和完整性将不再得到保障。\r       </p>","package":"data","memberOf":"dorado","properties":[{"name":"dataProvider","type":"dorado.DataProvider","desc":"获取为实体对象提供数据的数据提供者。","alias":"dorado.Entity#dataProvider","visibility":"public","memberOf":"dorado.Entity","package":"data"},{"name":"parameter","type":"Object","desc":"装载数据使用的附加参数。","alias":"dorado.Entity#parameter","visibility":"public","memberOf":"dorado.Entity","package":"data"},{"name":"entityId","type":"long","desc":"实体对象的id。","alias":"dorado.Entity#entityId","visibility":"public","memberOf":"dorado.Entity","package":"data"},{"name":"timestamp","type":"int","desc":"实体对象的时间戳。\r<p>\r每当实体对象中的数据或状态发生了改变，实体对象都会更新自己的时间戳，\r因此，时间戳可以可以用来判断实体对象中的数据或状态在一段时间内有没有被修改过。\r</p>","alias":"dorado.Entity#timestamp","visibility":"public","memberOf":"dorado.Entity","package":"data"},{"name":"dataTypeRepository","type":"dorad.DataRepository","desc":"该实体对象中的数据类型所属的数据类型管理器。","alias":"dorado.Entity#dataTypeRepository","visibility":"public","memberOf":"dorado.Entity","package":"data"},{"name":"dataType","type":"dorado.EntityDataType","desc":"该实体对象对应的实体数据类型。","alias":"dorado.Entity#dataType","visibility":"public","memberOf":"dorado.Entity","package":"data"},{"name":"state","type":"int","desc":"实体对象的状态。","alias":"dorado.Entity#state","visibility":"public","defaultValue":"dorado.Entity.STATE_NONE","memberOf":"dorado.Entity","package":"data"},{"name":"STATE_NONE","type":"int","desc":"实体对象的状态常量 - 无状态。","alias":"dorado.Entity.STATE_NONE","visibility":"public","isStatic":true,"memberOf":"dorado.Entity","package":"data"},{"name":"STATE_NEW","type":"int","desc":"实体对象的状态常量 - 新增状态。","alias":"dorado.Entity.STATE_NEW","visibility":"public","isStatic":true,"memberOf":"dorado.Entity","package":"data"},{"name":"STATE_MODIFIED","type":"int","desc":"实体对象的状态常量 - 已修改状态。","alias":"dorado.Entity.STATE_MODIFIED","visibility":"public","isStatic":true,"memberOf":"dorado.Entity","package":"data"},{"name":"STATE_DELETED","type":"int","desc":"实体对象的状态常量 - 已删除状态。","alias":"dorado.Entity.STATE_DELETED","visibility":"public","isStatic":true,"memberOf":"dorado.Entity","package":"data"},{"name":"STATE_MOVED","type":"int","desc":"实体对象的状态常量 - 被移动状态。 通产指该对象被从一个位置移动到了另一个位置，这包括其父对象的改变或仅仅是顺序被改变。","alias":"dorado.Entity.STATE_MOVED","visibility":"public","isStatic":true,"memberOf":"dorado.Entity","package":"data"}],"attributes":[],"methods":[{"name":"disableObservers","type":"method","desc":"禁止dorado.Entity将消息发送给其观察者。\r<p>\r该方法的主要作用是阻止与该实体对象关联的数据控件自动根据实体对象的变化刷新自身的显示内容，\r这样做的目的一般是为了提高对实体对象连续进行操作时的运行效率。\r</p>","alias":"dorado.Entity#disableObservers","visibility":"public","package":"data","memberOf":"dorado.Entity"},{"name":"enableObservers","type":"method","desc":"允许dorado.Entity将消息发送给其观察者。","alias":"dorado.Entity#enableObservers","visibility":"public","package":"data","memberOf":"dorado.Entity"},{"name":"notifyObservers","type":"method","desc":"通知dorado.Entity的观察者刷新数据。","alias":"dorado.Entity#notifyObservers","visibility":"public","package":"data","memberOf":"dorado.Entity"},{"name":"setState","type":"method","desc":"设置实体对象的状态。","alias":"dorado.Entity#setState","visibility":"public","params":[{"desc":"状态。","type":"int","name":"state"}],"package":"data","memberOf":"dorado.Entity"},{"name":"getPropertyDef","type":"method","desc":"根据名称返回某属性对应的PropertyDef。","alias":"dorado.Entity#getPropertyDef","visibility":"public","params":[{"desc":null,"type":"String","name":"property"}],"returns":{"desc":"得到的属性值。","type":"dorado.PropertyDef"},"package":"data","memberOf":"dorado.Entity"},{"name":"get","type":"method","desc":"获取属性值。\r<p>\r此方法还支持迭代式的属性读取，及通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.Entity的派生类还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r</p>","alias":"dorado.Entity#get","visibility":"public","params":[{"desc":"要获取的属性名。","type":"String","name":"property"},{"desc":"数据装载模式。<br/>\r           包含下列三种取值:\r           <ul>\r           <li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r           <li>auto - 如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r           <li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r           </ul>","type":"String","name":"loadMode","isOptional":true,"defaultValue":"\"always\""}],"returns":{"desc":"得到的属性值。","type":"Object"},"package":"data","memberOf":"dorado.Entity"},{"name":"getAsync","type":"method","desc":"以异步操作的方式获取属性值。\r<p>\r此方法还支持迭代式的属性读取，及通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.Entity的派生类还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r</p>","alias":"dorado.Entity#getAsync","visibility":"public","params":[{"desc":"要获取的属性名。","type":"String","name":"property"},{"desc":"回调对象，传入回调对象的参数即为得到的属性值。","type":"Function|dorado.Callback","name":"callback"},{"desc":"数据装载模式。<br/>\r           包含下列三种取值:\r           <ul>\r           <li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r           <li>auto - 对于异步操作而言此选项没有实际意义，系统内部的处理方法将与always完全一致。</li>\r           <li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r           </ul>","type":"String","name":"loadMode","isOptional":true,"defaultValue":"\"always\""}],"package":"data","memberOf":"dorado.Entity"},{"name":"getText","type":"method","desc":"获取属性的文本值。\r<p>\r该值可用于界面显示，例如：对于一个日期类型属性，是此方法可以得到经格式化处理之后的日期字符串。 具体的格式化方式由相应<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.PropertyDef')\">dorado.PropertyDef</A>中的displayFormat属性决定。\r</p>","alias":"dorado.Entity#getText","visibility":"public","params":[{"desc":"要获取的属性名。","type":"String","name":"property"},{"desc":"数据装载模式。<br/>\r           包含下列三种取值:\r           <ul>\r           <li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r           <li>auto - 如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r           <li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r           </ul>","type":"String","name":"loadMode","isOptional":true,"defaultValue":"\"always\""}],"returns":{"desc":"属性的文本值。","type":"String"},"package":"data","memberOf":"dorado.Entity"},{"name":"getTextAsync","type":"method","desc":"以异步方式获取属性的文本值。","alias":"dorado.Entity#getTextAsync","see":["dorado.Entity#getText"],"visibility":"public","params":[{"desc":"要获取的属性名。","type":"String","name":"property"},{"desc":"回调对象，传入回调对象的参数即为得到的属性的文本值。","type":"Function|dorado.Callback","name":"callback"},{"desc":"数据装载模式。<br/>\r           包含下列三种取值:\r           <ul>\r           <li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r           <li>auto - 对于异步操作而言此选项没有实际意义，系统内部的处理方法将与always完全一致。</li>\r           <li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r           </ul>","type":"String","name":"loadMode","isOptional":true,"defaultValue":"\"always\""}],"package":"data","memberOf":"dorado.Entity"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.Entity#set","visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r           <ul>\r           <li>当property为String时，系统会将property的作为要设置属性名处理。属性值为value参数代表的值。</li>\r           <li>\r           当property为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r           <p>\r           在此种使用方法中，有一种情况需要注意。见下面的这种代码：\r\r<pre class=\"symbol-example code\">\r\t<code class=\"javascript\">\remployee.set({\r\tname : &quot;John&quot;,\r\tcontact : {\r\t\tmobile : &quot;253466-436&quot;,\r\t\tmsn : &quot;asgee@xmail.com&quot;\r\t}\r});\r</code>\r\t</pre>\r\r<ul>\r           <li>\r           如果当前employee的contact属性为null，那么Dorado会自动添加一个新的Contact实体，并设置好其中的mobile和msn这两个子属性的值。\r           完成后，子Contact对象的状态将是NEW。 </li>\r           <li>\r           如果当前employee的contact属性不为null，那么Dorado会直接修改这个已存在的Contact实体的mobile和msn这两个子属性的值。\r           完成后，子Contact对象的状态将是MODIFIED或NEW。 </li>\r           </ul>\r           </p>\r           </li>\r           </ul>","type":"String","name":"property"},{"desc":"要设置的属性值。","type":"Object","name":"value"}],"returns":{"desc":null},"package":"data","memberOf":"dorado.Entity"},{"name":"setText","type":"method","desc":"以文本方式设置属性的值。\r<p>\r此处的文本值是指用于界面显示的文本，例如：对于一个日期类型属性，通过此方法设置时应传入与displayFormat属性匹配的日期格式文本。\r</p>","alias":"dorado.Entity#setText","visibility":"public","params":[{"desc":"要设置的属性名。","type":"String","name":"property"},{"desc":"要设置的属性值。","type":"String","name":"text"}],"package":"data","memberOf":"dorado.Entity"},{"name":"cancel","type":"method","desc":"取消对当前数据实体的各种数据操作。\r<ul>\r<li>如果此数据实体的状态是dorado.Entity.STATE_NEW，那么此操作将会删除此数据实体。</li>\r<li>如果此数据实体的状态是dorado.Entity.STATE_MODIFIED，那么此操作将会还原数据实体中的数据，并重置状态。</li>\r<li>如果此数据实体的状态是dorado.Entity.STATE_DELETE，那么此操作将会还原数据实体，并重置状态。</li>\r<li>如果此数据实体的状态是dorado.Entity.STATE_NONE，那么什么都不会发生。</li>\r<li>如果此数据实体的状态是dorado.Entity.STATE_MOVED，那么此操作将会还原数据实体，但不会重置状态。</li>\r</ul>","alias":"dorado.Entity#cancel","visibility":"public","params":[{"desc":"是否执行深度撤销。即一并撤销所有子实体（包括子实体中的子实体）的修改。","type":"boolean","name":"deep"}],"package":"data","memberOf":"dorado.Entity"},{"name":"reset","type":"method","desc":"重设实体对象。\r<p>\r此方法不会改变Entity的状态。但会重置那些通过引用属性(ReferencePropertyDef)装载的关联数据，引起这些关联数据的重新装载。\r</p>","alias":"dorado.Entity#reset","visibility":"public","params":[{"desc":"要重置的引用属性的属性名。如果需要定义多个，可以用“,”分隔。","type":"String","name":"property","isOptional":true}],"package":"data","memberOf":"dorado.Entity"},{"name":"createBrother","type":"method","desc":"创建并返回一个兄弟实体对象。即创建一个与本实体对象相同类型的新实体对象。","alias":"dorado.Entity#createBrother","visibility":"public","params":[{"desc":"新创建的实体对象要封装JSON数据对象，可以不指定此参数。","type":"Object|dorado.Entity","name":"data","isOptional":true},{"desc":"是否需要返回一个游离的实体对象。\r           如果本实体对象已经隶属于一个实体集合，那么默认情况下此方法会将新创建的实体对象追加到该集合中。\r           通过detached参数可以指定本方法不将新的实体对象追加到集合；<br/>\r           如果本实体对象不隶属于实体集合，那么detached参数将没有实际作用，新的实体对象将总是游离的。","type":"boolean","name":"detached","isOptional":true}],"returns":{"desc":"新创建的实体对象。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.Entity"},{"name":"createChild","type":"method","desc":"创建并返回一个子实体对象。","alias":"dorado.Entity#createChild","visibility":"public","params":[{"desc":"子实体对象对应的属性名。","type":"String","name":"property"},{"desc":"新创建的实体对象要封装JSON数据对象，可以不指定此参数。","type":"Object|dorado.Entity","name":"data","isOptional":true},{"desc":"是否需要返回一个游离的实体对象。\r           默认情况下，新创建的子实体对象会直接被设置到本实体对象的属性中。\r           通过detached参数可以指定本方法不将新的子实体对象附着到本实体对象中。<br/>\r           需要注意的是，如果子属性的数据类型为集合类型(<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AggregationDataType')\">dorado.AggregationDataType</A>)。\r           那么，新创建的子实体对象会被追加到该属性对应的实体集合中。如果属性的值为空，则测方法还会自动为该属性创建一个匹配的实体集合。","type":"boolean","name":"detached","isOptional":true}],"returns":{"desc":"新创建的实体对象。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.Entity"},{"name":"getPrevious","type":"method","desc":"返回与当前数据实体平级的前一个数据实体。\r<p>\r注意：此方法不会导致集合的自动装载动作。如果本数据实体不在某个实体集合中,那么此方法将直接返回null。\r</p>","alias":"dorado.Entity#getPrevious","visibility":"public","returns":{"desc":"前一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.Entity"},{"name":"getNext","type":"method","desc":"返回与当前数据实体平级的下一个数据实体。\r<p>\r注意：此方法不会导致集合的自动装载动作。如果本数据实体不在某个实体集合中,那么此方法将直接返回null。\r</p>","alias":"dorado.Entity#getNext","visibility":"public","returns":{"desc":"下一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.Entity"},{"name":"setCurrent","type":"method","desc":"将此数据实体设置为其目前所在的实体集合中的当前实体。\r<p>\r<b>一个数据实体某一时刻最多只能隶属于一个实体集合。</b><br/>\r如果此数据实体目前不属于任何实体集合，则此方法什么也不做。\r</p>","alias":"dorado.Entity#setCurrent","see":["dorado.EntityList#setCurrent"],"visibility":"public","params":[{"desc":"是否同时要将此数据实体之上的每一级父对象都设置为当前数据实体。","type":"boolean","name":"cascade","isOptional":true}],"package":"data","memberOf":"dorado.Entity"},{"name":"clearData","type":"method","desc":"清空本数据实体中所有的数据。","alias":"dorado.Entity#clearData","visibility":"public","package":"data","memberOf":"dorado.Entity"},{"name":"fromJSON","type":"method","desc":"将给定的JSON对象中的数据转换成为数据实体。","alias":"dorado.Entity#fromJSON","visibility":"public","params":[{"desc":"要转换的JSON对象。","type":"Object","name":"json"}],"package":"data","memberOf":"dorado.Entity"},{"name":"toJSON","type":"method","desc":"将实体对象转换成一个JSON数据对象。","alias":"dorado.Entity#toJSON","visibility":"public","params":[{"desc":"转换选项。","type":"Object","name":"options","isOptional":true},{"desc":"属性名数组，表示只转换该数组中列举过的属性。如果不指定此属性表示转换实体对象中的所有属性。","type":"String[]","name":"options.properties","isOptional":true},{"desc":"是否转换实体对象中那么submittable=false的属性（见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.PropertyDef#attribute:submittable')\">dorado.PropertyDef#attribute:submittable</A>）。默认按true进行处理。","type":"boolean","name":"options.includeUnsubmittableProperties","isOptional":true,"defaultValue":"true"},{"desc":"是否转换实体对象中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Reference')\">dorado.Reference</A>类型的属性。默认按true进行处理。","type":"boolean","name":"options.includeReferenceProperties","isOptional":true,"defaultValue":"true"},{"desc":"数据装载模式，此属性仅在options.includeReferenceProperties=true为true时有效。<br/>\r           包含下列三种取值:\r           <ul>\r           <li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r           <li>auto - 如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r           <li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r           </ul>","type":"String","name":"options.loadMode","isOptional":true,"defaultValue":"\"never\""},{"desc":"是否转换<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中尚未装载的页中的数据。\r           此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到实体对象内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON方法中，\r           因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的处理过程。 默认按true进行处理。","type":"boolean","name":"options.includeUnloadPage","isOptional":true},{"desc":"是否转换那些被标记为\"已删除\"的数据实体。 此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到实体对象内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON方法中，\r           因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的处理过程。 默认按false进行处理。","type":"boolean","name":"options.includeDeletedEntity","isOptional":true},{"desc":"是否只生成简单类型的属性到JSON中。","type":"boolean","name":"options.simplePropertyOnly","isOptional":true},{"desc":"是否在JSON对象中生成DataType信息，生成的DataType信息将被放置在名为$dataType的特殊子属性中。\r           注意：此属性的只对顶层JSON对象有效，即此方法永远不会为子JSON对象生成DataType信息。","type":"boolean","name":"options.generateDataType","isOptional":true},{"desc":"是否在JSON对象中生成实体对象的状态信息(即新增、已更改等状态)，生成的状态信息将被放置在名为$state的特殊子属性中。","type":"boolean","name":"options.generateState","isOptional":true},{"desc":"是否在JSON对象中生成实体对象的ID，生成的状态信息将被放置在名为$entityId的特殊子属性中。","type":"boolean","name":"options.generateEntityId","isOptional":true},{"desc":"是否在JSON对象中生成旧数据，生成的状态信息将被放置在名为$oldData的特殊子属性中。","type":"boolean","name":"options.generateOldData","isOptional":true},{"desc":"用户自定义的数据实体过滤函数，返回true/false表示是否需要将此当前数据实体转换到JSON中。\r           此函数的传入参数如下：","type":"Function","name":"options.entityFilter","isOptional":true},{"desc":"当前正被过滤的数据实体。","type":"dorado.Entity","name":"options.entityFilter.entity","isOptional":true}],"returns":{"desc":"得到的JSON数据对象。","type":"Object"},"package":"data","memberOf":"dorado.Entity"},{"name":"getWrapper","type":"method","desc":"将实体对象转换成一个可以以类似JSON方式来读写的代理对象。","alias":"dorado.Entity#getWrapper","visibility":"public","params":[{"desc":"转换选项。","type":"Object","name":"options","isOptional":true},{"desc":"是否代理Entity的getText方法。该选项默认值为false，表示代理Entity的get方法。","type":"boolean","name":"options.textMode","isOptional":true,"defaultValue":"false"},{"desc":"是否以只读方式代理Entity。该选项默认值为false。","type":"boolean","name":"options.readOnly","isOptional":true,"defaultValue":"false"},{"desc":"是否处理<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中尚未装载的页中的数据。\r           此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的getWrapper而言是没有意义的，但是由于options参数会自动被传递到实体对象内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的getWrapper方法中，\r           因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的处理过程。 默认按false进行处理。","type":"boolean","name":"options.includeUnloadPage","isOptional":true}],"returns":{"desc":"得到的代理对象。","type":"Object"},"package":"data","memberOf":"dorado.Entity"},{"name":"getOldData","type":"method","desc":"返回数据实体内部用于保存原有属性值的JSON对象。","alias":"dorado.Entity#getOldData","visibility":"public","returns":{"desc":"JSON对象。<br/>\r        注意：该对象可能并不存在。","type":"Object"},"package":"data","memberOf":"dorado.Entity"},{"name":"getMessages","type":"method","desc":"返回当前数据实体关联的额外信息的数组。","alias":"dorado.Entity#getMessages","visibility":"public","params":[{"desc":"属性名。\r           <p>\r           如果在调用时指定了这个参数，这表示要读取跟某个属性关联的额外信息。否则表示读取跟整个数据实体关联的额外信息。\r           </p>","type":"String","name":"property","isOptional":true}],"returns":{"desc":"[Object] 额外信息的数组。数组中的每一个元素是一个JSON对象，该JSON对象包含以下属性：\r        <ul>\r        <li>state - {String}\r        信息级别。取值范围包括：info、ok、warn、error。默认值为error。</li>\r        <li>text - {String} 信息内容。</li>\r        </ul>"},"package":"data","memberOf":"dorado.Entity"},{"name":"setMessages","type":"method","desc":"设置当前数据实体关联的额外信息的数组。\r<p>\r此方法有两种调用方式：\r<ul>\r<li>当我们为此方法传递一个传入参数时，表示要将传入的额外信息关联到整个数据实体上。</li>\r<li>当我们为此方法传递两个传入参数时，表示要将额外信息关联到数据实体的某个具体属性上。\r此时第一个参数将被认为是属性名，第二个参数被认为是额外信息。</li>\r</ul>\r</p>","alias":"dorado.Entity#setMessages","visibility":"public","params":[{"desc":"属性名。","type":"String","name":"property","isOptional":true},{"desc":"额外信息。\r           <p>\r           调用此方法时，既可以传入单个的信息，也可以传入信息的数组。\r           对于每一个信息既可以是一个描述信息完整信息的JSON对象，也可以是一个简单的字符窜（此时系统会自动将其信息级别处理为error）。\r           </p>","type":"String|Object|[String]|[Object]","name":"messages","isOptional":true}],"package":"data","memberOf":"dorado.Entity"},{"name":"getMessageState","type":"method","desc":"返回当前数据实体中最高的信息级别。即系统认为error高于warn高于ok高于info。","alias":"dorado.Entity#getMessageState","visibility":"public","params":[{"desc":"属性名。\r           <p>\r           如果在调用时指定了这个参数，这表示要返回跟某个属性的最高信息级别。否则表示读取跟整个数据实体关联的最高信息级别。\r           </p>","type":"String","name":"property","isOptional":true}],"returns":{"desc":"最高的验证信息级别。取值包括: error、warn、ok、info。","type":"String"},"package":"data","memberOf":"dorado.Entity"},{"name":"getValidateState","type":"method","desc":"返回数据实体中某属性校验状态。","alias":"dorado.Entity#getValidateState","visibility":"public","params":[{"desc":"属性名。","type":"Object","name":"property"}],"returns":{"desc":"校验状态。取值包括:\r        <ul>\r        <li>unvalidate - 尚未校验。</li>\r        <li>validating - 正在校验，指正有异步的校验过程仍未结束。</li>\r        <li>ok - 校验通过。</li>\r        <li>warn - 校验的返回信息中包含警告。</li>\r        <li>error - 校验未通过或校验失败。</li>\r        </ul>","type":"String"},"package":"data","memberOf":"dorado.Entity"},{"name":"validate","type":"method","desc":"验证此数据实体中的数据当前是否是有效的，即是否可以被提交保存。\r<p>\r关于是否有效的判断会与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityDataType#attribute:acceptValidationResult')\">dorado.EntityDataType#attribute:acceptValidationResult</A>的设置相关。\r</p>","alias":"dorado.Entity#validate","visibility":"public","params":[{"desc":"此参数有如下三种使用方式：\r           <ul>\r           <li>当传入一个String类型的值时，表示要校验的子属性，如果不指定则表示校验所有属性。</li>\r           <li>当传入一个boolean类型的值时，表示是否强制重新验证所有子属性及校验器。默认为true。</li>\r           <li>当传入一个JSON对象时，其中有可以包含如下的更多选项。</li>\r           </ul>","type":"String|boolean|Object","name":"options","isOptional":true,"defaultValue":"true"},{"desc":"要校验的子属性，如果不指定则表示校验所有属性。","type":"String","name":"options.property","isOptional":true},{"desc":"是否强制重新验证所有子属性及校验器。","type":"boolean","name":"options.force","isOptional":true,"defaultValue":"true"},{"desc":"只验证简单数据类型的属性中的数据，如String、boolean、int、Date等数据类型。\r           设置此属性产生的实际结果是验证逻辑将忽略对此数据实体中的所有子数据实体的有效性验证。","type":"boolean","name":"options.validateSimplePropertyOnly","isOptional":true,"defaultValue":"true"},{"desc":"是否重新执行那些异步的校验器。","type":"boolean","name":"options.preformAsyncValidator","isOptional":true},{"desc":"验证上下文。<br/>\r           传入此参数的目的通常是用于获得更加验证详尽的验证结果。此上下文对象中可以包含如下的返回属性：\r           <ul>\r           <li>result - {String} 验证结果。等同于此方法的返回值。</li>\r           <li>info - {[Object]}\r           包含所有info级别验证结果的数组。数组中的每一个元素是一个JSON对象，该JSON对象包含以下属性：\r           <ul>\r           <li>entity - {dorado.Entity} 相关的数据实体。</li>\r           <li>property - {String} 相关的数据实体属性。</li>\r           <li>state - {String}\r           信息级别。取值范围包括：info、ok、warn、error。默认值为error。</li>\r           <li>text - {String} 信息内容。</li>\r           </ul>\r           </li>\r           <li>ok - {[Object]} 包含所有ok级别验证结果的数组。同上。</li>\r           <li>warn - {[Object]} 包含所有warn级别验证结果的数组。同上。</li>\r           <li>error - {[Object]} 包含所有error级别验证结果的数组。同上。</li>\r           <li>executing - {[Object]}\r           尚未完成的异步验证过程描述信息的数组。数组中的每一个元素是一个JSON对象，该JSON对象包含以下属性：\r           <ul>\r           <li>entity - {dorado.Entity} 相关的数据实体。</li>\r           <li>property - {String} 相关的数据实体属性。</li>\r           <li>num - {int} 正在执行的验证过程的个数。</li>\r           </ul>\r           </li>\r           <li>executingValidationNum - {int} 总的正在执行的验证过程的个数。</li>\r           </ul>","type":"Object","name":"options.context","isOptional":true}],"returns":{"desc":"验证结果，可能会有如下3种返回值：\r        <ul>\r        <li>invalid - 表示本数据实体未通过数据验证，不能被提交。</li>\r        <li>ok - 表示本数据实体已通过验证，可以提交。</li>\r        </ul>","type":"String"},"package":"data","memberOf":"dorado.Entity"},{"name":"isDirty","type":"method","desc":"判断数据实体或数据实体中某属性中是否包含未提交的信息。","alias":"dorado.Entity#isDirty","visibility":"public","params":[{"desc":"要判断的属性。如果不定义则表示希望判断整个数据实体是否包含未提交的信息。","type":"String","name":"property","isOptional":true}],"returns":{"desc":"是否包含未提交的信息。","type":"boolean"},"package":"data","memberOf":"dorado.Entity"},{"name":"isCascadeDirty","type":"method","desc":"迭代式的判断该数据实体及其所有子数据实体中是否是否包含任何未提交的信息。","alias":"dorado.Entity#isCascadeDirty","visibility":"public","returns":{"desc":"是否包含未提交的信息。","type":"boolean"},"package":"data","memberOf":"dorado.Entity"},{"name":"flush","type":"method","desc":"重新装载当前实体中的数据。","alias":"dorado.Entity#flush","visibility":"public","params":[{"desc":null,"name":"callback"}],"package":"data","memberOf":"dorado.Entity"},{"name":"flushAsync","type":"method","desc":"以异步方式重新装载实体中的数据。","alias":"dorado.Entity#flushAsync","visibility":"public","params":[{"desc":"回调对象。","type":"Function|dorado.Callback","name":"callback"}],"package":"data","memberOf":"dorado.Entity"},{"name":"remove","type":"method","desc":"从所属的实体集合<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中删除本实体对象。\r如果本实体对象尚不属于任何实体集合，则此方法不会产生实际的作用。","alias":"dorado.Entity#remove","visibility":"public","params":[{"desc":"是否彻底断开被删除的数据实体与集合之间的关联。默认为不断开。<br/>\r           在通常情况下，当我们从集合中删除一个数据实体时，dorado只是在内部处理中将数据实体的状态标记为已删除状态而并没有真正的将数据实体从合集中移除掉。\r           这样做的目的是为了便于在今后提交时能够清晰的掌握集合中的元素究竟做过哪些改变。","type":"boolean","name":"detach","isOptional":true}],"package":"data","memberOf":"dorado.Entity"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.Entity","params":[{"desc":"要封装JSON数据对象。","type":"Object","name":"data","isOptional":true},{"desc":"数据类型的管理器。","type":"dorado.DataTypeRepository","name":"dataTypeRepository","isOptional":true},{"desc":"实体对象的数据类型。","type":"dorado.EntityDataType","name":"dataType","isOptional":true}]}],"events":[]}