SYMBOLS["dorado.EntityDataType"]={"name":"EntityDataType","type":"class","desc":null,"alias":"dorado.EntityDataType","author":"Benny Bao (mailto:benny.bao@bstek.com)","see":["dorado.PropertyDef","dorado.Reference","dorado.Lookup"],"classDesc":"实体类型。\r<p>\rEntityDataType的get方法在<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>的基础上做了增强。\r除了原有的读取属性值的功能之外，此方法还另外提供了下面的用法。\r<ul>\r   <li>当传入一个以#开头的字符串时，#后面的内容将被识别成属性声明的名称，表示根据名称获取属性声明。参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityDataType#getPropertyDef')\">dorado.EntityDataType#getPropertyDef</A>。</li>\r</ul>\r</p>","package":"data","inheritsFrom":["dorado.DataType","dorado.EventSupport"],"memberOf":"dorado","properties":[{"name":"ATTRIBUTES","type":"Object","desc":"用于声明该对象中所支持的所有Attribute。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.AttributeSupport#ATTRIBUTES","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的caption属性的声明。\rvar attributeDef = oop.ATTRIBUTES.caption。\r// 判断该属性是否只读\rif (attributeDef.readOnly) { ... ... }"}],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"objects","type":"dorado.AttributeSupport[]","desc":"对象数组。","alias":"dorado.AttributeSupport#objects","visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"}],"attributes":[{"name":"acceptUnknownProperty","type":"boolean","desc":"是否允许外界访问实体中尚未声名的属性。","alias":"dorado.EntityDataType#attribute:acceptUnknownProperty","visibility":"public","memberOf":"dorado.EntityDataType","package":"data"},{"name":"defaultDisplayProperty","type":"String","desc":"默认的显示属性。\r<p>\r当系统需要将一个属于此类型的数据实体转换成用于显示的文本时（即相当于调用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity#toText')\">dorado.Entity#toText</A>方法时），\r如果此时数据类型中定义了此值，那么系统将直接使用此值所代表的属性的属性值作为整个数据实体的显示文本。\r</p>\r<p>\r例如一个Employee类型中有id、name、sex、phone等很多属性，如果我们定义了Employee类型的defaultDisplayProperty=name，\r那么系统会将直接用name属性的值作为其隶属的数据实体的显示文本。\r</p>","alias":"dorado.EntityDataType#attribute:defaultDisplayProperty","visibility":"public","memberOf":"dorado.EntityDataType","package":"data"},{"name":"acceptValidationState","type":"String","desc":"当数据实体需要确认其中的内容修改时，最高可以接受哪个级别的验证信息。\r出此处给定的默认值ok之外，通常可选的值还有warn。info和error则一般不会作为此属性的值。","alias":"dorado.EntityDataType#attribute:acceptValidationState","see":["dorado.validator.Validator#validate","dorado.Entity#getValidationResults"],"visibility":"public","defaultValue":"\"ok\"","memberOf":"dorado.EntityDataType","package":"data"},{"name":"validatorsDisabled","type":"boolean","desc":"是否禁用其中所有的数据验证器。包括所有属性上的数据验证器。","alias":"dorado.EntityDataType#attribute:validatorsDisabled","visibility":"public","memberOf":"dorado.EntityDataType","package":"data"},{"name":"propertyDefs","type":"Object[]|dorado.PropertyDef[]","desc":"属性声明的集合。\r<p>\r此属性在读写时的意义不完全相同。\r<ul>\r<li>当读取时返回实体类型中属性声明的集合，类型为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.KeyedArray')\">dorado.util.KeyedArray</A>。</li>\r<li>当写入时用于添加属性声明。<br/>\r此处数组中既可以放入属性声明的实例，又可以放入JSON对象。\r具体请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityDataType#addPropertyDef')\">dorado.EntityDataType#addPropertyDef</A>。</li>\r</ul>\r</p>","alias":"dorado.EntityDataType#attribute:propertyDefs","visibility":"public","memberOf":"dorado.EntityDataType","package":"data"},{"name":"name","type":"String","desc":"数据类型的名称。","alias":"dorado.DataType#attribute:name","visibility":"public","memberOf":"dorado.DataType","package":"data","readOnly":true},{"name":"id","type":"String","desc":"用于在后端定位服务的id。如无特殊需要请不要修改。","alias":"dorado.DataType#attribute:id","visibility":"public","memberOf":"dorado.DataType","package":"data"},{"name":"dataTypeRepository","type":"dorado.DataTypeRepository","desc":"隶属的数据类型管理器。","alias":"dorado.DataType#attribute:dataTypeRepository","visibility":"public","memberOf":"dorado.DataType","package":"data","readOnly":true},{"name":"view","type":"dorado.widget.View","desc":"返回所属的视图。","alias":"dorado.DataType#attribute:view","visibility":"public","memberOf":"dorado.DataType","package":"data","readOnly":true},{"name":"userData","type":"Object","desc":"用户自定义数据。","alias":"dorado.DataType#attribute:userData","visibility":"public","memberOf":"dorado.DataType","package":"data"},{"name":"tags","type":"String|String[]","desc":"对象的标签。\r<p>\r开发人员可以为一个对象定义一到多个String型的标签，以便于后面快速的查找到一个或一批具有指定标签的对象。\r</p>","alias":"dorado.AttributeSupport#attribute:tags","see":["dorado.TagManager"],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true}],"methods":[{"name":"addPropertyDef","type":"method","desc":"向实体类型中添加一个属性声明。\r<p>\r此处数组中可放置两种类型的属性声明定义：\r   <ul>\r   <li>直接放入一个属性声明的实例对象。</li>\r   <li>放入含属性声明信息的JSON对象。<br/>\r此时可以使用子控件类型名称中\"dorado.\"和\"PropertyDef\"之间的部分作为$type的简写。\r如果$type为空或不指定$type，系统将会按照<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.PropertyDef')\">dorado.PropertyDef</A>来实例化。\r   </li>\r   </ul>\r</p>","alias":"dorado.EntityDataType#addPropertyDef","see":["dorado.PropertyDef","dorado.Reference","dorado.Toolkits.createInstance"],"visibility":"public","params":[{"desc":"要添加的属性声明或含属性声明信息的JSON对象。","type":"dorado.PropertyDef|Object","name":"propertyDef"}],"returns":{"desc":"dorado.PropertyDef 添加的属性声明。"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"removePropertyDef","type":"method","desc":"从实体类型中删除一个属性声明。","alias":"dorado.EntityDataType#removePropertyDef","visibility":"public","params":[{"desc":"要删除的属性声明。","type":"dorado.PropertyDef","name":"propertyDef"}],"package":"data","memberOf":"dorado.EntityDataType"},{"name":"removeAllPropertyDef","type":"method","desc":"从实体类型中删除所有属性声明。","alias":"dorado.EntityDataType#removeAllPropertyDef","visibility":"public","package":"data","memberOf":"dorado.EntityDataType"},{"name":"getPropertyDef","type":"method","desc":"根据属性名从实体类型返回相应的属性声明。","alias":"dorado.EntityDataType#getPropertyDef","visibility":"public","params":[{"desc":"属性名。","type":"String","name":"name"}],"returns":{"desc":"属性声明。","type":"dorado.PropertyDef"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"parse","type":"method","desc":"将传入的数据转换为一个实体对象。","alias":"dorado.EntityDataType#parse","visibility":"public","params":[{"desc":"要转换的数据","type":"Object","name":"data"}],"returns":{"desc":"转换后得到的实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"extend","type":"method","desc":"扩展本实体数据类型。即以当前的实体数据类型为模板，创建一个相似的、全新的实体数据类型。","alias":"dorado.EntityDataType#extend","visibility":"public","params":[{"desc":"新的实体数据类型的名称或构造参数。\r<p>\r此参数具有多态性，当我们传入一个String类型的参数时，该String值表示数据类型的name。\r当我们传入的参数是一个JSON对象时，系统会自动将该JSON对象中的属性复制到数据类型中。 <br/>\r如果没有在此步骤中没有为组件指定name，那么系统会自动为其分配一个name。\r</p>","type":"String|Object","name":"config"}],"returns":{"desc":"新的实体数据类型。","type":"dorado.EntityDataType"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"toText","type":"method","desc":"尝试将一个任意类型的值转换成本文本值。<br/>\r如需在子类中改变其逻辑其复写<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataType#doToText')\">dorado.DataType#doToText</A>方法。","alias":"dorado.DataType#toText","see":["dorado.DataType#doToText"],"visibility":"public","params":[{"desc":"要转换的数据。","type":"Object","name":"data"},{"desc":"转换时可能需要用到的参数。","type":"Object","name":"argument","isOptional":true}],"returns":{"desc":"转换后得到的文本。","type":"String"},"package":"data","memberOf":"dorado.DataType"},{"name":"doToText","type":"method","desc":"将一个任意类型的值转换成本文本值。此方法供子类复写。","alias":"dorado.DataType#doToText","see":["dorado.DataType#toText"],"visibility":"protected","params":[{"desc":"要转换的数据。","type":"Object","name":"data"},{"desc":"转换时可能需要用到的参数。","type":"Object","name":"argument","isOptional":true}],"returns":{"desc":"转换后得到的文本。","type":"String"},"package":"data","memberOf":"dorado.DataType"},{"name":"getAttributeWatcher","type":"method","desc":"返回与该对象关联的属性观察者。","alias":"dorado.AttributeSupport#getAttributeWatcher","visibility":"public","returns":{"desc":"属性观察者。","type":"dorado.AttributeWatcher"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"get","type":"method","desc":"读取指定的属性值。\r<p>\r此方法还支持迭代式的属性读取，即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.AttributeSupport的实例还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r如果碰到的中间对象dorado.AttributeSupport的实例，系统会自动读取它的Attribute；\r如果碰到的中间对象是普通的JSON对象，系统会直接读取它的属性。\r</p>","alias":"dorado.AttributeSupport#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"label\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"address.postCode\"); // 迭代式的属性读取\r// 如果address的属性值是一个dorado.AttributeSupport的实例，那么此行命令的效果相当于oop.get(\"address\").get(\"postCode\")。\r// 如果address的属性值是一个JSON对象，那么此行命令的效果相当于oop.get(\"address\").postCode"}],"visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"读取到的属性值。","type":"Object"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.AttributeSupport#set","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set(\"label\", \"Sample Text\"); oop.set(\"visible\", true);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set( { label : \"Sample Text\", visible : true });"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用属性迭代的特性为子对象中的属性赋值。\roop.set(\"address.postCode\", \"7232-00124\");\r... ...\roop.set({\r\t\"name\" : \"Toad\",\r\t\"address.postCode\" : \"7232-00124\"\r});\r// 上面的两行命令相当于\roop.get(\"address\").set(\"postCode\", \"7232-00124\")"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用上文中提及的第一种方法为label属性赋值，同时为onClick事件绑定一个监听器。\roop.set({\r label : \"Sample Text\",\r onClick : function(self, arg) {\r \t... ...\r }\r});"}],"visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r           <ul>\r           <li>当attr为String时，系统会将attr的作为要设置属性名处理。属性值为value参数代表的值。</li>\r           <li>当attr为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r           注意：当通过此方式为对象设置一系列属性时，系统只会跳过那些设置出错的属性，并不会给出错误信息，也不会中断正在执行的设置操作。</li>\r           </ul>\r           <p>\r           如同<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>方法，set方法也支持对属性进行迭代式的设置。\r           即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘，直到挖掘到倒数第二个子对象时停止并记录下一个子属性名，然后对该子对象的属性进行复制操作，请参考后面的例程。\r           </p>\r           <p>\r           set方法不但可以用于为对象的属性赋值，同时也可以用于为对象中的事件添加事件监听器。\r           <ul>\r           <li>直接以事件名称作为属性，以事件监听器作为属性值，进行赋值操作。</li>\r           <li>为对象listener属性赋值，具体方法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#attribute:listener')\">dorado.EventSupport#attribute:listener</A>。</li>\r           </ul>\r           虽然上述两种方法都可以实现添加事件监听器的功能，并且第一种方法看起来更加方便易用。但第二种方法却较第一种更为灵活。\r           例如：当我们需要一次性的为同一个事件绑定多个监听器，第一种方法是不能胜任的；\r           或者我们当我们批量的设置一组属性值和事件监听器时，第二种方法总是确保事件监听器首先被绑定然后才处理该操作中剩余的属性值的赋值（在绝大多数的场景的这样的顺序是更加合理的），\r           而此时如果使用第一种方法，监听器和属性值的处理顺序是难以预知的。\r           </p>","type":"String|Object","name":"attr"},{"desc":"此参数具有多重含义：要设置的属性值。当attr为Object时，此参数将被忽略。\r           <ul>\r           <li>当attr为String时，此参数代表要设置的属性值。</li>\r           <li>当attr为Object时，此参数可代表一组执行选项，见option参数的说明。</li>\r           </ul>","type":"Object","name":"value","isOptional":true},{"desc":"执行选项。此参数仅在attr参数为Object时有效。","type":"Object","name":"options","isOptional":true},{"desc":"是否忽略未知的属性。","type":"boolean","name":"options.skipUnknownAttribute","isOptional":true,"defaultValue":"false"},{"desc":"是否在发生错误后继续尝试后续的属性设置操作。","type":"boolean","name":"options.tryNextOnError","isOptional":true,"defaultValue":"false"},{"desc":"是否组织本次赋值操作覆盖对象中原有的属性值。\r           即对于那些已拥有值(曾经通过set方法写入过值)的属性跳过本次的赋值操作，而只对那些未定义过的属性进行赋值。","type":"boolean","name":"options.preventOverwriting","isOptional":true,"defaultValue":"false"}],"returns":{"desc":"返回对象自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"doSet","type":"method","desc":"用于实现为单个属性赋值的内部方法。","alias":"dorado.AttributeSupport#doSet","visibility":"protected","params":[{"desc":"要设置的属性名。","type":"String","name":"attr"},{"desc":"属性值。","type":"Object","name":"value"},{"desc":"是否忽略未知的属性。","type":"boolean","name":"skipUnknownAttribute","isOptional":true},{"desc":null,"name":"lockWritingTimes"}],"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"hasTag","type":"method","desc":"判断对象中是否定义了某个标签值。","alias":"dorado.AttributeSupport#hasTag","visibility":"public","params":[{"desc":"要判断的标签值。","type":"String","name":"tag"}],"returns":{"desc":"是否具有该标签值。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"}],"constructors":[],"events":[{"name":"beforeCurrentChange","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中的当前数据实体将要被改变前触发的事件。","alias":"dorado.EntityDataType#event:beforeCurrentChange","see":["dorado.EntityList#current","dorado.EntityList#setCurrent"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象集合。","type":"dorado.EntityList","name":"arg.entityList"},{"desc":"原先的当前数据实体。","type":"dorado.Entity","name":"arg.oldCurrent"},{"desc":"新的当前数据实体。","type":"dorado.Entity","name":"arg.newCurrent"},{"desc":"用于通知系统是否要继续完成后续动作。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onCurrentChange","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中的当前数据实体被改变后触发的事件。","alias":"dorado.EntityDataType#event:onCurrentChange","see":["dorado.EntityList#current","dorado.EntityList#setCurrent"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象集合。","type":"dorado.EntityList","name":"arg.entityList"},{"desc":"原先的当前数据实体。","type":"dorado.Entity","name":"arg.oldCurrent"},{"desc":"新的当前数据实体。","type":"dorado.Entity","name":"arg.newCurrent"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"beforeInsert","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中的将要插入一个新的数据实体前触发的事件。","alias":"dorado.EntityDataType#event:beforeInsert","see":["dorado.EntityList#insert"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象集合。","type":"dorado.EntityList","name":"arg.entityList"},{"desc":"将要插入的数据实体。","type":"dorado.Entity","name":"arg.entity"},{"desc":"插入方式。","type":"String","name":"arg.insertMode"},{"desc":"插入位置的参照数据实体。","type":"dorado.Entity","name":"arg.refEntity"},{"desc":"用于通知系统是否要继续完成后续动作。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onInsert","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中的插入一个新的数据实体后触发的事件。","alias":"dorado.EntityDataType#event:onInsert","see":["dorado.EntityList#insert"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象集合。","type":"dorado.EntityList","name":"arg.entityList"},{"desc":"新插入的数据实体。","type":"dorado.Entity","name":"arg.entity"},{"desc":"插入方式。","type":"String","name":"arg.insertMode"},{"desc":"插入位置的参照数据实体。","type":"dorado.Entity","name":"arg.refEntity"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"beforeRemove","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中的将要删除的一个数据实体前触发的事件。","alias":"dorado.EntityDataType#event:beforeRemove","see":["dorado.EntityList#remove"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象集合。","type":"dorado.EntityList","name":"arg.entityList"},{"desc":"将被删除的数据实体。","type":"dorado.Entity","name":"arg.entity"},{"desc":"用于通知系统是否要继续完成后续动作。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onRemove","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中的删除了一个数据实体后触发的事件。","alias":"dorado.EntityDataType#event:onRemove","see":["dorado.EntityList#remove"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象集合。","type":"dorado.EntityList","name":"arg.entityList"},{"desc":"被删除的数据实体。","type":"dorado.Entity","name":"arg.entity"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"beforeDataChange","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>中的属性值将要被改变前触发的事件。","alias":"dorado.EntityDataType#event:beforeDataChange","see":["dorado.Entity#set"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象。","type":"dorado.Entity","name":"arg.entity"},{"desc":"将要被改变的属性名。","type":"String","name":"arg.property"},{"desc":"原先的属性值。","type":"Object","name":"arg.oldValue"},{"desc":"将要写入的值。","type":"Object","name":"arg.newValue","writeable":true},{"desc":"用于通知系统是否要继续完成后续动作。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onDataChange","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>中的属性值被改变后触发的事件。","alias":"dorado.EntityDataType#event:onDataChange","see":["dorado.Entity#set"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象。","type":"dorado.Entity","name":"arg.entity"},{"desc":"被改变的属性名。","type":"String","name":"arg.property"},{"desc":"原先的属性值。","type":"Object","name":"arg.oldValue"},{"desc":"将要写入的值。","type":"Object","name":"arg.newValue"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"beforeStateChange","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的状态将要被改变前触发的事件。","alias":"dorado.EntityDataType#event:beforeStateChange","see":["dorado.Entity#state","dorado.Entity#setState"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象。","type":"dorado.Entity","name":"arg.entity"},{"desc":"原先的状态代码。","type":"int","name":"arg.oldState"},{"desc":"新的状态代码。","type":"int","name":"arg.newState"},{"desc":"用于通知系统是否要继续完成后续动作。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onStateChange","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的状态被改变后触发的事件。","alias":"dorado.EntityDataType#event:onStateChange","see":["dorado.Entity#state","dorado.Entity#setState"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象。","type":"dorado.Entity","name":"arg.entity"},{"desc":"原先的状态代码。","type":"int","name":"arg.oldState"},{"desc":"新的状态代码。","type":"int","name":"arg.newState"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onEntityLoad","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的被装载是触发的事件。<br/>\r此处所说的装载一般指数据实体从服务端被装载到客户端，在客户端添加一个数据实体不会触发此事件。","alias":"dorado.EntityDataType#event:onEntityLoad","visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象","type":"dorado.Entity","name":"arg.entity"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onMessageChange","type":"event","desc":"当某个此类型的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的额外信息被改变后触发的事件。","alias":"dorado.EntityDataType#event:onMessageChange","see":["dorado.Entity#getMessages","dorado.Entity#getMessageState","dorado.Entity#setMessages"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象。","type":"dorado.Entity","name":"arg.entity"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onEntityToText","type":"event","desc":"系统尝试将一个数据实体对象转换成一段用于显示的文本时触发的事件。","alias":"dorado.EntityDataType#event:onEntityToText","see":["dorado.Entity#state","dorado.Entity#setState"],"visibility":"public","params":[{"desc":"事件的发起者，即EntityDataType本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"触发事件的实体对象。","type":"dorado.Entity","name":"arg.entity"},{"desc":"转换得到的用于显示的文本。","type":"String","name":"arg.text","writeable":true},{"desc":"用于通知系统是否要继续完成后续动作。","type":"boolean","name":"arg.processDefault=false","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.EntityDataType"},{"name":"onAttributeChange","type":"event","desc":"当对象中的某属性值被改变时触发的事件。","alias":"dorado.AttributeSupport#event:onAttributeChange","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"发生改变的属性名。","type":"String","name":"arg.attribute"},{"desc":"新的属性值。","type":"Object","name":"arg.value"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}]}