SYMBOLS["dorado.EntityList"]={"name":"EntityList","type":"class","desc":null,"alias":"dorado.EntityList","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"实体对象集合。","package":"data","memberOf":"dorado","properties":[{"name":"current","type":"dorado.Entity","desc":"当前的数据实体。","alias":"dorado.EntityList#current","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"dataProvider","type":"dorado.DataProvider","desc":"获取为实体对象集合提供数据的数据提供者。","alias":"dorado.EntityList#dataProvider","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"parameter","type":"Object","desc":"装载数据使用的附加参数。\r<p>\r当集合需要通过DataProvider装载数据时，系统会将此处定义的参数合并到DataProvider原有的参数之上。 这里的合并可包含两种情况：\r当parameter是一个JSON对象时，系统会将该JSON对象中的个属性复制到DataProvider原有的参数之上；\r当parameter不是一个JSON对象时（如String、int等），系统会直接用此参数替换DataProvider原有的参数。\r</p>","alias":"dorado.EntityList#parameter","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"timestamp","type":"int","desc":"集合的时间戳。<br/>\r集合的元素有增减、或者有新的页被装载时，集合都会更新自己的时间戳， 因此，时间戳可以可以用来判断集合在一段时间内有没有被修改过。","alias":"dorado.EntityList#timestamp","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"dataTypeRepository","type":"dorad.DataRepository","desc":"该集合中的数据类型所属的数据类型管理器。","alias":"dorado.EntityList#dataTypeRepository","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"dataType","type":"dorado.AggregationDataType","desc":"集合数据类型。","alias":"dorado.EntityList#dataType","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"elementDataType","type":"dorado.EntityDataType","desc":"集合中元素的数据类型。","alias":"dorado.EntityList#elementDataType","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"pageSize","type":"int","desc":"进行分页浏览时每页的记录数。默认值为0。","alias":"dorado.EntityList#pageSize","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"pageNo","type":"int","desc":"当前位置所处的页号。默认值为1。","alias":"dorado.EntityList#pageNo","visibility":"public","defaultValue":"1","memberOf":"dorado.EntityList","package":"data"},{"name":"pageCount","type":"int","desc":"总的页数（包含尚未装载的页）。","alias":"dorado.EntityList#pageCount","visibility":"public","memberOf":"dorado.EntityList","package":"data"},{"name":"entityCount","type":"int","desc":"总的记录数（包含尚未装载的页中的记录数）。","alias":"dorado.EntityList#entityCount","visibility":"public","memberOf":"dorado.EntityList","package":"data"}],"attributes":[],"methods":[{"name":"disableObservers","type":"method","desc":"禁止dorado.EntityList将消息发送给其观察者。\r<p>\r该方法的主要作用是阻止与该实体对象集合关联的数据控件自动根据实体对象的变化刷新自身的显示内容，\r这样做的目的一般是为了提高对实体对象集合连续进行操作时的运行效率。\r</p>","alias":"dorado.EntityList#disableObservers","visibility":"public","package":"data","memberOf":"dorado.EntityList"},{"name":"enableObservers","type":"method","desc":"允许dorado.EntityList将消息发送给其观察者。","alias":"dorado.EntityList#enableObservers","visibility":"public","package":"data","memberOf":"dorado.EntityList"},{"name":"notifyObservers","type":"method","desc":"通知dorado.EntityList的观察者刷新数据。","alias":"dorado.EntityList#notifyObservers","visibility":"public","package":"data","memberOf":"dorado.EntityList"},{"name":"isPageLoaded","type":"method","desc":"判断某一个页的数据是否已经装载。","alias":"dorado.EntityList#isPageLoaded","visibility":"public","params":[{"desc":"页号。从1开始的数字。","type":"int","name":"pageNo"}],"returns":{"desc":"是否已经装载。","type":"boolean"},"package":"data","memberOf":"dorado.EntityList"},{"name":"setCurrent","type":"method","desc":"将集合中的某个数据实体设置为当前数据实体。","alias":"dorado.EntityList#setCurrent","visibility":"public","params":[{"desc":"数据实体。","type":"dorado.Entity","name":"current"}],"package":"data","memberOf":"dorado.EntityList"},{"name":"hasPrevious","type":"method","desc":"返回当前数据实体之前是否还存在其它数据实体。","alias":"dorado.EntityList#hasPrevious","visibility":"public","returns":{"desc":"当前数据实体之前是否还存在其它数据实体。","type":"boolean"},"package":"data","memberOf":"dorado.EntityList"},{"name":"hasNext","type":"method","desc":"返回当前数据实体之后是否还存在其它数据实体。","alias":"dorado.EntityList#hasNext","visibility":"public","returns":{"desc":"当前数据实体之后是否还存在其它数据实体。","type":"boolean"},"package":"data","memberOf":"dorado.EntityList"},{"name":"getFirst","type":"method","desc":"返回当前集合中的第一个数据实体。\r<p>注意：此方法不会导致集合的自动装载动作。</p>","alias":"dorado.EntityList#getFirst","visibility":"public","returns":{"desc":"第一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"getLast","type":"method","desc":"返回当前集合中的最后一个数据实体。\r<p>注意：此方法不会导致集合的自动装载动作。</p>","alias":"dorado.EntityList#getLast","visibility":"public","returns":{"desc":"最后一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"first","type":"method","desc":"将集合中的第一个数据实体设置为当前数据实体。","alias":"dorado.EntityList#first","visibility":"public","params":[{"desc":"{boolean} 如果有需要，是否自动装载尚未被加载的数据页。","name":"loadPage","isOptional":true}],"returns":{"desc":"返回第一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"previous","type":"method","desc":"将当前数据实体的前一个数据实体设置为当前数据实体。","alias":"dorado.EntityList#previous","visibility":"public","params":[{"desc":"{boolean} 如果有需要，是否自动装载尚未被加载的数据页。","name":"loadPage","isOptional":true}],"returns":{"desc":"返回前一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"next","type":"method","desc":"将当前数据实体的下一个数据实体设置为当前数据实体。","alias":"dorado.EntityList#next","visibility":"public","params":[{"desc":"{boolean} 如果有需要，是否自动装载尚未被加载的数据页。","name":"loadPage","isOptional":true}],"returns":{"desc":"返回下一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"last","type":"method","desc":"将集合中的最后一个数据实体设置为当前数据实体。","alias":"dorado.EntityList#last","visibility":"public","params":[{"desc":"{boolean} 如果有需要，是否自动装载尚未被加载的数据页。","name":"loadPage","isOptional":true}],"returns":{"desc":"返回最后一个数据实体。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"move","type":"method","desc":"根据给定的偏移量和当前数据实体的位置，向前或向后定位到另一个数据实体并将其设置为新的当前数据实体。\r例如设置offset为1，表示将当前数据实体的下一个数据实体设置为的当前数据实体。","alias":"dorado.EntityList#move","visibility":"public","params":[{"desc":"移动的步数，可以是负数。","type":"int","name":"offset"}],"package":"data","memberOf":"dorado.EntityList"},{"name":"gotoPage","type":"method","desc":"将实体集合翻到指定页中。 如果指定的页中的数据尚未装载，则将首先装载该页的数据。\r<p>\r此方法有两种执行方式，如果不指定callback参数将按照同步模式执行，如果指定了具体的callback则按照异步模式运行。\r</p>","alias":"dorado.EntityList#gotoPage","visibility":"public","params":[{"desc":"要跳转到的页号。从1开始的数字。","type":"int","name":"pageNo"},{"desc":"回调对象，传入回调对象的参数即为新的页。","type":"Function|dorado.Callback","name":"callback","isOptional":true}],"returns":{"desc":"如果是是同步模式调用的话，则返回新页中的第一个数据实体，否则返回null。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"firstPage","type":"method","desc":"将实体集合翻到第一页。\r<p>\r此方法有两种执行方式，如果不指定callback参数将按照同步模式执行，如果指定了具体的callback则按照异步模式运行。\r</p>","alias":"dorado.EntityList#firstPage","visibility":"public","params":[{"desc":"回调对象，传入回调对象的参数即为新的页。","type":"Function|dorado.Callback","name":"callback","isOptional":true}],"package":"data","memberOf":"dorado.EntityList"},{"name":"previousPage","type":"method","desc":"将实体集合向前翻一页。\r<p>\r此方法有两种执行方式，如果不指定callback参数将按照同步模式执行，如果指定了具体的callback则按照异步模式运行。\r</p>","alias":"dorado.EntityList#previousPage","visibility":"public","params":[{"desc":"回调对象，传入回调对象的参数即为新的页。","type":"Function|dorado.Callback","name":"callback","isOptional":true}],"package":"data","memberOf":"dorado.EntityList"},{"name":"nextPage","type":"method","desc":"将实体集合向后翻一页。\r<p>\r此方法有两种执行方式，如果不指定callback参数将按照同步模式执行，如果指定了具体的callback则按照异步模式运行。\r</p>","alias":"dorado.EntityList#nextPage","visibility":"public","params":[{"desc":"回调对象，传入回调对象的参数即为新的页。","type":"Function|dorado.Callback","name":"callback","isOptional":true}],"package":"data","memberOf":"dorado.EntityList"},{"name":"lastPage","type":"method","desc":"将实体集合翻到最后一页。\r<p>\r此方法有两种执行方式，如果不指定callback参数将按照同步模式执行，如果指定了具体的callback则按照异步模式运行。\r</p>","alias":"dorado.EntityList#lastPage","visibility":"public","params":[{"desc":"回调对象，传入回调对象的参数即为新的页。","type":"Function|dorado.Callback","name":"callback","isOptional":true}],"package":"data","memberOf":"dorado.EntityList"},{"name":"isEmpty","type":"method","desc":"返回某实体集合是否为空。","alias":"dorado.EntityList#isEmpty","visibility":"public","returns":{"desc":"是否是空。","type":"boolean"},"package":"data","memberOf":"dorado.EntityList"},{"name":"insert","type":"method","desc":"向集合中插入一个数据实体。","alias":"dorado.EntityList#insert","visibility":"public","params":[{"desc":"{optional} 要插入的数据实体或数据实体对应的JSON数据对象。\r如果不指定此参数或设置其值为null，EntityList会自动根据elementDataType来创建一个新的数据实体并插入。","type":"dorado.Entity|Object","name":"entity"},{"desc":"插入方式，包含下列四种取值：\r<ul>\r<li>begin - 在集合的起始位置插入。</li>\r<li>before - 在refEntity参数指定的数据实体之前插入。</li>\r<li>after - 在refEntity参数指定的数据实体之后插入。</li>\r<li>end - 在集合的末尾插入。默认值。</li>\r</ul>","type":"String","name":"insertMode","isOptional":true},{"desc":"插入位置的参照数据实体。","type":"dorado.Entity","name":"refEntity","isOptional":true}],"returns":{"desc":"返回插入的数据实体。"},"package":"data","memberOf":"dorado.EntityList"},{"name":"remove","type":"method","desc":"从集合中删除一个数据实体。","alias":"dorado.EntityList#remove","visibility":"public","params":[{"desc":"要删除的数据实体，如果此参数为空则表示将要删除集合中的当前数据实体。","type":"dorado.Entity","name":"entity","isOptional":true},{"desc":"是否彻底断开被删除的数据实体与集合之间的关联。默认为不断开。<br/>\r在通常情况下，当我们从集合中删除一个数据实体时，dorado只是在内部处理中将数据实体的状态标记为已删除状态而并没有真正的将数据实体从合集中移除掉。\r这样做的目的是为了便于在今后提交时能够清晰的掌握集合中的元素究竟做过哪些改变。","type":"boolean","name":"detach","isOptional":true}],"package":"data","memberOf":"dorado.EntityList"},{"name":"createChild","type":"method","desc":"创建并返回一个子实体对象。","alias":"dorado.EntityList#createChild","visibility":"public","params":[{"desc":"新创建的实体对象要封装JSON数据对象，可以不指定此参数。","type":"Object","name":"data","isOptional":true},{"desc":"是否需要返回一个游离的实体对象。\r默认情况下，新创建的子实体对象会直接被设置到集合中。\r通过detached参数可以指定本方法不将新的子实体对象附着到本集合中。","type":"boolean","name":"detached","isOptional":true}],"returns":{"desc":"新创建的实体对象。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"getById","type":"method","desc":"根据传入的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的id返回匹配的数据实体对象。","alias":"dorado.EntityList#getById","visibility":"public","params":[{"desc":"数据实体的id。","type":"Object","name":"id"}],"returns":{"desc":"匹配的数据实体对象。","type":"dorado.Entity"},"package":"data","memberOf":"dorado.EntityList"},{"name":"cancel","type":"method","desc":"取消对当前数据实体集合的各种数据操作。","alias":"dorado.EntityList#cancel","visibility":"public","params":[{"desc":"是否执行深度撤销。即一并撤销所有子实体（包括子实体中的子实体）的修改。","type":"boolean","name":"deep"}],"package":"data","memberOf":"dorado.EntityList"},{"name":"clear","type":"method","desc":"清空集合中的所有数据。","alias":"dorado.EntityList#clear","visibility":"public","package":"data","memberOf":"dorado.EntityList"},{"name":"flush","type":"method","desc":"清空集合中的所有数据并重新装载当前页中的数据。","alias":"dorado.EntityList#flush","visibility":"public","params":[{"desc":null,"name":"callback"}],"package":"data","memberOf":"dorado.EntityList"},{"name":"flushAsync","type":"method","desc":"清空集合中的所有数据并以异步方式重新装载当前页中的数据。","alias":"dorado.EntityList#flushAsync","visibility":"public","params":[{"desc":"回调对象。","type":"Function|dorado.Callback","name":"callback"}],"package":"data","memberOf":"dorado.EntityList"},{"name":"fromJSON","type":"method","desc":"将给定的JSON对象中的数据转换成为数据实体并添加到集合中。","alias":"dorado.EntityList#fromJSON","visibility":"public","params":[{"desc":"要转换的JSON对象。<br/>\r如果此处传入的是一个数组，那么数组中的对象会被逐一意添加到集合中; 如果传入的单个的对象，那么该对象会被作为一个元素添加到集合中。","type":"Object[]|Object","name":"json"}],"package":"data","memberOf":"dorado.EntityList"},{"name":"toJSON","type":"method","desc":"将实体集合转换成一个JSON数组。","alias":"dorado.EntityList#toJSON","visibility":"public","params":[{"desc":"转换选项。","type":"Object","name":"options","isOptional":true},{"desc":"属性名数组，表示只转换该数组中列举过的属性。如果不指定此属性表示转换实体对象中的所有属性。\r此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到集合中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON方法中，\r因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的处理过程。","type":"String[]","name":"options.properties","isOptional":true},{"desc":"是否转换实体对象中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Reference')\">dorado.Reference</A>类型的属性。默认按true进行处理。","type":"boolean","name":"options.includeReferenceProperties","isOptional":true,"defaultValue":"true"},{"desc":"数据装载模式，此属性仅在options.includeReferenceProperties=true为true时有效。<br/>\r包含下列三种取值:\r<ul>\r<li>always\t-\t如果有需要总是装载尚未装载的延时数据。</li>\r<li>auto\t-\t如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r<li>never\t-\t不会激活数据装载过程，直接返回数据的当前值。</li>\r</ul>","type":"String","name":"options.loadMode","isOptional":true,"defaultValue":"\"never\""},{"desc":"是否转换<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中尚未装载的页中的数据。默认按true进行处理。","type":"boolean","name":"options.includeUnloadPage","isOptional":true},{"desc":"是否转换那些被标记为\"已删除\"的数据实体。","type":"boolean","name":"options.includeDeletedEntity","isOptional":true},{"desc":"是否只生成简单类型的属性到JSON中。\r此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到集合中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON方法中，\r因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的处理过程。","type":"boolean","name":"options.simplePropertyOnly","isOptional":true},{"desc":"是否在JSON对象中生成DataType信息，生成的DataType信息将被放置在名为$dataType的特殊子属性中。\r此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到集合中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON方法中，\r因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的处理过程。\r另外，此属性的只对集合中的第一个JSON对象有效，即dorado认为集合中的所有<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的DataType都是相同的，因此不必为每一个<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>生成DataType信息。","type":"boolean","name":"options.generateDataType","isOptional":true},{"desc":"是否在JSON对象中生成实体对象的状态信息(即新增、已更改等状态)，生成的状态信息将被放置在名为$state的特殊子属性中。\r此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到集合中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON方法中，\r因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的处理过程。","type":"boolean","name":"options.generateState","isOptional":true},{"desc":"是否在JSON对象中生成实体对象的ID，生成的状态信息将被放置在名为$entityId的特殊子属性中。\r此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到集合中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON方法中，\r因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的处理过程。","type":"boolean","name":"options.generateEntityId","isOptional":true},{"desc":"是否在JSON对象中生成旧数据，生成的状态信息将被放置在名为$oldData的特殊子属性中。\r此属性对于<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>的toJSON而言是没有意义的，但是由于options参数会自动被传递到集合中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的toJSON方法中，\r因此它会影响内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>的处理过程。","type":"boolean","name":"options.generateOldData","isOptional":true},{"desc":"用户自定义的数据实体过滤函数，返回true/false表示是否需要将此当前数据实体转换到JSON中。\r此函数的传入参数如下：","type":"Function","name":"options.entityFilter","isOptional":true},{"desc":"当前正被过滤的数据实体。","type":"dorado.Entity","name":"options.entityFilter.entity","isOptional":true}],"returns":{"desc":"得到的JSON数组。\r<p>\r如果generateDataType选项为true，那么此方法有可能返回一个JSON对象而不是数组，以便于附加DataType这样的信息。\r</p>","type":"Object[]|Object"},"package":"data","memberOf":"dorado.EntityList"},{"name":"toArray","type":"method","desc":"返回包含所有数据实体的数组。\r<p>\r注意：返回的数组中将只包含当前已下载到客户端的数据实体。\r</p>","alias":"dorado.EntityList#toArray","visibility":"public","returns":{"desc":"得到的Entity数组。","type":"Object[]"},"package":"data","memberOf":"dorado.EntityList"},{"name":"getWrapper","type":"method","desc":"将所有数据实体转换成代理对象并放置到一个数组中。","alias":"dorado.EntityList#getWrapper","see":["dorado.Entity#getWrapper"],"visibility":"public","params":[{"desc":"转换选项。","type":"Object","name":"options","isOptional":true}],"returns":{"desc":"得到的代理对象数组。","type":"Object"},"package":"data","memberOf":"dorado.EntityList"},{"name":"each","type":"method","desc":"针对集合的每一个数据实体执行指定的函数。此方法可用于替代对集合的遍历代码。","alias":"dorado.EntityList#each","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 将每一个集合元素的name属性连接成为一个字符串\rvar names = \"\";\rvar entityList = ...\rentityList.each(function(entity){\r\t names += entity.get(\"name\");\r});"}],"visibility":"public","params":[{"desc":"针对每一个数据实体的函数。","type":"Function","name":"fn"},{"desc":"函数脚本的宿主，即函数脚本中this的含义。如果此参数为空则表示this为集合中的某个数据实体。","type":"Object","name":"scope","isOptional":true}],"package":"data","memberOf":"dorado.EntityList"},{"name":"iterator","type":"method","desc":"返回数据实体的迭代器。","alias":"dorado.EntityList#iterator","visibility":"public","params":[{"desc":"迭代选项。\r此参数具有两种设定方式，当直接传入逻辑值true/false时，dorado会将此逻辑值直接认为是针对上述includeDeletedEntity子属性的值；\r当传入的是一个对象时，dorado将尝试识别该对象子属性。","type":"Object|boolean","name":"options","isOptional":true},{"desc":"是否迭代被标记已删除的数据。","type":"boolean","name":"options.includeDeletedEntity","isOptional":true},{"desc":"是否迭代目前尚未下载的页中的数据。\r如果选择是，那么迭代的过程将引起集合自动装载那些尚未下载页。","type":"boolean","name":"options.includeUnloadPage","isOptional":true},{"desc":"从第几个数据实体开始迭代。","type":"int","name":"options.nextIndex","isOptional":true},{"desc":"只遍历指定页号中的数据。从1开始的数字。","type":"int","name":"options.pageNo","isOptional":true},{"desc":"只遍历当前页号中的数据。","type":"boolean","name":"options.currentPage","isOptional":true},{"desc":"是否对为未下载的页进行模拟遍历。\r在模拟遍历的过程中，迭代器将返回一个虚假的dorado.Entity实例代替未下载页中的某个数据实体。\r当启用此选项时，迭代器将在迭代过程中模拟出那些尚未下载的数据实体，但不会在迭代过程中引起实际的数据装载。","type":"boolean","name":"options.simulateUnloadPage","isOptional":true}],"returns":{"desc":"数据实体的迭代器。","type":"dorado.util.Iterator"},"package":"data","memberOf":"dorado.EntityList"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.EntityList","params":[{"desc":"用作初始化集合元素的JSON数据。<br/>\r如果此处传入的是一个数组，那么数组中的对象会被逐一意添加到集合中; 如果传入的单个的对象，那么该对象会被作为一个元素添加到集合中。","type":"Object[]|Object","name":"data","isOptional":true},{"desc":"数据类型的管理器。","type":"dorado.DataRepository","name":"dataTypeRepository","isOptional":true},{"desc":"集合数据类型。","type":"dorado.AggregationDataType","name":"dataType","isOptional":true}]}],"events":[]}