SYMBOLS["dorado.Exception"]={"name":"Exception","type":"class","desc":null,"alias":"dorado.Exception","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"throw new dorado.Exception(\"My Message.\");"}],"classDesc":"dorado异常的基类。\r<p>\r此类可以实例化并抛出。\r虽然JavaScript支持抛出任何类型的对象，但是在dorado的框架下抛出dorado.Exception或其派生类的实例可以获得额外的好处。\r例如：可以通过dorado.Exception获得错误堆栈信息，以辅助对错误的定位和调试。\r</p>\r<p>\r需要特别注意的是dorado.Excpeption对象一旦被创建，即便没有抛出(throw)，最终都会激活<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Exception.processException')\">dorado.Exception.processException</A>方法，\r默认情况下此异常信息一定会弹出错误提示(dorado.AbortException)。<br/>\r当然，尽管dorado.Excpeption一旦被创建会自动引起错误提示，大部分情况下我们仍需要将其抛出(throw)。\r否则当前程序仍会按照正常的情况继续向后执行，并不会被该异常打断。\r</p>","package":"core","inheritsFrom":["dorado.AbstractException"],"inherits":["dorado.AbortException","dorado.RemoteException","dorado.ResourceException","dorado.util.AjaxException","dorado.widget.editor.PostException"],"memberOf":"dorado","properties":[{"name":"stack","type":"String[]","desc":"dorado生成的错误堆栈信息。","alias":"dorado.Exception#stack","visibility":"public","memberOf":"dorado.Exception","package":"core"},{"name":"systemStack","type":"String[]","desc":"系统提供的错误堆栈信息。目前仅在FireFox、Mozilla下可以得到。","alias":"dorado.Exception#systemStack","visibility":"public","memberOf":"dorado.Exception","package":"core"},{"name":"remoteStack","type":"String[]","desc":"外部系统中的错误堆栈信息。对于来自Java的异常而言即异常堆栈中的StackTrace信息。","alias":"dorado.Exception#remoteStack","visibility":"public","memberOf":"dorado.Exception","package":"core"}],"attributes":[],"methods":[{"name":"formatStack","type":"method","desc":"将传入的调用堆栈信息格式化为较便于阅读的文本格式。","alias":"dorado.Exception#formatStack","see":["dorado.Exception.formatStack"],"visibility":"public","params":[{"desc":"调用堆栈信息。","type":"String[]","name":"stack"}],"returns":{"desc":"格式化后的调用堆栈信息。","type":"String"},"package":"core","memberOf":"dorado.Exception"},{"name":"formatStack","type":"method","desc":"将传入的调用堆栈信息格式化为较便于阅读的文本格式。","alias":"dorado.Exception.formatStack","visibility":"public","params":[{"desc":"调用堆栈信息。","type":"String[]","name":"stack"}],"returns":{"desc":"格式化后的调用堆栈信息。","type":"String"},"package":"core","isStatic":true,"memberOf":"dorado.Exception"},{"name":"processException","type":"method","desc":"处理一个异常对象。\r<p>\r注意：此方法需要处理的异常对象包括所有JavaScript所支持抛出的对象。\r</p>","alias":"dorado.Exception.processException","visibility":"public","params":[{"desc":"异常对象。","type":"dorado.Exception|Object","name":"e"},{"desc":null,"name":"showDialog"}],"package":"core","isStatic":true,"memberOf":"dorado.Exception"},{"name":"removeException","type":"method","desc":"从系统的异常堆栈中移除一个异常对象。","alias":"dorado.Exception.removeException","visibility":"public","params":[{"desc":"异常对象。","type":"dorado.Exception|Object","name":"e"}],"package":"core","isStatic":true,"memberOf":"dorado.Exception"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.Exception","params":[{"desc":"异常信息。","type":"String","name":"message","isOptional":true}]}],"events":[]}