SYMBOLS["dorado.JSON"]={"name":"JSON","type":"object","desc":null,"alias":"dorado.JSON","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"用于实现一些与JSON相关功能的对象。","package":"core","memberOf":"dorado","properties":[],"attributes":[],"methods":[{"name":"parse","type":"method","desc":"将一段JSON字符串解析成JSON对象。","alias":"dorado.JSON.parse","visibility":"public","params":[{"desc":"要解析的JSON字符串。","type":"Object","name":"text"},{"desc":"服务器返回的Response信息是否是不可信的。默认为false，即Response信息是可信的。<br/>\r此参数将决定dorado通过何种方式来解析服务端返回的JSON字符串，为了防止某些嵌入在JSON字符串中的黑客代码对应用造成伤害，\rdorado可以使用安全的方式来解析JSON字符串，但是这种安全检查会带来额外的性能损失。\r因此，如果您能够确定访问的服务器是安全的，其返回的JSON字符串不会嵌入黑客代码，那么就不必开启此选项。","type":"boolean","name":"untrusty","isOptional":true}],"returns":{"desc":"得到的JSON对象。","type":"Object"},"package":"core","isStatic":true,"memberOf":"dorado.JSON"},{"name":"stringify","type":"method","desc":"将给定的JSON对象、实体对象(<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>)或实体集合(<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>)转换成JSON字符串。","alias":"dorado.JSON.stringify","visibility":"public","params":[{"desc":"要转换的数据。","type":"Object","name":"value"},{"desc":"转换选项。","type":"Object","name":"options","isOptional":true},{"desc":"属性名数组，表示只转换该数组中列举过的属性。如果不指定此属性表示转换实体对象中的所有属性。","type":"String[]","name":"options.properties","isOptional":true},{"desc":"是否转换实体对象中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Reference')\">dorado.Reference</A>类型的属性。默认按false进行处理。","type":"boolean","name":"options.includeReferenceProperties","isOptional":true},{"desc":"是否转换实体对象中<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Lookup')\">dorado.Lookup</A>类型的属性。默认按false进行处理。","type":"boolean","name":"options.includeLookupProperties","isOptional":true},{"desc":"是否转换<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>中尚未装载的页中的数据。默认按false进行处理。","type":"boolean","name":"options.includeUnloadPage","isOptional":true}],"returns":{"desc":"得到的JSON字符串。","type":"String"},"package":"core","isStatic":true,"memberOf":"dorado.JSON"},{"name":"evaluate","type":"method","desc":"对JSON数据模板进行求值。\r<p>\rJSON数据模板事实上指包含function型值的JSON对象。 对JSON数据模板进行求值，就是执行这些function并且得到最终的返回值。\r</p>","alias":"dorado.JSON.evaluate","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 这是一个JSON数据模板，如下：\r{\r\tproperty1: \"value1\",\r\tproperty2: function() {\r\t\treturn 100 + 200;\r\t}\r}\r\r// 经过求值，我们将得到一个新的JSON对象，如下：\r{\r\tproperty1: \"value1\",\r\tproperty2: 300\r}"}],"visibility":"public","params":[{"desc":"JSON数据模板。","type":"Object","name":"template"}],"returns":{"desc":"求值后得到的最终JSON数据。"},"package":"core","isStatic":true,"memberOf":"dorado.JSON"}],"constructors":[],"events":[]}