SYMBOLS["dorado.ObjectGroup"]={"name":"ObjectGroup","type":"class","desc":null,"alias":"dorado.ObjectGroup","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"对象组。\r<p>用于将一批对象组合在一起，以便于方便的进行统一处理，例如统一的设置属性或调用方法。</p>","package":"core","memberOf":"dorado","properties":[],"attributes":[],"methods":[{"name":"set","type":"method","desc":"对组中的所有对象进行属性赋值操作。\r<p>如果对象组中的某个对象不支持此处将设置属性，该方法会跳过该对象这一个操作并继续后续处理。\r此方法的使用方法与(@link dorado.AttributeSupport#set)方法非常类似，具体使用说明请参考(@link dorado.AttributeSupport#set)方法的说明。</p>","alias":"dorado.ObjectGroup#set","see":["dorado.AttributeSupport#set"],"visibility":"public","params":[{"desc":"属性名或包含多个属性值对的JSON对象。","type":"String|Object","name":"attr"},{"desc":"属性值。","type":"Object","name":"value","isOptional":true}],"returns":{"desc":"返回对象组自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.ObjectGroup"},{"name":"get","type":"method","desc":"读取组中每一个对象的属性，并将所有结果集合成一个新组返回。","alias":"dorado.ObjectGroup#get","visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"由读取到的结果组成的对象组。","type":"dorado.ObjectGroup"},"package":"core","memberOf":"dorado.ObjectGroup"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.ObjectGroup#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.ObjectGroup"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.ObjectGroup#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.ObjectGroup"},{"name":"bind","type":"method","desc":"为组中的所有对象绑定事件。\r<p>如果对象组中的某个对象不支持事件，该方法会跳过该对象这一个操作并继续后续处理。\r此方法的使用方法与(@link dorado.EventSupport#bind)方法非常类似，具体使用说明请参考(@link dorado.EventSupport#bind)方法的说明。</p>","alias":"dorado.ObjectGroup#bind","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":"事件名称，可支持别名。","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true}],"returns":{"desc":"返回对象组自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.ObjectGroup"},{"name":"unbind","type":"method","desc":"从组中的所有对象中移除一个事件。\r<p>如果对象组中的某个对象不支持事件，该方法会跳过该对象这一个操作并继续后续处理。\r此方法的使用方法与(@link dorado.EventSupport#unbind)方法非常类似，具体使用说明请参考(@link dorado.EventSupport#unbind)方法的说明。</p>","alias":"dorado.ObjectGroup#unbind","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":"事件名称，可支持别名。","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器","type":"Function","name":"listener","isOptional":true}],"returns":{"desc":"返回对象组自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.ObjectGroup"},{"name":"invoke","type":"method","desc":"调用组中的所有对象的某个方法。","alias":"dorado.ObjectGroup#invoke","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 同时调用3个按钮的set方法，将他们的disabled属性设置为true。\rvar group = new dorado.ObjectGroup([button1, button2, button3]);\rgroup.invoke(\"set\", \"disabled\", true);"}],"visibility":"public","params":[{"desc":"要调用的方法名。","type":"String","name":"methodName"},{"desc":"调用方法时传入的参数。","type":"Object...","name":"arg","isOptional":true}],"package":"core","memberOf":"dorado.ObjectGroup"},{"name":"each","type":"method","desc":"遍历对象。","alias":"dorado.ObjectGroup#each","visibility":"public","params":[{"desc":"针对组中每一个对象的回调函数。此函数支持下列两个参数:\r<ul>\r<li>object - {dorado.AttributeSupport} 当前遍历到的对象。</li>\r<li>[i] - {int} 当前遍历到的对象的下标。</li>\r</ul>\r另外，此函数的返回值可用于通知系统是否要终止整个遍历操作。\r返回true或不返回任何数值表示继续执行遍历操作，返回false表示终止整个遍历操作。<br/>\r此回调函数中的this指向正在被遍历的对象数组。","type":"Function","name":"fn"}],"package":"core","memberOf":"dorado.ObjectGroup"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.ObjectGroup","params":[{"desc":"要进行的组合的对象的数组。","type":"Object[]","name":"objects"}]}],"events":[]}