SYMBOLS["dorado.PropertyDef"]={"name":"PropertyDef","type":"class","desc":null,"alias":"dorado.PropertyDef","author":"Benny Bao (mailto:benny.bao@bstek.com)","see":["dorado.EntityDataType"],"isAbstract":true,"classDesc":"实体类型中的属性声明的抽象类。\r<p>\r此对象的get方法在<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>的基础上做了增强。\r除了原有的读取属性值的功能之外，此方法还另外提供了下面的用法。\r<ul>\r   <li>当传入一个以#开头的字符串时，#后面的内容将被识别成数据校验器的名称，表示根据名称获取数据校验器。参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.PropertyDef#getValidator')\">dorado.PropertyDef#getValidator</A>。</li>\r</ul>\r</p>","package":"data","shortTypeName":"Default","inheritsFrom":["dorado.AttributeSupport","dorado.EventSupport"],"inherits":["dorado.BasePropertyDef","dorado.Reference"],"memberOf":"dorado","properties":[{"name":"ATTRIBUTES","type":"Object","desc":"用于声明该对象中所支持的所有Attribute。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.AttributeSupport#ATTRIBUTES","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的caption属性的声明。\rvar attributeDef = oop.ATTRIBUTES.caption。\r// 判断该属性是否只读\rif (attributeDef.readOnly) { ... ... }"}],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"objects","type":"dorado.AttributeSupport[]","desc":"对象数组。","alias":"dorado.AttributeSupport#objects","visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"}],"attributes":[{"name":"name","type":"String","desc":"属性名。","alias":"dorado.PropertyDef#attribute:name","visibility":"public","memberOf":"dorado.PropertyDef","package":"data","readOnly":true},{"name":"parent","type":"dorado.EntityDataType","desc":"此属性所隶属的实体类型。","alias":"dorado.PropertyDef#attribute:parent","visibility":"public","memberOf":"dorado.PropertyDef","package":"data","readOnly":true},{"name":"view","type":"dorado.widget.View","desc":"返回所属的视图。","alias":"dorado.PropertyDef#attribute:view","visibility":"public","memberOf":"dorado.PropertyDef","package":"data","readOnly":true},{"name":"dataType","type":"dorado.DataType","desc":"数据类型。","alias":"dorado.PropertyDef#attribute:dataType","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"label","type":"String","desc":"属性的标签，即用于显示的属性名。","alias":"dorado.PropertyDef#attribute:label","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"description","type":"String","desc":"属性的描述信息。","alias":"dorado.PropertyDef#attribute:description","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"readOnly","type":"boolean","desc":"属性是否只读。","alias":"dorado.PropertyDef#attribute:readOnly","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"visible","type":"boolean","desc":"属性是否默认可见。","alias":"dorado.PropertyDef#attribute:visible","visibility":"public","defaultValue":"true","memberOf":"dorado.PropertyDef","package":"data"},{"name":"typeFormat","type":"String","desc":"属性的输入格式。\r具体用法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.PropertyDef#attribute:displayFormat')\">dorado.PropertyDef#attribute:displayFormat</A>","alias":"dorado.PropertyDef#attribute:typeFormat","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"displayFormat","type":"String","desc":"属性的显示格式。\r<p>\r此属性对于不同的DataType其定义方法有不同的解释，具体的实现取决对相应DataType的toText方法。\r</p>\r<p>\r例如：\r<li>对于数值型DataType而言，displayFormat的定义与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.Common.formatFloat')\">dorado.util.Common.formatFloat</A>方法的format参数一致。<li>\r<li>对于日期时间型DataType而言，displayFormat的定义与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('Date.formatDate')\">Date.formatDate</A>方法的format参数一致。<li>\r</p>\r<p>\r当用户传入的displayFormat字符串以call:开头时，dorado会将call:后面的部分识别为一个全局Function的名字，\r如果系统中确实存在一个这样的Function，那么dorado会直接调用该Function并以其返回值作为转换后的格式。\r</p>","alias":"dorado.PropertyDef#attribute:displayFormat","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"mapping","type":"Object[]","desc":"一组用于定义改变属性显示方式的\"代码\"/\"名称\"键值对。","alias":"dorado.PropertyDef#attribute:mapping","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 例如对于一个以逻辑型表示性别的属性，我们可能希望在显示属性值时将true显示为\"男\"、将false显示为\"女\"。\rpropertyDef.set(\"mapping\", [\r\t{\r\t\tkey : \"true\",\r\t\tvalue : \"男\"\r\t},\r\t{\r\t\tkey : \"false\",\r\t\tvalue : \"女\"\r\t}\r]);"}],"visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"acceptUnknownMapKey","type":"boolean","desc":"是否允许向此属性设置mapping的键值中未声明的值。即不允许设置mapping的键值中未声明的值。\r<p>\r注意：此属性只在mapping属性确实有值时才有效。\r</p>","alias":"dorado.PropertyDef#attribute:acceptUnknownMapKey","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"submittable","type":"boolean","desc":"该属性中的内容默认情况是否需要向服务端提交。","alias":"dorado.PropertyDef#attribute:submittable","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"required","type":"boolean","desc":"是否非空。","alias":"dorado.PropertyDef#attribute:required","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"defaultValue","type":"Object","desc":"默认值。","alias":"dorado.PropertyDef#attribute:defaultValue","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"validators","type":"dorado.validator.Validator[]|Object[]|String[]","desc":"数据校验器的数组。\r<p>\r此处数组中可放置两种类型的校验器定义：\r\t<ul>\r\t<li>直接放入一个校验器的实例对象。</li>\r\t<li>放入含校验器信息的JSON对象。<br/>\r此时可以使用子控件类型名称中\"dorado.\"和\"Validator\"之间的部分作为$type的简写。\r\t</li>\r\t<li>直接放入一个字符串代表$type的简写。</li>\r\t</ul>\r</p>","alias":"dorado.PropertyDef#attribute:validators","see":["dorado.validator.Validator","dorado.Toolkits.createInstance"],"visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"dataTypeRepository","type":"dorado.DataTypeRepository","desc":"隶属的数据类型的管理器。","alias":"dorado.PropertyDef#attribute:dataTypeRepository","visibility":"public","memberOf":"dorado.PropertyDef","package":"data","readOnly":true},{"name":"userData","type":"Object","desc":"用户自定义数据。","alias":"dorado.PropertyDef#attribute:userData","visibility":"public","memberOf":"dorado.PropertyDef","package":"data"},{"name":"tags","type":"String|String[]","desc":"对象的标签。\r<p>\r开发人员可以为一个对象定义一到多个String型的标签，以便于后面快速的查找到一个或一批具有指定标签的对象。\r</p>","alias":"dorado.AttributeSupport#attribute:tags","see":["dorado.TagManager"],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true}],"methods":[{"name":"getMappedValue","type":"method","desc":"将给定的数值翻译成显示值。","alias":"dorado.PropertyDef#getMappedValue","see":["dorado.PropertyDef#attribute:mapping"],"visibility":"public","params":[{"desc":"要翻译的键值。","type":"String","name":"key"}],"returns":{"desc":"显示值。","type":"Object"},"package":"data","memberOf":"dorado.PropertyDef"},{"name":"getMappedKey","type":"method","desc":"根据给定的显示值返回与其匹配的键值。","alias":"dorado.PropertyDef#getMappedKey","see":["dorado.PropertyDef#attribute:mapping"],"visibility":"public","params":[{"desc":"要翻译的显示值。","type":"Object","name":"value"}],"returns":{"desc":"键值。","type":"String"},"package":"data","memberOf":"dorado.PropertyDef"},{"name":"getValidator","type":"method","desc":"根据名称返回对应的Validator。","alias":"dorado.PropertyDef#getValidator","visibility":"public","params":[{"desc":"名称","name":"name"}],"returns":{"desc":"dorado.Validator"},"package":"data","memberOf":"dorado.PropertyDef"},{"name":"getAttributeWatcher","type":"method","desc":"返回与该对象关联的属性观察者。","alias":"dorado.AttributeSupport#getAttributeWatcher","visibility":"public","returns":{"desc":"属性观察者。","type":"dorado.AttributeWatcher"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"get","type":"method","desc":"读取指定的属性值。\r<p>\r此方法还支持迭代式的属性读取，即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.AttributeSupport的实例还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r如果碰到的中间对象dorado.AttributeSupport的实例，系统会自动读取它的Attribute；\r如果碰到的中间对象是普通的JSON对象，系统会直接读取它的属性。\r</p>","alias":"dorado.AttributeSupport#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"label\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"address.postCode\"); // 迭代式的属性读取\r// 如果address的属性值是一个dorado.AttributeSupport的实例，那么此行命令的效果相当于oop.get(\"address\").get(\"postCode\")。\r// 如果address的属性值是一个JSON对象，那么此行命令的效果相当于oop.get(\"address\").postCode"}],"visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"读取到的属性值。","type":"Object"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.AttributeSupport#set","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set(\"label\", \"Sample Text\"); oop.set(\"visible\", true);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set( { label : \"Sample Text\", visible : true });"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用属性迭代的特性为子对象中的属性赋值。\roop.set(\"address.postCode\", \"7232-00124\");\r... ...\roop.set({\r\t\"name\" : \"Toad\",\r\t\"address.postCode\" : \"7232-00124\"\r});\r// 上面的两行命令相当于\roop.get(\"address\").set(\"postCode\", \"7232-00124\")"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用上文中提及的第一种方法为label属性赋值，同时为onClick事件绑定一个监听器。\roop.set({\r label : \"Sample Text\",\r onClick : function(self, arg) {\r \t... ...\r }\r});"}],"visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r           <ul>\r           <li>当attr为String时，系统会将attr的作为要设置属性名处理。属性值为value参数代表的值。</li>\r           <li>当attr为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r           注意：当通过此方式为对象设置一系列属性时，系统只会跳过那些设置出错的属性，并不会给出错误信息，也不会中断正在执行的设置操作。</li>\r           </ul>\r           <p>\r           如同<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>方法，set方法也支持对属性进行迭代式的设置。\r           即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘，直到挖掘到倒数第二个子对象时停止并记录下一个子属性名，然后对该子对象的属性进行复制操作，请参考后面的例程。\r           </p>\r           <p>\r           set方法不但可以用于为对象的属性赋值，同时也可以用于为对象中的事件添加事件监听器。\r           <ul>\r           <li>直接以事件名称作为属性，以事件监听器作为属性值，进行赋值操作。</li>\r           <li>为对象listener属性赋值，具体方法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#attribute:listener')\">dorado.EventSupport#attribute:listener</A>。</li>\r           </ul>\r           虽然上述两种方法都可以实现添加事件监听器的功能，并且第一种方法看起来更加方便易用。但第二种方法却较第一种更为灵活。\r           例如：当我们需要一次性的为同一个事件绑定多个监听器，第一种方法是不能胜任的；\r           或者我们当我们批量的设置一组属性值和事件监听器时，第二种方法总是确保事件监听器首先被绑定然后才处理该操作中剩余的属性值的赋值（在绝大多数的场景的这样的顺序是更加合理的），\r           而此时如果使用第一种方法，监听器和属性值的处理顺序是难以预知的。\r           </p>","type":"String|Object","name":"attr"},{"desc":"此参数具有多重含义：要设置的属性值。当attr为Object时，此参数将被忽略。\r           <ul>\r           <li>当attr为String时，此参数代表要设置的属性值。</li>\r           <li>当attr为Object时，此参数可代表一组执行选项，见option参数的说明。</li>\r           </ul>","type":"Object","name":"value","isOptional":true},{"desc":"执行选项。此参数仅在attr参数为Object时有效。","type":"Object","name":"options","isOptional":true},{"desc":"是否忽略未知的属性。","type":"boolean","name":"options.skipUnknownAttribute","isOptional":true,"defaultValue":"false"},{"desc":"是否在发生错误后继续尝试后续的属性设置操作。","type":"boolean","name":"options.tryNextOnError","isOptional":true,"defaultValue":"false"},{"desc":"是否组织本次赋值操作覆盖对象中原有的属性值。\r           即对于那些已拥有值(曾经通过set方法写入过值)的属性跳过本次的赋值操作，而只对那些未定义过的属性进行赋值。","type":"boolean","name":"options.preventOverwriting","isOptional":true,"defaultValue":"false"}],"returns":{"desc":"返回对象自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"doSet","type":"method","desc":"用于实现为单个属性赋值的内部方法。","alias":"dorado.AttributeSupport#doSet","visibility":"protected","params":[{"desc":"要设置的属性名。","type":"String","name":"attr"},{"desc":"属性值。","type":"Object","name":"value"},{"desc":"是否忽略未知的属性。","type":"boolean","name":"skipUnknownAttribute","isOptional":true},{"desc":null,"name":"lockWritingTimes"}],"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"hasTag","type":"method","desc":"判断对象中是否定义了某个标签值。","alias":"dorado.AttributeSupport#hasTag","visibility":"public","params":[{"desc":"要判断的标签值。","type":"String","name":"tag"}],"returns":{"desc":"是否具有该标签值。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.PropertyDef","params":[{"desc":"属性名。","type":"String","name":"name"},{"desc":"属性的数据类型。","type":"dorado.DataType|dorado.LazyLoadDataType","name":"dataType","isOptional":true}]}],"events":[{"name":"onGet","type":"event","desc":"当外界尝试从某数据实体中读取此属性的值时触发的事件。","alias":"dorado.PropertyDef#event:onGet","see":["dorado.Entity#get"],"visibility":"public","params":[{"desc":"事件的发起者，即本属性声明对象。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"当前读取的数据实体。","type":"dorado.Entity","name":"arg.entity"},{"desc":"默认将要返回给外界的属性值。\r同时如果您希望改变此实体属性提供给外界的值也可以直接修改此子属性。","type":"Object","name":"arg.value","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.PropertyDef"},{"name":"onGetText","type":"event","desc":"当外界尝试从某数据实体中读取此属性的文本值时触发的事件。","alias":"dorado.PropertyDef#event:onGetText","see":["dorado.Entity#getText"],"visibility":"public","params":[{"desc":"事件的发起者，即本属性声明对象。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"当前读取的数据实体。","type":"dorado.Entity","name":"arg.entity"},{"desc":"默认将要返回给外界的属性文本值。\r同时如果您希望改变此实体属性提供给外界的文本值也可以直接修改此子属性。","type":"String","name":"arg.text","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.PropertyDef"},{"name":"onSet","type":"event","desc":"当外界尝试向某数据实体的此属性中写入一个值时触发的事件。","alias":"dorado.PropertyDef#event:onSet","see":["dorado.Entity#set"],"visibility":"public","params":[{"desc":"事件的发起者，即本属性声明对象。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"当前设置的数据实体。","type":"dorado.Entity","name":"arg.entity"},{"desc":"默认将要写入该属性的值。\r同时如果您希望改变实际写入值也可以直接修改此子属性。","type":"Object","name":"arg.value","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"data","memberOf":"dorado.PropertyDef"},{"name":"onAttributeChange","type":"event","desc":"当对象中的某属性值被改变时触发的事件。","alias":"dorado.AttributeSupport#event:onAttributeChange","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"发生改变的属性名。","type":"String","name":"arg.attribute"},{"desc":"新的属性值。","type":"Object","name":"arg.value"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}]}