SYMBOLS["dorado.SummaryCalculators"]={"name":"SummaryCalculators","type":"object","desc":null,"alias":"dorado.SummaryCalculators","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"用于管理各种统计计算方法的对象。\r<p>\r每一种统计计算方法都以属性值的方法注册在此对象中，dorado默认提供了count、sum、average等常用的统计计算方法。\r默认支持的全部统计计算方法见本对象文档的Properties段落。\r</p>\r<p>\r统计计算方法有两种定义形式：\r<ul>\r<li>\r对于一些较简单的计算方法，可以直接以一个符合特定规范的Function来定义。\r<br/>\r例如sum（合计）的定义如下。\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\r// 此方法会在统计过程中针对每一个被统计对象执行一次。\r// 3个参数的含义分别是：当前统计结果（初始值为0），当前正被处理的数据实体，当前正统计的属性名。\rfunction(value, entity, property) {\r\treturn value + parseFloat(entity[property]) || 0;\r}\r</code>\r</pre>\r</li>\r<li>\r对于一些较复杂的计算方法，无法以一个Function来完成定义。此时可以采用一个包含3个方法的JSON对象来完成定义。\r<br/>\r例如average（平均值）的定义如下。\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\r{\r\t// 初始方法，用于初始化统计值。此方法只在统计开始前执行一次。\r\tgetInitialValue: function() {\r\t\treturn {\r\t\t\tsum: 0,\r\t\t\tcount: 0\r\t\t};\r\t},\r\r\t// 累计方法，此方法会在统计过程中针对每一个被统计对象执行一次。类似于上面提到简单定义中的那个Function。\r\t// 此处的value参数即是getInitialValue()返回的那个对象。\r\taccumulate: function(value, entity, property) {\r\t\tvalue.sum += getValueForSummary(entity, property);\r\t\tvalue.count++;\r\t\treturn value;\r\t},\r\r\t// 用于计算最终的统计值的方法，此方法只在统计完成前执行一次。\r\tgetFinalValue: function(value) {\r\t\treturn value.count ? value.sum / value.count : 0;\r\t}\r}\r</code>\r</pre>\r</li>\r</ul>\r</p>","package":"data","memberOf":"dorado","properties":[{"name":"count","type":"property","desc":"\"总数量\"计算方法。","alias":"dorado.SummaryCalculators.count","visibility":"public","isStatic":true,"memberOf":"dorado.SummaryCalculators","package":"data"},{"name":"sum","type":"property","desc":"\"合计值\"计算方法。","alias":"dorado.SummaryCalculators.sum","visibility":"public","isStatic":true,"memberOf":"dorado.SummaryCalculators","package":"data"},{"name":"average","type":"property","desc":"\"平均值\"计算方法。","alias":"dorado.SummaryCalculators.average","visibility":"public","isStatic":true,"memberOf":"dorado.SummaryCalculators","package":"data"},{"name":"max","type":"property","desc":"\"最大值\"计算方法。","alias":"dorado.SummaryCalculators.max","visibility":"public","isStatic":true,"memberOf":"dorado.SummaryCalculators","package":"data"},{"name":"min","type":"property","desc":"\"最小值\"计算方法。","alias":"dorado.SummaryCalculators.min","visibility":"public","isStatic":true,"memberOf":"dorado.SummaryCalculators","package":"data"}],"attributes":[],"methods":[],"constructors":[],"events":[]}