SYMBOLS["dorado.util.Common"]={"name":"Common","type":"object","desc":null,"alias":"dorado.util.Common","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"一些实现通用功能的工具方法。","package":"core","memberOf":"dorado.util","properties":[{"name":"URL_VARS","type":"property","desc":"用于注册URL预设变量的JSON对象。","alias":"dorado.util.Common.URL_VARS","see":["dorado.util.Common.translateURL","$url"],"visibility":"public","isStatic":true,"memberOf":"dorado.util.Common","package":"core"}],"attributes":[],"methods":[{"name":"translateURL","type":"method","desc":"将一段给定URL转换为最终的可以使用的URL。\r<p>\r此方法允许用户在定义一个URL时利用\">\"在URL中植入特定的内容。<br/>\r例如：\">images/loading.gif\"表示应用的根路径下的\"images/loading.gif\"。\r如果此时应用的根路径是\"/sampleApp\"，那么此方法最终返回的URL将是\"/sampleApp/images/loading.gif\"。（应用的根路径通过<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$setting')\">$setting</A>中的\"common.contextPath\"项设定）\r</p>\r<p>\r另外，此方法还支持在URL中植入预设变量。<br/>\r例如：\"skin>button.css\"表示系统当前皮肤根路径中的button.css。其中的\"skin>\"就代表一个名为skin的预设变量。此方法会将预设变量的值替换的URL中。<br/>\r假设skin变量的值为\"/sampleApp/skins/nature/\"，那么上述URL的最终转换结果为\"/sampleApp/skins/nature/button.css\"。\r</p>\r<p>\r此方法中使用的预设变量都需要注册在<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Toolkits.URL_VARS')\">dorado.Toolkits.URL_VARS</A>中，系统默认情况下只提供一个名为skin的预设变量。开发人员可以根据自己的需要向URL_VARS中注册自己的预设变量。\r</p>","alias":"dorado.util.Common.translateURL","see":["$url","dorado.Toolkits.URL_VARS"],"visibility":"public","params":[{"desc":"要转换的URL。","type":"String","name":"url"}],"returns":{"desc":"转换后得到的URL。","type":"String"},"package":"core","isStatic":true,"memberOf":"dorado.util.Common"},{"name":"formatFloat","type":"method","desc":"格式化输出数字的方法。\r<p>\r此方法的format参数是一个格式化字符串，用于指定数字的格式化方式。 其语法中包含下面的几种具有特定含义的字符或组合:\r<ul>\r<li># - 用于表示一个非强制输出的数字字符。即如果在此位置有可用的数字则输出该数字，否则不输出任何内容。</li>\r<li>0 - 用于表示一个强制输出的数字字符。即如果在此位置有可用的数字则输出该数字，否则将输出0来占位。</li>\r<li>#, - 用于表示以123,456,这样的方式向左输出所有的剩余数字。</li>\r</ul>\r</p>","alias":"dorado.util.Common.formatFloat","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var $formatFloat = dorado.util.Common.formatFloat;\r$formatFloat(123456789.789, \"#,##0.00\"); // 123,456,789.79\r$formatFloat(123456789.789, \"#\"); // 123456790\r$formatFloat(123456789.789, \"0\"); // 123456790\r$formatFloat(123, \"#.##\"); // 123\r$formatFloat(123, \"0.00\"); // 123.00\r$formatFloat(0.123, \"0.##\"); // 0.12\r$formatFloat(0.123, \"#.##\"); // .12\r$formatFloat(-0.123, \"0.##\"); // -0.12\r$formatFloat(-0.123, \"#.##\"); // -.12\r$formatFloat(1234.567, \"$#,##0.00/DAY\"); // $1,234.57/DAY\r$formatFloat(02145375683, \"(###)########\"); // (021)45375683"}],"visibility":"public","params":[{"desc":"要转换的浮点数。","type":"float","name":"n"},{"desc":"格式化字符串。","type":"String","name":"format"}],"returns":{"desc":"格式化后得到的字符串。","type":"String"},"package":"core","isStatic":true,"memberOf":"dorado.util.Common"},{"name":"parseFloat","type":"method","desc":"尝试将一段字符串中包含的数字转换成一个浮点数。 如果转换失败将返回Number.NaN。","alias":"dorado.util.Common.parseFloat","visibility":"public","params":[{"desc":"要转换的字符串。","type":"String","name":"s"}],"returns":{"desc":"转换后得到的浮点数。","type":"float"},"package":"core","isStatic":true,"memberOf":"dorado.util.Common"},{"name":"getClassType","type":"method","desc":"根据给定的Class类型的名称返回具体的Class的构造器。","alias":"dorado.util.Common.getClassType","visibility":"public","params":[{"desc":"Class类型的名称。","type":"String","name":"type"},{"desc":"是否已安静的方式执行。即当此方法的执行过程中发生异常时，是否要抛出异常。","type":"boolean","name":"silence","isOptional":true}],"returns":{"desc":"具体的Class的构造器。","type":"Function"},"package":"core","isStatic":true,"memberOf":"dorado.util.Common"},{"name":"getSingletonInstance","type":"method","desc":"返回一个单例对象。","alias":"dorado.util.Common.getSingletonInstance","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用类型名\rvar renderer = dorado.util.Common.getSingletonInstance(\"dorado.widget.grid.DefaultCellRenderer\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用创建工厂\rvar renderer = dorado.util.Common.getSingletonInstance(function() {\r\treturn dorado.widget.grid.DefaultCellRenderer();\r});"}],"see":["$singleton"],"visibility":"public","params":[{"desc":"单例对象的类型名或创建工厂。","type":"String|Function","name":"factory"}],"returns":{"desc":"单例对象的实例。","type":"Object"},"package":"core","isStatic":true,"memberOf":"dorado.util.Common"}],"constructors":[],"events":[]}