SYMBOLS["dorado.util.Dom"]={"name":"Dom","type":"object","desc":null,"alias":"dorado.util.Dom","author":"Benny Bao (mailto:benny.bao@bstek.com), Frank Zhang (mailto:frank.zhang@bstek.com)","classDesc":"提供DOM相关操作的工具类。","package":"core","memberOf":"dorado.util","properties":[],"attributes":[],"methods":[{"name":"getInvisibleContainer","type":"method","desc":"返回一个不可见的DIV节点。\r<p>\r此处的不可见并非是指利用style.display或style.visibility设置成为不可见的DIV。\r而一个本质可见却位于屏幕之外而无法被看到的DIV。\r</p>\r<p>\r本方法最多只会创建一个不可见的DIV节点，因此每一次调用此方法我们都会得到相同的返回结果。\r</p>","alias":"dorado.util.Dom.getInvisibleContainer","visibility":"public","returns":{"desc":"DIV节点。","type":"HTMLElement"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"getOwnerWindow","type":"method","desc":"根据传入的节点返回节点所属的window对象。","alias":"dorado.util.Dom.getOwnerWindow","visibility":"public","params":[{"desc":"HTML元素或节点。","type":"HTMLElement","name":"node"}],"returns":{"desc":"window对象。","type":"Window"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"isOwnerOf","type":"method","desc":"判断owner参数代表的节点是否是node参数代表的节点的上级节点。","alias":"dorado.util.Dom.isOwnerOf","visibility":"public","params":[{"desc":"要判断的节点。","type":"HTMLElement","name":"node"},{"desc":"上级节点。","type":"HTMLElement","name":"owner"}],"returns":{"desc":"是否上级节点。","type":"boolean"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"findParent","type":"method","desc":"根据fn函数所代表的匹配规则，查找第一个匹配的父节点。","alias":"dorado.util.Dom.findParent","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 查找并返回node节点的&lt;DIV&gt;类型的父节点\rvar parentDiv = dorado.util.Dom.findParent(node, function(parentNode) {\r\treturn parentNode.tagName.toLowerCase() == \"div\";\r});"}],"visibility":"public","params":[{"desc":"子节点。","type":"HTMLElement","name":"node"},{"desc":"用于描述匹配规则的函数。","type":"Function","name":"fn"},{"desc":"查找范围中是否包含node参数指定的子节点自身，默认为true。","type":"boolean","name":"includeSelf","isOptional":true,"defaultValue":"true"}],"returns":{"desc":"找到的父节点。","type":"HTMLElement"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"getCellPosition","type":"method","desc":"取得触发事件的表格单元格。","alias":"dorado.util.Dom.getCellPosition","visibility":"public","params":[{"desc":"浏览器的event对象。","type":"Event","name":"event"}],"returns":{"desc":"触发事件的表格单元格，包含row、column、element属性。","type":"Object"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"dockAround","type":"method","desc":"将一个DOM对象一环绕的方式停靠在另一个固定位置DOM对象的周围。\r<p>\r该方法把固定位置的DOM对象的横向和纵向进行了区域划分。<br />\r横向可以分为五个区域，分别是left、innerleft、center、innerright、top。<br />\r纵向也可以分为5个区域，分别是top、innertop、center、innerbottom、bottom。<br />\r如下图所示（橙色方块代表fixedElement，从fixedElement的左上角作为原点坐标，可以为水平和垂直方向分别划分5个区域，该图主要展示水平和垂直区域的划分）：\r</p>\r<img class=\"clip-image\" src=\"images/dock-around-1.jpg\">\r<p>\r根据水平方向五个区域，垂直方向五个区域，那么对水平方向和垂直方向进行组合，则可以得出25中组合，如下图所示：\r</p>\r<img class=\"clip-image\" src=\"images/dock-around-2.jpg\">\r<p>\r这些组合基本上可以满足用户的大部分需求，如果计算出来的位置需要微调，可以使用offsetLeft、offsetTop进行微调。\r</p>\r\r<p>\r另外，此方法在设定停靠位置的同时会尽可能使DOM对象位于屏幕的可见区域内。\r该方法会先判断出该组件是横向超出，还是纵向超出，然后根据要停靠的DOM对象的align和vAlign设置，进行一个合理的方向的调整。\r如果该方向可以显示在屏幕范围内，则使用该位置。<br />\r如果仍然不能显示在屏幕范围内，我们就认为该组件的超出触发，会调用该组件的overflowHandler来处理组件的超出。\r</p>","alias":"dorado.util.Dom.dockAround","visibility":"public","params":[{"desc":"要停靠的DOM对象。\r    此DOM对象是绝对定位的(style.position=absolute)并且其DOM树处于顶层位置(即其父节点是document.body)。","type":"HTMLElement","name":"element"},{"desc":"固定位置的DOM对象，如果是window，则表示该要停靠的DOM元素相对于当前可视范围进行停靠。","type":"HTMLElement|window","name":"fixedElement"},{"desc":"以JSON方式定义的选项。","type":"Object","name":"options"},{"desc":"在水平方向上，停靠的DOM对象停靠在固定位置的DOM对象的位置。可选值为left、innerleft、center、innerright、top。","type":"String","name":"options.align","isOptional":true,"defaultValue":"innerleft"},{"desc":"在垂直方向上，停靠的DOM对象停靠在固定位置的DOM对象的位置。可选值为top、innertop、center、innerbottom、bottom。","type":"String","name":"options.vAlign","isOptional":true,"defaultValue":"innertop"},{"desc":"在水平方向上，停靠的DOM对象与固定位置的DOM对象之间的间隙大小，可以为正，可以为负。","type":"int","name":"options.gapX","isOptional":true,"defaultValue":"0"},{"desc":"在垂直方向上，停靠的DOM对象与固定位置的DOM对象之间的间隙大小，可以为正，可以为负。","type":"int","name":"options.gapY","isOptional":true,"defaultValue":"0"},{"desc":"使用align计算出组件的位置的水平偏移量，可以为正，可以为负。","type":"int","name":"options.offsetLeft","isOptional":true,"defaultValue":"0"},{"desc":"使用vAlign计算出组件的位置的垂直偏移量，可以为正，可以为负。","type":"int","name":"options.offsetTop","isOptional":true,"defaultValue":"0"},{"desc":"当使用默认的align、vAlign计算的位置超出屏幕可见范围以后，是否要对停靠DOM对象的位置进行调整，默认为true，即进行调整。","type":"boolean","name":"options.autoAdjustPosition","isOptional":true,"defaultValue":"true"},{"desc":"当组件无法显示在屏幕范围以内以后，就认为停靠的DOM对象的超出触发了，该属性用来标示是否对这种情况进行处理，默认会对这种情况进行处理。","type":"boolean","name":"options.handleOverflow","isOptional":true,"defaultValue":"true"},{"desc":"当停靠的DOM的超出触发以后，要调用的函数。","type":"Function","name":"options.overflowHandler","isOptional":true}],"returns":{"desc":"计算出来的位置。","type":"Object"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"locateIn","type":"method","desc":"将一个绝对定位(style.position=absolute)的DOM对象放置在屏幕或另一个DOM对象的可见区域内。","alias":"dorado.util.Dom.locateIn","visibility":"public","params":[{"desc":"要放置的DOM对象。\r    此DOM对象是绝对定位的(style.position=absolute)并且其DOM树处于顶层位置(即其父节点是document.body)。","type":"HTMLElement","name":"element"},{"desc":"以JSON方式定义的选项。","type":"Object","name":"options"},{"desc":"作为容器的DOM对象（并不是指DOM结构上的父节点，仅指视觉上的关系）。如果不指定此属性则表示放置在屏幕可见区域内。","type":"HTMLElement","name":"options.parent"},{"desc":"水平偏移量，可以为正，可以为负。","type":"int","name":"options.offsetLeft"},{"desc":"垂直偏移量，可以为正，可以为负。","type":"int","name":"options.offsetTop"},{"desc":"当使用指定的position计算的位置超出屏幕可见范围以后，是否要对停靠DOM对象的位置进行调整，默认为true，即进行调整。","type":"boolean","name":"options.autoAdjustPosition"},{"desc":"当组件无法显示在屏幕范围以内以后，认为停靠的DOM的超出触发了，该属性用来标示是否对这种情况进行处理，默认会对这种情况进行处理。","type":"boolean","name":"options.handleOverflow"},{"desc":"当停靠的DOM的超出触发以后，要调用的函数。","type":"Function","name":"options.overflowHandler"}],"returns":{"desc":"计算出来的位置。","type":"Object"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"disableUserSelection","type":"method","desc":"禁止某DOM对象（包含其中的子元素）被鼠标选中。","alias":"dorado.util.Dom.disableUserSelection","visibility":"public","params":[{"desc":"DOM对象。","type":"HTMLElement","name":"element"}],"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"enableUserSelection","type":"method","desc":"允许某DOM对象（包含其中的子元素）被鼠标选中。","alias":"dorado.util.Dom.enableUserSelection","visibility":"public","params":[{"desc":"DOM对象。","type":"HTMLElement","name":"element"}],"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"bringToFront","type":"method","desc":"将相应元素提到最前面，即为相应元素设置合适的style.zIndex使其不至于被其他元素阻挡。","alias":"dorado.util.Dom.bringToFront","visibility":"public","params":[{"desc":"DOM对象。","type":"HTMLElement","name":"element"},{"desc":"zIndex偏移量，默认为0。","type":"int","name":"radius","isOptional":true}],"returns":{"desc":"该DOM对象获得的新的zIndex的值。","type":"int"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"xCreate","type":"method","desc":"根据以JSON形式定义的组件的模板信息快速的创建DOM元素。","alias":"dorado.util.Dom.xCreate","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 创建一个按钮\n$DomUtils.xCreate({\n\ttagName: \"button\",\n\tcontent: \"Click Me\",\t// 定义按钮的标题\n\tstyle: {\t// 定义按钮的style\n\t\tborder: \"1px black solid\",\n\t\tbackgroundColor: \"white\"\n\t},\n\tonclick: function() {\t// 定义onclick事件\n\t\talert(\"Button clicked.\");\n\t}\n});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 创建一个按钮\n$DomUtils.xCreate({\n\ttagName: \"DIV\",\n\tcontentText: \"<Input>\"\t// contentText属性类似于content，但contentText中的文本内容不会被识别成为HTML\n});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 创建两个DIV, 同时将两个DIV注册到上下文中\nvar context = {};\n$DomUtils.xCreate([\n\t{\n\t\ttagName: \"div\",\n\t\tcontent: \"Content of DIV1\",\n\t\tcontextKey: \"div1\"\n\t},\n\t{\n\t\ttagName: \"div\",\n\t\tcontent: \"Content of DIV2\",\n\t\tcontextKey: \"div2\"\n\t}\n], null, context);\nvar div1 = context.div1;\nvar div2 = context.div2;"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 一个表格\n$DomUtils.xCreate(\n\t{\n\t\ttagName: \"table\",\n\t\tcontent: [\n\t\t\t{\n\t\t\t\ttagName: \"tr\",\n\t\t\t\tcontent: [\n\t\t\t\t\t{\n\t\t\t\t\t\ttagName: \"td\"\n\t\t\t\t\t\tcontent: \"1.1\"\n\t\t\t\t\t},\n\t\t\t\t\t{\n\t\t\t\t\t\ttagName: \"td\"\n\t\t\t\t\t\tcontent: \"1.2\"\n\t\t\t\t\t}\n\t\t\t\t]\n\t\t\t},\n\t\t\t{\n\t\t\t\ttagName: \"tr\",\n\t\t\t\tcontent: [\n\t\t\t\t\t{\n\t\t\t\t\t\ttagName: \"td\"\n\t\t\t\t\t\tcontent: \"2.1\"\n\t\t\t\t\t},\n\t\t\t\t\t{\n\t\t\t\t\t\ttagName: \"td\"\n\t\t\t\t\t\tcontent: \"2.2\"\n\t\t\t\t\t}\n\t\t\t\t]\n\t\t\t}\n\t\t]\n\t}\n);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用带参数的模板\nvar template = function(arg) {\n\treturn [ {\n\t\ttagName : \"button\",\n\t\tcontent : arg.buttonText1\n\t}, {\n\t\ttagName : \"button\",\n\t\tcontent : arg.buttonText2\n\t} ]\n};\nvar arg = {\n\tbuttonText1 : \"Button 1\",\n\tbuttonText2 : \"Button 2\"\n};\n$DomUtils.xCreate(template, arg);"}],"visibility":"public","params":[{"desc":"JSON形式定义的组件的模板信息。","type":"Object|Object[]","name":"template"},{"desc":"JSON形式定义的模板参数。","type":"Object","name":"arg","isOptional":true},{"desc":"用于在创建过程中搜集子元素引用的上下文对象。\n对于那些模板信息中带有contextKey属性的子元素，本方法会自动将相应的子元素的引用添加到context的属性中。","type":"Object","name":"context","isOptional":true}],"returns":{"desc":"新创建的HTML元素或HTML元素的数组。","type":"HTMLElement|HTMLElement[]"},"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"},{"name":"modernScroll","type":"method","desc":null,"alias":"dorado.util.Dom.modernScroll","visibility":"public","params":[{"desc":null,"type":"Object","name":"container"},{"desc":null,"type":"Object","name":"options","isOptional":true},{"desc":null,"type":"boolean","name":"options.listenSize","isOptional":true},{"desc":null,"type":"boolean","name":"options.listenContainerSize","isOptional":true},{"desc":null,"type":"boolean","name":"options.listenContentSize","isOptional":true}],"package":"core","isStatic":true,"memberOf":"dorado.util.Dom"}],"constructors":[],"events":[]}