SYMBOLS["dorado.util.KeyedArray"]={"name":"KeyedArray","type":"class","desc":null,"alias":"dorado.util.KeyedArray","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var keyedArray = new dorado.util.KeyedArray();"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var keyedArray = new dorado.util.KeyedArray( function(obj) {\r\t// 此处的参数obj为数组中的某个元素，返回值为与该元素匹配的键值。\r\t\treturn obj.id;\r\t});"}],"classDesc":"键值对数组，即支持通过键值对元素进行快速定位的数组。","package":"core","memberOf":"dorado.util","properties":[{"name":"items","type":"Array","desc":"键值对数组中的所有元素。","alias":"dorado.util.KeyedArray#items","visibility":"public","memberOf":"dorado.util.KeyedArray","package":"core"},{"name":"size","type":"int","desc":"键值对数组的大小，即数组中的元素个数。","alias":"dorado.util.KeyedArray#size","visibility":"public","memberOf":"dorado.util.KeyedArray","package":"core"}],"attributes":[],"methods":[{"name":"insert","type":"method","desc":"向键值对数组中添加一个对象。","alias":"dorado.util.KeyedArray#insert","visibility":"public","params":[{"desc":"要添加的对象。","type":"Object","name":"data"},{"desc":"对象的插入位置或插入模式。如果不定义此参数表示将对象添加到集合的末尾。\r此参数具有两种可能的含义:\r<ul>\r<li>当此参数是一个数字时，表示新对象在集合中的最终位置。</li>\r<li>当此参数是一个字符串时，表示新对象的插入模式。\r插入方式，包含下列四种取值：\r<ul>\r<li>begin - 在链表的起始位置插入。</li>\r<li>before - 在refData参数指定的参照对象之前插入。</li>\r<li>after - 在refData参数指定的参照对象之后插入。</li>\r<li>end - 在链表的末尾插入。</li>\r</ul>\r</li>\r</ul>","type":"int|String","name":"insertMode","isOptional":true},{"desc":"插入位置的参照对象。此参数仅在insertMode参数为字符串时有意义。","type":"Object","name":"refData","isOptional":true}],"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"append","type":"method","desc":"向键值对数组中追加一个对象。","alias":"dorado.util.KeyedArray#append","visibility":"public","params":[{"desc":"要追加的对象。","type":"Object","name":"data"}],"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"remove","type":"method","desc":"从键值对数组中移除一个对象。","alias":"dorado.util.KeyedArray#remove","visibility":"public","params":[{"desc":"要移除的对象。","type":"Object","name":"data"}],"returns":{"desc":"被移除元素的下标位置。","type":"int"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"removeAt","type":"method","desc":"从键值对数组中移除指定位置的元素。","alias":"dorado.util.KeyedArray#removeAt","visibility":"public","params":[{"desc":"要移除元素的下标位置。","type":"int","name":"i"}],"returns":{"desc":"返回从数组中移除移除的对象.","type":"Object"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"removeKey","type":"method","desc":"从键值对数组中移除指定键值。","alias":"dorado.util.KeyedArray#removeKey","visibility":"public","params":[{"desc":"要移除元素的键值。","type":"String","name":"key"}],"returns":{"desc":"返回从数组中移除移除的对象.","type":"Object"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"indexOf","type":"method","desc":"根据对象返回其在键值对数组中的下标位置。如果指定的对象不在键值对数组中将返回-1。","alias":"dorado.util.KeyedArray#indexOf","visibility":"public","params":[{"desc":"查找的对象。","type":"Object","name":"data"}],"returns":{"desc":"下标位置。","type":"int"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"replace","type":"method","desc":"替换键值对数组的某一项。","alias":"dorado.util.KeyedArray#replace","visibility":"public","params":[{"desc":"将被替换的对象。","type":"Object","name":"oldData"},{"desc":"新的对象。","type":"Object","name":"newData"}],"returns":{"desc":"发生替换动作下标位置。如果返回-1则表示被替换的对象并不存在于该数组中。","type":"int"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"get","type":"method","desc":"根据传入的下标位置或键值返回匹配的对象。","alias":"dorado.util.KeyedArray#get","visibility":"public","params":[{"desc":"下标位置或键值。","type":"int|String","name":"k"}],"returns":{"desc":"匹配的对象。","type":"Object"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"clear","type":"method","desc":"清除集合中的所有对象。","alias":"dorado.util.KeyedArray#clear","visibility":"public","package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"iterator","type":"method","desc":"返回数组的迭代器。","alias":"dorado.util.KeyedArray#iterator","visibility":"public","params":[{"desc":"从哪一个元素所在的位置开始迭代。","type":"Object","name":"from","isOptional":true}],"returns":{"desc":"数组迭代器。","type":"dorado.util.Iterator"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"each","type":"method","desc":"针对键值对数组中的每一个元素执行指定的函数。此方法可用于替代对数组的遍历代码。","alias":"dorado.util.KeyedArray#each","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 将每一个数组元素的name属性连接成为一个字符串。\rvar names = \"\";\rvar keyedArray = new dorado.util.KeyedArray();\r... ... ...\rkeyedArray.each(function(obj){\r\tnames += obj.name;\r});"}],"visibility":"public","params":[{"desc":"针对每一个元素执行的函数。","type":"Function","name":"fn"},{"desc":"函数脚本的宿主，即函数脚本中this的含义。如果此参数为空则表示this为数组中的某个对象。","type":"Object","name":"scope","isOptional":true}],"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"toArray","type":"method","desc":"将集成从所有的对象导出至一个数组中。","alias":"dorado.util.KeyedArray#toArray","visibility":"public","returns":{"desc":"包含所有集合元素的数组。","type":"Array"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"clone","type":"method","desc":"浅度克隆本键值对数组。","alias":"dorado.util.KeyedArray#clone","visibility":"public","returns":{"desc":"克隆的数组。","type":"dorado.util.KeyedArray"},"package":"core","memberOf":"dorado.util.KeyedArray"},{"name":"deepClone","type":"method","desc":"深度克隆本键值对数组。","alias":"dorado.util.KeyedArray#deepClone","visibility":"public","returns":{"desc":"克隆的数组。","type":"dorado.util.KeyedArray"},"package":"core","memberOf":"dorado.util.KeyedArray"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.util.KeyedArray","params":[{"desc":"用于从元素中提取元素键值的函数，此函数应该返回一个String作为键值。","type":"Function","name":"getKeyFunction","isOptional":true}]}],"events":[]}