SYMBOLS["dorado.util.ObjectPool"]={"name":"ObjectPool","type":"class","desc":"构造器。","alias":"dorado.util.ObjectPool","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 结合XMLHttpRequest创建过程的简陋示例：\r// 声明XMLHttpRequest的创建工厂\rvar factory = {\r\tmakeObject: function() {\r\t\t// 创建XMLHttpRequset对象\r\t\t// 注：这里的创建方法不够健壮，勿学！\r\t\tif (window.ActiveXObject){\r\t\t\treturn new ActiveXObject(\"Microsoft.XMLHTTP\");\r\t\t}\r\t\telse {\r\t\t\treturn new XMLHttpRequest();\r\t\t}\r\t},\tpassivateObject: function(xhr) {\r\t\t// 重置XMLHttpRequset对象\r\t\txhr.onreadystatechange = {};\r\t\txhr.abort();\r\t}\r};\rvar pool = new ObjectPool(factory); // 创建对象池\r......\rvar xhr = pool.borrowObject(); // 获得一个XMLHttpRequest对象\rxhr.onreadystatechange = function() {\r\tif (xhr.readyState == 4) {\r\t\t......\r\t\tpool.returnObject(xhr); // 归还XMLHttpRequest对象\r\t}\r};\rxhr.open(method, url, true);\r......"}],"classDesc":"对象缓存池。用于对对象进行缓存、池化管理的容器。","package":"core","memberOf":"dorado.util","properties":[],"attributes":[],"methods":[{"name":"borrowObject","type":"method","desc":"从对象池中租借一个对象。","alias":"dorado.util.ObjectPool#borrowObject","visibility":"public","returns":{"desc":"返回租借到的对象实例。","type":"Object"},"package":"core","memberOf":"dorado.util.ObjectPool"},{"name":"returnObject","type":"method","desc":"向对象池归还一个先前租借的对象。","alias":"dorado.util.ObjectPool#returnObject","visibility":"public","params":[{"desc":"要归还的对象。","type":"Object","name":"object"}],"package":"core","memberOf":"dorado.util.ObjectPool"},{"name":"getNumActive","type":"method","desc":"返回对象池中的激活对象的个数。","alias":"dorado.util.ObjectPool#getNumActive","visibility":"public","returns":{"desc":"激活对象的个数。","type":"int"},"package":"core","memberOf":"dorado.util.ObjectPool"},{"name":"getNumIdle","type":"method","desc":"返回对象池中的空闲对象的个数。","alias":"dorado.util.ObjectPool#getNumIdle","visibility":"public","returns":{"desc":"空闲对象的个数。","type":"int"},"package":"core","memberOf":"dorado.util.ObjectPool"},{"name":"destroy","type":"method","desc":"销毁对象池及其中管理的所有对象。","alias":"dorado.util.ObjectPool#destroy","visibility":"public","package":"core","memberOf":"dorado.util.ObjectPool"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.util.ObjectPool","params":[{"desc":"可池化对象的工厂。","type":"Object","name":"factory"},{"desc":"(<b>必须指定</b>) 创建一个新的对象，该方法的返回值即为新创建的对象。","type":"Function","name":"factory.makeObject"},{"desc":"销毁一个对象。","type":"Function","name":"factory.destroyObject"},{"desc":"当一个对象被激活（被租借）时触发的方法。","type":"Function","name":"factory.activateObject"},{"desc":"当一个对象被钝化（被归还）时触发的方法。","type":"Function","name":"factory.passivateObject"}]}],"events":[]}