SYMBOLS["dorado.widget.CaptionBar"]={"name":"CaptionBar","type":"class","desc":null,"alias":"dorado.widget.CaptionBar","author":"Frank Zhang (mailto:frank.zhang@bstek.com)","classDesc":"标题栏\r<p>\r主要用来显示标题，也可以显示图标和工具按钮，目前被dorado.widget.Panel与dorado.widget.accordion.Section使用。\r一般情况下，用户不需要手工添加一个标题栏组件。\r</p>","package":"base-widget-desktop","inheritsFrom":["dorado.widget.Control"],"memberOf":"dorado.widget","properties":[{"name":"focusable","type":"boolean","desc":"用于指示该种控件是否支持获得控制焦点。","alias":"dorado.widget.Control#focusable","visibility":"protected","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"tabStop","type":"boolean","desc":"是否可通过Tab键获得控制焦点。","alias":"dorado.widget.Control#tabStop","visibility":"protected","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"selectable","type":"boolean","desc":"该控件（包含其中的子控件）是否允许被鼠标选中。","alias":"dorado.widget.Control#selectable","visibility":"protected","defaultValue":"true","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"},{"name":"ATTRIBUTES","type":"Object","desc":"用于声明该对象中所支持的所有Attribute。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.AttributeSupport#ATTRIBUTES","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的caption属性的声明。\rvar attributeDef = oop.ATTRIBUTES.caption。\r// 判断该属性是否只读\rif (attributeDef.readOnly) { ... ... }"}],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"objects","type":"dorado.AttributeSupport[]","desc":"对象数组。","alias":"dorado.AttributeSupport#objects","visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"attributes":[{"name":"caption","type":"String","desc":"标题栏上显示的标题。","alias":"dorado.widget.CaptionBar#attribute:caption","visibility":"public","memberOf":"dorado.widget.CaptionBar","package":"base-widget-desktop"},{"name":"icon","type":"String","desc":"标题栏上显示的图标。","alias":"dorado.widget.CaptionBar#attribute:icon","visibility":"public","memberOf":"dorado.widget.CaptionBar","package":"base-widget-desktop"},{"name":"iconClass","type":"String","desc":"标题栏上显示的图标用的className。","alias":"dorado.widget.CaptionBar#attribute:iconClass","visibility":"public","memberOf":"dorado.widget.CaptionBar","package":"base-widget-desktop"},{"name":"buttons","type":"dorado.util.KeyedArray","desc":"标题栏右侧的工具按钮。","alias":"dorado.widget.CaptionBar#attribute:buttons","visibility":"public","memberOf":"dorado.widget.CaptionBar","package":"base-widget-desktop"},{"name":"width","type":"int|String","desc":"宽度。","alias":"dorado.widget.Control#attribute:width","visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"height","type":"int|String","desc":"高度。","alias":"dorado.widget.Control#attribute:height","visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"renderTo","type":"String|HTMLElement","desc":"用于指定该控件在创建后自动渲染到指定到网页中的什么位置中的属性。最终控件将被渲染目标位置对象的内部。\r<p>\r该属性的内容是CSS Selector的表达式（用于确定渲染的目标位置）或直接传入目标位置的DOM对象。\r</p>\r<p>\r注意：此属性的值只能在控件的构造参数中指定，当控件创建完成后再通过set方法修改将是没有任何意义的。\r</p>\r<p>\r注意：如果同时定义了控件的renderTo和renderOn属性，那么系统将会忽略renderOn中的值。\r</p>","alias":"dorado.widget.Control#attribute:renderTo","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 指定此按钮自动渲染到id为divButtonHolder的DOM元素中。\rnew dorado.widget.Button({\r\tcaption: \"Test Button\",\r\trenderTo: \"#divButtonHolder\"\r});"}],"see":["dorado.widget.Control#attribute:renderOn"],"visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support","writeBeforeReady":true},{"name":"renderOn","type":"String|HTMLElement","desc":"用于指定该控件在创建后自动渲染到指定到网页中的什么位置中的属性。最终控件将直接替换掉目标位置对象。\r<p>\r该属性的内容是CSS Selector的表达式（用于确定渲染的目标位置）或直接传入目标位置的DOM对象。\r</p>\r<p>\r注意：此属性的值只能在控件的构造参数中指定，当控件创建完成后再通过set方法修改将是没有任何意义的。\r</p>\r<p>\r注意：如果同时定义了控件的renderTo和renderOn属性，那么系统将会忽略renderOn中的值。\r</p>","alias":"dorado.widget.Control#attribute:renderOn","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 指定此按钮自动渲染并替换掉id为myButton的DOM元素。\rnew dorado.widget.Button({\r\tcaption: \"Test Button\",\r\trenderOn: \"#myButton\"\r});"}],"see":["dorado.widget.Control#attribute:renderTo"],"visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support","writeBeforeReady":true},{"name":"visible","type":"Boolean","desc":"是否可见。","alias":"dorado.widget.Control#attribute:visible","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"actualVisible","type":"boolean","desc":"用于表述此控件当前是否真实可见。\r<p>\r除控件的visible属性可以改变本控件的可见状态之外，父控件被隐藏、面板收起、窗口最小化等原因都可能造成某控件实际处于不可见状态。\r因此visible为true的控件，其actualVisible属性未必也返回true。\r</p>","alias":"dorado.widget.Control#attribute:actualVisible","visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support","readOnly":true},{"name":"hideMode","type":"boolean","desc":"隐藏模式，表示当用户将该控件的visible属性设置为false时，系统应通过怎样的方式隐藏它。取值范围如下：\r<ul>\r<li>visibility    -    仅将此控件的设置为不可见，它仍将占用布局控件。</li>\r<li>display    -    将此控件从布局中抹去，且其他控件可以占用它空出的位置。</li>\r</ul>","alias":"dorado.widget.Control#attribute:hideMode","visibility":"public","defaultValue":"\"visibility\"","memberOf":"dorado.widget.Control","package":"widget-support","writeBeforeReady":true},{"name":"attached","type":"boolean","desc":"指示控件所对应的HTML元素被真正的添加(相当于appendChild)到HTML的dom树中。","alias":"dorado.widget.Control#attribute:attached","visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support","readOnly":true},{"name":"focused","type":"boolean","desc":"指示控件当前是否拥有控制焦点","alias":"dorado.widget.Control#attribute:focused","visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support","readOnly":true},{"name":"focusParent","type":"dorado.widget.Control","desc":"用表示控件在处理控制焦点是的上下级关系。\r<p>\r在通常情况下，控件的focusParent与parent是一致的，只有在个别情况下例外。\r例如：我们创建了一个TextEditor控件使其作为Grid控件的单元格编辑器， 由于Grid控件并不是一个<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container')\">dorado.widget.Container</A>的子类，因此TextEditor的parent不可能是Grid。\r然后TextEditor与Grid又确实具有上下级的关系，尤其是在处理控制焦点时，此时系统会将TextEditor的focusParent属性设置为Grid。\r</p>","alias":"dorado.widget.Control#attribute:focusParent","visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"tip","type":"String","desc":"提示信息。","alias":"dorado.widget.Control#attribute:tip","visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"layoutConstraint","type":"Object","desc":"控件使用的布局条件。\r<p>\r此属性只会在控件被添加到布局管理器后才会产生实际效果。<br/>\r除了通过此方法为控件定义布局条件之外，也可以直接通过<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container#addChild')\">dorado.widget.Container#addChild</A>方法的layoutConstraint参数。\raddChild方法会自动将传入的layoutConstaint参数的值（如果确实定义了该参数值的话）自动赋值给相应控件的layoutConstaint属性。\r</p>","alias":"dorado.widget.Control#attribute:layoutConstraint","see":["dorado.widget.Container#addChild"],"visibility":"public","memberOf":"dorado.widget.Control","package":"widget-support"},{"name":"ready","type":"boolean","desc":"组件当前是否已激活。","alias":"dorado.widget.Component#attribute:ready","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"parent","type":"dorado.widget.Component","desc":"父控件。","alias":"dorado.widget.Component#attribute:parent","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"dataTypeRepository","type":"dorado.DataTypeRepository","desc":"此视图对象使用的数据类型管理器。","alias":"dorado.widget.Component#attribute:dataTypeRepository","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"id","type":"String","desc":"组件的id。","alias":"dorado.widget.ViewElement#attribute:id","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","writeBeforeReady":true},{"name":"destroyed","type":"boolean","desc":"组件当前是否已被销毁。","alias":"dorado.widget.ViewElement#attribute:destroyed","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"parentViewElement","type":"dorado.widget.ViewElement","desc":"父组件。","alias":"dorado.widget.ViewElement#attribute:parentViewElement","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"view","type":"dorado.widget.View","desc":"组件所属的视图。","alias":"dorado.widget.ViewElement#attribute:view","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"userData","type":"Object","desc":"用户自定义数据。","alias":"dorado.widget.ViewElement#attribute:userData","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support"},{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true},{"name":"className","type":"String","desc":"CSS类名。","alias":"dorado.RenderableElement#attribute:className","visibility":"public","memberOf":"dorado.RenderableElement","package":"core","writeBeforeReady":true},{"name":"exClassName","type":"String","desc":"扩展CSS类名。","alias":"dorado.RenderableElement#attribute:exClassName","visibility":"public","memberOf":"dorado.RenderableElement","package":"core"},{"name":"style","type":"Object|String","desc":"用于简化DOM元素style属性设置过程的虚拟属性。\r此处用于赋值给style属性的对象是一个结构与HTMLElement的style相似的JavaScript对象。","alias":"dorado.RenderableElement#attribute:style","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 当我们需要为DOM元素指定背景色和字体颜色时可以使用这样的style\rrenderable.set(\"style\", {\r\tcolor : \"yellow\",\r\tbackgroundColor : \"blue\"\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"renderable.set(\"style\", \"color: yellow; background-color: blue\");"}],"visibility":"public","memberOf":"dorado.RenderableElement","package":"core"},{"name":"rendered","type":"boolean","desc":"指示此对象是否已经渲染过。","alias":"dorado.RenderableElement#attribute:rendered","visibility":"public","memberOf":"dorado.RenderableElement","package":"core","readOnly":true},{"name":"tags","type":"String|String[]","desc":"对象的标签。\r<p>\r开发人员可以为一个对象定义一到多个String型的标签，以便于后面快速的查找到一个或一批具有指定标签的对象。\r</p>","alias":"dorado.AttributeSupport#attribute:tags","see":["dorado.TagManager"],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"draggable","type":"boolean","desc":"是否可拖拽。","alias":"dorado.Draggable#attribute:draggable","visibility":"public","memberOf":"dorado.Draggable","package":"core"},{"name":"dragTags","type":"String|String[]","desc":"拖拽标签。\r<p>\r声明拖拽标签可用用标签数组或是以','分隔的标签字符串。\r</p>\r<p>\r当系统发现被拖拽对象的标签数组与鼠标移经的可接受拖拽对象的标签数组之间的交集不为空时，\r系统将认为被拖拽对象可以被放置到该可接受拖拽对象中。（这只是一个大致的判断，具体的运行结果还可能受相关对象的事件定义所影响。）\r</p>","alias":"dorado.Draggable#attribute:dragTags","see":["dorado.Droppable#attribute:droppableTags"],"visibility":"public","memberOf":"dorado.Draggable","package":"core"},{"name":"droppable","type":"boolean","desc":"是否可接受拖放。","alias":"dorado.Droppable#attribute:droppable","visibility":"public","memberOf":"dorado.Droppable","package":"core"},{"name":"droppableTags","type":"String|String[]","desc":"可接受的拖拽标签。\r<p>\r声明拖拽标签可用用标签数组或是以','分隔的标签字符串。\r</p>","alias":"dorado.Droppable#attribute:droppableTags","see":["dorado.Draggable#attribute:dragTags"],"visibility":"public","memberOf":"dorado.Droppable","package":"core"}],"methods":[{"name":"addButton","type":"method","desc":"为标题栏添加按钮。","alias":"dorado.widget.CaptionBar#addButton","visibility":"public","params":[{"desc":"标题栏上要添加的按钮。","type":"dorado.widget.SimpleButton","name":"button"},{"desc":"要添加的按钮的索引，不指定的话添加到最后一个。当index属性大于100的时候，index属性会被当作priority使用，可以保证index属性大的一直显示在最后(Panel、Dialog内置的tools依赖此功能)。","name":"index","isOptional":true}],"package":"base-widget-desktop","memberOf":"dorado.widget.CaptionBar"},{"name":"getButton","type":"method","desc":"取得工具栏上的按钮。","alias":"dorado.widget.CaptionBar#getButton","visibility":"public","params":[{"desc":"要取得的按钮的索引、id或者按钮本身。","type":"String|int|dorado.widget.SimpleButton","name":"button"}],"package":"base-widget-desktop","memberOf":"dorado.widget.CaptionBar"},{"name":"removeButton","type":"method","desc":"删除标题栏上指定的按钮","alias":"dorado.widget.CaptionBar#removeButton","visibility":"public","params":[{"desc":"要删除的按钮","type":"String|int|dorado.widget.SimpleButton","name":"button"}],"package":"base-widget-desktop","memberOf":"dorado.widget.CaptionBar"},{"name":"clearButtons","type":"method","desc":"删除标题栏上所有的工具按钮。","alias":"dorado.widget.CaptionBar#clearButtons","visibility":"public","package":"base-widget-desktop","memberOf":"dorado.widget.CaptionBar"},{"name":"doOnFocus","type":"method","desc":"当控件获得控制焦点时被激活的内部方法。","alias":"dorado.widget.Control#doOnFocus","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"doOnBlur","type":"method","desc":"当控件失去控制焦点时被激活的内部方法。","alias":"dorado.widget.Control#doOnBlur","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"doOnAttachToDocument","type":"method","desc":"当控件所对应的HTML元素被真正的添加(相当于appendChild)到HTML的dom树中时激活的方法。","alias":"dorado.widget.Control#doOnAttachToDocument","see":["dorado.widget.Control#onAttachToDocument"],"visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"doOnDetachFromDocument","type":"method","desc":"当控件所对应的HTML元素被从(相当于removeChild)到HTML的dom树中分离时激活的方法。","alias":"dorado.widget.Control#doOnDetachFromDocument","see":["dorado.widget.Control.prototype#onDetachFromDocument"],"visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"refreshDom","type":"method","desc":"根据控件自身的属性设定来刷新DOM对象。\r<p>\r此方法会在控件每一次被刷新时调用，因此那些设置DOM对象的颜色、字体、尺寸的代码适合放置在此方法中。\r</p>","alias":"dorado.widget.Control#refreshDom","visibility":"public","params":[{"desc":"控件对应的DOM对象。","type":"HTMLElement","name":"dom"}],"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"notifySizeChange","type":"method","desc":"向控件所在的布局管理器通知本控件的尺寸已经发生了变化。","alias":"dorado.widget.Control#notifySizeChange","visibility":"protected","params":[{"desc":null,"type":"boolean","name":"delay"},{"desc":"是否强制通知父容器","type":"boolean","name":"force"}],"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"getDom","type":"method","desc":"返回控件对应的DOM对象。","alias":"dorado.widget.Control#getDom","visibility":"public","returns":{"desc":"控件对应的DOM对象。","type":"HTMLElement"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"render","type":"method","desc":"将本对象渲染到指定的DOM容器中。","alias":"dorado.widget.Control#render","visibility":"public","params":[{"desc":"作为容器的DOM元素。\r<li>如果此参数为空，将根据renderTo或renderOn属性来决定渲染位置。</li>\r<li>如果renderTo不为空，将以renderTo指向的DOM对象作为容器。</li>\r<li>如果renderOn不为空，将替换renderOn指向的DOM对象。</li>\r<li>如果renderTo和renderOn均为空，将以document.body作为容器。</li>","type":"HTMLElement","name":"containerElement","isOptional":true},{"desc":"指定新的DOM元素要在那个子元素之前插入，即通过此参数可以指定新的DOM元素的插入位置。","type":"HTMLElement","name":"nextChildElement","isOptional":true}],"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"replace","type":"method","desc":"本对象并替换指定的DOM对象。","alias":"dorado.widget.Control#replace","visibility":"public","params":[{"desc":"要替换的DOM元素。如果此参数为空，将替换renderOn属性所指向的对象。\r如果renderTo属性也是空，将以document.body作为容器。","type":"HTMLElement","name":"containerElement","isOptional":true}],"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onAttachToDocument","type":"method","desc":"当控件所对应的HTML元素被真正的添加(相当于appendChild)到HTML的dom树中时激活的方法。\r<p>\r当控件的createDom()方法执行时，控件所对应的HTML元素处于游离状态。此时我们调用HTML元素的offsetWidth、currentStyle属性都是无效的。\r只有当该HTML元素最终被添加到HTML的dom树后，这些属性才会生效。\r</p>\r<p>\r当HTML元素通过appendChild方法被添加为某个父HTML元素中后，并不一定意味着游离状态的结束。\r如果父HTML元素是游离状态的，那么其中的所有各层子元素都是游离状态的。\r同理，当父HTML元素最终被添加到HTML的dom树后，其中的所有各层子元素都将结束游离状态。\r</p>\r<p>\r如无特殊需要，一般请不要复写此方法，而应复写doOnAttachToDocument。\r</p>","alias":"dorado.widget.Control#onAttachToDocument","see":["dorado.widget.Control#doOnDetachFromDocument"],"visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onDetachFromDocument","type":"method","desc":"当控件所对应的HTML元素被从(相当于removeChild)到HTML的dom树中分离时激活的方法。\r<p>\r如无特殊需要，一般请不要复写此方法，而应复写doOnDetachFromDocument。\r</p>","alias":"dorado.widget.Control#onDetachFromDocument","see":["dorado.widget.Control#onAttachToDocument","dorado.widget.Control#doOnDetachFromDocument"],"visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"registerInnerControl","type":"method","desc":"将一个给定控件注册为本控件的内部控件。\r<p>\r内部控件与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container')\">dorado.widget.Container</A>中的子控件是不同的概念。\r内部控件是父控件自身的组成部分，例如RadioGroup控件本身就是由其中的一到多个RadioButton构成的。\r</p>\r<p>\rregisterInnerControl方法一般也不应该被外部程序调用，而是应该有控件自身的代码在createDom或refreshDom等方法中调用。\r利用registerInnerControl方法注册内部控件的目的是为了正确向这些控件传播系统消息，管理这些控件的状态。<br/>\r完成注册后的内部控件的parent和focusParent属性都将指向本控件。\r</p>","alias":"dorado.widget.Control#registerInnerControl","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.Control","name":"control"}],"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"unregisterInnerControl","type":"method","desc":"注销一个给定的内部控件。","alias":"dorado.widget.Control#unregisterInnerControl","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.Control","name":"control"}],"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onResize","type":"method","desc":"当控件自身的尺寸发生改变时激活的方法。\r<p>\r例如：对于容器类控件而言，当其自身的尺寸发生改变时，我们往往需要对容器内部的布局和子控件进行相应的处理，\r以使这些对象能够正确的使用尺寸的改变。此时，我们可以将这些处理逻辑放置在onResize方法中。\r</p>","alias":"dorado.widget.Control#onResize","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"findParent","type":"method","desc":"根据给定的类型需要最靠近此控件的父控件。","alias":"dorado.widget.Control#findParent","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 寻找某按钮所隶属的Dialog控件。\rvar dialog = button1.findParent(dorado.widget.Dialog);"}],"visibility":"public","params":[{"desc":"要需要的父控件的类型。","type":"Prototype","name":"type"}],"returns":{"desc":"找到的父控件。","type":"dorado.widget.Container"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"getFocusableSubControls","type":"method","desc":"返回可聚焦的子控件的集合。","alias":"dorado.widget.Control#getFocusableSubControls","visibility":"public","returns":{"desc":"可聚焦的子控件的集合。","type":"[dorado.widget.Control]"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"isFocusable","type":"method","desc":"返回控件当前是否可以接收控制焦点成为当前控件。","alias":"dorado.widget.Control#isFocusable","visibility":"public","params":[{"desc":"是否要分析控件各层父控件已确定该控件自身当前是否可以获得焦点。默认为false。\r例如：当某个Panel对象被设置为不可用时，那么该Panel中所包含所有控件都将无法接受控制焦点。","type":"boolean","name":"deep","isOptional":true}],"returns":{"desc":"是否可以接收控制焦点。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"setFocus","type":"method","desc":"使控件获得控制焦点。","alias":"dorado.widget.Control#setFocus","visibility":"public","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onFocus","type":"method","desc":"当控件获得控制焦点时被激活的方法。","alias":"dorado.widget.Control#onFocus","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onBlur","type":"method","desc":"当控件失去控制焦点时被激活的方法。","alias":"dorado.widget.Control#onBlur","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onKeyDown","type":"method","desc":"当控件拥有控制焦点，并且用户按下任何键盘键（包括系统按钮，如箭头键和功能键）时被激活的方法。","alias":"dorado.widget.Control#onKeyDown","visibility":"protected","params":[{"desc":"DHTML事件中的Event对象。","type":"Event","name":"evt"}],"returns":{"desc":"用于通知系统如何进行下一步处理的返回值。<br/>\r有下列三种可能结果:\r<ul>\r<li>true - 表示允许将此事件进一步通知给上层控件（指此控件的focusParent属性指向的控件）。</li>\r<li>false - 表示禁止将此事件进一步通知给上层控件，同时终止浏览器对此键盘操作的默认响应处理。</li>\r<li>不定义返回值 - 表示禁止将此事件进一步通知给上层控件，但不中断浏览器对此键盘操作的默认响应处理。</li>\r</ul>","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onKeyPress","type":"method","desc":"当控件拥有控制焦点，并且用户按下并放开任何字母数字键时被激活的方法。","alias":"dorado.widget.Control#onKeyPress","visibility":"protected","params":[{"desc":"DHTML事件中的Event对象。","type":"Event","name":"evt"}],"returns":{"desc":"用于通知系统如何进行下一步处理的返回值。<br/>\r有下列三种可能结果:\r<ul>\r<li>true - 表示允许将此事件进一步通知给上层控件（指此控件的focusParent属性指向的控件）。</li>\r<li>false - 表示禁止将此事件进一步通知给上层控件，同时终止浏览器对此键盘操作的默认响应处理。</li>\r<li>不定义返回值 - 表示禁止将此事件进一步通知给上层控件，但不中断浏览器对此键盘操作的默认响应处理。</li>\r</ul>","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"scrollIntoView","type":"method","desc":"将此控件滚动到可见区域内。\r此方法可能导致该控件的每一级父控件发生滚动（如果有需要的话），以便于尽可能的是该控件可见。","alias":"dorado.widget.Control#scrollIntoView","visibility":"public","package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onReady","type":"method","desc":"当组件的状态已变为可用时被激活的方法。","alias":"dorado.widget.Component#onReady","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"destroy","type":"method","desc":"销毁组件。","alias":"dorado.widget.ViewElement#destroy","visibility":"public","package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"registerInnerViewElement","type":"method","desc":"将一个给定控件注册为本控件的内部控件。\r<p>\r内部控件与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container')\">dorado.widget.Container</A>中的子控件是不同的概念。\r内部控件是父控件自身的组成部分，例如RadioGroup控件本身就是由其中的一到多个RadioButton构成的。\r</p>\r<p>\rregisterInnerViewElement方法一般也不应该被外部程序调用，而是应该有控件自身的代码在createDom或refreshDom等方法中调用。\r利用registerInnerViewElement方法注册内部控件的目的是为了正确向这些控件传播系统消息，管理这些控件的状态。<br/>\r完成注册后的内部控件的parent和focusParent属性都将指向本控件。\r</p>","alias":"dorado.widget.ViewElement#registerInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"unregisterInnerViewElement","type":"method","desc":"注销一个给定的内部控件。","alias":"dorado.widget.ViewElement#unregisterInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"createDom","type":"method","desc":"创建对象对应的DOM元素。\r<p>\r此方法只会在对象第一次渲染时执行一次。 所以一般而言，不应该在此放置初始化DOM元素的代码。例如那些设置DOM元素的颜色、字体、尺寸的代码。\r而那些而DOM元素绑定事件监听器的代码则适合放置在此方法中。\r</p>","alias":"dorado.RenderableElement#createDom","visibility":"public","returns":{"desc":"新创建的DOM元素。","type":"HTMLElement"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"resetDimension","type":"method","desc":"重设对象的尺寸。","alias":"dorado.RenderableElement#resetDimension","visibility":"protected","params":[{"desc":"是否强制重设对象的尺寸，忽略对于宽高值是否发生过改变的判断。","type":"boolean","name":"forced","isOptional":true}],"returns":{"desc":"本次操作是否改变了对象的尺寸设置。","type":"boolean"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"getRealWidth","type":"method","desc":"获得渲染时实际应该采用的宽度值。\r<p>\r通过width属性设置的宽度值并不总是该对象实际渲染时所使用的值，实际的宽度常常会受布局管理器或其他类似的功能控制。\r此方法的作用就是返回渲染时实际应该采用的宽度值。\r</p>","alias":"dorado.RenderableElement#getRealWidth","visibility":"public","returns":{"desc":"宽度。","type":"int|String"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"getRealHeight","type":"method","desc":"获得渲染时实际应该采用的高度值。\r<p>\r通过width属性设置的高度值并不总是该对象实际渲染时所使用的值，实际的高度常常会受布局管理器或其他类似的功能控制。\r此方法的作用就是返回渲染时实际应该采用的高度值。\r</p>","alias":"dorado.RenderableElement#getRealHeight","visibility":"public","returns":{"desc":"宽度。","type":"int|String"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"unrender","type":"method","desc":"将对象的DOM节点从其父节点中移除。","alias":"dorado.RenderableElement#unrender","visibility":"public","package":"core","memberOf":"dorado.RenderableElement"},{"name":"refresh","type":"method","desc":"刷新此对象的显示。","alias":"dorado.RenderableElement#refresh","visibility":"public","params":[{"desc":"是否允许此次refresh动作延时执行。设置成true有利于系统对refresh动作进行优化处理。","type":"boolean","name":"delay"}],"package":"core","memberOf":"dorado.RenderableElement"},{"name":"getAttributeWatcher","type":"method","desc":"返回与该对象关联的属性观察者。","alias":"dorado.AttributeSupport#getAttributeWatcher","visibility":"public","returns":{"desc":"属性观察者。","type":"dorado.AttributeWatcher"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"get","type":"method","desc":"读取指定的属性值。\r<p>\r此方法还支持迭代式的属性读取，即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.AttributeSupport的实例还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r如果碰到的中间对象dorado.AttributeSupport的实例，系统会自动读取它的Attribute；\r如果碰到的中间对象是普通的JSON对象，系统会直接读取它的属性。\r</p>","alias":"dorado.AttributeSupport#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"label\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"address.postCode\"); // 迭代式的属性读取\r// 如果address的属性值是一个dorado.AttributeSupport的实例，那么此行命令的效果相当于oop.get(\"address\").get(\"postCode\")。\r// 如果address的属性值是一个JSON对象，那么此行命令的效果相当于oop.get(\"address\").postCode"}],"visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"读取到的属性值。","type":"Object"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.AttributeSupport#set","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set(\"label\", \"Sample Text\"); oop.set(\"visible\", true);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set( { label : \"Sample Text\", visible : true });"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用属性迭代的特性为子对象中的属性赋值。\roop.set(\"address.postCode\", \"7232-00124\");\r... ...\roop.set({\r\t\"name\" : \"Toad\",\r\t\"address.postCode\" : \"7232-00124\"\r});\r// 上面的两行命令相当于\roop.get(\"address\").set(\"postCode\", \"7232-00124\")"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用上文中提及的第一种方法为label属性赋值，同时为onClick事件绑定一个监听器。\roop.set({\r label : \"Sample Text\",\r onClick : function(self, arg) {\r \t... ...\r }\r});"}],"visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r           <ul>\r           <li>当attr为String时，系统会将attr的作为要设置属性名处理。属性值为value参数代表的值。</li>\r           <li>当attr为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r           注意：当通过此方式为对象设置一系列属性时，系统只会跳过那些设置出错的属性，并不会给出错误信息，也不会中断正在执行的设置操作。</li>\r           </ul>\r           <p>\r           如同<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>方法，set方法也支持对属性进行迭代式的设置。\r           即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘，直到挖掘到倒数第二个子对象时停止并记录下一个子属性名，然后对该子对象的属性进行复制操作，请参考后面的例程。\r           </p>\r           <p>\r           set方法不但可以用于为对象的属性赋值，同时也可以用于为对象中的事件添加事件监听器。\r           <ul>\r           <li>直接以事件名称作为属性，以事件监听器作为属性值，进行赋值操作。</li>\r           <li>为对象listener属性赋值，具体方法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#attribute:listener')\">dorado.EventSupport#attribute:listener</A>。</li>\r           </ul>\r           虽然上述两种方法都可以实现添加事件监听器的功能，并且第一种方法看起来更加方便易用。但第二种方法却较第一种更为灵活。\r           例如：当我们需要一次性的为同一个事件绑定多个监听器，第一种方法是不能胜任的；\r           或者我们当我们批量的设置一组属性值和事件监听器时，第二种方法总是确保事件监听器首先被绑定然后才处理该操作中剩余的属性值的赋值（在绝大多数的场景的这样的顺序是更加合理的），\r           而此时如果使用第一种方法，监听器和属性值的处理顺序是难以预知的。\r           </p>","type":"String|Object","name":"attr"},{"desc":"此参数具有多重含义：要设置的属性值。当attr为Object时，此参数将被忽略。\r           <ul>\r           <li>当attr为String时，此参数代表要设置的属性值。</li>\r           <li>当attr为Object时，此参数可代表一组执行选项，见option参数的说明。</li>\r           </ul>","type":"Object","name":"value","isOptional":true},{"desc":"执行选项。此参数仅在attr参数为Object时有效。","type":"Object","name":"options","isOptional":true},{"desc":"是否忽略未知的属性。","type":"boolean","name":"options.skipUnknownAttribute","isOptional":true,"defaultValue":"false"},{"desc":"是否在发生错误后继续尝试后续的属性设置操作。","type":"boolean","name":"options.tryNextOnError","isOptional":true,"defaultValue":"false"},{"desc":"是否组织本次赋值操作覆盖对象中原有的属性值。\r           即对于那些已拥有值(曾经通过set方法写入过值)的属性跳过本次的赋值操作，而只对那些未定义过的属性进行赋值。","type":"boolean","name":"options.preventOverwriting","isOptional":true,"defaultValue":"false"}],"returns":{"desc":"返回对象自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"doSet","type":"method","desc":"用于实现为单个属性赋值的内部方法。","alias":"dorado.AttributeSupport#doSet","visibility":"protected","params":[{"desc":"要设置的属性名。","type":"String","name":"attr"},{"desc":"属性值。","type":"Object","name":"value"},{"desc":"是否忽略未知的属性。","type":"boolean","name":"skipUnknownAttribute","isOptional":true},{"desc":null,"name":"lockWritingTimes"}],"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"hasTag","type":"method","desc":"判断对象中是否定义了某个标签值。","alias":"dorado.AttributeSupport#hasTag","visibility":"public","params":[{"desc":"要判断的标签值。","type":"String","name":"tag"}],"returns":{"desc":"是否具有该标签值。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"getDraggableOptions","type":"method","desc":"返回当系统将此对象初始化为可拖拽对象时将要传递给<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('jQuery.draggable')\">jQuery.draggable</A>方法的options参数。","alias":"dorado.Draggable#getDraggableOptions","visibility":"protected","params":[{"desc":"将要初始化的HTMLElement。","type":"HTMLElement","name":"dom"}],"package":"core","memberOf":"dorado.Draggable"},{"name":"createDraggingInfo","type":"method","desc":"创建当此对象进入被拖拽状态后与之相关联的拖拽信息对象。","alias":"dorado.Draggable#createDraggingInfo","visibility":"protected","params":[{"desc":"将要拖拽的HTMLElement。","type":"HTMLElement","name":"dom"},{"desc":"传递给<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('jQuery.draggable')\">jQuery.draggable</A>方法的options参数。\rreturn {dorado.DraggingInfo} 拖拽信息对象。","type":"Object","name":"dom"}],"package":"core","memberOf":"dorado.Draggable"},{"name":"initDraggingInfo","type":"method","desc":"初始化给定的拖拽信息对象。","alias":"dorado.Draggable#initDraggingInfo","visibility":"protected","params":[{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"evt"}],"package":"core","memberOf":"dorado.Draggable"},{"name":"initDraggingIndicator","type":"method","desc":"初始化给定的拖拽光标对象。","alias":"dorado.Draggable#initDraggingIndicator","visibility":"protected","params":[{"desc":"拖拽光标对象。","type":"dorado.DraggingIndicator|HTMLElement","name":"indicator"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"evt"}],"package":"core","memberOf":"dorado.Draggable"},{"name":"getDroppableOptions","type":"method","desc":"返回当系统将此对象初始化为可接受拖拽对象时将要传递给<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('jQuery.droppable')\">jQuery.droppable</A>方法的options参数。","alias":"dorado.Droppable#getDroppableOptions","visibility":"protected","params":[{"desc":"将要初始化的HTMLElement。","type":"HTMLElement","name":"dom"}],"package":"core","memberOf":"dorado.Droppable"}],"constructors":[],"events":[{"name":"onCreateDom","type":"event","desc":"当组件对应的根DOM对象被创建时触发的事件。","alias":"dorado.widget.Control#event:onCreateDom","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"组件对应的根DOM对象。","type":"HTMLElement","name":"arg.dom"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"beforeRefreshDom","type":"event","desc":"当组件将要刷新其对应的DOM对象之前触发的事件。","alias":"dorado.widget.Control#event:beforeRefreshDom","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"组件对应的根DOM对象。","type":"HTMLElement","name":"arg.dom"},{"desc":"是否要继续系统默认的刷新操作。","type":"boolean","name":"arg.processDefault","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onRefreshDom","type":"event","desc":"当组件刷新其对应的DOM对象时触发的事件。\r<p>\r在实际的使用过程中，<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Control#event:beforeRefreshDom')\">dorado.widget.Control#event:beforeRefreshDom</A>可能是更加常用的事件。\r</P>","alias":"dorado.widget.Control#event:onRefreshDom","see":["dorado.widget.Control#event:beforeRefreshDom"],"visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"组件对应的根DOM对象。","type":"HTMLElement","name":"arg.dom"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onClick","type":"event","desc":"当控件被点击时触发的事件。","alias":"dorado.widget.Control#event:onClick","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"表示用户按下的是哪个按钮，具体请参考DHTML的相关文档。","type":"int","name":"arg.button"},{"desc":"DHTML中的事件event参数。","type":"Event","name":"arg.event"},{"desc":"表示是否要终止该鼠标事件的冒泡处理机制。\r如果返回false相当于调用了系统event的preventDefault()和stopPropagation()方法。\r不定义此参数表示交由系统自行判断。","type":"boolean","name":"arg.returnValue","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onDoubleClick","type":"event","desc":"当控件被双击时触发的事件。","alias":"dorado.widget.Control#event:onDoubleClick","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"表示用户按下的是哪个按钮，具体请参考DHTML的相关文档。","type":"int","name":"arg.button"},{"desc":"DHTML中的事件event参数。","type":"Event","name":"arg.event"},{"desc":"表示是否要终止该鼠标事件的冒泡处理机制。\r如果返回false相当于调用了系统event的preventDefault()和stopPropagation()方法。\r不定义此参数表示交由系统自行判断。","type":"boolean","name":"arg.returnValue","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onMouseDown","type":"event","desc":"当鼠标在控件中按下时触发的事件。","alias":"dorado.widget.Control#event:onMouseDown","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"表示用户按下的是哪个按钮，具体请参考DHTML的相关文档。","type":"int","name":"arg.button"},{"desc":"DHTML中的事件event参数。","type":"Event","name":"arg.event"},{"desc":"表示是否要终止该鼠标事件的冒泡处理机制。\r如果返回false相当于调用了系统event的preventDefault()和stopPropagation()方法。\r不定义此参数表示交由系统自行判断。","type":"boolean","name":"arg.returnValue","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onMouseUp","type":"event","desc":"当鼠标在控件中抬起时触发的事件。","alias":"dorado.widget.Control#event:onMouseUp","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"表示用户按下的是哪个按钮，具体请参考DHTML的相关文档。","type":"int","name":"arg.button"},{"desc":"DHTML中的事件event参数。","type":"Event","name":"arg.event"},{"desc":"表示是否要终止该鼠标事件的冒泡处理机制。\r如果返回false相当于调用了系统event的preventDefault()和stopPropagation()方法。\r不定义此参数表示交由系统自行判断。","type":"boolean","name":"arg.returnValue","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onContextMenu","type":"event","desc":"当控件中的系统上下文菜单将要显示时触发的事件。","alias":"dorado.widget.Control#event:onContextMenu","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"DHTML中的事件event参数。","type":"Event","name":"arg.event"},{"desc":"是否要继续系统的默认操作，让系统上下文菜单显示出来。","type":"boolean","name":"arg.processDefault=false","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onFocus","type":"event","desc":"当控件获得控制焦点时触发的事件。","alias":"dorado.widget.Control#event:onFocus","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onBlur","type":"event","desc":"当控件失去控制焦点时触发的事件。","alias":"dorado.widget.Control#event:onBlur","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onKeyDown","type":"event","desc":"当控件拥有焦点并且有按键被按下时触发的事件。","alias":"dorado.widget.Control#event:onKeyDown","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"按键对应的keyCode。","type":"int","name":"arg.keyCode"},{"desc":"Shift键是否按下。","type":"boolean","name":"arg.shiftKey"},{"desc":"Ctrl键是否按下。","type":"boolean","name":"arg.ctrlKey"},{"desc":"Alt键是否按下。","type":"boolean","name":"arg.altKey"},{"desc":"DHTML中的事件event参数。","type":"Event","name":"arg.event"},{"desc":"用于通知系统如何进行下一步处理的返回值。<br/>\r有下列三种可能结果:\r<ul>\r<li>true - 表示允许将此键盘消息进一步通知给上层控件（指此控件的focusParent属性指向的控件）。</li>\r<li>false - 表示禁止将此键盘消息进一步通知给上层控件，同时终止浏览器对此键盘操作的默认响应处理。</li>\r<li>不定义返回值 - 表示禁止将此键盘消息进一步通知给上层控件。</li>\r</ul>","type":"Boolean","name":"arg.returnValue=undefined","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onKeyPress","type":"event","desc":"当控件拥有焦点并且有ASCII码的按键被按下时触发的事件。","alias":"dorado.widget.Control#event:onKeyPress","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"按键对应的keyCode。","type":"int","name":"arg.keyCode"},{"desc":"Shift键是否按下。","type":"boolean","name":"arg.shiftKey"},{"desc":"Ctrl键是否按下。","type":"boolean","name":"arg.ctrlKey"},{"desc":"Alt键是否按下。","type":"boolean","name":"arg.altKey"},{"desc":"DHTML中的事件event参数。","type":"Event","name":"arg.event"},{"desc":"用于通知系统如何进行下一步处理的返回值。<br/>\r有下列三种可能结果:\r<ul>\r<li>true - 表示允许将此键盘消息进一步通知给上层控件（指此控件的focusParent属性指向的控件）。</li>\r<li>false - 表示禁止将此键盘消息进一步通知给上层控件，同时终止浏览器对此键盘操作的默认响应处理。</li>\r<li>不定义返回值 - 表示禁止将此键盘消息进一步通知给上层控件。</li>\r</ul>","type":"Boolean","name":"arg.returnValue=undefined","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Control"},{"name":"onReady","type":"event","desc":"当组件被激活（即真正可用时）时触发的事件。","alias":"dorado.widget.Component#event:onReady","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"onCreate","type":"event","desc":"当组件被创建时触发的事件。\r<p>\r与其他事件不同，onCreate事件中的this是个例外，它并不指向控件所属的View对象，而是指向$view（见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$view')\">$view</A>）。\r之所以这样是因此，该事件是在控件创建的过程中触发的，而在此时控件还没有被添加到具体的（最终的）View中。\r因此在触发此事件系统无法得知此控件应该属于哪个View。<br/>\r<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.View')\">dorado.widget.View</A>对象的onCreate事件又是这个例外规则中的例外。\r因为View对象的onCreate事件中的this总是指向自身的，因此View对象的onCreate事件与其他事件中的this并没有什么不同。\r</p>","alias":"dorado.widget.ViewElement#event:onCreate","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"onDestroy","type":"event","desc":"当组件被销毁时触发的事件。","alias":"dorado.widget.ViewElement#event:onDestroy","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"onAttributeChange","type":"event","desc":"当对象中的某属性值被改变时触发的事件。","alias":"dorado.AttributeSupport#event:onAttributeChange","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"发生改变的属性名。","type":"String","name":"arg.attribute"},{"desc":"新的属性值。","type":"Object","name":"arg.value"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"onGetDraggingIndicator","type":"event","desc":"当此对象开始进入拖拽状态之初，系统尝试相应的拖拽指示光标时触发的事件。","alias":"dorado.Draggable#event:onGetDraggingIndicator","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"系统将要使用的默认拖拽指示光标。\r<p>\r您可以直接修改此光标对象，也可以用新的实例替换掉此光标。甚至可以返回一个自己创建好的HTMLElement作用拖拽光标。\r</p>","type":"dorado.DraggingIndicator|HTMLElement","name":"arg.indicator","writeable":true},{"desc":"系统Event对象。","type":"Event","name":"arg.event"},{"desc":"被拖拽对象对应的HTMLElement。","type":"HTMLElement","name":"arg.draggableElement"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"},{"name":"onDragStart","type":"event","desc":"当此对象将要进入拖拽状态时触发的事件。","alias":"dorado.Draggable#event:onDragStart","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"},{"desc":"用于通知系统是否要继续完成后续动作。\r即返回true表示允许此对象开始被拖拽，返回false则禁止此对象被拖拽。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"},{"name":"onDragStop","type":"event","desc":"当此对象的拖拽操作结束时触发的事件。\r拖拽对象被成功的放置或拖拽操作被取消时都会触发此事件。","alias":"dorado.Draggable#event:onDragStop","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"},{"name":"onDragMove","type":"event","desc":"当此对象被拖动时触发的事件。\r即当此对象处于被拖拽状态时伴随着鼠标的移动系统会不停的触发此事件。","alias":"dorado.Draggable#event:onDragMove","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"},{"name":"onDraggingSourceOver","type":"event","desc":"当有某被拖拽对象进入此对象的区域时触发的事件。","alias":"dorado.Droppable#event:onDraggingSourceOver","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"},{"desc":"是否可接受此拖拽对象。","type":"boolean","name":"arg.accept","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Droppable"},{"name":"onDraggingSourceOut","type":"event","desc":"当有某被拖拽对象离开此对象的区域时触发的事件。","alias":"dorado.Droppable#event:onDraggingSourceOut","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Droppable"},{"name":"onDraggingSourceMove","type":"event","desc":"当有某被拖拽对象在此对象的区域内移动时触发的事件。","alias":"dorado.Droppable#event:onDraggingSourceMove","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Droppable"},{"name":"beforeDraggingSourceDrop","type":"event","desc":"当有某被拖拽对象在此对象的区域内被释放之前触发的事件。","alias":"dorado.Droppable#event:beforeDraggingSourceDrop","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"},{"desc":"是否要继续系统默认的操作。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Droppable"},{"name":"onDraggingSourceDrop","type":"event","desc":"当有某被拖拽对象在此对象的区域内被释放时触发的事件。","alias":"dorado.Droppable#event:onDraggingSourceDrop","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Droppable"}]}