SYMBOLS["dorado.widget.Component"]={"name":"Component","type":"class","desc":null,"alias":"dorado.widget.Component","author":"Benny Bao (mailto:benny.bao@bstek.com)","isAbstract":true,"classDesc":"组件的抽象类。","package":"widget-support","inheritsFrom":["dorado.widget.ViewElement"],"inherits":["dorado.widget.Action","dorado.widget.Control","dorado.widget.DataSet","dorado.widget.FormProfile","dorado.widget.Trigger"],"memberOf":"dorado.widget","properties":[{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"}],"attributes":[{"name":"ready","type":"boolean","desc":"组件当前是否已激活。","alias":"dorado.widget.Component#attribute:ready","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"parent","type":"dorado.widget.Component","desc":"父控件。","alias":"dorado.widget.Component#attribute:parent","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"dataTypeRepository","type":"dorado.DataTypeRepository","desc":"此视图对象使用的数据类型管理器。","alias":"dorado.widget.Component#attribute:dataTypeRepository","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"id","type":"String","desc":"组件的id。","alias":"dorado.widget.ViewElement#attribute:id","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","writeBeforeReady":true},{"name":"destroyed","type":"boolean","desc":"组件当前是否已被销毁。","alias":"dorado.widget.ViewElement#attribute:destroyed","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"parentViewElement","type":"dorado.widget.ViewElement","desc":"父组件。","alias":"dorado.widget.ViewElement#attribute:parentViewElement","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"view","type":"dorado.widget.View","desc":"组件所属的视图。","alias":"dorado.widget.ViewElement#attribute:view","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"userData","type":"Object","desc":"用户自定义数据。","alias":"dorado.widget.ViewElement#attribute:userData","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support"},{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true}],"methods":[{"name":"onReady","type":"method","desc":"当组件的状态已变为可用时被激活的方法。","alias":"dorado.widget.Component#onReady","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"destroy","type":"method","desc":"销毁组件。","alias":"dorado.widget.ViewElement#destroy","visibility":"public","package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"registerInnerViewElement","type":"method","desc":"将一个给定控件注册为本控件的内部控件。\r<p>\r内部控件与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container')\">dorado.widget.Container</A>中的子控件是不同的概念。\r内部控件是父控件自身的组成部分，例如RadioGroup控件本身就是由其中的一到多个RadioButton构成的。\r</p>\r<p>\rregisterInnerViewElement方法一般也不应该被外部程序调用，而是应该有控件自身的代码在createDom或refreshDom等方法中调用。\r利用registerInnerViewElement方法注册内部控件的目的是为了正确向这些控件传播系统消息，管理这些控件的状态。<br/>\r完成注册后的内部控件的parent和focusParent属性都将指向本控件。\r</p>","alias":"dorado.widget.ViewElement#registerInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"unregisterInnerViewElement","type":"method","desc":"注销一个给定的内部控件。","alias":"dorado.widget.ViewElement#unregisterInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.widget.Component","params":[{"desc":"配置信息。\r<p>\r此参数具有多态性，当我们传入一个String类型的参数时，该String值表示组件的id。\r当我们传入的参数是一个JSON对象时，系统会自动将该JSON对象中的属性设置到组件中。 <br/>\r如果没有在此步骤中没有为组件指定id，那么系统会自动为其分配一个id。\r</p>","type":"String|Object","name":"config","isOptional":true}]}],"events":[{"name":"onReady","type":"event","desc":"当组件被激活（即真正可用时）时触发的事件。","alias":"dorado.widget.Component#event:onReady","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"onCreate","type":"event","desc":"当组件被创建时触发的事件。\r<p>\r与其他事件不同，onCreate事件中的this是个例外，它并不指向控件所属的View对象，而是指向$view（见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$view')\">$view</A>）。\r之所以这样是因此，该事件是在控件创建的过程中触发的，而在此时控件还没有被添加到具体的（最终的）View中。\r因此在触发此事件系统无法得知此控件应该属于哪个View。<br/>\r<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.View')\">dorado.widget.View</A>对象的onCreate事件又是这个例外规则中的例外。\r因为View对象的onCreate事件中的this总是指向自身的，因此View对象的onCreate事件与其他事件中的this并没有什么不同。\r</p>","alias":"dorado.widget.ViewElement#event:onCreate","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"onDestroy","type":"event","desc":"当组件被销毁时触发的事件。","alias":"dorado.widget.ViewElement#event:onDestroy","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"}]}