SYMBOLS["dorado.widget.DataControl"]={"name":"DataControl","type":"class","desc":null,"alias":"dorado.widget.DataControl","author":"Benny Bao (mailto:benny.bao@bstek.com)","see":["dorado.widget.DataSet"],"isAbstract":true,"classDesc":"数据控件。\r<p>\r数据控件可与数据集(<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet')\">dorado.widget.DataSet</A>)进行绑定，用于控制或显示数据集中的数据。\r主要用于跟DataSet中的数据实体<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Entity')\">dorado.Entity</A>或数据实体的集合<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityList')\">dorado.EntityList</A>进行绑定。\r</p>","package":"widget-support","inheritsFrom":["dorado.widget.DataSetObserver"],"inherits":["dorado.widget.DataBlockView","dorado.widget.DataGrid","dorado.widget.DataListBox","dorado.widget.DataPilot","dorado.widget.DataTree","dorado.widget.PropertyDataControl","dorado.widget.TemplateField"],"memberOf":"dorado.widget","properties":[],"attributes":[{"name":"dataSet","type":"dorado.widget.DataSet","desc":"数据控件绑定的数据集。","alias":"dorado.widget.DataControl#attribute:dataSet","visibility":"public","memberOf":"dorado.widget.DataControl","package":"widget-support"},{"name":"dataPath","type":"String","desc":"数据路径，用于指定数据控件与数据集中的哪些数据节点进行关联。","alias":"dorado.widget.DataControl#attribute:dataPath","see":["dorado.DataPath"],"visibility":"public","memberOf":"dorado.widget.DataControl","package":"widget-support"}],"methods":[{"name":"disableBinding","type":"method","desc":"禁止控件接收来自数据集的消息。","alias":"dorado.widget.DataControl#disableBinding","visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataControl"},{"name":"enableBinding","type":"method","desc":"允许控件接收来自数据集的消息。","alias":"dorado.widget.DataControl#enableBinding","visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataControl"},{"name":"getBindingData","type":"method","desc":"返回控件实际绑定的数据。","alias":"dorado.widget.DataControl#getBindingData","see":["dorado.widget.DataSet#getData"],"visibility":"public","params":[{"desc":"传递给内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet#getData')\">dorado.widget.DataSet#getData</A>方法的选项参数。","type":"Object|boolean","name":"options","isOptional":true}],"returns":{"desc":"控件实际绑定的数据。","type":"dorado.EntityList|dorado.Entity"},"package":"widget-support","memberOf":"dorado.widget.DataControl"},{"name":"getBindingDataType","type":"method","desc":"返回控件实际绑定的数据类型。","alias":"dorado.widget.DataControl#getBindingDataType","visibility":"public","params":[{"desc":"传递给内部<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet#getDataType')\">dorado.widget.DataSet#getDataType</A>方法的选项参数。","type":"Object|boolean","name":"options","isOptional":true}],"returns":{"desc":"控件实际绑定的数据类型。","type":"dorado.DataType"},"package":"widget-support","memberOf":"dorado.widget.DataControl"},{"name":"dataSetMessageReceived","type":"method","desc":"当控件接收到的数据集消息被激活的方法。","alias":"dorado.widget.DataControl#dataSetMessageReceived","visibility":"public","params":[{"desc":"消息代码。","type":"Object","name":"messageCode"},{"desc":"消息参数。","type":"Object","name":"arg"}],"package":"widget-support","memberOf":"dorado.widget.DataControl"},{"name":"filterDataSetMessage","type":"method","desc":"对接收到的数据集消息进行过滤。\r如果此方法返回true，则表示接受这一消息，并进一步调用processDataSetMessage()对消息进行处理。","alias":"dorado.widget.DataControl#filterDataSetMessage","visibility":"protected","params":[{"desc":"消息代码。","type":"int","name":"messageCode"},{"desc":"消息参数。","type":"Object","name":"arg","isOptional":true}],"returns":{"desc":"用于表示是否接受此消息的逻辑值。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.DataControl"},{"name":"processDataSetMessage","type":"method","desc":"处理接收到的来自数据集的消息。\r<p>\r此处可能接受到的消息包括：\r<ul>\r<li><A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet.MESSAGE_REFRESH')\">dorado.widget.DataSet.MESSAGE_REFRESH</A></li>\r<li><A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet.MESSAGE_CURRENT_CHANGED')\">dorado.widget.DataSet.MESSAGE_CURRENT_CHANGED</A></li>\r<li><A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet.MESSAGE_DATA_CHANGED')\">dorado.widget.DataSet.MESSAGE_DATA_CHANGED</A></li>\r<li><A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet.MESSAGE_REFRESH_ENTITY')\">dorado.widget.DataSet.MESSAGE_REFRESH_ENTITY</A></li>\r<li><A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet.MESSAGE_ENTITY_STATE_CHANGED')\">dorado.widget.DataSet.MESSAGE_ENTITY_STATE_CHANGED</A></li>\r<li><A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet.MESSAGE_INSERTED')\">dorado.widget.DataSet.MESSAGE_INSERTED</A></li>\r<li><A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet.MESSAGE_DELETED')\">dorado.widget.DataSet.MESSAGE_DELETED</A></li>\r</ul>\r</p>","alias":"dorado.widget.DataControl#processDataSetMessage","visibility":"protected","params":[{"desc":"消息代码。","type":"int","name":"messageCode"},{"desc":"消息参数。","type":"Object","name":"arg","isOptional":true}],"package":"widget-support","memberOf":"dorado.widget.DataControl"}],"constructors":[],"events":[{"name":"onGetBindingData","type":"event","desc":"当数据绑定控件尝试获得绑定的数据时触发的事件。开发人员可以通过此事件来定制实际与控件绑定的数据。\r<p>\r一旦定义了此事件dataPath属性将会失效，控件直接以此事件中指定的数据作为绑定数据。\r需要注意的是，此事件中的指定的绑定数据必须取自控件绑定的数据集<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.DataSet')\">dorado.widget.DataSet</A>，否则系统将会报错。\r</p>","alias":"dorado.widget.DataControl#event:onGetBindingData","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"传递给getBindingData()方法的options参数。","type":"Object","name":"arg.options"},{"desc":"将该控件实际绑定的数据写入此属性中。","type":"dorado.EntityList|dorado.Entity","name":"arg.data","writeable":true},{"desc":"是否在事件结束后继续执行系统默认的获取数据的逻辑。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.DataControl"},{"name":"onGetBindingDataType","type":"event","desc":"当数据绑定控件尝试获得绑定的数据类型时触发的事件。\r对于很多数据控件而言，都可能需要在获取实际的绑定数据之前事先获知其绑定的具体数据类型。\r如数据表格等，其可能需要事先获得具体数据类型已初始化表格列的信息。\r<p>\r默认情况下，数据控件会自动根据dataPath属性来确定绑定的数据类型。\r然而，当我们为控件定义了onGetBindingData事件后dataPath属性将会失效。\r而此时如果通过onGetBindingData事件取得的绑定数据为null时，数据控件将无法获知其绑定的具体数据类型。\r在此种情形下，数据控件将通过本事件来尝试获知其绑定的具体数据类型。\r</p>","alias":"dorado.widget.DataControl#event:onGetBindingDataType","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"将该控件实际绑定的数据类型写入此属性中。","type":"dorado.DataType","name":"arg.dataType","writeable":true},{"desc":"是否在事件结束后继续执行系统默认的获取数据类型的逻辑。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.DataControl"}]}