SYMBOLS["dorado.widget.DataSet"]={"name":"DataSet","type":"class","desc":null,"alias":"dorado.widget.DataSet","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"数据集。\r<p>\r用于封装一组数据（指实体对象或实体集合）的控件。\r</p>","package":"widget-support","shortTypeName":"DataSet","inheritsFrom":["dorado.widget.Component"],"memberOf":"dorado.widget","properties":[{"name":"MESSAGE_REFRESH","type":"int","desc":"通知监听器需要进行数据刷新的消息。\r<p>\r与此种消息对应的消息参数为null。\r</p>","alias":"dorado.widget.DataSet.MESSAGE_REFRESH","visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"MESSAGE_DATA_CHANGED","type":"int","desc":"表示数据实体中的属性值发生变化的消息。\r<p>\r与此种消息对应的消息参数具有下列子属性：\r<ul>\r<li>entity - {dorado.Entity} 发生改变的数据实体。</li>\r<li>property - {String} 被改变属性名。</li>\r<li>oldValue - {Object} 原先的值。</li>\r<li>newValue - {Object} 新的值。</li>\r</ul>\r</p>","alias":"dorado.widget.DataSet.MESSAGE_DATA_CHANGED","visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"MESSAGE_ENTITY_STATE_CHANGED","type":"int","desc":"表示数据实体的状态变化的消息。\r<p>\r与此种消息对应的消息参数具有下列子属性：\r<ul>\r<li>entity - {dorado.Entity} 发生改变的数据实体。</li>\r<li>oldState - {int} 原先的状态。</li>\r<li>newState - {int} 新的状态。</li>\r</ul>\r</p>","alias":"dorado.widget.DataSet.MESSAGE_ENTITY_STATE_CHANGED","see":["dorado.Entity#attribute:state"],"visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"MESSAGE_DELETED","type":"int","desc":"表示实体集合中有数据实体被删除的消息。\r<p>\r与此种消息对应的消息参数具有下列子属性：\r<ul>\r<li>entityList - {dorado.EntityList} 发生的实体集合。</li>\r<li>entity - {dorado.Entity} 被删除的数据实体。</li>\r</ul>\r</p>","alias":"dorado.widget.DataSet.MESSAGE_DELETED","see":["dorado.EntityList#remove"],"visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"MESSAGE_INSERTED","type":"int","desc":"表示实体集合中添加了新数据实体的消息。\r<p>\r与此种消息对应的消息参数具有下列子属性：\r<ul>\r<li>entityList - {dorado.EntityList} 发生的实体集合。</li>\r<li>entity - {dorado.Entity} 被添加的数据实体。</li>\r<li>insertMode - {dorado.Entity} 插入方式。</li>\r<li>refEntity - {dorado.Entity} 插入位置的参照数据实体。</li>\r</ul>\r</p>","alias":"dorado.widget.DataSet.MESSAGE_INSERTED","see":["dorado.EntityList#insert"],"visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"MESSAGE_CURRENT_CHANGED","type":"int","desc":"表示实体集合中当前数据实体发生改变的消息。\r<p>\r与此种消息对应的消息参数具有下列子属性：\r<ul>\r<li>entityList - {dorado.EntityList} 发生的实体集合。</li>\r<li>oldCurrent - {dorado.Entity} 原先的当前数据实体。</li>\r<li>newCurrent - {dorado.Entity} 新的当前数据实体。</li>\r</ul>\r</p>","alias":"dorado.widget.DataSet.MESSAGE_CURRENT_CHANGED","see":["dorado.EntityList#insert"],"visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"MESSAGE_REFRESH_ENTITY","type":"int","desc":"通知监听器需要针对某个数据实体进行数据刷新的消息。\r<p>\r与此种消息对应的消息参数具有下列子属性：\r<ul>\r<li>entity - {dorado.Entity} 需要刷新的数据实体。</li>\r</ul>\r</p>","alias":"dorado.widget.DataSet.MESSAGE_REFRESH_ENTITY","visibility":"public","isStatic":true,"isConstant":true,"memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"}],"attributes":[{"name":"loadMode","type":"String","desc":"数据集中数据的自动装载方式。\r<p>\r该属性具有下列两中可能的取值，默认情况下系统将按照lazy的方式来进行处理：\r<ul>\r<li>preload - 随着页面创建就预先从服务器端装载好数据。</li>\r<li>onReady - 当数据集的状态变为ready时自动开始装载数据。注意：此处所指的的异步装载方式。</li>\r<li>lazy - 当数据集的getData()或getDataAsync()方法第一次被调用时开始装载数据。</li>\r<li>manual - 当数据集的flush()或flushAsync()方法被调用时才开始装载数据。</li>\r</ul>\r</p>","alias":"dorado.widget.DataSet#attribute:loadMode","visibility":"public","defaultValue":"lazy","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"dataType","type":"dorado.DataType","desc":"数据集中数据的数据类型。\r<p>\r此属性对于数据集而言并非必须定义的，很多时候系统可以根据dataProvider的设置自行获得数据的数据类型。\r但当一个数据集并不与任何dataProvider关系时，改属性往往是必须定义的。<br/>\r另外，如果为此属性指定的数据类型，那么必须保证该数据类型与dataProvider返回的数据的数据类型是一致的。\r</p>","alias":"dorado.widget.DataSet#attribute:dataType","visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"data","type":"Object|dorado.Entity|dorado.EntityList","desc":"数据集中封装的数据。","alias":"dorado.widget.DataSet#attribute:data","see":["dorado.widget.DataSet#getData"],"visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"dataProvider","type":"dorado.DataProvider","desc":"数据提供器。","alias":"dorado.widget.DataSet#attribute:dataProvider","visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"parameter","type":"Object","desc":"装载数据时使用的参数，及传递给数据提供器的参数。","alias":"dorado.widget.DataSet#attribute:parameter","visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"pageSize","type":"int","desc":"装载数据时使用的分页大小，即按照每页多少条记录来进行分页装载。","alias":"dorado.widget.DataSet#attribute:pageSize","visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"pageNo","type":"int","desc":"初始状态下要装载的数据页号。从1开始的数字。","alias":"dorado.widget.DataSet#attribute:pageNo","visibility":"public","defaultValue":"1","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"dataLoaded","type":"boolean","desc":"数据集是否已完成了初始的数据装载过程。","alias":"dorado.widget.DataSet#attribute:dataLoaded","visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support","readOnly":true},{"name":"readOnly","type":"boolean","desc":"数据集是否只读。","alias":"dorado.widget.DataSet#attribute:readOnly","visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"cacheable","type":"boolean","desc":"是否要根据parameter参数将每次装载的数据缓存起来。","alias":"dorado.widget.DataSet#attribute:cacheable","visibility":"public","memberOf":"dorado.widget.DataSet","package":"widget-support"},{"name":"ready","type":"boolean","desc":"组件当前是否已激活。","alias":"dorado.widget.Component#attribute:ready","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"parent","type":"dorado.widget.Component","desc":"父控件。","alias":"dorado.widget.Component#attribute:parent","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"dataTypeRepository","type":"dorado.DataTypeRepository","desc":"此视图对象使用的数据类型管理器。","alias":"dorado.widget.Component#attribute:dataTypeRepository","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"id","type":"String","desc":"组件的id。","alias":"dorado.widget.ViewElement#attribute:id","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","writeBeforeReady":true},{"name":"destroyed","type":"boolean","desc":"组件当前是否已被销毁。","alias":"dorado.widget.ViewElement#attribute:destroyed","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"parentViewElement","type":"dorado.widget.ViewElement","desc":"父组件。","alias":"dorado.widget.ViewElement#attribute:parentViewElement","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"view","type":"dorado.widget.View","desc":"组件所属的视图。","alias":"dorado.widget.ViewElement#attribute:view","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"userData","type":"Object","desc":"用户自定义数据。","alias":"dorado.widget.ViewElement#attribute:userData","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support"},{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true}],"methods":[{"name":"get","type":"method","desc":"读取指定的属性值或提取DataSet中的数据。\r<p>\r此方法在<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>的基础上做了增强。\r除了原有的读取属性值的功能之外，此方法还另外提供了下面的用法。\r<ul>\r   <li>当传入一个以data:开头的字符串时，data:后面的所有内容将被识别成DataPath。</li>\r</ul>\r</p>\r<p>\r<b>需要注意的是，此处的data:语法不能被使用在DataSet的set方法中！</b>\r</p>","alias":"dorado.widget.DataSet#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"//上面的两句代码功能相同\rvar employees = ds.get(\"data:#.employees\");\rvar employees = ds.queryData(\"#.employees\");"}],"see":["dorado.AttributeSupport#get"],"visibility":"public","params":[{"desc":"属性值或其他表达式。","type":"Object","name":"attr"}],"returns":{"desc":"读取到的属性值或提取到的子对象","type":"Object"},"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"setData","type":"method","desc":"设置数据集封装的数据。","alias":"dorado.widget.DataSet#setData","visibility":"public","params":[{"desc":"数据。","type":"Object|dorado.Entity|dorado.EntityList","name":"data"}],"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"insert","type":"method","desc":"向数据集中添加一条顶层记录。\r<li>如果数据集的数据类型是集合，那么此方法表示向顶层集合中添加一条记录。</li>\r<li>如果数据集的数据类型是实体类型，那么此方法表示直接新建一条记录并将其设置为数据集的顶层数据。\r如果在执行此方法之前数据集的顶层数据不是空，那么此方法将会报错。</li>","alias":"dorado.widget.DataSet#insert","visibility":"public","params":[{"desc":"可以通过此参数传入一个JSON来初始化新增的记录，也可以直接传入要新增的Entity。","type":"dorado.Entity|Object","name":"data","isOptional":true}],"returns":{"desc":"新创建的数据实体。","type":"dorado.Entity"},"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"getData","type":"method","desc":"返回数据集封装的数据。\r<p>\r如果指定了数据路径(path)参数，此方法将利用DataPath来对DataSet中的数据进行提取。\r不过在默认情况下将启用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.evaluate')\">dorado.DataPath.evaluate</A>的firstResultOnly和acceptAggregation这两个选项。\r</p>","alias":"dorado.widget.DataSet#getData","see":["dorado.DataPath#evaluate","dorado.widget.DataSet#queryData"],"visibility":"public","params":[{"desc":"数据路径。","type":"String","name":"path","isOptional":true},{"desc":"选项。\r<p>\r此参数具有两种设定方式。当直接传入字符串时，dorado会将此逻辑值直接认为是针对loadMode子属性的值；\r当传入的是一个对象时，dorado将尝试识别该对象中的子属性。 其支持的子属性请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.evaluate')\">dorado.DataPath.evaluate</A>方法的执行选项。\r除此之外options还支持一些额外的选项，见下面的参数说明。\r</p>","type":"String|Object","name":"options","isOptional":true},{"desc":"数据装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r<li>auto - 如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r<li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r</ul>","type":"String","name":"options.loadMode=\"always\""},{"desc":"是否要清除DataSet中原有的数据并重新提取数据。","type":"boolean","name":"options.flush"}],"returns":{"desc":null,"type":"dorado.Entity|dorado.EntityList|any"},"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"getDataAsync","type":"method","desc":"以异步操作的方式获得数据集封装的数据。\r<p>\r如果指定了数据路径(path)参数，此方法将利用DataPath来对DataSet中的数据进行提取。\r不过在默认情况下将启用<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.evaluate')\">dorado.DataPath.evaluate</A>的firstResultOnly和acceptAggregation这两个选项。\r</p>","alias":"dorado.widget.DataSet#getDataAsync","see":["#getData","dorado.DataPath#evaluate","dorado.widget.DataSet#queryDataAsync"],"visibility":"public","params":[{"desc":"数据路径。","type":"String","name":"path","isOptional":true},{"desc":"回调对象，传入回调对象的参数即为提取到的数据。","type":"Function|dorado.Callback","name":"callback"},{"desc":"选项。\r<p>\r此参数具有两种设定方式。当直接传入字符串时，dorado会将此逻辑值直接认为是针对loadMode子属性的值；\r当传入的是一个对象时，dorado将尝试识别该对象中的子属性。 其支持的子属性请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.evaluate')\">dorado.DataPath.evaluate</A>方法的执行选项。\r除此之外options还支持一些额外的选项，见下面的参数说明。\r</p>","type":"String|Object","name":"options","isOptional":true},{"desc":"数据装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r<li>auto - 对于异步操作而言此选项没有实际意义，系统内部的处理方法将与always完全一致。</li>\r<li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r</ul>","type":"String","name":"options.loadMode=\"always\""},{"desc":"是否要清除DataSet中原有的数据并重新提取数据。","type":"boolean","name":"options.flush"}],"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"queryData","type":"method","desc":"利用DataPath来查询数据集中的数据。","alias":"dorado.widget.DataSet#queryData","see":["dorado.DataPath#evaluate","dorado.widget.DataSet#getData"],"visibility":"public","params":[{"desc":"数据路径。","type":"String","name":"path"},{"desc":"选项。\r<p>\r此参数具有两种设定方式。当直接传入字符串时，dorado会将此逻辑值直接认为是针对loadMode子属性的值；\r当传入的是一个对象时，dorado将尝试识别该对象中的子属性。 其支持的子属性请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.evaluate')\">dorado.DataPath.evaluate</A>方法的执行选项。\r除此之外options还支持一些额外的选项，见下面的参数说明。\r</p>","type":"String|Object","name":"options","isOptional":true},{"desc":"数据装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r<li>auto - 如果有需要则自动启动异步的数据装载过程，但对于本次方法调用将返回数据的当前值。</li>\r<li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r</ul>","type":"String","name":"options.loadMode=\"always\""},{"desc":"是否要清除DataSet中原有的数据并重新提取数据。","type":"boolean","name":"options.flush"}],"returns":{"desc":null,"type":"dorado.Entity|[dorado.Entity]"},"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"queryDataAsync","type":"method","desc":"利用DataPath来查询数据集中的数据。","alias":"dorado.widget.DataSet#queryDataAsync","see":["#getData","dorado.DataPath#evaluate","dorado.widget.DataSet#getDataAsync"],"visibility":"public","params":[{"desc":"数据路径。","type":"String","name":"path"},{"desc":"回调对象，传入回调对象的参数即为提取到的数据。","type":"Function|dorado.Callback","name":"callback"},{"desc":"选项。\r<p>\r此参数具有两种设定方式。当直接传入字符串时，dorado会将此逻辑值直接认为是针对loadMode子属性的值；\r当传入的是一个对象时，dorado将尝试识别该对象中的子属性。 其支持的子属性请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.evaluate')\">dorado.DataPath.evaluate</A>方法的执行选项。\r除此之外options还支持一些额外的选项，见下面的参数说明。\r</p>","type":"Stringed|Object","name":"options","isOptional":true},{"desc":"数据装载模式。<br/>\r包含下列三种取值:\r<ul>\r<li>always - 如果有需要总是装载尚未装载的延时数据。</li>\r<li>auto - 对于异步操作而言此选项没有实际意义，系统内部的处理方法将与always完全一致。</li>\r<li>never - 不会激活数据装载过程，直接返回数据的当前值。</li>\r</ul>","type":"String","name":"options.loadMode=\"always\""},{"desc":"是否要清除DataSet中原有的数据并重新提取数据。","type":"boolean","name":"options.flush"}],"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"flush","type":"method","desc":"以同步方式刷新DataSet中的数据。即清除DataSet中原有的数据并重新提取。\r其作用等同于<pre>dataSet.getData(null, { flush: true });</pre>","alias":"dorado.widget.DataSet#flush","see":["dorado.widget.DataSet#flushAsync","dorado.widget.DataSet#getData"],"visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"flushAsync","type":"method","desc":"以异步方式刷新DataSet中的数据。即清除DataSet中原有的数据并重新提取。\r其作用等同于<pre>dataSet.getDataAsync(null, null, { flush: true });</pre>","alias":"dorado.widget.DataSet#flushAsync","see":["dorado.widget.DataSet#flush","dorado.widget.DataSet#getDataAsync"],"visibility":"public","params":[{"desc":"执行选项。\r此参数有两种定义方式：\r<ul>\r   <li>当参数的类型是Function时，系统会将其解释为下面提及的options.callback参数。<li>\r   <li>当参数的类型是Object时，系统会将其解释可能包含更多子设置的执行选项。具体支持的子设置见下面的描述。<li>\r</ul>","type":"Function|Object","name":"options","isOptional":true},{"desc":"回调对象，传入回调对象的参数即为提取到的数据。","type":"Function|dorado.Callback","name":"options.callback","isOptional":true},{"desc":"是否要在刷新动作执行期间显示模态操作的提示信息。","type":"boolean","name":"options.modal","isOptional":true},{"desc":"如果要显示模态操作的提示信息，那么应该显示怎样的文字提示。","type":"String","name":"options.executingMessage","isOptional":true}],"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"getDataType","type":"method","desc":"返回数据集的数据类型。如果指定了数据路径(path)参数，此方法将提取数据路径所对应的数据类型。\r<p>\r需要特别注意的是，此方法默认情况下总是会返回实体数据类型(<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EntityDataType')\">dorado.EntityDataType</A>)，而不是(<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AggregationDataType')\">dorado.AggregationDataType</A>)。<br/>\r例如：假设DataSet的实际数据类型为\"[Employee]\"，此时调用DataSet的getDataType()方法，我们将得到数据类型Employee，而不是[Employee]。<br/>\r如果我们确实需要获得数据类型[Employee]，应使用options来改变此方法的执行行为。\r</p>","alias":"dorado.widget.DataSet#getDataType","see":["dorado.DataPath#getDataType"],"visibility":"public","params":[{"desc":"数据路径。","type":"String","name":"path","isOptional":true},{"desc":"传递给<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataPath.getDataType')\">dorado.DataPath.getDataType</A>方法的选项参数。","type":"Object","name":"options","isOptional":true}],"returns":{"desc":"取得的数据类型。","type":"dorado.DataType"},"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"clear","type":"method","desc":"清除数据集中当前的所有数据。","alias":"dorado.widget.DataSet#clear","visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"addObserver","type":"method","desc":"向数据集中添加一个消息的监听器。","alias":"dorado.widget.DataSet#addObserver","visibility":"public","params":[{"desc":"要添加的消息监听器。","type":"dorado.widget.DataSetObserver","name":"observer"}],"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"removeObserver","type":"method","desc":"从数据集中移除一个消息的监听器。","alias":"dorado.widget.DataSet#removeObserver","visibility":"public","params":[{"desc":"要移除的消息监听器。","type":"dorado.widget.DataSetObserver","name":"observer"}],"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"disableObservers","type":"method","desc":"禁止DataSet将消息发送给其观察者。\r<p>\r该方法的主要作用是阻止与该DataSet关联的数据控件自动根据DataSet中的数据变化刷新自身的显示内容，\r这样做的目的一般是为了提高对DataSet连续进行操作时的运行效率。\r</p>","alias":"dorado.widget.DataSet#disableObservers","visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"enableObservers","type":"method","desc":"允许DataSet将消息发送给其观察者。","alias":"dorado.widget.DataSet#enableObservers","visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"notifyObservers","type":"method","desc":"通知DataSet的所有观察者刷新数据。","alias":"dorado.widget.DataSet#notifyObservers","visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"getOwnerDataSet","type":"method","desc":"返回某数据实体或实体集合当前所隶属的DataSet。","alias":"dorado.widget.DataSet.getOwnerDataSet","visibility":"public","params":[{"desc":"数据实体或实体集合。","type":"dorado.Entity|dorado.EntityList","name":"data"}],"returns":{"desc":"隶属的DataSet。","type":"dorado.widget.DataSet"},"package":"widget-support","isStatic":true,"memberOf":"dorado.widget.DataSet"},{"name":"onReady","type":"method","desc":"当组件的状态已变为可用时被激活的方法。","alias":"dorado.widget.Component#onReady","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"destroy","type":"method","desc":"销毁组件。","alias":"dorado.widget.ViewElement#destroy","visibility":"public","package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"registerInnerViewElement","type":"method","desc":"将一个给定控件注册为本控件的内部控件。\r<p>\r内部控件与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container')\">dorado.widget.Container</A>中的子控件是不同的概念。\r内部控件是父控件自身的组成部分，例如RadioGroup控件本身就是由其中的一到多个RadioButton构成的。\r</p>\r<p>\rregisterInnerViewElement方法一般也不应该被外部程序调用，而是应该有控件自身的代码在createDom或refreshDom等方法中调用。\r利用registerInnerViewElement方法注册内部控件的目的是为了正确向这些控件传播系统消息，管理这些控件的状态。<br/>\r完成注册后的内部控件的parent和focusParent属性都将指向本控件。\r</p>","alias":"dorado.widget.ViewElement#registerInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"unregisterInnerViewElement","type":"method","desc":"注销一个给定的内部控件。","alias":"dorado.widget.ViewElement#unregisterInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"}],"constructors":[],"events":[{"name":"beforeLoadData","type":"event","desc":"当DataSet将要尝试数据装载之前触发的事件。","alias":"dorado.widget.DataSet#event:beforeLoadData","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"当前装载的页号。","type":"int","name":"arg.pageNo"},{"desc":"= true 用于通知系统是否要继续完成后续动作。","type":"Object","name":"arg.processDefault","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"onLoadData","type":"event","desc":"当数据装载完成时触发的事件。\r<p>\r注意：当数据完成装载并不代表就一定有数据被装载到本地，此事件仅仅表示成功的完成了一次数据装载的动作。\r</p>","alias":"dorado.widget.DataSet#event:onLoadData","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"当前装载的页号。","type":"int","name":"arg.pageNo"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"onDataLoad","type":"event","desc":null,"deprecated":true,"alias":"dorado.widget.DataSet#event:onDataLoad","visibility":"public","package":"widget-support","memberOf":"dorado.widget.DataSet"},{"name":"onReady","type":"event","desc":"当组件被激活（即真正可用时）时触发的事件。","alias":"dorado.widget.Component#event:onReady","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"onCreate","type":"event","desc":"当组件被创建时触发的事件。\r<p>\r与其他事件不同，onCreate事件中的this是个例外，它并不指向控件所属的View对象，而是指向$view（见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$view')\">$view</A>）。\r之所以这样是因此，该事件是在控件创建的过程中触发的，而在此时控件还没有被添加到具体的（最终的）View中。\r因此在触发此事件系统无法得知此控件应该属于哪个View。<br/>\r<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.View')\">dorado.widget.View</A>对象的onCreate事件又是这个例外规则中的例外。\r因为View对象的onCreate事件中的this总是指向自身的，因此View对象的onCreate事件与其他事件中的this并没有什么不同。\r</p>","alias":"dorado.widget.ViewElement#event:onCreate","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"onDestroy","type":"event","desc":"当组件被销毁时触发的事件。","alias":"dorado.widget.ViewElement#event:onDestroy","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"}]}