SYMBOLS["dorado.widget.FloatControl"]={"name":"FloatControl","type":"class","desc":null,"alias":"dorado.widget.FloatControl","isAbstract":true,"classDesc":"浮动控件的接口。\r<p>\r浮动控件是一种比较特殊的可视化控件。例如：菜单、下拉框、对话框等控件。 初始情况下这些控件是不可见的，直到其render()方法被调用。\r一般而言，浮动控件在渲染时不受布局管理器的约束。除非我们显式的为其指定布局条件。\r</p>","package":"widget-support","inherits":["dorado.widget.AbstractMenu","dorado.widget.FloatPanel","dorado.widget.Tip"],"memberOf":"dorado.widget","properties":[],"attributes":[{"name":"floating","type":"boolean","desc":"是否浮动，默认为true。","alias":"dorado.widget.FloatControl#attribute:floating","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FloatControl","package":"widget-support","writeBeforeReady":true},{"name":"floatingClassName","type":"String","desc":"如果浮动，则会为组件的dom添加上该className。","alias":"dorado.widget.FloatControl#attribute:floatingClassName","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support","writeBeforeReady":true},{"name":"animateType","type":"String","desc":"当组件显示或者隐藏的时候要使用的动画类型。\r<p>\r一般情况下组件的显示或者隐藏是同一类型的，则无需另外设置showAnimateType或者hideAnimateType。反之，则设置。\r需要说明的是，在显示的时候，showAnimateType的优先级会高于animateType，在隐藏的时候，hideAnimateType的优先级会高于animateType。\r</p>\r<p>\r目前可选值：zoom、slide、safeSlide、fade、none。\r对几个动画进行一个简单的说明。\r<ol>\r <li>none：不使用动画，直接显示或者隐藏。</li>\r <li>zoom：使用一个灰色的html element的放大或者缩小来展示组件的显示或者隐藏。目前被Dialog使用。</li>\r <li>slide：通过四个方向(从上到下，从下到上，从左到右，从右到左)四个方向展示组件的显示与隐藏，目前被Menu的showAnimateType使用。</li>\r <li>safeSlide：在非IE浏览器下，如果组件内部包含IFrame组件时，使用slide类型的动画，会导致IFrame重新加载，在这种情况下，应该使用safeSlide类型的动画替换之。\r 另外，如果想保留组件中某些组件的滚动条，也需要使用safeSlide替换slide类型的动画。</li>\r <li>fade：通过改变组件的html element的透明度来展示组件的显示或者隐藏，目前被Tip使用。</li>\r</ol>\r</p>","alias":"dorado.widget.FloatControl#attribute:animateType","visibility":"public","defaultValue":"\"zoom\"","memberOf":"dorado.widget.FloatControl","package":"widget-support","skipAutoRefresh":true},{"name":"showAnimateType","type":"String","desc":"默认值为空，当显示的时候，取显示要使用的动画，优先级会高于animateType。<br/>\r\r可选值：zoom、slide、safeSlide、fade、none。\r关于动画的说明，参考animateType的说明。","alias":"dorado.widget.FloatControl#attribute:showAnimateType","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support","skipAutoRefresh":true},{"name":"hideAnimateType","type":"String","desc":"默认值为空，当隐藏的时候，取隐藏要使用的动画，优先级会高于animateType。 <br />\r\r可选值：zoom、slide、safeSlide、fade、none。\r关于动画的说明，参考animateType的说明。","alias":"dorado.widget.FloatControl#attribute:hideAnimateType","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support","skipAutoRefresh":true},{"name":"animateTarget","type":"dorado.widget.Control|String|HTMLElement","desc":"动画开始时的目标来源，目前仅在animateType为zoom的时候会使用，用来确定动画开始的位置。","alias":"dorado.widget.FloatControl#attribute:animateTarget","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support","skipAutoRefresh":true},{"name":"left","type":"Integer","desc":"组件在屏幕上的左偏移。","alias":"dorado.widget.FloatControl#attribute:left","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"top","type":"Integer","desc":"组件在屏幕上的上偏移。","alias":"dorado.widget.FloatControl#attribute:top","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"center","type":"boolean","desc":"是否居中显示组件。","alias":"dorado.widget.FloatControl#attribute:center","visibility":"public","defaultValue":"false","memberOf":"dorado.widget.FloatControl","package":"widget-support","skipAutoRefresh":true},{"name":"anchorTarget","type":"attribute","desc":"锚定对象，如果是window，则表示该要停靠的DOM元素相对于当前可视范围进行停靠。<br />\r如果是组件或者HTMLElement，则是相对于组件的dom元素或HTMLElement进行停靠。","alias":"dorado.widget.FloatControl#attribute:anchorTarget","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"offsetLeft","type":"int","desc":"使用align、vAlign计算出组件的位置或者指定的位置的水平偏移量，可以为正，可以为负。","alias":"dorado.widget.FloatControl#attribute:offsetLeft","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"offsetTop","type":"int","desc":"使用align、vAlign计算出组件的位置或者指定的位置的垂直偏移量，可以为正，可以为负。","alias":"dorado.widget.FloatControl#attribute:offsetTop","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"align","type":"String","desc":"在水平方向上，组件停靠在anchorTarget的位置。可选值为left、innerleft、center、innerright、right。","alias":"dorado.widget.FloatControl#attribute:align","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"vAlign","type":"String","desc":"在垂直方向上，停靠的DOM对象停靠在固定位置的DOM对象的位置。可选值为top、innertop、center、innerbottom、bottom。","alias":"dorado.widget.FloatControl#attribute:vAlign","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"autoAdjustPosition","type":"boolean","desc":"当使用默认的align、vAlign计算的位置超出屏幕可见范围以后，是否要对停靠DOM对象的位置进行调整，默认为true，即进行调整。","alias":"dorado.widget.FloatControl#attribute:autoAdjustPosition","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"handleOverflow","type":"boolean","desc":"当自动调整以后也无法使得组件显示在屏幕范围以内以后，就认为停靠的DOM对象的超出触发了，该属性用来标示是否对这种情况进行处理，默认会对这种情况进行处理。","alias":"dorado.widget.FloatControl#attribute:handleOverflow","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"modal","type":"boolean","desc":"是否模态显示组件。","alias":"dorado.widget.FloatControl#attribute:modal","visibility":"public","defaultValue":"false","memberOf":"dorado.widget.FloatControl","package":"widget-support","skipAutoRefresh":true},{"name":"modalType","type":"String","desc":"模态以后显示的模态背景的类型。<br />\r可选值: dark、transparent。<br />\r每一种类型对应一个className，如果要扩展，可以扩展dorado.widget.FloatControl.modalTypeClassName对象。<br />","alias":"dorado.widget.FloatControl#attribute:modalType","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"shadowMode","type":"String","desc":"组件的阴影的阴影使用的模式。<br />\r\r可选值：drop、sides、frame、none。","alias":"dorado.widget.FloatControl#attribute:shadowMode","visibility":"public","defaultValue":"\"sides\"","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"focusAfterShow","type":"boolean","desc":"是否在显示之后自动获得焦点，默认值为true。","alias":"dorado.widget.FloatControl#attribute:focusAfterShow","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FloatControl","package":"widget-support"},{"name":"continuedFocus","type":"boolean","desc":"是否在显示之后延续之前的焦点管理状态，默认值是由Modal属性决定的，当modal为true的时候，continuedFocus为true，反之亦然。\r<p>\r此属性仅在focusAfterShow为true是有实际意义。\r<ul>\r\t<li>\r\t如果此属性为true，那么当此控件显示之后，Dorado并不会令之前拥有焦点的控件失去焦点，即使此控件在显示之后获得了控制焦点。\r\t</li>\r\t<li>\r\t如果此属性为false，那么当此控件显示之后之前拥有焦点的控件将失去焦点。\r\t</li>\r</ul>\r</p>","alias":"dorado.widget.FloatControl#attribute:continuedFocus","visibility":"public","memberOf":"dorado.widget.FloatControl","package":"widget-support"}],"methods":[{"name":"show","type":"method","desc":"显示浮动控件。\r<p>\r如无特殊需要请不要复写此方法，而应该复写doShow方法。\r</p>\r<p>\r目前支持三种方式来决定位置：\r<ol>\r\t<li>指定anchorTarget</li>\r <li>指定position</li>\r <li>指定event</li>\r\t<li>指定left、top</li>\r</ol>\r指定anchorTarget以后，anchorTarget会作为fixedElement传入dockAround方法，除了dockAround方法用到的参数，其他参数会被忽略。<br />\r指定position以后，position会作为参数传入locateIn方法，除了locateIn方法用到的参数，其他参数会被忽略。<br />\r指定event以后，显示的位置则等于event.pageX和event.pageY<br />\r若不指定anchorTarget，也不指定position，则会判断用户是不是设置了center、left、top属性，根据这几个属性计算出组件显示的位置。\r</p>","alias":"dorado.widget.FloatControl#show","visibility":"public","params":[{"desc":"传入的Json参数，下面的参数不会被设置为组件的显示属性。<br />\r       如果组件每次显示使用的都是不同的参数，不建议使用组件属性里面的显示参数，建议每次在调用show方法的时候动态指定Json参数。<br />\r       如果options类型为Function，则会被当做options.callback使用，与onShow事件调用的时间相同。","type":"Object|Function","name":"options","isOptional":true},{"desc":"组件显示的位置，该参数应该为Object，用left、top属性表示绝对值。","type":"Object","name":"options.position","isOptional":true},{"desc":"锚定对象，如果是window，则表示该要停靠的DOM元素相对于当前可视范围进行停靠。<br />\r             如果是组件或者HTMLElement，则是相对于组件的dom元素或HTMLElement进行停靠。","type":"HTMLElement|dorado.widget.Control","name":"options.anchorTarget","isOptional":true},{"desc":"jQuery绑定的事件中传入的event。","type":"Event","name":"options.event","isOptional":true},{"desc":"在水平方向上，组件停靠在anchorTarget的位置。可选值为left、innerleft、center、innerright、top。","type":"String","name":"options.align","isOptional":true,"defaultValue":"innerleft"},{"desc":"在垂直方向上，组件停靠在anchorTarget的位置。可选值为top、innertop、center、innerbottom、bottom。","type":"String","name":"options.vAlign","isOptional":true,"defaultValue":"innertop"},{"desc":"在水平方向上，停靠的DOM对象与固定位置的DOM对象之间的间隙大小，可以为正，可以为负。","type":"int","name":"options.gapX","isOptional":true,"defaultValue":"0"},{"desc":"在垂直方向上，停靠的DOM对象与固定位置的DOM对象之间的间隙大小，可以为正，可以为负。","type":"int","name":"options.gapY","isOptional":true,"defaultValue":"0"},{"desc":"使用align计算出组件的位置的水平偏移量，可以为正，可以为负。","type":"int","name":"options.offsetLeft","isOptional":true,"defaultValue":"0"},{"desc":"使用vAlign计算出组件的位置的垂直偏移量，可以为正，可以为负。","type":"int","name":"options.offsetTop","isOptional":true,"defaultValue":"0"},{"desc":"当使用默认的align、vAlign计算的位置超出屏幕可见范围以后，是否要对停靠DOM对象的位置进行调整，默认为true，即进行调整。","type":"boolean","name":"options.autoAdjustPosition","isOptional":true,"defaultValue":"true"},{"desc":"当自动调整以后也无法使得组件显示在屏幕范围以内以后，认为组件的超出触发了，该属性用来标示是否对这种情况进行处理，默认会对这种情况进行处理。","type":"boolean","name":"options.handleOverflow","isOptional":true,"defaultValue":"true"},{"desc":"当组件的超出触发以后，要触发的函数，如果不指定，会去判断组件是否存在doHandleOverflow方法，如果存在，则会触发改方法。","type":"Function","name":"options.overflowHandler","isOptional":true},{"desc":"动画类型。","type":"String","name":"options.animateType","isOptional":true},{"desc":"在FloatControl显示完成之后，调用的回调函数，与onShow事件调用的时间相同。","type":"Function","name":"options.callback","isOptional":true}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"doShow","type":"method","desc":"该方法在动画播放之前调用，会确定组件显示的位置，在位置确定以后，会按照组件属性的设置执行动画。\r如果需要在动画播放之前执行一些动作，请覆写该方法。","alias":"dorado.widget.FloatControl#doShow","visibility":"protected","params":[{"desc":"Json类型的参数，同show方法。","type":"Object","name":"options"}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"doAfterShow","type":"method","desc":"在动画完成之后会调用此方法。\r该方法会根据组件的设置，为组件添加阴影、移到最前、获得焦点等。\r在该方法的最后，会触发onShow方法。","alias":"dorado.widget.FloatControl#doAfterShow","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"getShowPosition","type":"method","desc":"取得组件显示的位置。","alias":"dorado.widget.FloatControl#getShowPosition","visibility":"protected","params":[{"desc":"Json类型的参数，同show方法。","type":"Object","name":"options"}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"hide","type":"method","desc":"隐藏浮动控件。\r<p>\r如无特殊需要请不要复写此方法，而应该复写doHide方法。\r</p>","alias":"dorado.widget.FloatControl#hide","visibility":"public","params":[{"desc":"Json类型的参数","type":"Object","name":"options"}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"doHide","type":"method","desc":"该方法在动画播放之前调用，会按照组件属性的设置执行动画。\r如果需要在动画播放之前执行一些动作，请覆写该方法。","alias":"dorado.widget.FloatControl#doHide","visibility":"protected","params":[{"desc":"Json类型的参数，同hide方法。","type":"Object","name":"options"}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"doAfterHide","type":"method","desc":"在动画完成之后会调用此方法。\r在该方法的最后，会触发onHide方法。","alias":"dorado.widget.FloatControl#doAfterHide","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.FloatControl"}],"constructors":[],"events":[{"name":"beforeShow","type":"event","desc":"在显示之前触发。","alias":"dorado.widget.FloatControl#event:beforeShow","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"onShow","type":"event","desc":"在显示之后触发。","alias":"dorado.widget.FloatControl#event:onShow","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"afterShow","type":"event","desc":"在onShow的动画完成之后触发。","alias":"dorado.widget.FloatControl#event:afterShow","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"beforeHide","type":"event","desc":"在隐藏之前触发。","alias":"dorado.widget.FloatControl#event:beforeHide","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"onHide","type":"event","desc":"在隐藏之后触发。","alias":"dorado.widget.FloatControl#event:onHide","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"afterHide","type":"event","desc":"在onHide的动画完成之后触发。","alias":"dorado.widget.FloatControl#event:afterHide","visibility":"public","params":[{"desc":"事件的发起者，即控件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"beforeClose","type":"event","desc":"在组件关闭之前触发。","alias":"dorado.widget.FloatControl#event:beforeClose","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.FloatControl"},{"name":"onClose","type":"event","desc":"在组件关闭之后触发。","alias":"dorado.widget.FloatControl#event:onClose","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.FloatControl"}]}