SYMBOLS["dorado.widget.FormConfig"]={"name":"FormConfig","type":"class","desc":null,"alias":"dorado.widget.FormConfig","author":"Benny Bao (mailto:benny.bao@bstek.com)","isAbstract":true,"classDesc":"包含表单项中主要配置信息的抽象类。","package":"form","inherits":["dorado.widget.FormElement","dorado.widget.FormProfile"],"memberOf":"dorado.widget","properties":[],"attributes":[{"name":"width","type":"int","desc":"宽度。","alias":"dorado.widget.FormConfig#attribute:width","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"height","type":"int","desc":"高度。","alias":"dorado.widget.FormConfig#attribute:height","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"className","type":"String","desc":"CSS类名。","alias":"dorado.widget.FormConfig#attribute:className","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"exClassName","type":"String","desc":"扩展CSS类名。","alias":"dorado.widget.FormConfig#attribute:exClassName","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"editorType","type":"String","desc":"表单项类型。\r<p>\r此属性的值实质为编辑器控件的$type。<br/>\r例如当我们希望其中的编辑器为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.TextEditor')\">dorado.widget.TextEditor</A>时，可以定义此属性的值为TextEditor。\r因为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.TextEditor')\">dorado.widget.TextEditor</A>的$type为TextEditor。<br/>\r当我们希望其中的编辑器为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.CheckBox')\">dorado.widget.CheckBox</A>时，可以定义此属性的值为CheckBox。<br/>\r当我们希望其中的编辑器为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Label')\">dorado.widget.Label</A>时，可以定义此属性的值为Label。\r由于Label并不是一个继承自<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.AbstractEditor')\">dorado.widget.AbstractEditor</A>，因此FormElement将不具备数据编辑的功能。\r</p>\r<p>\r通过此方法定义编辑器控件具有一定的局限性，很多编辑控件在实际使用时往往需要定义额外的属性。\r如<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.CustomSpinner')\">dorado.widget.CustomSpinner</A>必须定义pattern属性才能正常使用，在这种情况下应该通过editor属性直接声明具体的编辑器。\r</p>","alias":"dorado.widget.FormConfig#attribute:editorType","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"entity","type":"Object|dorado.Entity","desc":"绑定的数据实体。","alias":"dorado.widget.FormConfig#attribute:entity","see":["dorado.widget.AbstractEditor#attribute:entity"],"visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"dataSet","type":"dorado.widget.DataSet","desc":"绑定的数据集。","alias":"dorado.widget.FormConfig#attribute:dataSet","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"dataPath","type":"String","desc":"数据路径，用于指定数据控件与数据集中的哪些数据节点进行关联。","alias":"dorado.widget.FormConfig#attribute:dataPath","see":["dorado.DataPath"],"visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelSeparator","type":"String","desc":"文本标签与编辑器之间的分隔字符。","alias":"dorado.widget.FormConfig#attribute:labelSeparator","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"showLabel","type":"boolean","desc":"文本标签是否可见。","alias":"dorado.widget.FormConfig#attribute:showLabel","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelWidth","type":"int","desc":"文本标签的宽度。","alias":"dorado.widget.FormConfig#attribute:labelWidth","visibility":"public","defaultValue":"80","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelSpacing","type":"int","desc":"文本标签与编辑框之间空隙的宽度。","alias":"dorado.widget.FormConfig#attribute:labelSpacing","visibility":"public","defaultValue":"3","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelPosition","type":"String","desc":"文本标签的显示位置。\r<p>\r目前支持以下几种取值：\r<ul>\r<li>left - 左侧。</li>\r<li>top - 上方。</li>\r</ul>\r</p>","alias":"dorado.widget.FormConfig#attribute:labelPosition","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelAlign","type":"String","desc":"文本标签的水平对齐方式。\r<p>\r目前支持以下几种取值：\r<ul>\r<li>left - 左对齐。</li>\r<li>right - 右对齐。</li>\r</ul>\r</p>","alias":"dorado.widget.FormConfig#attribute:labelAlign","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"editorWidth","type":"int","desc":"编辑器的宽度。","alias":"dorado.widget.FormConfig#attribute:editorWidth","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"showHint","type":"boolean","desc":"是否显示提示信息区。","alias":"dorado.widget.FormConfig#attribute:showHint","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintWidth","type":"int","desc":"提示信息区的宽度。","alias":"dorado.widget.FormConfig#attribute:hintWidth","visibility":"public","defaultValue":"22","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintSpacing","type":"int","desc":"提示信息区与编辑框之间的空隙的宽度。","alias":"dorado.widget.FormConfig#attribute:hintSpacing","visibility":"public","defaultValue":"3","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"showHintMessage","type":"boolean","desc":"是否将提示信息的文本消息直接显示在界面中。\r<p>\r否则见只在提示信息区显示图标形式的表单项状态。\r</p>","alias":"dorado.widget.FormConfig#attribute:showHintMessage","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintPosition","type":"String","desc":"提示信息区的显示位置。\r<p>\r目前支持以下几种取值：\r<ul>\r<li>right - 右侧。</li>\r<li>bottom - 下方。</li>\r</ul>\r</p>","alias":"dorado.widget.FormConfig#attribute:hintPosition","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintControl","type":"dorado.widget.dorado.widget.DataMessage","desc":"内部使用的信息提示控件。","alias":"dorado.widget.FormConfig#attribute:hintControl","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","readOnly":true},{"name":"readOnly","type":"boolean","desc":"是否只读。","alias":"dorado.widget.FormConfig#attribute:readOnly","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"}],"methods":[],"constructors":[],"events":[]}