SYMBOLS["dorado.widget.FormProfile"]={"name":"FormProfile","type":"class","desc":null,"alias":"dorado.widget.FormProfile","author":"Benny Bao (mailto:benny.bao@bstek.com)","see":["dorado.widget.FormElement"],"classDesc":"表单配置。\r<p>\r此控件并不用于显示，其目的是为了方便为一批表单元素统一的定义表单属性。\r例如：我们可以在View中添加一个FormProfile控件，并在其中定义好labelWidth=120。 然后在后面定义具体的<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.FormElement')\">dorado.widget.FormElement</A>的过程中，我们只要将其与这个FormProfile控件进行绑定，那么该FormElement就会自动的获得labelWidth=120的设置。\r</p>\r<p>\r另外，为了进一步的简化操作。<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.FormElement')\">dorado.widget.FormElement</A>还会在创建的过程中自动的在View中寻找是否存在id为\"defaultFormProfile\"的FormProfile控件。\r如果找到则将自动建立与其的绑定关系。\r因此，在很多情况下，我们只要声明一个id为\"defaultFormProfile\"的FormProfile控件，并且将需要的表单属性设置在其中。\r然后，这个View中所有的FormElement在默认情况下，都将自动从中读取配置信息。\r</p>","package":"form","shortTypeName":"FormProfile","inheritsFrom":["dorado.widget.Component","dorado.widget.FormConfig"],"inherits":["dorado.widget.AutoForm"],"memberOf":"dorado.widget","properties":[{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"}],"attributes":[{"name":"entity","type":"Object|dorado.Entity","desc":"绑定的数据实体。","alias":"dorado.widget.FormProfile#attribute:entity","see":["dorado.widget.AbstractEditor#attribute:entity"],"visibility":"public","memberOf":"dorado.widget.FormProfile","package":"form"},{"name":"ready","type":"boolean","desc":"组件当前是否已激活。","alias":"dorado.widget.Component#attribute:ready","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"parent","type":"dorado.widget.Component","desc":"父控件。","alias":"dorado.widget.Component#attribute:parent","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"dataTypeRepository","type":"dorado.DataTypeRepository","desc":"此视图对象使用的数据类型管理器。","alias":"dorado.widget.Component#attribute:dataTypeRepository","visibility":"public","memberOf":"dorado.widget.Component","package":"widget-support","readOnly":true},{"name":"id","type":"String","desc":"组件的id。","alias":"dorado.widget.ViewElement#attribute:id","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","writeBeforeReady":true},{"name":"destroyed","type":"boolean","desc":"组件当前是否已被销毁。","alias":"dorado.widget.ViewElement#attribute:destroyed","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"parentViewElement","type":"dorado.widget.ViewElement","desc":"父组件。","alias":"dorado.widget.ViewElement#attribute:parentViewElement","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"view","type":"dorado.widget.View","desc":"组件所属的视图。","alias":"dorado.widget.ViewElement#attribute:view","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"userData","type":"Object","desc":"用户自定义数据。","alias":"dorado.widget.ViewElement#attribute:userData","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support"},{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true},{"name":"width","type":"int","desc":"宽度。","alias":"dorado.widget.FormConfig#attribute:width","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"height","type":"int","desc":"高度。","alias":"dorado.widget.FormConfig#attribute:height","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"className","type":"String","desc":"CSS类名。","alias":"dorado.widget.FormConfig#attribute:className","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"exClassName","type":"String","desc":"扩展CSS类名。","alias":"dorado.widget.FormConfig#attribute:exClassName","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"editorType","type":"String","desc":"表单项类型。\r<p>\r此属性的值实质为编辑器控件的$type。<br/>\r例如当我们希望其中的编辑器为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.TextEditor')\">dorado.widget.TextEditor</A>时，可以定义此属性的值为TextEditor。\r因为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.TextEditor')\">dorado.widget.TextEditor</A>的$type为TextEditor。<br/>\r当我们希望其中的编辑器为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.CheckBox')\">dorado.widget.CheckBox</A>时，可以定义此属性的值为CheckBox。<br/>\r当我们希望其中的编辑器为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Label')\">dorado.widget.Label</A>时，可以定义此属性的值为Label。\r由于Label并不是一个继承自<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.AbstractEditor')\">dorado.widget.AbstractEditor</A>，因此FormElement将不具备数据编辑的功能。\r</p>\r<p>\r通过此方法定义编辑器控件具有一定的局限性，很多编辑控件在实际使用时往往需要定义额外的属性。\r如<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.CustomSpinner')\">dorado.widget.CustomSpinner</A>必须定义pattern属性才能正常使用，在这种情况下应该通过editor属性直接声明具体的编辑器。\r</p>","alias":"dorado.widget.FormConfig#attribute:editorType","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"dataSet","type":"dorado.widget.DataSet","desc":"绑定的数据集。","alias":"dorado.widget.FormConfig#attribute:dataSet","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"dataPath","type":"String","desc":"数据路径，用于指定数据控件与数据集中的哪些数据节点进行关联。","alias":"dorado.widget.FormConfig#attribute:dataPath","see":["dorado.DataPath"],"visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelSeparator","type":"String","desc":"文本标签与编辑器之间的分隔字符。","alias":"dorado.widget.FormConfig#attribute:labelSeparator","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"},{"name":"showLabel","type":"boolean","desc":"文本标签是否可见。","alias":"dorado.widget.FormConfig#attribute:showLabel","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelWidth","type":"int","desc":"文本标签的宽度。","alias":"dorado.widget.FormConfig#attribute:labelWidth","visibility":"public","defaultValue":"80","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelSpacing","type":"int","desc":"文本标签与编辑框之间空隙的宽度。","alias":"dorado.widget.FormConfig#attribute:labelSpacing","visibility":"public","defaultValue":"3","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelPosition","type":"String","desc":"文本标签的显示位置。\r<p>\r目前支持以下几种取值：\r<ul>\r<li>left - 左侧。</li>\r<li>top - 上方。</li>\r</ul>\r</p>","alias":"dorado.widget.FormConfig#attribute:labelPosition","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"labelAlign","type":"String","desc":"文本标签的水平对齐方式。\r<p>\r目前支持以下几种取值：\r<ul>\r<li>left - 左对齐。</li>\r<li>right - 右对齐。</li>\r</ul>\r</p>","alias":"dorado.widget.FormConfig#attribute:labelAlign","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"editorWidth","type":"int","desc":"编辑器的宽度。","alias":"dorado.widget.FormConfig#attribute:editorWidth","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"showHint","type":"boolean","desc":"是否显示提示信息区。","alias":"dorado.widget.FormConfig#attribute:showHint","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintWidth","type":"int","desc":"提示信息区的宽度。","alias":"dorado.widget.FormConfig#attribute:hintWidth","visibility":"public","defaultValue":"22","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintSpacing","type":"int","desc":"提示信息区与编辑框之间的空隙的宽度。","alias":"dorado.widget.FormConfig#attribute:hintSpacing","visibility":"public","defaultValue":"3","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"showHintMessage","type":"boolean","desc":"是否将提示信息的文本消息直接显示在界面中。\r<p>\r否则见只在提示信息区显示图标形式的表单项状态。\r</p>","alias":"dorado.widget.FormConfig#attribute:showHintMessage","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintPosition","type":"String","desc":"提示信息区的显示位置。\r<p>\r目前支持以下几种取值：\r<ul>\r<li>right - 右侧。</li>\r<li>bottom - 下方。</li>\r</ul>\r</p>","alias":"dorado.widget.FormConfig#attribute:hintPosition","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","writeBeforeReady":true},{"name":"hintControl","type":"dorado.widget.dorado.widget.DataMessage","desc":"内部使用的信息提示控件。","alias":"dorado.widget.FormConfig#attribute:hintControl","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form","readOnly":true},{"name":"readOnly","type":"boolean","desc":"是否只读。","alias":"dorado.widget.FormConfig#attribute:readOnly","visibility":"public","memberOf":"dorado.widget.FormConfig","package":"form"}],"methods":[{"name":"onReady","type":"method","desc":"当组件的状态已变为可用时被激活的方法。","alias":"dorado.widget.Component#onReady","visibility":"protected","package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"destroy","type":"method","desc":"销毁组件。","alias":"dorado.widget.ViewElement#destroy","visibility":"public","package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"registerInnerViewElement","type":"method","desc":"将一个给定控件注册为本控件的内部控件。\r<p>\r内部控件与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container')\">dorado.widget.Container</A>中的子控件是不同的概念。\r内部控件是父控件自身的组成部分，例如RadioGroup控件本身就是由其中的一到多个RadioButton构成的。\r</p>\r<p>\rregisterInnerViewElement方法一般也不应该被外部程序调用，而是应该有控件自身的代码在createDom或refreshDom等方法中调用。\r利用registerInnerViewElement方法注册内部控件的目的是为了正确向这些控件传播系统消息，管理这些控件的状态。<br/>\r完成注册后的内部控件的parent和focusParent属性都将指向本控件。\r</p>","alias":"dorado.widget.ViewElement#registerInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"unregisterInnerViewElement","type":"method","desc":"注销一个给定的内部控件。","alias":"dorado.widget.ViewElement#unregisterInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"}],"constructors":[],"events":[{"name":"onReady","type":"event","desc":"当组件被激活（即真正可用时）时触发的事件。","alias":"dorado.widget.Component#event:onReady","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.Component"},{"name":"onCreate","type":"event","desc":"当组件被创建时触发的事件。\r<p>\r与其他事件不同，onCreate事件中的this是个例外，它并不指向控件所属的View对象，而是指向$view（见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$view')\">$view</A>）。\r之所以这样是因此，该事件是在控件创建的过程中触发的，而在此时控件还没有被添加到具体的（最终的）View中。\r因此在触发此事件系统无法得知此控件应该属于哪个View。<br/>\r<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.View')\">dorado.widget.View</A>对象的onCreate事件又是这个例外规则中的例外。\r因为View对象的onCreate事件中的this总是指向自身的，因此View对象的onCreate事件与其他事件中的this并没有什么不同。\r</p>","alias":"dorado.widget.ViewElement#event:onCreate","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"onDestroy","type":"event","desc":"当组件被销毁时触发的事件。","alias":"dorado.widget.ViewElement#event:onDestroy","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"}]}