SYMBOLS["dorado.widget.grid.ColumnModel"]={"name":"ColumnModel","type":"class","desc":null,"alias":"dorado.widget.grid.ColumnModel","author":"Benny Bao (mailto:benny.bao@bstek.com)","isAbstract":true,"classDesc":"表格的列模型。\r<p>表格的列模型是用于辅助表格控件管理其中的列信息的对象。</p>\r<p>\rColumnModel的get方法在<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>的基础上做了增强。\r除了原有的读取属性值的功能之外，此方法还另外提供了下面的用法。\r<ul>\r   <li>当传入一个以#开头的字符串时，#后面的内容将被识别成列的名称，表示根据名称获取表格列。参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.grid.ColumnModel#getColumn')\">dorado.widget.grid.ColumnModel#getColumn</A>。</li>\r</ul>\r</p>","package":"grid","inheritsFrom":["dorado.AttributeSupport"],"inherits":["dorado.widget.AbstractGrid","dorado.widget.grid.ColumnGroup"],"memberOf":"dorado.widget.grid","properties":[{"name":"ATTRIBUTES","type":"Object","desc":"用于声明该对象中所支持的所有Attribute。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.AttributeSupport#ATTRIBUTES","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的caption属性的声明。\rvar attributeDef = oop.ATTRIBUTES.caption。\r// 判断该属性是否只读\rif (attributeDef.readOnly) { ... ... }"}],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"objects","type":"dorado.AttributeSupport[]","desc":"对象数组。","alias":"dorado.AttributeSupport#objects","visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"attributes":[{"name":"columns","type":"dorado.widget.grid.Column[]|dorado.util.KeyedArray","desc":"子列集合。\r<p>\r此属性在读写时的意义不完全相同。\r<ul>\r<li>当读取时返回组中的子列的集合，类型为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.KeyedArray')\">dorado.util.KeyedArray</A>。</li>\r<li>\r当写入时用于向组中添加列。<br/>\r此处数组中既可以放入表格列(<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.grid.Column')\">dorado.widget.grid.Column</A>)的实例，又可以放入JSON对象，甚至可以是用字符串描述的列。\r具体请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.grid.ColumnModel#addColumns')\">dorado.widget.grid.ColumnModel#addColumns</A>。\r</li>\r</ul>\r</p>","alias":"dorado.widget.grid.ColumnModel#attribute:columns","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 向表格中添加两个列\rgroup.set(\"columns\", [ {\r\t name : \"id\",\r\t property : \"prop1\",\r\t readOnly : true\r}, {\r\t name : \"name\",\r\t property : \"prop2\"\r} ]);"}],"see":["dorado.widget.grid.ColumnModel#addColumns"],"visibility":"public","memberOf":"dorado.widget.grid.ColumnModel","package":"grid"},{"name":"tags","type":"String|String[]","desc":"对象的标签。\r<p>\r开发人员可以为一个对象定义一到多个String型的标签，以便于后面快速的查找到一个或一批具有指定标签的对象。\r</p>","alias":"dorado.AttributeSupport#attribute:tags","see":["dorado.TagManager"],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"methods":[{"name":"addColumn","type":"method","desc":"添加一个表格列。\r<p>\r此处有三种方式可用于定义表格列：\r   <ul>\r   <li>直接传入一个表格列的实例对象。</li>\r   <li>传入含表格列信息的JSON对象。<br/>\r此时可以使用子控件类型名称中\"dorado.widget.grid\"和\"Column\"之间的部分作为$type的简写。<br/>\r另外，如果没有显式的定义$type，系统也会自动判断具体的列类型。\r       <ul>\r       <li>如果JSON对像中包含columns属性的定义，那么该对象将被实例化为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.grid.ColumnGroup')\">dorado.widget.grid.ColumnGroup</A>。</li>\r       <li>其他情况下该对象将被实例化为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.grid.DataColumn')\">dorado.widget.grid.DataColumn</A>。</li>\r       </ul>\r   </li>\r   <li>传入一个字符串，系统会将此字符床识别为$type，并依次创建具体的表格列。</li>\r   </ul>\r</p>","alias":"dorado.widget.grid.ColumnModel#addColumn","see":["dorado.Toolkits.createInstance","dorado.util.KeyedList#insert"],"visibility":"public","params":[{"desc":"表格列或含表格列信息的JSON对象。","type":"dorado.widget.grid.Column|Object|String","name":"columnConfig"},{"desc":"插入模式。","type":"String","name":"insertMode","isOptional":true},{"desc":"参照表格列。","type":"dorado.widget.grid.Column","name":"refColumn","isOptional":true}],"returns":{"desc":"新插入的表格列。","type":"dorado.widget.grid.Column"},"package":"grid","memberOf":"dorado.widget.grid.ColumnModel"},{"name":"addColumns","type":"method","desc":"通过包含子列信息的JSON对象自动初始化所有子列。","alias":"dorado.widget.grid.ColumnModel#addColumns","visibility":"public","params":[{"desc":"包含子列信息的JSON对象数组。","type":"Object[]","name":"columnConfigs"}],"package":"grid","memberOf":"dorado.widget.grid.ColumnModel"},{"name":"removeColumn","type":"method","desc":"删除一个表格列。","alias":"dorado.widget.grid.ColumnModel#removeColumn","visibility":"public","params":[{"desc":"要删除的表格列。","type":"dorado.widget.grid.Column","name":"column"}],"package":"grid","memberOf":"dorado.widget.grid.ColumnModel"},{"name":"removeAllColumns","type":"method","desc":"删除所有表格列。","alias":"dorado.widget.grid.ColumnModel#removeAllColumns","visibility":"public","package":"grid","memberOf":"dorado.widget.grid.ColumnModel"},{"name":"getColumn","type":"method","desc":"根据名称返回相应的表格列。","alias":"dorado.widget.grid.ColumnModel#getColumn","visibility":"public","params":[{"desc":"表格列的名称。","type":"String","name":"name"}],"returns":{"desc":"表格列。","type":"dorado.widget.grid.Column"},"package":"grid","memberOf":"dorado.widget.grid.ColumnModel"},{"name":"findColumns","type":"method","desc":"按照列名寻找表格列（包含组合列中的子列）。","alias":"dorado.widget.grid.ColumnModel#findColumns","visibility":"public","params":[{"desc":"列名。","type":"Object","name":"name"}],"returns":{"desc":"找到的表格列的数组。","type":"dorado.widget.grid.Column[]"},"package":"grid","memberOf":"dorado.widget.grid.ColumnModel"},{"name":"getAttributeWatcher","type":"method","desc":"返回与该对象关联的属性观察者。","alias":"dorado.AttributeSupport#getAttributeWatcher","visibility":"public","returns":{"desc":"属性观察者。","type":"dorado.AttributeWatcher"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"get","type":"method","desc":"读取指定的属性值。\r<p>\r此方法还支持迭代式的属性读取，即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.AttributeSupport的实例还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r如果碰到的中间对象dorado.AttributeSupport的实例，系统会自动读取它的Attribute；\r如果碰到的中间对象是普通的JSON对象，系统会直接读取它的属性。\r</p>","alias":"dorado.AttributeSupport#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"label\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"address.postCode\"); // 迭代式的属性读取\r// 如果address的属性值是一个dorado.AttributeSupport的实例，那么此行命令的效果相当于oop.get(\"address\").get(\"postCode\")。\r// 如果address的属性值是一个JSON对象，那么此行命令的效果相当于oop.get(\"address\").postCode"}],"visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"读取到的属性值。","type":"Object"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.AttributeSupport#set","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set(\"label\", \"Sample Text\"); oop.set(\"visible\", true);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set( { label : \"Sample Text\", visible : true });"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用属性迭代的特性为子对象中的属性赋值。\roop.set(\"address.postCode\", \"7232-00124\");\r... ...\roop.set({\r\t\"name\" : \"Toad\",\r\t\"address.postCode\" : \"7232-00124\"\r});\r// 上面的两行命令相当于\roop.get(\"address\").set(\"postCode\", \"7232-00124\")"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用上文中提及的第一种方法为label属性赋值，同时为onClick事件绑定一个监听器。\roop.set({\r label : \"Sample Text\",\r onClick : function(self, arg) {\r \t... ...\r }\r});"}],"visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r           <ul>\r           <li>当attr为String时，系统会将attr的作为要设置属性名处理。属性值为value参数代表的值。</li>\r           <li>当attr为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r           注意：当通过此方式为对象设置一系列属性时，系统只会跳过那些设置出错的属性，并不会给出错误信息，也不会中断正在执行的设置操作。</li>\r           </ul>\r           <p>\r           如同<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>方法，set方法也支持对属性进行迭代式的设置。\r           即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘，直到挖掘到倒数第二个子对象时停止并记录下一个子属性名，然后对该子对象的属性进行复制操作，请参考后面的例程。\r           </p>\r           <p>\r           set方法不但可以用于为对象的属性赋值，同时也可以用于为对象中的事件添加事件监听器。\r           <ul>\r           <li>直接以事件名称作为属性，以事件监听器作为属性值，进行赋值操作。</li>\r           <li>为对象listener属性赋值，具体方法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#attribute:listener')\">dorado.EventSupport#attribute:listener</A>。</li>\r           </ul>\r           虽然上述两种方法都可以实现添加事件监听器的功能，并且第一种方法看起来更加方便易用。但第二种方法却较第一种更为灵活。\r           例如：当我们需要一次性的为同一个事件绑定多个监听器，第一种方法是不能胜任的；\r           或者我们当我们批量的设置一组属性值和事件监听器时，第二种方法总是确保事件监听器首先被绑定然后才处理该操作中剩余的属性值的赋值（在绝大多数的场景的这样的顺序是更加合理的），\r           而此时如果使用第一种方法，监听器和属性值的处理顺序是难以预知的。\r           </p>","type":"String|Object","name":"attr"},{"desc":"此参数具有多重含义：要设置的属性值。当attr为Object时，此参数将被忽略。\r           <ul>\r           <li>当attr为String时，此参数代表要设置的属性值。</li>\r           <li>当attr为Object时，此参数可代表一组执行选项，见option参数的说明。</li>\r           </ul>","type":"Object","name":"value","isOptional":true},{"desc":"执行选项。此参数仅在attr参数为Object时有效。","type":"Object","name":"options","isOptional":true},{"desc":"是否忽略未知的属性。","type":"boolean","name":"options.skipUnknownAttribute","isOptional":true,"defaultValue":"false"},{"desc":"是否在发生错误后继续尝试后续的属性设置操作。","type":"boolean","name":"options.tryNextOnError","isOptional":true,"defaultValue":"false"},{"desc":"是否组织本次赋值操作覆盖对象中原有的属性值。\r           即对于那些已拥有值(曾经通过set方法写入过值)的属性跳过本次的赋值操作，而只对那些未定义过的属性进行赋值。","type":"boolean","name":"options.preventOverwriting","isOptional":true,"defaultValue":"false"}],"returns":{"desc":"返回对象自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"doSet","type":"method","desc":"用于实现为单个属性赋值的内部方法。","alias":"dorado.AttributeSupport#doSet","visibility":"protected","params":[{"desc":"要设置的属性名。","type":"String","name":"attr"},{"desc":"属性值。","type":"Object","name":"value"},{"desc":"是否忽略未知的属性。","type":"boolean","name":"skipUnknownAttribute","isOptional":true},{"desc":null,"name":"lockWritingTimes"}],"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"hasTag","type":"method","desc":"判断对象中是否定义了某个标签值。","alias":"dorado.AttributeSupport#hasTag","visibility":"public","params":[{"desc":"要判断的标签值。","type":"String","name":"tag"}],"returns":{"desc":"是否具有该标签值。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}],"constructors":[],"events":[{"name":"onAttributeChange","type":"event","desc":"当对象中的某属性值被改变时触发的事件。","alias":"dorado.AttributeSupport#event:onAttributeChange","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"发生改变的属性名。","type":"String","name":"arg.attribute"},{"desc":"新的属性值。","type":"Object","name":"arg.value"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}]}