SYMBOLS["dorado.widget.grid.ControlCellEditor"]={"name":"ControlCellEditor","type":"class","desc":null,"alias":"dorado.widget.grid.ControlCellEditor","author":"Benny Bao (mailto:benny.bao@bstek.com)","isAbstract":true,"classDesc":"控件型的单元格编辑器的抽象类。\r<p>此类的基本作用是直接使用一个dorado控件作为具体的单元格编辑器。</p>","package":"grid","inheritsFrom":["dorado.widget.grid.CellEditor"],"inherits":["dorado.widget.grid.SimpleCellEditor"],"memberOf":"dorado.widget.grid","properties":[{"name":"grid","type":"dorado.widget.AbstractGrid","desc":"所属的表格控件。","alias":"dorado.widget.grid.CellEditor#grid","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"column","type":"dorado.widget.grid.Column","desc":"对应的表格单元列。","alias":"dorado.widget.grid.CellEditor#column","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"data","type":"dorado.Entity|Object","desc":"编辑器当前对应的数据对象。","alias":"dorado.widget.grid.CellEditor#data","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"showBorder","type":"boolean","desc":"是否要显示边框。","alias":"dorado.widget.grid.CellEditor#showBorder","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"minWidth","type":"int","desc":"最小宽度。","alias":"dorado.widget.grid.CellEditor#minWidth","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"minHeight","type":"int","desc":"最小高度。","alias":"dorado.widget.grid.CellEditor#minHeight","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"inited","type":"boolean","desc":"编辑器对应的DOM元素对象是否已初始化。","alias":"dorado.widget.grid.CellEditor#inited","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"visible","type":"boolean","desc":"编辑器是否正处于可见状态。","alias":"dorado.widget.grid.CellEditor#visible","visibility":"public","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"cachable","type":"boolean","desc":"是否启用缓存。默认为启用。\r<p>是使用后系统并不销毁该编辑器，而是将其缓存起来供同一列的其他单元格备用。\r一旦启用了此缓存功能，那么该列中的每一个单元格的编辑器都将是同一个实例。</p>","alias":"dorado.widget.grid.CellEditor#cachable","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"hideCellContent","type":"boolean","desc":"是否要在编辑过程中隐藏表格单元格中的内容。","alias":"dorado.widget.grid.CellEditor#hideCellContent","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.grid.CellEditor","package":"grid"},{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"}],"attributes":[{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true}],"methods":[{"name":"createEditorControl","type":"method","desc":"创建具体的单元格编辑器控件。","alias":"dorado.widget.grid.ControlCellEditor#createEditorControl","visibility":"public","returns":{"desc":"新创建的单元格编辑器。","type":"dorado.widget.Control"},"package":"grid","memberOf":"dorado.widget.grid.ControlCellEditor"},{"name":"setEditorControl","type":"method","desc":"设置具体的单元格编辑器控件。","alias":"dorado.widget.grid.ControlCellEditor#setEditorControl","visibility":"public","params":[{"desc":null,"type":"dorado.widget.Control","name":"editorControl"}],"package":"grid","memberOf":"dorado.widget.grid.ControlCellEditor"},{"name":"initDom","type":"method","desc":"初始化编辑器对应的DOM元素对象。","alias":"dorado.widget.grid.CellEditor#initDom","visibility":"public","params":[{"desc":"编辑器对应的DOM元素对象。","type":"HTMLElement","name":"dom"}],"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"refresh","type":"method","desc":"刷新编辑器中的内容。","alias":"dorado.widget.grid.CellEditor#refresh","visibility":"public","package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"post","type":"method","desc":"确认单元格编辑器中的修改。","alias":"dorado.widget.grid.CellEditor#post","visibility":"public","package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"createDom","type":"method","desc":"创建单元格编辑器对应的DOM对象。","alias":"dorado.widget.grid.CellEditor#createDom","visibility":"protected","returns":{"desc":"DOM对象。","type":"HTMLElement"},"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"getDom","type":"method","desc":"返回单元格编辑器对应的DOM对象。","alias":"dorado.widget.grid.CellEditor#getDom","visibility":"public","returns":{"desc":"DOM对象。","type":"HTMLElement"},"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"resize","type":"method","desc":"当单元格的尺寸发生变化是被激活的方法。","alias":"dorado.widget.grid.CellEditor#resize","visibility":"protected","package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"shouldShow","type":"method","desc":"用于告知系统某单元格当前是否可以进入编辑状态。","alias":"dorado.widget.grid.CellEditor#shouldShow","visibility":"public","params":[{"desc":"对应的表格单元格。","type":"HTMLElement","name":"cell"}],"returns":{"desc":"是否要显示编辑器。","type":"boolean"},"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"show","type":"method","desc":"显示该单元格编辑器。","alias":"dorado.widget.grid.CellEditor#show","visibility":"public","params":[{"desc":"所属的表格控件。","type":"dorado.widget.AbstractGrid","name":"parent"},{"desc":"对应的表格单元格。","type":"HTMLElement","name":"cell"}],"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"hide","type":"method","desc":"隐藏该单元格编辑器。","alias":"dorado.widget.grid.CellEditor#hide","visibility":"public","params":[{"desc":"是否要在隐藏的同时尝试确认编辑器中的修改。","type":"boolean","name":"post"}],"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"getEditorValue","type":"method","desc":"返回单元格编辑器中当前的数值。","alias":"dorado.widget.grid.CellEditor#getEditorValue","visibility":"protected","package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"beforePost","type":"method","desc":"当单元格编辑器中的修改将被确认之前激活的方法。","alias":"dorado.widget.grid.CellEditor#beforePost","visibility":"protected","params":[{"desc":null,"name":"arg"}],"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"onPost","type":"method","desc":"当单元格编辑器中的修改被确认时激活的方法。","alias":"dorado.widget.grid.CellEditor#onPost","visibility":"protected","params":[{"desc":null,"name":"arg"}],"package":"grid","memberOf":"dorado.widget.grid.CellEditor"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"}],"constructors":[],"events":[]}