SYMBOLS["dorado.widget.layout.FormLayout"]={"name":"FormLayout","type":"class","desc":null,"alias":"dorado.widget.layout.FormLayout","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"表单式布局管理器。\r<p>\r一般用于辅助表单的定义。\r在使用时可以为表单式布局指定好列数，以及每一列的宽度。然后根据控件被添加进布局管理器的顺序依次进行排列。\r同时，开发人员还可以在排列的过程中为特定的控件指定跨行或跨列的特殊规则。\r</p>\r<p>\r下图就是一个比较典型的表单式布局。注意其中的Contrl4被设定为跨两行，Control6被设定为跨两列。\r而Control8由于被设定为跨两列，而原位置的空间又不足，因此自动被安排到了下一个位置。\r</p>\r<img class=\"clip-image\" src=\"images/form-layout-1.gif\">\r<p>\rFormLayout的布局条件支持的具体子属性包括:\r<ul>\r<li>padding    -    {int} 布局区域内四周的留白的大小，像素值。</li>\r<li>colSpan    -    {int} 该区域的列跨度，即占据几列的宽度。默认值为1。</li>\r<li>rowSpan    -    {int}  该区域的行跨度，即占据几行的高度。默认值为1。</li>\r</ul>\r</p>","package":"layout","shortTypeName":"Form","inheritsFrom":["dorado.widget.layout.Layout"],"memberOf":"dorado.widget.layout","properties":[{"name":"ATTRIBUTES","type":"Object","desc":"用于声明该对象中所支持的所有Attribute。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.AttributeSupport#ATTRIBUTES","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的caption属性的声明。\rvar attributeDef = oop.ATTRIBUTES.caption。\r// 判断该属性是否只读\rif (attributeDef.readOnly) { ... ... }"}],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"},{"name":"objects","type":"dorado.AttributeSupport[]","desc":"对象数组。","alias":"dorado.AttributeSupport#objects","visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"attributes":[{"name":"cols","type":"String","desc":"表单布局的分栏方式。\r<p>\r定义分栏方式的基本格式为: 列1的宽度[列1的ClassName],列2的宽度[列2的ClassName],.....\r</p>\r<p>\r其中列的宽度既可以使用像素值，也可以使用'*'表示中充满剩余宽度。<br/>\r列的ClassName不是必须给定的信息，可以省略。如果要省略某列的ClassName，请注意一同省略'['和']'。\r</p>","alias":"dorado.widget.layout.FormLayout#attribute:cols","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 下面的例子表示将FormLayout，设置为具有两个列。\r// 其中第一列的宽度为80，并且指定第一列的布局区域全部使用label-region作为CSS ClassName。\r// 第二列的占据剩余的宽度，并且指定第二列的布局区域全部使用input-region作为CSS ClassName。\rnew dorado.widget.layout.FormLayout({\r\tcols: \"80[label-region],*[input-region]\"\r});"}],"visibility":"public","defaultValue":"\"*,*\"","memberOf":"dorado.widget.layout.FormLayout","package":"layout"},{"name":"rowHeight","type":"int","desc":"默认的行高。","alias":"dorado.widget.layout.FormLayout#attribute:rowHeight","visibility":"public","defaultValue":"22","memberOf":"dorado.widget.layout.FormLayout","package":"layout"},{"name":"colPadding","type":"int","desc":"表单列之间的留白大小。像素值。","alias":"dorado.widget.layout.FormLayout#attribute:colPadding","visibility":"public","defaultValue":"6","memberOf":"dorado.widget.layout.FormLayout","package":"layout"},{"name":"rowPadding","type":"int","desc":"表单行之间的留白大小。像素值。","alias":"dorado.widget.layout.FormLayout#attribute:rowPadding","visibility":"public","defaultValue":"6","memberOf":"dorado.widget.layout.FormLayout","package":"layout"},{"name":"stretchWidth","type":"boolean","desc":"是否将表单的宽度自动扩展为撑满容器。","alias":"dorado.widget.layout.FormLayout#attribute:stretchWidth","visibility":"public","memberOf":"dorado.widget.layout.FormLayout","package":"layout"},{"name":"padding","type":"int","desc":"四周的留白大小。像素值。","alias":"dorado.widget.layout.Layout#attribute:padding","visibility":"public","memberOf":"dorado.widget.layout.Layout","package":"widget-support"},{"name":"container","type":"dorado.widget.Container","desc":"此布局管理器所隶属的容器控件。","alias":"dorado.widget.layout.Layout#attribute:container","visibility":"public","memberOf":"dorado.widget.layout.Layout","package":"widget-support","readOnly":true},{"name":"rendered","type":"boolean","desc":"指示此控件是否已经渲染过。","alias":"dorado.widget.layout.Layout#attribute:rendered","visibility":"public","memberOf":"dorado.widget.layout.Layout","package":"widget-support","readOnly":true},{"name":"attached","type":"boolean","desc":"指示布局管理器所对应的HTML元素被真正的添加(相当于appendChild)到HTML的dom树中。","alias":"dorado.widget.layout.Layout#attribute:attached","visibility":"public","memberOf":"dorado.widget.layout.Layout","package":"widget-support","readOnly":true},{"name":"tags","type":"String|String[]","desc":"对象的标签。\r<p>\r开发人员可以为一个对象定义一到多个String型的标签，以便于后面快速的查找到一个或一批具有指定标签的对象。\r</p>","alias":"dorado.AttributeSupport#attribute:tags","see":["dorado.TagManager"],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"methods":[{"name":"createDom","type":"method","desc":"创建布局管理器对应的DOM对象。","alias":"dorado.widget.layout.Layout#createDom","visibility":"protected","returns":{"desc":"布局管理器对应的DOM对象。","type":"HTMLElement"},"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"refreshDom","type":"method","desc":"根据布局管理器自身的属性设定来刷新DOM对象。\r<p>\r此方法会在布局管理器每一次被刷新时调用，因此那些设置DOM对象的颜色、字体、尺寸的代码适合放置在此方法中。\r</p>","alias":"dorado.widget.layout.Layout#refreshDom","visibility":"protected","params":[{"desc":"布局管理器对应的DOM对象。","type":"HTMLElement","name":"dom"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"doOnControlSizeChange","type":"method","desc":"当布局区域内的控件尺寸发生改变时由外部激活的方法，供子类复写的方法。","alias":"dorado.widget.layout.Layout#doOnControlSizeChange","see":["dorado.widget.layout.Layout#onControlSizeChange"],"visibility":"protected","params":[{"desc":"尺寸发生改变的控件","type":"dorado.widget.Control","name":"control"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"onAddControl","type":"method","desc":"当有新的控件被添加到布局管理器中时被激活的方法。","alias":"dorado.widget.layout.Layout#onAddControl","see":["dorado.widget.layout.Layout#addControl"],"visibility":"protected","params":[{"desc":"要添加的控件。","type":"dorado.widget.Control","name":"control"}],"returns":{"desc":"新增的布局区域描述对象。","type":"Object"},"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"onRemoveControl","type":"method","desc":"当将要从布局管理器中移除一个子控件时被激活的方法。","alias":"dorado.widget.layout.Layout#onRemoveControl","see":["dorado.widget.layout.Layout#removeControl"],"visibility":"protected","params":[{"desc":"要移除的子控件。","type":"dorado.widget.Control","name":"control"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"doRefreshRegion","type":"method","desc":"刷新指定的布局区域，供子类复写的方法。","alias":"dorado.widget.layout.Layout#doRefreshRegion","see":["dorado.widget.layout.Layout#refreshControl"],"visibility":"protected","params":[{"desc":"要刷新的布局区域。","type":"Object","name":"region"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"getDom","type":"method","desc":"返回布局管理器对应的DOM对象。","alias":"dorado.widget.layout.Layout#getDom","visibility":"public","returns":{"desc":"布局管理器对应的DOM对象。","type":"HTMLElement"},"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"refresh","type":"method","desc":"刷新布局。","alias":"dorado.widget.layout.Layout#refresh","visibility":"public","package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"onAttachToDocument","type":"method","desc":"当布局管理器所属的容器控件被真正的添加(相当于appendChild)到HTML的dom树中时激活的方法。","alias":"dorado.widget.layout.Layout#onAttachToDocument","see":["dorado.widget.Control.onAttachToDocument"],"visibility":"public","params":[{"desc":"控件容器的DOM对象。","type":"HTMLElement","name":"containerElement"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"onDetachFromDocument","type":"method","desc":"当布局管理器所属的容器控件被从(相当于removeChild)到HTML的dom树中分离时激活的方法。","alias":"dorado.widget.layout.Layout#onDetachFromDocument","see":["dorado.widget.Control.onDetachFromDocument"],"visibility":"public","package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"getPreviousRegion","type":"method","desc":"返回指定的布局区域的前一个布局区域。","alias":"dorado.widget.layout.Layout#getPreviousRegion","visibility":"protected","params":[{"desc":"指定的布局区域。","type":"Object","name":"region"}],"returns":{"desc":"前一个布局区域。","type":"Object"},"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"getNextRegion","type":"method","desc":"返回指定的布局区域的下一个布局区域。","alias":"dorado.widget.layout.Layout#getNextRegion","visibility":"protected","params":[{"desc":"指定的布局区域。","type":"Object","name":"region"}],"returns":{"desc":"下一个布局区域。","type":"Object"},"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"addControl","type":"method","desc":"向布局管理器中添加一个控件。","alias":"dorado.widget.layout.Layout#addControl","visibility":"public","params":[{"desc":"要添加的控件。","type":"dorado.widget.Control","name":"control"},{"desc":"布局条件。","type":"Object","name":"layoutConstraint","isOptional":true}],"returns":{"desc":"新增的布局区域描述对象。","type":"Object"},"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"removeControl","type":"method","desc":"从布局管理器中移除一个子控件。","alias":"dorado.widget.layout.Layout#removeControl","visibility":"public","params":[{"desc":"要移除的子控件。","type":"dorado.widget.Control","name":"control"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"removeAllControls","type":"method","desc":"从布局管理器中移除所有子控件。","alias":"dorado.widget.layout.Layout#removeAllControls","visibility":"public","package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"disableRendering","type":"method","desc":"禁止布局管理器的自动重渲染。","alias":"dorado.widget.layout.Layout#disableRendering","visibility":"public","package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"enableRendering","type":"method","desc":"允许布局管理器的自动重渲染。","alias":"dorado.widget.layout.Layout#enableRendering","visibility":"public","package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"refreshControl","type":"method","desc":"刷新指定的控件对应的布局。\r此方法一般不应在子类中复写，如有需要子类应该复写本类中的doRefreshControl方法。","alias":"dorado.widget.layout.Layout#refreshControl","see":["dorado.widget.layout.Layout#doRefreshRegion"],"visibility":"protected","params":[{"desc":"子控件或子控件的id。","type":"doraod.widget.Control|String","name":"control"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"onResize","type":"method","desc":"当布局管理器的尺寸发生改变时激活的方法。\r此方法一般不应在子类中复写，如有需要子类应该复写本类中的doOnResize方法。","alias":"dorado.widget.layout.Layout#onResize","see":["dorado.widget.Control#onResize"],"visibility":"protected","package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"doOnResize","type":"method","desc":"当布局管理器的尺寸发生改变时激活的方法，供子类复写的方法。","alias":"dorado.widget.layout.Layout#doOnResize","see":["dorado.widget.layout.Layout#onResize","dorado.widget.Control#onResize"],"visibility":"protected","package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"onControlSizeChange","type":"method","desc":"当布局区域内的控件尺寸发生改变时由外部激活的方法。\r此方法一般不应在子类中复写，如有需要子类应该复写本类中的doOnControlSizeChange方法。","alias":"dorado.widget.layout.Layout#onControlSizeChange","visibility":"protected","params":[{"desc":"尺寸发生改变的控件","type":"dorado.widget.Control","name":"control"},{"desc":"尺寸发生改变的控件","type":"boolean","name":"delay"},{"desc":"是否强制通知父容器","type":"boolean","name":"force"}],"package":"widget-support","memberOf":"dorado.widget.layout.Layout"},{"name":"getAttributeWatcher","type":"method","desc":"返回与该对象关联的属性观察者。","alias":"dorado.AttributeSupport#getAttributeWatcher","visibility":"public","returns":{"desc":"属性观察者。","type":"dorado.AttributeWatcher"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"get","type":"method","desc":"读取指定的属性值。\r<p>\r此方法还支持迭代式的属性读取，即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br/>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.AttributeSupport的实例还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r如果碰到的中间对象dorado.AttributeSupport的实例，系统会自动读取它的Attribute；\r如果碰到的中间对象是普通的JSON对象，系统会直接读取它的属性。\r</p>","alias":"dorado.AttributeSupport#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"label\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"address.postCode\"); // 迭代式的属性读取\r// 如果address的属性值是一个dorado.AttributeSupport的实例，那么此行命令的效果相当于oop.get(\"address\").get(\"postCode\")。\r// 如果address的属性值是一个JSON对象，那么此行命令的效果相当于oop.get(\"address\").postCode"}],"visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"读取到的属性值。","type":"Object"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.AttributeSupport#set","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set(\"label\", \"Sample Text\"); oop.set(\"visible\", true);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set( { label : \"Sample Text\", visible : true });"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用属性迭代的特性为子对象中的属性赋值。\roop.set(\"address.postCode\", \"7232-00124\");\r... ...\roop.set({\r\t\"name\" : \"Toad\",\r\t\"address.postCode\" : \"7232-00124\"\r});\r// 上面的两行命令相当于\roop.get(\"address\").set(\"postCode\", \"7232-00124\")"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用上文中提及的第一种方法为label属性赋值，同时为onClick事件绑定一个监听器。\roop.set({\r label : \"Sample Text\",\r onClick : function(self, arg) {\r \t... ...\r }\r});"}],"visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r           <ul>\r           <li>当attr为String时，系统会将attr的作为要设置属性名处理。属性值为value参数代表的值。</li>\r           <li>当attr为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r           注意：当通过此方式为对象设置一系列属性时，系统只会跳过那些设置出错的属性，并不会给出错误信息，也不会中断正在执行的设置操作。</li>\r           </ul>\r           <p>\r           如同<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>方法，set方法也支持对属性进行迭代式的设置。\r           即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘，直到挖掘到倒数第二个子对象时停止并记录下一个子属性名，然后对该子对象的属性进行复制操作，请参考后面的例程。\r           </p>\r           <p>\r           set方法不但可以用于为对象的属性赋值，同时也可以用于为对象中的事件添加事件监听器。\r           <ul>\r           <li>直接以事件名称作为属性，以事件监听器作为属性值，进行赋值操作。</li>\r           <li>为对象listener属性赋值，具体方法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#attribute:listener')\">dorado.EventSupport#attribute:listener</A>。</li>\r           </ul>\r           虽然上述两种方法都可以实现添加事件监听器的功能，并且第一种方法看起来更加方便易用。但第二种方法却较第一种更为灵活。\r           例如：当我们需要一次性的为同一个事件绑定多个监听器，第一种方法是不能胜任的；\r           或者我们当我们批量的设置一组属性值和事件监听器时，第二种方法总是确保事件监听器首先被绑定然后才处理该操作中剩余的属性值的赋值（在绝大多数的场景的这样的顺序是更加合理的），\r           而此时如果使用第一种方法，监听器和属性值的处理顺序是难以预知的。\r           </p>","type":"String|Object","name":"attr"},{"desc":"此参数具有多重含义：要设置的属性值。当attr为Object时，此参数将被忽略。\r           <ul>\r           <li>当attr为String时，此参数代表要设置的属性值。</li>\r           <li>当attr为Object时，此参数可代表一组执行选项，见option参数的说明。</li>\r           </ul>","type":"Object","name":"value","isOptional":true},{"desc":"执行选项。此参数仅在attr参数为Object时有效。","type":"Object","name":"options","isOptional":true},{"desc":"是否忽略未知的属性。","type":"boolean","name":"options.skipUnknownAttribute","isOptional":true,"defaultValue":"false"},{"desc":"是否在发生错误后继续尝试后续的属性设置操作。","type":"boolean","name":"options.tryNextOnError","isOptional":true,"defaultValue":"false"},{"desc":"是否组织本次赋值操作覆盖对象中原有的属性值。\r           即对于那些已拥有值(曾经通过set方法写入过值)的属性跳过本次的赋值操作，而只对那些未定义过的属性进行赋值。","type":"boolean","name":"options.preventOverwriting","isOptional":true,"defaultValue":"false"}],"returns":{"desc":"返回对象自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"doSet","type":"method","desc":"用于实现为单个属性赋值的内部方法。","alias":"dorado.AttributeSupport#doSet","visibility":"protected","params":[{"desc":"要设置的属性名。","type":"String","name":"attr"},{"desc":"属性值。","type":"Object","name":"value"},{"desc":"是否忽略未知的属性。","type":"boolean","name":"skipUnknownAttribute","isOptional":true},{"desc":null,"name":"lockWritingTimes"}],"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"hasTag","type":"method","desc":"判断对象中是否定义了某个标签值。","alias":"dorado.AttributeSupport#hasTag","visibility":"public","params":[{"desc":"要判断的标签值。","type":"String","name":"tag"}],"returns":{"desc":"是否具有该标签值。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}],"constructors":[],"events":[{"name":"onAttributeChange","type":"event","desc":"当对象中的某属性值被改变时触发的事件。","alias":"dorado.AttributeSupport#event:onAttributeChange","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"发生改变的属性名。","type":"String","name":"arg.attribute"},{"desc":"新的属性值。","type":"Object","name":"arg.value"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}]}