SYMBOLS["dorado.widget.tree.BaseNode"]={"name":"BaseNode","type":"class","desc":null,"alias":"dorado.widget.tree.BaseNode","author":"Benny Bao (mailto:benny.bao@bstek.com)","isAbstract":true,"classDesc":"树状列表的节点。","package":"tree","inheritsFrom":["dorado.widget.ViewElement"],"inherits":["dorado.widget.tree.DataNode","dorado.widget.tree.Node"],"memberOf":"dorado.widget.tree","properties":[{"name":"EVENTS","type":"Object","desc":"用于声明该对象中所支持的所有事件。<br/>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.EventSupport#EVENTS","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的onClick事件的声明。\rvar eventDef = oop.ENENTS.onClick。"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core"}],"attributes":[{"name":"tree","type":"dorado.widget.Tree","desc":"该节点所隶属的柱状列表。","alias":"dorado.widget.tree.BaseNode#attribute:tree","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree","readOnly":true},{"name":"parent","type":"dorado.widget.tree.BaseNode","desc":"该节点所隶属父节点。","alias":"dorado.widget.tree.BaseNode#attribute:parent","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree","readOnly":true},{"name":"nodes","type":"dorado.util.KeyedArray|[Object]|[dorado.widget.tree.BaseNode]","desc":"子节点的集合。\r<p>\r此属性在读写时的意义不完全相同。\r<ul>\r<li>当读取时树状列表中的子节点集合，类型为<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.KeyedArray')\">dorado.util.KeyedArray</A>。</li>\r<li>\r当写入时用于向树状列表中添加子节点。<br/>\r传入的数据应是数组，此数组中既可以放入子节点的实例，又可以放入JSON对象。\r</li>\r</ul>\r</p>","alias":"dorado.widget.tree.BaseNode#attribute:nodes","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"firstNode","type":"dorado.widget.tree.BaseNode","desc":"返回第一个有效的子节点。","alias":"dorado.widget.tree.BaseNode#attribute:firstNode","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree","readOnly":true},{"name":"label","type":"String","desc":"节点标题文字。","alias":"dorado.widget.tree.BaseNode#attribute:label","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"icon","type":"String","desc":"节点图标URL。","alias":"dorado.widget.tree.BaseNode#attribute:icon","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"iconClass","type":"String","desc":"图标元素的CSS Class。","alias":"dorado.widget.tree.BaseNode#attribute:iconClass","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"expandedIcon","type":"String","desc":"节点展开后的图标URL。\r如果此属性未定义则直接使用icon属性中定义的图标作为展开后的图标。","alias":"dorado.widget.tree.BaseNode#attribute:expandedIcon","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"expandedIconClass","type":"String","desc":"节点展开后图标元素的CSS Class。","alias":"dorado.widget.tree.BaseNode#attribute:expandedIconClass","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"checkable","type":"boolean","desc":"该节点上是否要显示一个复选框。","alias":"dorado.widget.tree.BaseNode#attribute:checkable","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"checked","type":"Boolean","desc":"该节点上是否已被复选选中。\r<p>此属性支持3中状态：true、false、null。其中null表示半勾选状态。</p>","alias":"dorado.widget.tree.BaseNode#attribute:checked","visibility":"public","defaultValue":"false","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"autoCheckChildren","type":"boolean","desc":"是否自动根据本节点的勾选状态来维护所有子节点的勾选状态。","alias":"dorado.widget.tree.BaseNode#attribute:autoCheckChildren","visibility":"public","defaultValue":"true","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"tip","type":"String","desc":"提示信息。","alias":"dorado.widget.tree.BaseNode#attribute:tip","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"data","type":"Object","desc":"可任意设定的与该节点关联在一起的数据。","alias":"dorado.widget.tree.BaseNode#attribute:data","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"hasChild","type":"boolean","desc":"该节点是否拥有子节点。","alias":"dorado.widget.tree.BaseNode#attribute:hasChild","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"expanded","type":"boolean","desc":"该节点当前是否已展开。","alias":"dorado.widget.tree.BaseNode#attribute:expanded","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"expanding","type":"boolean","desc":"该节点当前是否正处于展开状态。\r一般而言只要当树正在等待从远端装载子节点数据时会处于此状态。","alias":"dorado.widget.tree.BaseNode#attribute:expanding","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree","readOnly":true},{"name":"visible","type":"boolean","desc":"用于判断此节点当前是否可见的属性。\r<p>\r节点是否可见主要与其父节点是否处于展开状态相关。\r另外，对于尚未被关联到树中的节点其可见状态总是false。\r</p>","alias":"dorado.widget.tree.BaseNode#attribute:visible","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree","readOnly":true},{"name":"userData","type":"Object","desc":"用户自定义数据。","alias":"dorado.widget.tree.BaseNode#attribute:userData","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree"},{"name":"level","type":"int","desc":"树节点当前所处的层数。\r<p>\r对于我们在树中可见的顶层节点，其level为1；其中的子节点的level为2。\r</p>","alias":"dorado.widget.tree.BaseNode#attribute:level","visibility":"public","memberOf":"dorado.widget.tree.BaseNode","package":"tree","readOnly":true},{"name":"id","type":"String","desc":"组件的id。","alias":"dorado.widget.ViewElement#attribute:id","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","writeBeforeReady":true},{"name":"destroyed","type":"boolean","desc":"组件当前是否已被销毁。","alias":"dorado.widget.ViewElement#attribute:destroyed","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"parentViewElement","type":"dorado.widget.ViewElement","desc":"父组件。","alias":"dorado.widget.ViewElement#attribute:parentViewElement","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"view","type":"dorado.widget.View","desc":"组件所属的视图。","alias":"dorado.widget.ViewElement#attribute:view","visibility":"public","memberOf":"dorado.widget.ViewElement","package":"widget-support","readOnly":true},{"name":"listener","type":"Object|Object[]","desc":"用于简化为对象添加监听器操作的虚拟属性，该属性不支持读取操作。\r<p>\r此属性的具有多态性：\r<ul>\r<li>当要赋的值为单个的JSON对象时，我们可以以事件名作为JSON对象的属性名，以事件方法作为属性值。\r在此JSON对象中关联一到多个事件。</li>\r<li>当要赋的值为数组时，数组中的每一个JSON对象都用于描述一个事件监听器。\r监听器的描述对象是一个可包含下列3个子属性的JSON对象：\r<ul>\r<li>name - {String} 要监听的事件名称。</li>\r<li>listener - {Function} 事件监听方法。</li>\r<li>[options] - {Object} 监听选项。见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#bind')\">dorado.EventSupport#bind</A>中的options参数的说明。</li>\r</ul>\r采用此种方式定义的目的一般是为了同时某一个事件关联多个监听器，或者为了指定事件监听器的选项。 </li>\r</ul>\r</p>\r<p>\r注意：此属性只在那些实现了<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport')\">dorado.AttributeSupport</A>接口的子类中有效。\r</p>","alias":"dorado.EventSupport#attribute:listener","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 1\roop.set(\"listener\", {\r\t onFocus: function(button) {\r\t\t ... ...\r\t },\r\t onBlur: function(button) {\r\t\t ... ...\r\t }\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// sample 2\r// 利用数组一次性定义两个监听器\roop.set(\"listener\", {\r\tonFocus: [\r\t\t{\r\t\t\tfn: function(button) {\r\t\t\t\t... ...\r\t\t\t},\r\t\t\toptions:{ once: true }\r\t\t},\r\t\tfunction: (button) {\r\t\t\t... ...\r\t\t}\r});"}],"visibility":"public","memberOf":"dorado.EventSupport","package":"core","writeOnly":true}],"methods":[{"name":"refresh","type":"method","desc":"刷新节点的显示。","alias":"dorado.widget.tree.BaseNode#refresh","visibility":"public","package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"addNode","type":"method","desc":"向节点中插入一个子节点。","alias":"dorado.widget.tree.BaseNode#addNode","see":["dorado.util.KeyedArray#insert"],"visibility":"public","params":[{"desc":"要插入的子节点。此处也可以传入描述子节点信息的JSON对象。","type":"dorado.widget.tree.BaseNode|Object","name":"data"},{"desc":"对象的插入位置或插入模式。","type":"int|String","name":"insertMode","isOptional":true},{"desc":"插入位置的参照对象。","type":"Object","name":"refData","isOptional":true}],"returns":{"desc":"新插入的树节点。","type":"dorado.widget.tree.BaseNode"},"package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"addNodes","type":"method","desc":"向节点中插入一批子节点。","alias":"dorado.widget.tree.BaseNode#addNodes","visibility":"public","params":[{"desc":"子节点数组或包含子节点信息的JSON对象数组。","type":"dorado.widget.tree.BaseNode[]|Object[]","name":"nodeConfigs"}],"package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"remove","type":"method","desc":"从父节点中删除本节点。","alias":"dorado.widget.tree.BaseNode#remove","visibility":"public","package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"clearChildren","type":"method","desc":"清除本节点的所有子节点。","alias":"dorado.widget.tree.BaseNode#clearChildren","visibility":"public","package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"doExpand","type":"method","desc":"展开节点，此方法可供子类复写。","alias":"dorado.widget.tree.BaseNode#doExpand","see":["dorado.widget.tree.BaseNode#expand"],"visibility":"protected","params":[{"desc":"回调对象。","type":"Function|Callback","name":"callback"}],"package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"doExpandAsync","type":"method","desc":"以异步处理的方式展开节点，此方法可供子类复写。","alias":"dorado.widget.tree.BaseNode#doExpandAsync","see":["dorado.widget.tree.BaseNode#expandAsync"],"visibility":"protected","params":[{"desc":"回调对象。","type":"Function|Callback","name":"callback"}],"package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"expand","type":"method","desc":"展开节点。\r<p>此方法通常不应被子类复写，如有需要子类应复写doExpand方法。</p>\r<p>此方法是以同步模式执行的，因此在通常情况下我们并不需要利用回调机制来感知展开动作是否完成。\r因此只要此方法结束展开动作事实就已经结束了，不过此时展开节点的动画效果可能并未结束。\r为了满足某些特殊场景的需求，此方法特别提供的回调参数以响应节点展开动画的结束事件。</p>","alias":"dorado.widget.tree.BaseNode#expand","see":["dorado.widget.tree.BaseNode#doExpand"],"visibility":"public","params":[{"desc":"回调对象。","type":"Function|Callback","name":"callback","isOptional":true}],"package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"expandAsync","type":"method","desc":"以异步处理的方式展开节点。\r<p>此方法通常不应被子类复写，如有需要子类应复写doExpandAsync方法。</p>","alias":"dorado.widget.tree.BaseNode#expandAsync","see":["dorado.widget.tree.BaseNode#doExpandAsync"],"visibility":"public","params":[{"desc":"回调对象。","type":"Function|Callback","name":"callback"}],"package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"doCollapse","type":"method","desc":"收起节点。此方法可供子类复写。","alias":"dorado.widget.tree.BaseNode#doCollapse","see":["dorado.widget.tree.BaseNode#collapse"],"visibility":"protected","package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"collapse","type":"method","desc":"收起节点。\r<p>此方法通常不应被子类复写，doCollapse。</p>","alias":"dorado.widget.tree.BaseNode#collapse","see":["dorado.widget.tree.BaseNode#doCollapse"],"visibility":"public","package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"highlight","type":"method","desc":"高亮树节点。","alias":"dorado.widget.tree.BaseNode#highlight","see":["dorado.widget.Tree#highlightItem"],"visibility":"public","params":[{"desc":"高亮选项。见jQuery ui相关文档中关于highlight方法的说明。","type":"Object","name":"options","isOptional":true},{"desc":"动画速度。","type":"Object","name":"speed","isOptional":true}],"package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"expandParents","type":"method","desc":"展开此节点的每一级父节点，以便于该节点可以处于可见状态。\r<p>\r此方法不负责将该节点设置为当前节点。\r</p>","alias":"dorado.widget.tree.BaseNode#expandParents","visibility":"public","package":"tree","memberOf":"dorado.widget.tree.BaseNode"},{"name":"destroy","type":"method","desc":"销毁组件。","alias":"dorado.widget.ViewElement#destroy","visibility":"public","package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"registerInnerViewElement","type":"method","desc":"将一个给定控件注册为本控件的内部控件。\r<p>\r内部控件与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container')\">dorado.widget.Container</A>中的子控件是不同的概念。\r内部控件是父控件自身的组成部分，例如RadioGroup控件本身就是由其中的一到多个RadioButton构成的。\r</p>\r<p>\rregisterInnerViewElement方法一般也不应该被外部程序调用，而是应该有控件自身的代码在createDom或refreshDom等方法中调用。\r利用registerInnerViewElement方法注册内部控件的目的是为了正确向这些控件传播系统消息，管理这些控件的状态。<br/>\r完成注册后的内部控件的parent和focusParent属性都将指向本控件。\r</p>","alias":"dorado.widget.ViewElement#registerInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"unregisterInnerViewElement","type":"method","desc":"注销一个给定的内部控件。","alias":"dorado.widget.ViewElement#unregisterInnerViewElement","visibility":"protected","params":[{"desc":"内部控件。","type":"dorado.widget.ViewElement","name":"viewElement"}],"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"addListener","type":"method","desc":"添加一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#addListener","see":["dorado.EventSupport#bind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"},{"desc":null,"name":"options"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"removeListener","type":"method","desc":"移除一个事件监听器。","deprecated":true,"alias":"dorado.EventSupport#removeListener","see":["dorado.EventSupport#unbind"],"visibility":"public","params":[{"desc":null,"name":"name"},{"desc":null,"name":"listener"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"bind","type":"method","desc":"添加一个事件监听器。","alias":"dorado.EventSupport#bind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法为添加的事件监听器定义别名，以便于在未来可以更加方便的删除该事件监听器。</p>\r<p>例如当您使用<pre>\"onClick.system\"</pre>这样的名称来绑定事件，这相当于为onClick事件定义了一个别名为system的事件监听器。\r当您想要移除该事件监听器时，只要这样调用<pre>button.unbind(\"onClick.system\")</pre>就可以了。</p>","type":"String","name":"name"},{"desc":"事件监听方法。","type":"Function","name":"listener"},{"desc":"监听选项。","type":"Object","name":"options","isOptional":true},{"desc":"事件方法脚本的宿主，即事件脚本中this的含义。如果此参数为空则表示this为触发该事件的对象。","type":"Object","name":"options.scope","isOptional":true},{"desc":"该事件是否只支持执行一次，即当事件第一次触发之后时间监听器将被自动移除。","type":"boolean","name":"options.once","isOptional":true},{"desc":"延时多少毫秒后触发。","type":"int","name":"options.delay","isOptional":true}],"returns":{"desc":"返回宿主对象自身。","type":"Object"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"unbind","type":"method","desc":"移除一个事件监听器。","alias":"dorado.EventSupport#unbind","visibility":"public","params":[{"desc":"事件名称。\r<p>此处允许您通过特殊的语法来根据别名删除某个事件监听器。</p>","type":"String","name":"name"},{"desc":"事件监听器。如果不指定此参数则表示移除该事件中的所有监听器。","type":"Function","name":"listener","isOptional":true}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"clearListeners","type":"method","desc":"清除事件中的所有事件监听器。","alias":"dorado.EventSupport#clearListeners","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"package":"core","memberOf":"dorado.EventSupport"},{"name":"disableListeners","type":"method","desc":"禁用所有事件的监听器。","alias":"dorado.EventSupport#disableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"enableListeners","type":"method","desc":"启用所有事件的监听器。","alias":"dorado.EventSupport#enableListeners","visibility":"public","package":"core","memberOf":"dorado.EventSupport"},{"name":"fireEvent","type":"method","desc":"触发一个事件。","alias":"dorado.EventSupport#fireEvent","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"},{"desc":"0到n个事件参数。","type":"Object","name":"args...","isOptional":true}],"returns":{"desc":"返回事件队列的触发过程是否正常的执行结束。","type":"boolean"},"package":"core","memberOf":"dorado.EventSupport"},{"name":"getListenerCount","type":"method","desc":"返回某事件中 已定义的事件监听器的个数。","alias":"dorado.EventSupport#getListenerCount","visibility":"public","params":[{"desc":"事件名称。","type":"String","name":"name"}],"returns":{"desc":"已定义的事件监听器的个数。","type":"int"},"package":"core","memberOf":"dorado.EventSupport"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.widget.tree.BaseNode","params":[{"desc":"配置信息。\r<p>\r此参数具有多态性。当传入的数值为String时，系统会将此参数识别为节点的文字标签。\r当我们传入的参数是一个JSON对象时，系统会自动将该JSON对象中的属性设置到节点中。\r</p>","type":"String|Object","name":"config","isOptional":true}]}],"events":[{"name":"onCreate","type":"event","desc":"当组件被创建时触发的事件。\r<p>\r与其他事件不同，onCreate事件中的this是个例外，它并不指向控件所属的View对象，而是指向$view（见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$view')\">$view</A>）。\r之所以这样是因此，该事件是在控件创建的过程中触发的，而在此时控件还没有被添加到具体的（最终的）View中。\r因此在触发此事件系统无法得知此控件应该属于哪个View。<br/>\r<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.View')\">dorado.widget.View</A>对象的onCreate事件又是这个例外规则中的例外。\r因为View对象的onCreate事件中的this总是指向自身的，因此View对象的onCreate事件与其他事件中的this并没有什么不同。\r</p>","alias":"dorado.widget.ViewElement#event:onCreate","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"},{"name":"onDestroy","type":"event","desc":"当组件被销毁时触发的事件。","alias":"dorado.widget.ViewElement#event:onDestroy","visibility":"public","params":[{"desc":"事件的发起者，即组件本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"widget-support","memberOf":"dorado.widget.ViewElement"}]}