SYMBOLS["dorado.widget.treegrid.ItemModel"]={"name":"ItemModel","type":"class","desc":null,"alias":"dorado.widget.treegrid.ItemModel","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"树状表格控件的数据模型。\r<p>用于辅助树状表格控件管理数据的对象。</p>","package":"tree-grid","inheritsFrom":["dorado.widget.list.ItemModel","dorado.widget.grid.ItemModel"],"memberOf":"dorado.widget.treegrid","properties":[],"attributes":[],"methods":[{"name":"setItemDomSize","type":"method","desc":"列表控件中每一个列表元素显示时的大小。","alias":"dorado.widget.list.ItemModel#setItemDomSize","visibility":"public","params":[{"desc":"列表元素的大小。","type":"int","name":"itemDomSize"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"getStartIndex","type":"method","desc":"返回迭代数据的起始位置。","alias":"dorado.widget.list.ItemModel#getStartIndex","see":["dorado.widget.list.ItemModel#setStartIndex"],"visibility":"public","returns":{"desc":"起始位置。","type":"int"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"setStartIndex","type":"method","desc":"列表控件的可视区域中第一个可见列表项的位置序号，即迭代数据的起始位置。此序号是从0开始计算的。","alias":"dorado.widget.list.ItemModel#setStartIndex","visibility":"public","params":[{"desc":"起始位置。","type":"int","name":"startIndex"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"isReverse","type":"method","desc":"是否要以逆向对象数据进行迭代。","alias":"dorado.widget.list.ItemModel#isReverse","visibility":"public","returns":{"desc":"是否逆向。","type":"boolean"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"setReverse","type":"method","desc":"设置是否要以逆向对象数据进行迭代。","alias":"dorado.widget.list.ItemModel#setReverse","visibility":"public","params":[{"desc":"是否逆向。","type":"boolean","name":"reverse"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"setScrollSize","type":"method","desc":"设置可视区域和滚动区域的大小。","alias":"dorado.widget.list.ItemModel#setScrollSize","visibility":"public","params":[{"desc":"可视区域的大小。","type":"int","name":"viewPortSize"},{"desc":"滚动区域的大小。","type":"int","name":"scrollSize"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"setScrollPos","type":"method","desc":"设置可视区域当前的滚动位置。","alias":"dorado.widget.list.ItemModel#setScrollPos","visibility":"public","params":[{"desc":"滚动位置。","type":"int","name":"scrollPos"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"getItems","type":"method","desc":"返回列表中要显示的数据。","alias":"dorado.widget.list.ItemModel#getItems","visibility":"public","returns":{"desc":"data 数据。","type":"Object[]|dorado.EntityList"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"setItems","type":"method","desc":"设置列表中要显示的数据。","alias":"dorado.widget.list.ItemModel#setItems","visibility":"public","params":[{"desc":"数据。","type":"Object[]|dorado.EntityList","name":"items"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"iterator","type":"method","desc":"返回一个从startIndex位置开始的数据迭代器。","alias":"dorado.widget.list.ItemModel#iterator","see":["dorado.widget.list.ItemModel#startIndex"],"visibility":"public","params":[{"desc":"起始的迭代位置。\r如果不定义此参数将从ItemModel的startIndex属性指定的位置开始迭代。","type":"int","name":"startIndex","isOptional":true}],"returns":{"desc":"数据迭代器。","type":"dorado.util.Iterator"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"getItemCount","type":"method","desc":"返回总的列表数据实体的个数。","alias":"dorado.widget.list.ItemModel#getItemCount","visibility":"public","returns":{"desc":"数据实体的个数。","type":"int"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"getItemAt","type":"method","desc":"根据传入的序号返回相应的列表数据实体，此序号是从0开始计算的。","alias":"dorado.widget.list.ItemModel#getItemAt","visibility":"public","params":[{"desc":"列表数据实体的序号。","type":"int","name":"index"}],"returns":{"desc":"数据实体。","type":"Object|dorado.Entity"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"getItemById","type":"method","desc":"根据传入的Id返回相应的列表数据实体。","alias":"dorado.widget.list.ItemModel#getItemById","visibility":"public","params":[{"desc":"数据实体的Id。","type":"String|int","name":"itemId"}],"returns":{"desc":"数据实体。","type":"Object|dorado.Entity"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"getItemIndex","type":"method","desc":"根据传入的列表数据实体返回其在整个列表中的位置序号，此序号是从0开始计算的。","alias":"dorado.widget.list.ItemModel#getItemIndex","visibility":"public","params":[{"desc":"数据实体。","type":"Object|dorado.Entity","name":"item"}],"returns":{"desc":"index 数据实体的序号。","type":"int"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"sort","type":"method","desc":"对所有数据实体进行排序。详见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.DataUtil.sort')\">dorado.DataUtil.sort</A>。","alias":"dorado.widget.list.ItemModel#sort","see":["dorado.DataUtil.sort"],"visibility":"public","params":[{"desc":"排序参数或排序参数的数组。","type":"Object|Object[]","name":"sortParams"},{"desc":"要排序的属性名。","type":"String","name":"sortParams.property"},{"desc":"是否逆向排序。","type":"boolean","name":"sortParams.desc"},{"desc":"比较器。","type":"Function","name":"comparator"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"filter","type":"method","desc":"对所有数据实体进行过滤。","alias":"dorado.widget.list.ItemModel#filter","visibility":"public","params":[{"desc":"过滤条件的数组。","type":"Object[]","name":"filterParams"},{"desc":"自定义过滤方法。","type":"Function","name":"customFilter","isOptional":true},{"desc":"要过滤的属性名。","type":"String","name":"filterParams.property"},{"desc":"比较操作符。如\"=\"、\"like\"、\">\"、\"<=\"等。","type":"String","name":"filterParams.operator"},{"desc":"过滤条件值。","type":"Object","name":"filterParams.value"},{"desc":"子过滤条件的连接方式，有\"and\"和\"or\"两种取值。\r<p>\r当此属性的值不为空时filterParams.property、filterParams.operator、filterParams.value这些子属性都将被忽略，系统会进一步处理filterParams.criterions属性。\r</p>","type":"String","name":"filterParams.junction"},{"desc":"子过滤条件数组。此参数仅在filterParams.junction不为空时有效。","type":"[Object]","name":"filterParams.filterParams"}],"package":"list-support","memberOf":"dorado.widget.list.ItemModel"},{"name":"toArray","type":"method","desc":"将列表数据模型中的数据导出到一个数组中。","alias":"dorado.widget.list.ItemModel#toArray","visibility":"public","returns":{"desc":"数据实体数组。","type":"Object[]"},"package":"list-support","memberOf":"dorado.widget.list.ItemModel"}],"constructors":[],"events":[]}