SYMBOLS["dorado.Draggable"]={"name":"Draggable","type":"class","desc":null,"alias":"dorado.Draggable","author":"Benny Bao (mailto:benny.bao@bstek.com)","see":["dorado.Droppable"],"classDesc":"可拖拽对象的通用接口。","package":"core","memberOf":"dorado","properties":[],"attributes":[{"name":"draggable","type":"boolean","desc":"是否可拖拽。","alias":"dorado.Draggable#attribute:draggable","visibility":"public","memberOf":"dorado.Draggable","package":"core"},{"name":"dragTags","type":"String|String[]","desc":"拖拽标签。\r<p>\r声明拖拽标签可用用标签数组或是以','分隔的标签字符串。\r</p>\r<p>\r当系统发现被拖拽对象的标签数组与鼠标移经的可接受拖拽对象的标签数组之间的交集不为空时，\r系统将认为被拖拽对象可以被放置到该可接受拖拽对象中。（这只是一个大致的判断，具体的运行结果还可能受相关对象的事件定义所影响。）\r</p>","alias":"dorado.Draggable#attribute:dragTags","see":["dorado.Droppable#attribute:droppableTags"],"visibility":"public","memberOf":"dorado.Draggable","package":"core"}],"methods":[{"name":"getDraggableOptions","type":"method","desc":"返回当系统将此对象初始化为可拖拽对象时将要传递给<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('jQuery.draggable')\">jQuery.draggable</A>方法的options参数。","alias":"dorado.Draggable#getDraggableOptions","visibility":"protected","params":[{"desc":"将要初始化的HTMLElement。","type":"HTMLElement","name":"dom"}],"package":"core","memberOf":"dorado.Draggable"},{"name":"createDraggingInfo","type":"method","desc":"创建当此对象进入被拖拽状态后与之相关联的拖拽信息对象。","alias":"dorado.Draggable#createDraggingInfo","visibility":"protected","params":[{"desc":"将要拖拽的HTMLElement。","type":"HTMLElement","name":"dom"},{"desc":"传递给<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('jQuery.draggable')\">jQuery.draggable</A>方法的options参数。\rreturn {dorado.DraggingInfo} 拖拽信息对象。","type":"Object","name":"dom"}],"package":"core","memberOf":"dorado.Draggable"},{"name":"initDraggingInfo","type":"method","desc":"初始化给定的拖拽信息对象。","alias":"dorado.Draggable#initDraggingInfo","visibility":"protected","params":[{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"evt"}],"package":"core","memberOf":"dorado.Draggable"},{"name":"initDraggingIndicator","type":"method","desc":"初始化给定的拖拽光标对象。","alias":"dorado.Draggable#initDraggingIndicator","visibility":"protected","params":[{"desc":"拖拽光标对象。","type":"dorado.DraggingIndicator|HTMLElement","name":"indicator"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"evt"}],"package":"core","memberOf":"dorado.Draggable"}],"constructors":[],"events":[{"name":"onGetDraggingIndicator","type":"event","desc":"当此对象开始进入拖拽状态之初，系统尝试相应的拖拽指示光标时触发的事件。","alias":"dorado.Draggable#event:onGetDraggingIndicator","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"系统将要使用的默认拖拽指示光标。\r<p>\r您可以直接修改此光标对象，也可以用新的实例替换掉此光标。甚至可以返回一个自己创建好的HTMLElement作用拖拽光标。\r</p>","type":"dorado.DraggingIndicator|HTMLElement","name":"arg.indicator","writeable":true},{"desc":"系统Event对象。","type":"Event","name":"arg.event"},{"desc":"被拖拽对象对应的HTMLElement。","type":"HTMLElement","name":"arg.draggableElement"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"},{"name":"onDragStart","type":"event","desc":"当此对象将要进入拖拽状态时触发的事件。","alias":"dorado.Draggable#event:onDragStart","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"},{"desc":"用于通知系统是否要继续完成后续动作。\r即返回true表示允许此对象开始被拖拽，返回false则禁止此对象被拖拽。","type":"boolean","name":"arg.processDefault=true","writeable":true}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"},{"name":"onDragStop","type":"event","desc":"当此对象的拖拽操作结束时触发的事件。\r拖拽对象被成功的放置或拖拽操作被取消时都会触发此事件。","alias":"dorado.Draggable#event:onDragStop","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"},{"name":"onDragMove","type":"event","desc":"当此对象被拖动时触发的事件。\r即当此对象处于被拖拽状态时伴随着鼠标的移动系统会不停的触发此事件。","alias":"dorado.Draggable#event:onDragMove","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"拖拽信息对象。","type":"dorado.DraggingInfo","name":"arg.draggingInfo"},{"desc":"系统Event对象。","type":"Event","name":"arg.event"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.Draggable"}]}