SYMBOLS["dorado.RenderableElement"]={"name":"RenderableElement","type":"class","desc":null,"alias":"dorado.RenderableElement","author":"Benny Bao (mailto:benny.bao@bstek.com)","isAbstract":true,"classDesc":"可渲染对象的通用接口。","package":"core","inheritsFrom":["dorado.AttributeSupport"],"inherits":["dorado.DraggingIndicator"],"memberOf":"dorado","properties":[{"name":"ATTRIBUTES","type":"Object","desc":"用于声明该对象中所支持的所有Attribute。<br>\r此属性中的对象一般由dorado系统自动生成，且往往一个类型的所有实例都共享同一个EVENTS对象。\r因此，如无特殊需要，我们不应该在运行时手动的修改此对象中的内容。","alias":"dorado.AttributeSupport#ATTRIBUTES","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 获取某对象的caption属性的声明。\rvar attributeDef = oop.ATTRIBUTES.caption。\r// 判断该属性是否只读\rif (attributeDef.readOnly) { ... ... }"}],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"attributes":[{"name":"className","type":"String","desc":"CSS类名。","alias":"dorado.RenderableElement#attribute:className","visibility":"public","memberOf":"dorado.RenderableElement","package":"core"},{"name":"exClassName","type":"String","desc":"扩展CSS类名。","alias":"dorado.RenderableElement#attribute:exClassName","visibility":"public","memberOf":"dorado.RenderableElement","package":"core"},{"name":"width","type":"int","desc":"宽度。","alias":"dorado.RenderableElement#attribute:width","visibility":"public","memberOf":"dorado.RenderableElement","package":"core"},{"name":"height","type":"int","desc":"高度。","alias":"dorado.RenderableElement#attribute:height","visibility":"public","memberOf":"dorado.RenderableElement","package":"core"},{"name":"style","type":"Object|String","desc":"用于简化DOM元素style属性设置过程的虚拟属性。\r此处用于赋值给style属性的对象是一个结构与HTMLElement的style相似的JavaScript对象。","alias":"dorado.RenderableElement#attribute:style","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 当我们需要为DOM元素指定背景色和字体颜色时可以使用这样的style\rrenderable.set(\"style\", {\r\tcolor : \"yellow\",\r\tbackgroundColor : \"blue\"\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"renderable.set(\"style\", \"color: yellow; background-color: blue\");"}],"visibility":"public","memberOf":"dorado.RenderableElement","package":"core"},{"name":"rendered","type":"boolean","desc":"指示此对象是否已经渲染过。","alias":"dorado.RenderableElement#attribute:rendered","visibility":"public","memberOf":"dorado.RenderableElement","package":"core","readOnly":true},{"name":"tags","type":"String|String[]","desc":"对象的标签。\r<p>\r开发人员可以为一个对象定义一到多个String型的标签，以便于后面快速的查找到一个或一批具有指定标签的对象。\r</p>","alias":"dorado.AttributeSupport#attribute:tags","see":["dorado.TagManager"],"visibility":"public","memberOf":"dorado.AttributeSupport","package":"core"}],"methods":[{"name":"createDom","type":"method","desc":"创建对象对应的DOM元素。\r<p>\r此方法只会在对象第一次渲染时执行一次。 所以一般而言，不应该在此放置初始化DOM元素的代码。例如那些设置DOM元素的颜色、字体、尺寸的代码。\r而那些而DOM元素绑定事件监听器的代码则适合放置在此方法中。\r</p>","alias":"dorado.RenderableElement#createDom","visibility":"public","returns":{"desc":"新创建的DOM元素。","type":"HTMLElement"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"refreshDom","type":"method","desc":"根据对象自身的属性设定来刷新DOM元素。\r<p>\r此方法会在对象每一次被刷新时调用，因此那些设置DOM元素的颜色、字体、尺寸的代码适合放置在此方法中。\r</p>","alias":"dorado.RenderableElement#refreshDom","visibility":"public","params":[{"desc":"对应的DOM元素。","type":"HTMLElement","name":"dom"}],"package":"core","memberOf":"dorado.RenderableElement"},{"name":"resetDimension","type":"method","desc":"重设对象的尺寸。","alias":"dorado.RenderableElement#resetDimension","visibility":"protected","params":[{"desc":"是否强制重设对象的尺寸，忽略对于宽高值是否发生过改变的判断。","type":"boolean","name":"forced","isOptional":true}],"returns":{"desc":"本次操作是否改变了对象的尺寸设置。","type":"boolean"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"getRealWidth","type":"method","desc":"获得渲染时实际应该采用的宽度值。\r<p>\r通过width属性设置的宽度值并不总是该对象实际渲染时所使用的值，实际的宽度常常会受布局管理器或其他类似的功能控制。\r此方法的作用就是返回渲染时实际应该采用的宽度值。\r</p>","alias":"dorado.RenderableElement#getRealWidth","visibility":"public","returns":{"desc":"宽度。","type":"int|String"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"getRealHeight","type":"method","desc":"获得渲染时实际应该采用的高度值。\r<p>\r通过width属性设置的高度值并不总是该对象实际渲染时所使用的值，实际的高度常常会受布局管理器或其他类似的功能控制。\r此方法的作用就是返回渲染时实际应该采用的高度值。\r</p>","alias":"dorado.RenderableElement#getRealHeight","visibility":"public","returns":{"desc":"宽度。","type":"int|String"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"getDom","type":"method","desc":"返回对象对应的DOM元素。","alias":"dorado.RenderableElement#getDom","visibility":"public","returns":{"desc":"控件对应的DOM元素。","type":"HTMLElement"},"package":"core","memberOf":"dorado.RenderableElement"},{"name":"render","type":"method","desc":"将本对象渲染到指定的DOM容器中。","alias":"dorado.RenderableElement#render","visibility":"public","params":[{"desc":"作为容器的DOM元素。如果此参数为空，将以document.body作为容器。","type":"HTMLElement","name":"containerElement"},{"desc":"指定新的DOM元素要在那个子元素之前插入，即通过此参数可以指定新的DOM元素的插入位置。","type":"HTMLElement","name":"nextChildElement","isOptional":true}],"package":"core","memberOf":"dorado.RenderableElement"},{"name":"replace","type":"method","desc":"本对象并替换指定的DOM对象。","alias":"dorado.RenderableElement#replace","visibility":"public","params":[{"desc":"要替换的DOM对象。","type":"HTMLElement","name":"elmenent"}],"package":"core","memberOf":"dorado.RenderableElement"},{"name":"unrender","type":"method","desc":"将对象的DOM节点从其父节点中移除。","alias":"dorado.RenderableElement#unrender","visibility":"public","package":"core","memberOf":"dorado.RenderableElement"},{"name":"refresh","type":"method","desc":"刷新此对象的显示。","alias":"dorado.RenderableElement#refresh","visibility":"public","params":[{"desc":"是否允许此次refresh动作延时执行。设置成true有利于系统对refresh动作进行优化处理。","type":"boolean","name":"delay"}],"package":"core","memberOf":"dorado.RenderableElement"},{"name":"getAttributeWatcher","type":"method","desc":"返回与该对象关联的属性观察者。","alias":"dorado.AttributeSupport#getAttributeWatcher","visibility":"public","returns":{"desc":"属性观察者。","type":"dorado.AttributeWatcher"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"get","type":"method","desc":"读取指定的属性值。\r<p>\r此方法还支持迭代式的属性读取，即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘并返回最终结果。<br>\r当进行迭代式的读取时，系统会自动判断前一个属性返回的对象是dorado.AttributeSupport的实例还是普通JSON对象，并藉此决定如何进一步执行读取操作。\r如果碰到的中间对象dorado.AttributeSupport的实例，系统会自动读取它的Attribute；\r如果碰到的中间对象是普通的JSON对象，系统会直接读取它的属性。\r</p>","alias":"dorado.AttributeSupport#get","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"label\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.get(\"address.postCode\");\t// 迭代式的属性读取\t\r// 如果address的属性值是一个dorado.AttributeSupport的实例，那么此行命令的效果相当于oop.get(\"address\").get(\"postCode\")。\r// 如果address的属性值是一个JSON对象，那么此行命令的效果相当于oop.get(\"address\").postCode"}],"visibility":"public","params":[{"desc":"属性名。","type":"String","name":"attr"}],"returns":{"desc":"读取到的属性值。","type":"Object"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"set","type":"method","desc":"设置属性值。","alias":"dorado.AttributeSupport#set","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set(\"label\", \"Sample Text\");\roop.set(\"visible\", true);"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"oop.set( {\r\t label : \"Sample Text\",\r\t visible : true\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用属性迭代的特性为子对象中的属性赋值。\roop.set(\"address.postCode\", \"7232-00124\");\r... ...\roop.set( {\r\t \"name\" : \"Toad\",\r\t \"address.postCode\" : \"7232-00124\"\r});\r// 上面的两行命令相当于oop.get(\"address\").set(\"postCode\", \"7232-00124\")"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 使用上文中提及的第一种方法为label属性赋值，同时为click事件绑定一个监听器。\roop.set( {\r\tlabel : \"Sample Text\",\r\tonClick : function(self, arg) {\r\t\t... ...\r\t}\r});"}],"visibility":"public","params":[{"desc":"此参数具有下列两种设置方式：\r<ul>\r<li>当attr为String时，系统会将attr的作为要设置属性名处理。属性值为value参数代表的值。</li>\r<li>当attr为Object时，系统会将忽略value参数。此时，可以通过attr参数的JSON对象定义一组要设置的属性值。\r注意：当通过此方式为对象设置一系列属性时，系统只会跳过那些设置出错的属性，并不会给出错误信息，也不会中断正在执行的设置操作。</li>\r</ul>\r<p>\r如同<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.AttributeSupport#get')\">dorado.AttributeSupport#get</A>方法，set方法也支持对属性进行迭代式的设置。\r即通过\".\"来分割一组属性名，交由此方法一层层向下挖掘，直到挖掘到倒数第二个子对象时停止并记录下一个子属性名，然后对该子对象的属性进行复制操作，请参考后面的例程。\r</p>\r<p>\rset方法不但可以用于为对象的属性赋值，同时也可以用于为对象中的事件添加事件监听器。\r<ul>\r<li>直接以事件名称作为属性，以事件监听器作为属性值，进行赋值操作。</li>\r<li>为对象listener属性赋值，具体方法请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.EventSupport#attribute:listener')\">dorado.EventSupport#attribute:listener</A>。</li>\r</ul>\r虽然上述两种方法都可以实现添加事件监听器的功能，并且第一种方法看起来更加方便易用。但第二种方法却较第一种更为灵活。\r例如：当我们需要一次性的为同一个事件绑定多个监听器，第一种方法是不能胜任的；\r或者我们当我们批量的设置一组属性值和事件监听器时，第二种方法总是确保事件监听器首先被绑定然后才处理该操作中剩余的属性值的赋值（在绝大多数的场景的这样的顺序是更加合理的），\r而此时如果使用第一种方法，监听器和属性值的处理顺序是难以预知的。\r</p>","type":"String|Object","name":"attr"},{"desc":"此参数具有多重含义：要设置的属性值。当attr为Object时，此参数将被忽略。\r<ul>\r<li>当attr为String时，此参数代表要设置的属性值。</li>\r<li>当attr为Object时，此参数可代表一组执行选项，见option参数的说明。</li>\r</ul>","type":"Object","name":"value","isOptional":true},{"desc":"执行选项。此参数仅在attr参数为Object时有效。","type":"Object","name":"options","isOptional":true},{"desc":"是否忽略未知的属性。","type":"boolean","name":"options.skipUnknownAttribute","isOptional":true,"defaultValue":"false"},{"desc":"是否在发生错误后继续尝试后续的属性设置操作。","type":"boolean","name":"options.tryNextOnError","isOptional":true,"defaultValue":"false"},{"desc":"是否组织本次赋值操作覆盖对象中原有的属性值。\r即对于那些已拥有值(曾经通过set方法写入过值)的属性跳过本次的赋值操作，而只对那些未定义过的属性进行赋值。","type":"boolean","name":"options.preventOverwriting","isOptional":true,"defaultValue":"false"}],"returns":{"desc":"返回对象自身。","type":"dorado.AttributeSupport"},"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"doSet","type":"method","desc":"用于实现为单个属性赋值的内部方法。","alias":"dorado.AttributeSupport#doSet","visibility":"protected","params":[{"desc":"要设置的属性名。","type":"String","name":"attr"},{"desc":"属性值。","type":"Object","name":"value"},{"desc":"是否忽略未知的属性。","type":"boolean","name":"skipUnknownAttribute","isOptional":true},{"desc":null,"name":"lockWritingTimes"}],"package":"core","memberOf":"dorado.AttributeSupport"},{"name":"hasTag","type":"method","desc":"判断对象中是否定义了某个标签值。","alias":"dorado.AttributeSupport#hasTag","visibility":"public","params":[{"desc":"要判断的标签值。","type":"String","name":"tag"}],"returns":{"desc":"是否具有该标签值。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}],"constructors":[],"events":[{"name":"onAttributeChange","type":"event","desc":"当对象中的某属性值被改变时触发的事件。","alias":"dorado.AttributeSupport#event:onAttributeChange","visibility":"public","params":[{"desc":"事件的发起者，即对象本身。","type":"Object","name":"self"},{"desc":"事件参数。","type":"Object","name":"arg"},{"desc":"发生改变的属性名。","type":"String","name":"arg.attribute"},{"desc":"新的属性值。","type":"Object","name":"arg.value"}],"returns":{"desc":"是否要继续后续事件的触发操作，不提供返回值时系统将按照返回值为true进行处理。","type":"boolean"},"package":"core","memberOf":"dorado.AttributeSupport"}]}