SYMBOLS["dorado.Toolkits"]={"name":"Toolkits","type":"object","desc":null,"alias":"dorado.Toolkits","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"工具方法集。","package":"core","memberOf":"dorado","properties":[{"name":"URL_VARS","type":"property","desc":"用于注册URL预设变量的JSON对象。","alias":"dorado.Toolkits.URL_VARS","see":["dorado.Toolkits.translateURL","$url"],"visibility":"public","isStatic":true,"memberOf":"dorado.Toolkits","package":"core"}],"attributes":[],"methods":[{"name":"registerPrototype","type":"method","desc":"向系统中注册一个类型的简写名。\r<p>\r此注册的目的是为了将一种对象类型跟一个简写名关联起来，简化创建对象的操作。<br>\r例如用户可以直接通过JSON对象中的$type属性指定该JSON对象最终应被实例化成哪种类型的实例。\r见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Toolkits.createInstance')\">dorado.Toolkits.createInstance</A>。\r</p>\r<p>\rdorado并不要求所有支持此种简化创建过程的类型都必须通过此方法注册到系统中。\r事实上，对于大多数的类而言系统都支持根据一定的规则自动确定其类型简写名。\r具体的缩写规则由各处的处理代码自行决定，例如<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.widget.Container#attribute:children')\">dorado.widget.Container#attribute:children</A>。\r</p>","alias":"dorado.Toolkits.registerPrototype","see":["dorado.Toolkits.createInstance"],"visibility":"public","params":[{"desc":"命名空间。","type":"String","name":"namespace"},{"desc":"类型名简写。此参数支持下列两种定义方式：\r<ul>\r<li>传入一个String代表类型名简写。</li>\r<li>传入一个JSON对象表示要一次性的注册一组类型。\r此时系统将忽略type参数，并将此JSON对象中的属性名认作类型名简写，属性值认作要注册的对象类型。</li>\r</ul>","type":"String|Object","name":"name"},{"desc":"对象的构造函数。","type":"Prototype","name":"constr"}],"package":"core","isStatic":true,"memberOf":"dorado.Toolkits"},{"name":"getPrototype","type":"method","desc":"根据传入的类型简写名返回匹配的对象的构造函数。","alias":"dorado.Toolkits.getPrototype","visibility":"public","params":[{"desc":"命名空间。\r此处可以定义多个命名空间，以\",\"隔开，表示依次在这些命名空间寻找注册的类型。","type":"String","name":"namespace"},{"desc":"类型名简写。","type":"String|Object","name":"name"}],"returns":{"desc":"对象的构造函数。","type":"Prototype"},"package":"core","isStatic":true,"memberOf":"dorado.Toolkits"},{"name":"createInstance","type":"method","desc":"此方法用于根据JSON配置对象中的$type属性指定的对象类型来实例化一个新的对象。\r<p>\r在具体的执行过程中首先根据{$link dorado.Toolkits.registerPrototype}注册的简写名来识别$type。<br>\r如果上面的步骤未能找到匹配项，则开始根据typeTranslator中定义的规则继续尝试识别$type。<br>\r如果通过typeTranslator中定义的规则仍未能找到匹配项，那么此方法会将$type当作对象类型的全名进行识别。\r</p>","alias":"dorado.Toolkits.createInstance","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 根据JSON配置创建一个Button对象。\rvar button = dorado.Toolkits.createInstance(\"widget\", {\r\t$type: \"dorado.widget.Button\",\r\tid: \"button1\",\r\tcaption: \"TestButton\"\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用typeTranslator参数，简化$type属性中的定义。\rvar button = dorado.Toolkits.createInstance(\"widget\", {\r\t$type: \"Button\",\r\tid: \"button1\",\r\tcaption: \"TestButton\"\r}, function(type) {\r\tswitch (type) {\r\t\tcase \"Panel\": return dorado.widget.Panel;\r\t\tcase \"Button\": return dorado.widget.Button;\r\t\tcase \"Input\": return dorado.widget.TextEditor;\r\t\tdefault: return dorado.widget.Control;\r\t}\r});"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 利用typeTranslator参数，简化$type属性中的定义。\rvar button = dorado.Toolkits.createInstance(\"widget\", {\r\t$type: \"Button\",\r\tid: \"button1\",\r\tcaption: \"TestButton\"\r}, \"dorado.widget.\");"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 直接传入一个String作为$type的值。\rvar button = dorado.Toolkits.createInstance(\"widget\", \"Button\");"}],"see":["dorado.Toolkits.registerPrototype"],"visibility":"public","params":[{"desc":"命名空间。\r此处可以定义多个命名空间，以\",\"隔开，表示依次在这些命名空间寻找注册的类型。","type":"String","name":"namespace"},{"desc":"JSON配置对象。\r<ul>\r<li>当参数类型为Object时表示JSON配置对象。</li>\r<li>当参数类型为String时表示$type的值。</li>\r<li></li>\r</ul>","type":"Object|String","name":"config"},{"desc":"此参数有两种定义形式：\r<ul>\r<li>当参数类型为Function时表示用于将$type的值转换为具体对象类型的回调函数。</li>\r<li>当参数类型为String时表示对象类型名的前缀。在运行时附加到$type属性之前形成完整的对象名称。</li>\r<li></li>\r</ul>\r对象类型名的前缀。在运行时附加到$type属性之前形成完整的对象名称。","type":"Function|String","name":"typeTranslator","isOptional":true}],"returns":{"desc":"创建得到的新对象。","type":"Object"},"package":"core","isStatic":true,"memberOf":"dorado.Toolkits"},{"name":"translateURL","type":"method","desc":"将一段给定URL转换为最终的可以使用的URL。\r<p>\r此方法允许用户在定义一个URL时利用\">\"在URL中植入特定的内容。<br>\r例如：\">images/loading.gif\"表示应用的根路径下的\"images/loading.gif\"。\r如果此时应用的根路径是\"/sampleApp\"，那么此方法最终返回的URL将是\"/sampleApp/images/loading.gif\"。（应用的根路径通过<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('$setting')\">$setting</A>中的\"common.contextPath\"项设定）\r</p>\r<p>\r另外，此方法还支持在URL中植入预设变量。<br>\r例如：\">skin>button.css\"表示系统当前皮肤根路径中的button.css。其中的\">skin>\"就代表一个名为skin的预设变量。此方法会将预设变量的值替换的URL中。<br>\r假设skin变量的值为\"/sampleApp/skins/nature/\"，那么上述URL的最终转换结果为\"/sampleApp/skins/nature/button.css\"。\r</p>\r<p>\r此方法中使用的预设变量都需要注册在<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Toolkits.URL_VARS')\">dorado.Toolkits.URL_VARS</A>中，系统默认情况下只提供一个名为skin的预设变量。开发人员可以根据自己的需要向URL_VARS中注册自己的预设变量。\r</p>","alias":"dorado.Toolkits.translateURL","see":["$url","dorado.Toolkits.URL_VARS"],"visibility":"public","params":[{"desc":"要转换的URL。","type":"String","name":"url"}],"returns":{"desc":"转换后得到的URL。","type":"String"},"package":"core","isStatic":true,"memberOf":"dorado.Toolkits"}],"constructors":[],"events":[]}