SYMBOLS["dorado.util.AjaxResult"]={"name":"AjaxResult","type":"class","desc":"构造器。","alias":"dorado.util.AjaxResult","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"用于封装Ajax请求(包含同步请求)返回结果的对象。","package":"core","memberOf":"dorado.util","properties":[{"name":"options","type":"Object","desc":"发起请求时使用的请求选项。","alias":"dorado.util.AjaxResult#options","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"success","type":"boolean","desc":"Ajax请求是否执行成功。","alias":"dorado.util.AjaxResult#success","visibility":"public","defaultValue":"true","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"url","type":"String","desc":"请求的URL。","alias":"dorado.util.AjaxResult#url","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"method","type":"String","desc":"发起请求时使用的HttpMethod。","alias":"dorado.util.AjaxResult#method","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"status","type":"int","desc":"服务器返回的Http状态码。<br>\r如：200表示正常返回、404表示请求的资源不存在等，详情请参考Http协议说明。","alias":"dorado.util.AjaxResult#status","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"statusText","type":"String","desc":"服务器返回的Http状态描述。<br>\r如：OK表示正常返回、NOT_MODIFIED表示资源未发生任何改变等，详情请参考Http协议说明。","alias":"dorado.util.AjaxResult#statusText","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"allResponseHeaders","type":"String","desc":"包含所有的Response头信息的字符串。<br>\r其格式为：header1=value1;header2=value2;...","alias":"dorado.util.AjaxResult#allResponseHeaders","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"text","type":"String","desc":"服务器返回的原始文本信息。","alias":"dorado.util.AjaxResult#text","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"},{"name":"exception","type":"Error","desc":"请求过程中发生的异常。","alias":"dorado.util.AjaxResult#exception","visibility":"public","memberOf":"dorado.util.AjaxResult","package":"core"}],"attributes":[],"methods":[{"name":"getResponseHeaders","type":"method","desc":"返回一个包含所有的Response头信息的对象。<br>\r所有的Response头信息以属性的形式存放在该对象中，其形式如下：<br>\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\r{\r\t \"content-type\": \"text/xml\",\r\t \"header1\": \"value1\",\r\t \"header2\": \"value2\",\r\t ... ... ...\r}\r</code>\r</pre>","alias":"dorado.util.AjaxResult#getResponseHeaders","visibility":"public","returns":{"desc":"包含所有的Response头信息的对象。","type":"Object"},"package":"core","memberOf":"dorado.util.AjaxResult"},{"name":"getXmlDocument","type":"method","desc":"以XmlDocument的形式获得服务器返回的Response信息。","alias":"dorado.util.AjaxResult#getXmlDocument","visibility":"public","returns":{"desc":"XmlDocument。","type":"XMLDocument"},"package":"core","memberOf":"dorado.util.AjaxResult"},{"name":"getJsonData","type":"method","desc":"以JSON数据的形式获得服务器返回的Response信息。","alias":"dorado.util.AjaxResult#getJsonData","visibility":"public","params":[{"desc":"服务器返回的Response信息是否是不可信的。默认为false，即Response信息是可信的。<br>\r此参数将决定dorado通过何种方式来解析服务端返回的JSON字符串，为了防止某些嵌入在JSON字符串中的黑客代码对应用造成伤害，\rdorado可以使用安全的方式来解析JSON字符串，但是这种安全检查会带来额外的性能损失。\r因此，如果您能够确定访问的服务器是安全的，其返回的JSON字符串不会嵌入黑客代码，那么就不必开启此选项。","type":"boolean","name":"untrusty","isOptional":true}],"returns":{"desc":"JSON数据。","type":"Object"},"package":"core","memberOf":"dorado.util.AjaxResult"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.util.AjaxResult","params":[{"desc":"发起请求时使用的请求选项。","type":"Object","name":"options"},{"desc":"用于实现远程访问的XMLHttpRequest对象。","type":"XMLHttpRequest","name":"connObj","isOptional":true}]}],"events":[]}