SYMBOLS["dorado.util.KeyedList"]={"name":"KeyedList","type":"class","desc":null,"alias":"dorado.util.KeyedList","author":"Benny Bao (mailto:benny.bao@bstek.com)","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var keyedList = new dorado.util.KeyedList();"},{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"var keyedList = new dorado.util.KeyedList( function(obj) {\r\t \t// 此处的参数obj为数组中的某个元素，返回值为与该元素匹配的键值。\r\t\treturn obj.id;\r\t });"}],"classDesc":"键值对集合，即支持通过键值对元素进行快速定位的集合。\r该集合的本质是一个双向链表，集合中的元素都被封装在一个个的链表元素中，链表元素对象包含下列子属性：\r<ul>\r<li>data - 该链表元素中封装的对象。</li>\r<li>previous - 该链表元素的前一个链表元素。</li>\r<li>next - 该链表元素的下一个链表元素。</li>\r</ul>","package":"core","memberOf":"dorado.util","properties":[{"name":"first","type":"Object","desc":"链表中的第一个元素。","alias":"dorado.util.KeyedList#first","visibility":"public","memberOf":"dorado.util.KeyedList","package":"core"},{"name":"last","type":"Object","desc":"链表中的最后一个元素。","alias":"dorado.util.KeyedList#last","visibility":"public","memberOf":"dorado.util.KeyedList","package":"core"},{"name":"size","type":"int","desc":"集合的大小，即集合中的元素个数。","alias":"dorado.util.KeyedList#size","visibility":"public","memberOf":"dorado.util.KeyedList","package":"core"}],"attributes":[],"methods":[{"name":"insert","type":"method","desc":"向集合中插入一个对象。","alias":"dorado.util.KeyedList#insert","visibility":"public","params":[{"desc":"要插入的对象。","type":"Object","name":"data"},{"desc":"插入方式，包含下列四种取值：\r<ul>\r<li>begin - 在链表的起始位置插入。</li>\r<li>before - 在refData参数指定的参照对象之前插入。</li>\r<li>after - 在refData参数指定的参照对象之后插入。</li>\r<li>end - 在链表的末尾插入。</li>\r</ul>","type":"String","name":"insertMode","isOptional":true},{"desc":"插入位置的参照对象。","type":"Object","name":"refData","isOptional":true}],"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"append","type":"method","desc":"向集合中追加一个对象。","alias":"dorado.util.KeyedList#append","visibility":"public","params":[{"desc":"要集合的对象。","type":"Object","name":"data"}],"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"remove","type":"method","desc":"从集合中移除一个对象。","alias":"dorado.util.KeyedList#remove","visibility":"public","params":[{"desc":"要移除的对象。","type":"Object","name":"data"}],"returns":{"desc":"是否成功的移除了对象。","type":"boolean"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"removeKey","type":"method","desc":"根据传入的键值从集合中移除匹配的对象。","alias":"dorado.util.KeyedList#removeKey","visibility":"public","params":[{"desc":"键值。","type":"String","name":"key"}],"returns":{"desc":"被移除的匹配的对象。","type":"Object"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"get","type":"method","desc":"根据传入的键值返回匹配的对象。","alias":"dorado.util.KeyedList#get","visibility":"public","params":[{"desc":"键值。","type":"String","name":"key"}],"returns":{"desc":"匹配的对象。","type":"Object"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"clear","type":"method","desc":"清除集合中的所有对象。","alias":"dorado.util.KeyedList#clear","visibility":"public","package":"core","memberOf":"dorado.util.KeyedList"},{"name":"iterator","type":"method","desc":"返回键值对集合的迭代器。","alias":"dorado.util.KeyedList#iterator","visibility":"public","params":[{"desc":"从哪一个元素所在的位置开始迭代。迭代时不包含传入的元素，而是从该元素的上一个或下一个开始。","type":"Object","name":"from","isOptional":true}],"returns":{"desc":"键值对集合的迭代器。","type":"dorado.util.KeyedListIterator"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"each","type":"method","desc":"针对集合的每一个元素执行指定的函数。此方法可用于替代对集合的遍历代码，示例如下：","alias":"dorado.util.KeyedList#each","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 将每一个集合元素的name属性连接成为一个字符串。\rvar names = \"\";\rvar keyedList = new dorado.util.KeyedList();\r... ... ...\rkeyedList.each(function(obj){\r\t names += obj.name;\r});"}],"visibility":"public","params":[{"desc":"针对每一个元素执行的函数","type":"Function","name":"fn"},{"desc":"函数脚本的宿主，即函数脚本中this的含义。如果此参数为空则表示this为集合中的某个对象。","type":"Object","name":"scope","isOptional":true}],"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"toArray","type":"method","desc":"将集成从所有的对象导出至一个数组中。","alias":"dorado.util.KeyedList#toArray","visibility":"public","returns":{"desc":"包含所有集合元素的数组。","type":"Array"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"getFirst","type":"method","desc":"返回集合中的第一个对象。","alias":"dorado.util.KeyedList#getFirst","visibility":"public","returns":{"desc":"集合中的第一个对象。","type":"Object"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"getLast","type":"method","desc":"返回集合中的最后一个对象。","alias":"dorado.util.KeyedList#getLast","visibility":"public","returns":{"desc":"集合中的最后一个对象。","type":"Object"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"clone","type":"method","desc":"浅度克隆本键值对集合。","alias":"dorado.util.KeyedList#clone","visibility":"public","returns":{"desc":"克隆的集合。","type":"dorado.util.KeyedList"},"package":"core","memberOf":"dorado.util.KeyedList"},{"name":"deepClone","type":"method","desc":"深度克隆本键值对集合。","alias":"dorado.util.KeyedList#deepClone","visibility":"public","returns":{"desc":"克隆的集合。","type":"dorado.util.KeyedArray"},"package":"core","memberOf":"dorado.util.KeyedList"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.util.KeyedList","params":[{"desc":"用于从元素中提取元素键值的函数，此函数应该返回一个String作为键值。","type":"Function","name":"getKeyFunction","isOptional":true}]}],"events":[]}