SYMBOLS["dorado.util.Map"]={"name":"Map","type":"class","desc":null,"alias":"dorado.util.Map","author":"Benny Bao (mailto:benny.bao@bstek.com)","see":["$map"],"classDesc":"仿Map对象。用于维护若干组键值对。\r<p>\r此对象最经常被使用的场景是在DataSet、Action、Reference等对象的parameter属性中。\r因为很多时候我们会希望将这写地方的parameter参数设置成类似Map的形式，以便于利用Map的特性在parameter中维护若干个子参数，每一个自参数保存在Map的一个键值下。\r这样就可以比较方便的在逻辑代码中根据实际需要增删Map中的子参数。<br>\r当然，这一功能通过标准的JSON对象完全可以实现，这里的Map对象只是可以让这种使用方法变得更加简单而已。\r</p>\r<p>\r假设您通过Dorado的IDE将某Action的parameter属性定义成一个Entity，且其中包含了两个属性值a和b作为两个子参数。\r当该属性被Dorado引擎自动生成到客户端时，Dorado会自动将其创建为一个Map对象。\r如果在实际的运行过程中您又有两个额外的子参数c和d需要添加到这个Map对象中时，你只需要调用如下的方法：\r<pre class=\"symbol-example code\">\r<code class=\"javascript\">\raction.set(\"parameter\", $map({ c: \"xxx\", d: true }));\r</code>\r</pre>\rDorado就会自动将c和d合并到parameter属性原有的Map中，而不是直接用这个只包含c和d的Map替换之。<br>\\\r之所以这样是因为，对于上述提及的这些parameter属性Dorado都已内置了针对Map的特殊处理逻辑。\r只要某属性原先的值类型是一个Map，当通过set方法为其设置一个新的Map时，Dorado会自动将新的Map中的键值对合并到原Map中。<br>\r当某属性原有的值和将要写入的值中有任何一个不是Map类型时，Dorado将只会使用最简单的属性写入逻辑。即将原有的值完整的替换掉。\r</p>","package":"core","memberOf":"dorado.util","properties":[],"attributes":[],"methods":[{"name":"put","type":"method","desc":"向Map中添加一到多个键值对。\r<p>\r此方法有如下两种使用方式：\r<ul>\r\t<li>添加一组键值对，以String的形式定义key参数，同时定义value参数。</li>\r\t<li>一次性的添加多组键值对，以JSON/dorado.util.Map的形式定义key参数。此时不需要定义value参数。</li>\r</ul>\r</p>","alias":"dorado.util.Map#put","visibility":"public","params":[{"desc":"要设置的键或者以JSON/dorado.util.Map方式定义的若干组键值对。","type":"String|Object|dorado.util.Map","name":"key"},{"desc":"键值。","type":"Object","name":"value","isOptional":true}],"package":"core","memberOf":"dorado.util.Map"},{"name":"set","type":"method","desc":"此方法与<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.Map#put')\">dorado.util.Map#put</A>的作用和用法完全相同，\r提供该方法目的主要是为了使之与Dorado中的其他对象的使用方法形成统一。","alias":"dorado.util.Map#set","see":["dorado.util.Map#put"],"visibility":"public","package":"core","memberOf":"dorado.util.Map"},{"name":"get","type":"method","desc":"根据给定的键返回相应的值。","alias":"dorado.util.Map#get","visibility":"public","params":[{"desc":"要读取的键。","type":"String","name":"key"}],"returns":{"desc":"相应的值。","type":"Object"},"package":"core","memberOf":"dorado.util.Map"},{"name":"remove","type":"method","desc":"删除Map中的某个键值对。","alias":"dorado.util.Map#remove","visibility":"public","params":[{"desc":"要删除的键。","type":"String","name":"key"}],"package":"core","memberOf":"dorado.util.Map"},{"name":"clear","type":"method","desc":"清空Map中所有的键值对。","alias":"dorado.util.Map#clear","visibility":"public","package":"core","memberOf":"dorado.util.Map"},{"name":"toJSON","type":"method","desc":"将此Map对象转换为标准的JSON对象并返回。","alias":"dorado.util.Map#toJSON","visibility":"public","returns":{"desc":"包含Map中所有键值对的JSON对象。","type":"Object"},"package":"core","memberOf":"dorado.util.Map"},{"name":"keys","type":"method","desc":"返回包含Map中所有键值的数组。","alias":"dorado.util.Map#keys","visibility":"public","returns":{"desc":"键值数组。","type":"String[]"},"package":"core","memberOf":"dorado.util.Map"},{"name":"eachKey","type":"method","desc":"遍历所有键值对。","alias":"dorado.util.Map#eachKey","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"map.each(function(key, value) {\r\t// your code\r});"}],"visibility":"public","params":[{"desc":"针对数组中每一个元素的回调函数。此函数支持下列两个参数:\r<ul>\r<li>key - {String} 当前遍历到的键。</li>\r<li>value - {Object} 当前遍历到的键值。</li>\r</ul>\r另外，此函数的返回值可用于通知系统是否要终止整个遍历操作。\r返回true或不返回任何数值表示继续执行遍历操作，返回false表示终止整个遍历操作。<br>\r此回调函数中的this指向正在被遍历的数组。","type":"Function","name":"fn"}],"package":"core","memberOf":"dorado.util.Map"}],"constructors":[{"name":"constuctor","type":"constuctor","memberOf":"dorado.util.Map","params":[{"desc":"用于初始化Map键值对的参数。\r此参数应是一个JSON对象，其中定义的所有属性会自动的被添加到Map中。","type":"Object|dorado.util.Map","name":"config","isOptional":true}]}],"events":[]}