SYMBOLS["jQuery"]={"name":"jQuery","type":"object","desc":null,"alias":"jQuery","author":"Benny Bao (mailto:benny.bao@bstek.com)","classDesc":"针对jQuery的扩展。\r<p>\r<b>注意：这里给出的并不是jQuery的使用文档，而是dorado7对jQuery所做了一系列扩展方法的文档。</b>\r</p>","package":"core","properties":[],"attributes":[],"methods":[{"name":"shadow","type":"method","desc":"为HTML元素添加阴影效果。\r<p>\r注意：在默认情况下，IE和其他浏览器中的所使用的阴影的实现方式是不同的。<br>\r在其他浏览器中，我们将使用纯CSS的方法来显示对象阴影。这样可以提高阴影的显示效率，但是在这种情况下options中的offset选项将是无效的。阴影的大小由CSS中的定义决定。\r</p>\r<p>\r使用该方法添加的阴影效果，如果不是需要移除，则无需手动移除，可以调用unshadow与shadow方法来临时禁用或启用阴影效果。\r在非IE浏览器下，浏览器会控制阴影的显示隐藏与大小。\r在IE浏览器下，使用了属性监听事件来控制阴影的显示隐藏与大小。\r</p>","alias":"jQuery#shadow","see":["jQuery#unshadow"],"visibility":"public","params":[{"desc":"选项。","type":"Object","name":"options","isOptional":true},{"desc":"阴影类型，目前有drop、sides、frame这三种类型供选择。","type":"String","name":"options.mode","isOptional":true,"defaultValue":"\"drop\""},{"desc":"阴影大小。","type":"int","name":"options.offset","isOptional":true,"defaultValue":"4"}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"unshadow","type":"method","desc":"移除HTML元素上的阴影效果。","alias":"jQuery#unshadow","see":["jQuery#shadow"],"visibility":"public","returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"left","type":"method","desc":"返回或设置对象的style.left值。","alias":"jQuery#left","visibility":"public","params":[{"desc":"style.left值。","type":"String|int","name":"val","isOptional":true}],"returns":{"desc":"style.left值;或者当此方法用于设置对象的style.left时返回调用此方法的jQuery对象自身。","type":"int|jQuery"},"package":"core","memberOf":"jQuery"},{"name":"top","type":"method","desc":"返回或设置对象的style.top值。","alias":"jQuery#top","visibility":"public","params":[{"desc":"style.top。","type":"String|int","name":"val","isOptional":true}],"returns":{"desc":"style.top值;或者当此方法用于设置对象的style.top时返回调用此方法的jQuery对象自身。","type":"int|jQuery"},"package":"core","memberOf":"jQuery"},{"name":"right","type":"method","desc":"返回或设置对象的style.right值。","alias":"jQuery#right","visibility":"public","params":[{"desc":"style.right。","type":"String|int","name":"val","isOptional":true}],"returns":{"desc":"style.right值;或者当此方法用于设置对象的style.right时返回调用此方法的jQuery对象自身。","type":"int|jQuery"},"package":"core","memberOf":"jQuery"},{"name":"bottom","type":"method","desc":"返回或设置对象的style.bottom值。","alias":"jQuery#bottom","visibility":"public","params":[{"desc":"style.bottom。","type":"String|int","name":"val","isOptional":true}],"returns":{"desc":"style.bottom值;或者当此方法用于设置对象的style.bottom时返回调用此方法的jQuery对象自身。","type":"int|jQuery"},"package":"core","memberOf":"jQuery"},{"name":"position","type":"method","desc":"返回或设置对象的坐标，即返回或设置对象的style.left和style.top。","alias":"jQuery#position","visibility":"public","params":[{"desc":"style.left。","type":"String|int","name":"left","isOptional":true},{"desc":"style.top。","type":"String|int","name":"top","isOptional":true}],"returns":{"desc":"对象坐标;或者当此方法用于设置对象的坐标时返回调用此方法的jQuery对象自身。\r此处返回的对象坐标是一个的JSON对象，其中包含下列子属性：\r<ul>\r<li>left - style.left的值。</li>\r<li>top - style.top的值。</li>\r</ul>","type":"Object|jQuery"},"package":"core","memberOf":"jQuery"},{"name":"outerWidth","type":"method","desc":"返回或设置对象的实际宽度。\r<p>\r当我们不定义此方法的width参数时，表示我们需要此方法返回对象的实际宽度； 如果定义了此方法的width参数，表示我们要设置此对象的实际宽度。\r</p>","alias":"jQuery#outerWidth","visibility":"public","params":[{"desc":"将要设置的宽度。\r当此处指定的宽度为百分比时，此方法将直接简单的把此参数赋给对象的style.width属性。","type":"String|int","name":"width","isOptional":true}],"returns":{"desc":"对象的实际宽度（包含对象的padding、border）;或者当此方法用于设置对象的宽度时返回调用此方法的jQuery对象自身。","type":"int|jQuery"},"package":"core","memberOf":"jQuery"},{"name":"outerHeight","type":"method","desc":"返回或设置对象的实际高度。\r<p>\r当我们不定义此方法的height参数时，表示我们需要此方法返回对象的实际高度；\r如果定义了此方法的height参数，表示我们要设置此对象的实际高度。\r</p>","alias":"jQuery#outerHeight","visibility":"public","params":[{"desc":"将要设置的高度。\r当此处指定的高度为百分比时，此方法将直接简单的把此参数赋给对象的style.height属性。","type":"String|int","name":"height","isOptional":true}],"returns":{"desc":"对象的实际高度（包含对象的padding、border）;或者当此方法用于设置对象的高度时返回调用此方法的jQuery对象自身。","type":"int|jQuery"},"package":"core","memberOf":"jQuery"},{"name":"bringToFront","type":"method","desc":"将相应元素提到最前面，即为相应元素设置合适的style.zIndex使其不至于被其他元素阻挡。","alias":"jQuery#bringToFront","visibility":"public","returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"addClassOnHover","type":"method","desc":"当鼠标经过该对象时为该对象添加一个CSS Class，并在鼠标离开后移除该CSS Class。\r<p>\r注意：此方法不适用于$fly()方法返回的对象。应使用$()或jQuery()来封装DOM对象。\r</p>","alias":"jQuery#addClassOnHover","visibility":"public","params":[{"desc":"要设置的CSS Class。","type":"String","name":"cls"},{"desc":"要将CSS Class设置给哪个对象，如果不指定此参数则将设置给调用此方法的jQuery对象。","type":"jQuery","name":"clsOwner","isOptional":true},{"desc":"一个用于判断是否要启用鼠标悬停效果的函数，其返回值的true/false决定是否要启用悬停效果。 该fn的scope即为jQuery对象自身。","type":"Function","name":"fn","isOptional":true}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"addClassOnFocus","type":"method","desc":"当该对象获得焦点时为该对象添加一个CSS Class，并在对象失去焦点后移除该CSS Class。\r<p>\r注意：此方法不适用于$fly()方法返回的对象。应使用$()或jQuery()来封装DOM对象。\r</p>","alias":"jQuery#addClassOnFocus","visibility":"public","params":[{"desc":"要设置的CSS Class。","type":"String","name":"cls"},{"desc":"要将CSS Class设置给哪个对象，如果不指定此参数则将设置给调用此方法的jQuery对象。","type":"jQuery","name":"clsOwner","isOptional":true},{"desc":"一个用于判断是否要启用焦点效果的函数，其返回值的true/false决定是否要启用焦点效果。 该fn的scope即为jQuery对象自身。","type":"Function","name":"fn","isOptional":true}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"addClassOnClick","type":"method","desc":"当鼠标在该对象上按下时为该对象添加一个CSS Class，并在鼠标抬起后移除该CSS Class。\r<p>\r注意：此方法不适用于$fly()方法返回的对象。应使用$()或jQuery()来封装DOM对象。\r</p>","alias":"jQuery#addClassOnClick","visibility":"public","params":[{"desc":"要设置的CSS Class。","type":"String","name":"cls"},{"desc":"要将CSS Class设置给哪个对象，如果不指定此参数则将设置给调用此方法的jQuery对象。","type":"jQuery","name":"clsOwner","isOptional":true},{"desc":"一个用于判断是否要启用单击效果的函数，其返回值的true/false决定是否要启用单击效果。 该fn的scope即为jQuery对象自身。","type":"Function","name":"fn","isOptional":true}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"repeatOnClick","type":"method","desc":"当鼠标在该对象上按下的时候重复执行一个函数，当鼠标抬起以后，则取消执行这段函数。","alias":"jQuery#repeatOnClick","visibility":"public","params":[{"desc":"要执行的函数。","type":"Function","name":"fn"},{"desc":"重复执行的间隔。","type":"int","name":"interval=100"}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"fullWindow","type":"method","desc":"调用对象应为display为block的元素。","alias":"jQuery#fullWindow","visibility":"public","returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"unfullWindow","type":"method","desc":"调用对象应为display为block的元素。","alias":"jQuery#unfullWindow","visibility":"public","returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"xCreate","type":"method","desc":"根据以JSON形式定义的组件的模板信息快速的插入批量元素。<br>\r更多的例子请参考<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Dom.xCreateElement')\">dorado.Dom.xCreateElement</A>的文档。","alias":"jQuery#xCreate","example":[{"title":"example","type":"","name":"","isOptional":false,"defaultValue":"","desc":"// 创建并插入一个按钮\rjQuery(\"body\").xCreate({\r\ttagName: \"button\",\r\tcontent: \"Click Me\",\t// 定义按钮的标题\r\tstyle: {\t// 定义按钮的style\r\t\tborder: \"1px black solid\",\r\t\tbackgroundColor: \"white\"\r\t}\r\tonclick: function() {\t// 定义onclick事件\r\t\talert(\"Button clicked.\");\r\t}\r});"}],"see":["dorado.util.Dom.xCreateElement"],"visibility":"public","params":[{"desc":"JSON形式定义的组件的模板信息。","type":"Object|Array","name":"template"},{"desc":"JSON形式定义的模板参数。","type":"Object","name":"arg","isOptional":true},{"desc":"执行选项。","type":"Object","name":"options","isOptional":true},{"desc":"是否已插入而不是追加的方式将新创建的元素添加到父对象中。xCreate默认是以appendChild的模式添加新元素的。","type":"boolean","name":"options.insertBefore","isOptional":true},{"desc":"当使用insertBefore方式添加新元素时，应将新元素插入到哪一个原有的子元素之前。如果不定义此参数，则将插入所有子元素之前。","type":"HTMLElement","name":"options.refNode","isOptional":true},{"desc":"指定此方法是否返回新创建的元素，否则方法返回的是调用者自身。","type":"boolean","name":"options.returnNewElements","isOptional":true},{"desc":"上下文对象，见<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.util.Dom.xCreateElement')\">dorado.util.Dom.xCreateElement</A>中的context参数。","type":"Object","name":"options.context","isOptional":true}],"returns":{"desc":"jQuery对象或新创建的元素。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"slideIn","type":"method","desc":"类似slideDown与slideUp，区别在于这个动画不会真正的去改变动画元素的width和height属性，页面效果看起来更美观。\r<p>\r目前FloatControl及其子组件均使用了此动画。\r如果参数为字符串，则表示为direction，不能传入其他参数。如果为json，则根据options中的规则获取配置信息。\r</p>","alias":"jQuery#slideIn","visibility":"public","params":[{"desc":"Json类型的参数。","type":"Object","name":"options"},{"desc":"要滑动的方向，可选的是t2b、b2t、l2r、r2l。意义分别是从上到下、从下到上、从左到右、从右到左。默认值为t2b。","type":"String","name":"options.direction"},{"desc":"完成后要调用的回调函数。","type":"Function","name":"options.complete"},{"desc":"动画执行的时间，单位为毫秒。","type":"int","name":"options.duration"},{"desc":"是用哪个easing function.","type":"String","name":"options.easing"},{"desc":"每步动画完成以后调用的回调函数。","type":"Function","name":"options.step"}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"slideOut","type":"method","desc":"类似slideDown与slideUp，区别在于这个动画不会真正的去改变动画元素的width和height属性，页面效果看起来更美观。\r<p>\r目前FloatControl以及其子组件使用了此动画。\r如果参数为字符串，则表示为direction，不能传入其他参数。如果为json，则根据options中的规则获取配置信息。\r</p>","alias":"jQuery#slideOut","visibility":"public","params":[{"desc":"Json类型的参数。","type":"Object","name":"options"},{"desc":"要滑动的方向，可选的是t2b、b2t、l2r、r2l。意义分别是从上到下、从下到上、从左到右、从右到左。默认值为t2b。","type":"String","name":"options.direction"},{"desc":"完成后要调用的回调函数。","type":"Function","name":"options.complete"},{"desc":"动画执行的时间，单位为毫秒。","type":"int","name":"options.duration"},{"desc":"是用哪个easing function.","type":"String","name":"options.easing"},{"desc":"每步动画完成以后调用的回调函数。","type":"Function","name":"options.step"}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"safeSlideIn","type":"method","desc":"安全滑入动画效果。\r与slideIn的区别在于该动画不会挪动dom元素的位置，可以避免iframe的刷新(非IE浏览器)、滚动条的复位等问题。","alias":"jQuery#safeSlideIn","visibility":"public","params":[{"desc":null,"name":"options"}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"safeSlideOut","type":"method","desc":"安全滑出动画。\r与slideOut的区别在于该动画不会挪动dom元素的位置，可以避免iframe的刷新(非IE浏览器)、滚动条的复位等问题。","alias":"jQuery#safeSlideOut","visibility":"public","params":[{"desc":null,"name":"options"}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"draggable","type":"method","desc":"此方法是对jQuery UI中draggable方法的增强，请首先参考jQuery UI中draggable方法的使用方法。","alias":"jQuery#draggable","visibility":"public","params":[{"desc":"选项。以下只列出dorado增加额外子参数。","type":"Object","name":"options"},{"desc":"拖拽信息或用于获取拖拽信息的Function。<br>\r要使一个可拖拽对象可以被dorado的控件感知和接受，只需要定义了此参数即可。","type":"Function|dorado.DraggingInfo","name":"options.draggingInfo","isOptional":true},{"desc":"与此可拖拽元素对应的dorado可拖拽对象。\r如果定义了此参数，那么我们就可以通过<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Draggable')\">dorado.Draggable</A>支持的各种方法和事件对拖拽操作进行监听和控制。","type":"dorado.Draggable","name":"options.doradoDraggable","isOptional":true}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"},{"name":"droppable","type":"method","desc":"此方法是对jQuery UI中droppable方法的增强，请首先参考jQuery UI中droppable方法的使用方法。","alias":"jQuery#droppable","visibility":"public","params":[{"desc":"选项。以下只列出dorado增加额外子参数。","type":"Object","name":"options"},{"desc":"与此可拖拽元素对应的dorado可接受拖拽对象。\r如果定义了此参数，那么我们就可以通过<A class=\"symbol-link\" href=\"javascript:openSymbolDoc('dorado.Droppable')\">dorado.Droppable</A>支持的各种方法和事件对拖拽操作进行监听和控制。","type":"dorado.Droppable","name":"options.doradoDroppable","isOptional":true}],"returns":{"desc":"调用此方法的jQuery对象自身。","type":"jQuery"},"package":"core","memberOf":"jQuery"}],"constructors":[],"events":[]}